{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Trie.Curry_Internal
  ( C_InternalTrie (..)
  , d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
  , d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
  , nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
  , d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
  , nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  , d_C_empty'
  , d_C_null'
  , d_C_singleton'
  , d_C_update'
  , nd_C_update'
  , d_C_delete'
  , d_C_lookup'
  , d_C_toList'
  , d_C_second
  , nd_C_second )
  where

import Basics
import qualified Data.Curry_Maybe
import qualified Curry_Prelude


data C_InternalTrie t0
  = C_InternalTrie (Curry_Prelude.C_Maybe t0) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0)))
  | Choice_C_InternalTrie Cover ID (C_InternalTrie t0) (C_InternalTrie t0)
  | Choices_C_InternalTrie Cover ID [C_InternalTrie t0]
  | Fail_C_InternalTrie Cover FailInfo
  | Guard_C_InternalTrie Cover Constraints (C_InternalTrie t0)

instance (Curry t0) => Show (C_InternalTrie t0) where
  showsPrec d (Choice_C_InternalTrie cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_InternalTrie cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_InternalTrie cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_InternalTrie cd info) = showChar '!'
  showsPrec _ (C_InternalTrie x1 x2) = showString "(InternalTrie" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance (Curry t0) => Read (C_InternalTrie t0) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_InternalTrie x1 x2, r2) | (_
    , r0) <- readQualified "Data.Trie.Internal" "InternalTrie" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s

instance NonDet (C_InternalTrie t0) where
  choiceCons = Choice_C_InternalTrie
  choicesCons = Choices_C_InternalTrie
  failCons = Fail_C_InternalTrie
  guardCons = Guard_C_InternalTrie
  try (Choice_C_InternalTrie cd i x y) = tryChoice cd i x y
  try (Choices_C_InternalTrie cd i xs) = tryChoices cd i xs
  try (Fail_C_InternalTrie cd info) = Fail cd info
  try (Guard_C_InternalTrie cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_InternalTrie cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_InternalTrie cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_InternalTrie cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_InternalTrie cd i _) = error
    ("Data.Trie.Internal.InternalTrie.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_InternalTrie cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_InternalTrie cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0) => Generable (C_InternalTrie t0) where
  generate s c = Choices_C_InternalTrie c (freeID [2] s) [C_InternalTrie
    (generate (leftSupply s) c) (generate (rightSupply s) c)]

instance (Curry t0) => NormalForm (C_InternalTrie t0) where
  ($!!) cont (C_InternalTrie x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_InternalTrie y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_InternalTrie cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_InternalTrie cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_InternalTrie cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_InternalTrie cd info) _ _ = failCons cd info
  ($##) cont (C_InternalTrie x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_InternalTrie y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_InternalTrie cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_InternalTrie cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_InternalTrie cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_InternalTrie cd info) _ _ = failCons cd info
  showCons (C_InternalTrie _ _) = "Data.Trie.Internal.InternalTrie _ _"
  showCons x = error
    ("Data.Trie.Internal.InternalTrie.showCons: no constructor: " ++ show x)
  searchNF search cont (C_InternalTrie x1 x2) = search (\y1 -> search (\y2 ->
    cont (C_InternalTrie y1 y2)) x2) x1
  searchNF _ _ x = error
    ("Data.Trie.Internal.InternalTrie.searchNF: no constructor: " ++ show x)

instance (Curry t0) => Unifiable (C_InternalTrie t0) where
  (=.=) (C_InternalTrie x1 x2) (C_InternalTrie y1 y2) d cs = (&) ((=:=) x1 y1 d
    cs) ((=:=) x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_InternalTrie x1 x2) (C_InternalTrie y1 y2) d cs = (&) ((=:<=) x1 y1
    d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_InternalTrie x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_InternalTrie cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_InternalTrie cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_InternalTrie cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_InternalTrie cd i _) = error
    ("Data.Trie.Internal.InternalTrie.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_InternalTrie cd info) = [Unsolvable info]
  bind d i (Guard_C_InternalTrie cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_InternalTrie x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_InternalTrie cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_InternalTrie cd j@(FreeID _ _) xs) = lazyBindOrNarrow
    d i cd j xs
  lazyBind d i (Choices_C_InternalTrie cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_InternalTrie cd i _) = error
    ("Data.Trie.Internal.InternalTrie.lazyBind: Choices with ChoiceID: " ++ show
    i)
  lazyBind _ _ (Fail_C_InternalTrie cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_InternalTrie cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance (Curry t0) => Curry (C_InternalTrie t0) where

d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Functor
  C_InternalTrie
d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Functor (acceptCs
    id
    d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash)
    (d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie.Internal._inst#Prelude.Functor#Data.Trie.Internal.InternalTrie#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._inst#Prelude.Functor#Data.Trie.Internal.InternalTrie#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Functor C_InternalTrie
nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Functor (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash))
    (nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie.Internal._inst#Prelude.Functor#Data.Trie.Internal.InternalTrie#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._inst#Prelude.Functor#Data.Trie.Internal.InternalTrie#"
    (showCons x1))

d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t1 -> Cover
  -> ConstStore -> t0) -> C_InternalTrie t1 -> Cover -> ConstStore
  -> C_InternalTrie t0
d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash x1 x2 cd cs =
  case x2 of
  C_InternalTrie x3 x4 -> C_InternalTrie
    (Curry_Prelude.d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Prelude_dot_Maybe_hash
    x1 x3 cd cs) (Curry_Prelude.d_C_map (d_C_second
    (d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1)) x4 cd cs)
  Choice_C_InternalTrie d i l r -> narrow d i
    (d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1 r cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1 z cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._impl#fmap#Prelude.Functor#Data.Trie.Internal.InternalTrie#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._impl#fmap#Prelude.Functor#Data.Trie.Internal.InternalTrie#"
    (showCons x2))

nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t1 t0
  -> C_InternalTrie t1 -> IDSupply -> Cover -> ConstStore -> C_InternalTrie t0
nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash x1 x2 s cd cs =
  case x2 of
  C_InternalTrie x3 x4 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` C_InternalTrie
    (Curry_Prelude.nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Prelude_dot_Maybe_hash
    x1 x3 s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id (nd_C_second (wrapNX id
    (nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1)))) x4 s1 cd cs)))
  Choice_C_InternalTrie d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1 l s cd cs)
    (nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1 r s cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1 z s cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1 e s cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._impl#fmap#Prelude.Functor#Data.Trie.Internal.InternalTrie#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._impl#fmap#Prelude.Functor#Data.Trie.Internal.InternalTrie#"
    (showCons x2))

d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Cover -> ConstStore -> C_InternalTrie t0 -> Cover -> ConstStore
  -> C_InternalTrie t1
d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_lt_dollar_hash_Prelude_dot_Functor
  d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
  cd cs

nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Func (C_InternalTrie t0) (C_InternalTrie
  t1))
nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash s cd cs =
  let s0 = s
  in s0 `seq`
  Curry_Prelude.nd_OP_uscore_def_hash_lt_dollar_hash_Prelude_dot_Functor (wrapNX
  id
  nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash)
  s0 cd cs

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data (C_InternalTrie t0)
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie.Internal._inst#Prelude.Data#Data.Trie.Internal.InternalTrie#0##"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._inst#Prelude.Data#Data.Trie.Internal.InternalTrie#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> C_InternalTrie t0 -> C_InternalTrie t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x2 of
  C_InternalTrie x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_11 x5 x1 x4 x3 s0 cd cs
  Choice_C_InternalTrie d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 l x3 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 r x3 s cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 z x3 s cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 e x3 s cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._impl#===#Prelude.Data#Data.Trie.Internal.InternalTrie#0##"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._impl#===#Prelude.Data#Data.Trie.Internal.InternalTrie#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> IDSupply -> Cover -> ConstStore -> C_InternalTrie t0
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_InternalTrie
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Maybe_hash_0_hash_hash
  x1 s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  x1)))) s1 cd cs)))

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  (C_InternalTrie t0)
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 cd cs) (acceptCs id
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1))
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie.Internal._inst#Prelude.Show#Data.Trie.Internal.InternalTrie#0##"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._inst#Prelude.Show#Data.Trie.Internal.InternalTrie#0##"
    (showCons x2))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show (C_InternalTrie t0)
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Show
    (nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 s0 cd cs) (wrapDX (wrapNX id) (acceptCs id
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 s1 cd cs)))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie.Internal._inst#Prelude.Show#Data.Trie.Internal.InternalTrie#0##"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._inst#Prelude.Show#Data.Trie.Internal.InternalTrie#0##"
    (showCons x2))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Cover -> ConstStore
  -> C_InternalTrie t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  x1)

nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> IDSupply -> Cover -> ConstStore -> Func (C_InternalTrie t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 s cd cs =
  wrapNX id (Curry_Prelude.nd_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  x1)))

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_Int
  -> C_InternalTrie t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 x2 x3 cd cs =
  case x3 of
  C_InternalTrie x4 x5 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x2 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "InternalTrie "))
    (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
    x1 (Curry_Prelude.C_Int (11)) x4 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1)) (Curry_Prelude.C_Int (11)) cd cs) x5 cd cs) cd cs) cd cs) cd cs) cd cs
  Choice_C_InternalTrie d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x2 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x2 r cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x2 z cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x2 e cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._impl#showsPrec#Prelude.Show#Data.Trie.Internal.InternalTrie#0##"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._impl#showsPrec#Prelude.Show#Data.Trie.Internal.InternalTrie#0##"
    (showCons x3))

nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Int -> C_InternalTrie t0 -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x3 of
  C_InternalTrie x4 x5 -> let s15 = s
    in s15 `seq` (let s14 = leftSupply s15
                      s16 = rightSupply s15
                      s2 = leftSupply s16
                      s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s2 `seq` (s13 `seq` Curry_Prelude.nd_C_showParen
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) (Curry_Prelude.C_Int (10)) s0 cd cs) x2 s1 cd cs))
    (let s12 = leftSupply s13
         s10 = rightSupply s13
    in s12 `seq` (s10 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "InternalTrie "))) (let s9 = leftSupply s10
                            s11 = rightSupply s10
                            s3 = leftSupply s11
                            s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s3 `seq` (s8 `seq` Curry_Prelude.nd_OP_dot
    (Curry_Prelude.nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
    x1 (Curry_Prelude.C_Int (11)) x4 s3 cd cs) (let s7 = leftSupply s8
                                                    s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " ")))
    (let s5 = leftSupply s6
         s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1)))) (Curry_Prelude.C_Int (11)) s4 cd cs) x5 s5 cd cs)) s7 cd cs)) s9 cd
    cs)))) s12 cd cs)) s14 cd cs))))
  Choice_C_InternalTrie d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x2 l s cd cs)
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x2 r s cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x2 z s cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x2 e s cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._impl#showsPrec#Prelude.Show#Data.Trie.Internal.InternalTrie#0##"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._impl#showsPrec#Prelude.Show#Data.Trie.Internal.InternalTrie#0##"
    (showCons x3))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_InternalTrie t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  x1) cd cs

nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (C_InternalTrie t0)) (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 s cd cs =
  let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  x1)) s0 cd cs

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq (C_InternalTrie t0)
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1))
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie.Internal._inst#Prelude.Eq#Data.Trie.Internal.InternalTrie#0##"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._inst#Prelude.Eq#Data.Trie.Internal.InternalTrie#0##"
    (showCons x2))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq (C_InternalTrie t0)
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie.Internal._inst#Prelude.Eq#Data.Trie.Internal.InternalTrie#0##"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._inst#Prelude.Eq#Data.Trie.Internal.InternalTrie#0##"
    (showCons x2))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> C_InternalTrie t0
  -> C_InternalTrie t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 x2 x3 cd cs =
  case x2 of
  C_InternalTrie x4 x5 -> d_C__case_10 x5 x1 x4 x3 cd cs
  Choice_C_InternalTrie d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 l x3 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 r x3 cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 z x3 cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 e x3 cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._impl#==#Prelude.Eq#Data.Trie.Internal.InternalTrie#0##"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._impl#==#Prelude.Eq#Data.Trie.Internal.InternalTrie#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> C_InternalTrie t0 -> C_InternalTrie t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x2 of
  C_InternalTrie x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_10 x5 x1 x4 x3 s0 cd cs
  Choice_C_InternalTrie d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 l x3 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 r x3 s cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 z x3 s cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 e x3 s cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._impl#==#Prelude.Eq#Data.Trie.Internal.InternalTrie#0##"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Data.Trie.Internal._impl#==#Prelude.Eq#Data.Trie.Internal.InternalTrie#0##"
    (showCons x2))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Cover -> ConstStore
  -> C_InternalTrie t0 -> Cover -> ConstStore -> C_InternalTrie t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  x1))

nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> IDSupply -> Cover -> ConstStore -> Func (C_InternalTrie t0) (Func
  (C_InternalTrie t0) Curry_Prelude.C_Bool)
nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash x1 s cd cs =
  wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  x1))))

d_C_empty' :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => C_InternalTrie t0
d_C_empty' cd cs = C_InternalTrie Curry_Prelude.C_Nothing Curry_Prelude.OP_List

d_C_null' :: forall t0 . (Curry_Prelude.Curry t0) => C_InternalTrie t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_null' x1 cd cs = case x1 of
  C_InternalTrie x2 x3 -> d_C__case_9 x3 x2 cd cs
  Choice_C_InternalTrie d i l r -> narrow d i (d_C_null' l cd cs) (d_C_null' r
    cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> d_C_null' z cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> d_C_null' e cd x) $! addCs
    c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail "Data.Trie.Internal.null'"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.null'" (showCons x1))

d_C_singleton' :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> Cover -> ConstStore -> C_InternalTrie t0
d_C_singleton' x1 x2 cd cs = Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_singleton_tick_dot_uscore_hash_lambda2) (C_InternalTrie
  (Curry_Prelude.C_Just x2) Curry_Prelude.OP_List) x1 cd cs

d_OP_singleton_tick_dot_uscore_hash_lambda2 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Char -> C_InternalTrie t0 -> Cover -> ConstStore
  -> C_InternalTrie t0
d_OP_singleton_tick_dot_uscore_hash_lambda2 x1 x2 cd cs = C_InternalTrie
  Curry_Prelude.C_Nothing (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x1 x2)
  Curry_Prelude.OP_List)

d_C_update' :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.C_Maybe t0 -> Cover -> ConstStore
  -> t0) -> C_InternalTrie t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Bool (C_InternalTrie t0)
d_C_update' x1 x2 x3 cd cs = case x1 of
  Curry_Prelude.OP_List -> d_C__case_7 x2 x3 cd cs
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_6 x6 x2 x7 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_update' l x2 x3 cd cs)
    (d_C_update' r x2 x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_update' z x2
    x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_update' e x2 x3
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Trie.Internal.update'" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.update'" (showCons x1))

nd_C_update' :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.C_Maybe t0) t0 -> C_InternalTrie
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Bool (C_InternalTrie t0)
nd_C_update' x1 x2 x3 s cd cs = case x1 of
  Curry_Prelude.OP_List -> let s0 = s in s0 `seq` nd_C__case_7 x2 x3 s0 cd cs
  Curry_Prelude.OP_Cons x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_6 x6 x2 x7 x3 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_update' l x2 x3 s cd
    cs) (nd_C_update' r x2 x3 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_update' z
    x2 x3 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_update' e x2
    x3 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Trie.Internal.update'" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.update'" (showCons x1))

d_OP_update_tick_dot_uscore_hash_selFP2_hash_incr :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (C_InternalTrie t0)
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_update_tick_dot_uscore_hash_selFP2_hash_incr x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_update_tick_dot_uscore_hash_selFP2_hash_incr l cd cs)
    (d_OP_update_tick_dot_uscore_hash_selFP2_hash_incr r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_update_tick_dot_uscore_hash_selFP2_hash_incr z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_update_tick_dot_uscore_hash_selFP2_hash_incr e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.Internal.update'._#selFP2#incr" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.update'._#selFP2#incr"
    (showCons x1))

d_OP_update_tick_dot_uscore_hash_selFP3_hash_t_tick :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (C_InternalTrie t0)
  -> Cover -> ConstStore -> C_InternalTrie t0
d_OP_update_tick_dot_uscore_hash_selFP3_hash_t_tick x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_update_tick_dot_uscore_hash_selFP3_hash_t_tick l cd cs)
    (d_OP_update_tick_dot_uscore_hash_selFP3_hash_t_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_update_tick_dot_uscore_hash_selFP3_hash_t_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_update_tick_dot_uscore_hash_selFP3_hash_t_tick e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.Internal.update'._#selFP3#t'" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.update'._#selFP3#t'" (showCons
    x1))

d_OP_update_tick_dot_uscore_hash_lambda4 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char
  (C_InternalTrie t0) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_update_tick_dot_uscore_hash_lambda4 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs) x3 cd cs) x1 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_update_tick_dot_uscore_hash_lambda4 x1 l cd cs)
    (d_OP_update_tick_dot_uscore_hash_lambda4 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_update_tick_dot_uscore_hash_lambda4 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_update_tick_dot_uscore_hash_lambda4 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.Internal.update'._#lambda4" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.update'._#lambda4" (showCons
    x2))

d_C_delete' :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_InternalTrie t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (C_InternalTrie t0)
d_C_delete' x1 x2 cd cs = case x2 of
  C_InternalTrie x3 x4 -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_Maybe_hash
    (d_C__case_4 x3 x4 x1 cd cs) d_OP_delete_tick_dot_uscore_hash_lambda13 cd cs
  Choice_C_InternalTrie d i l r -> narrow d i (d_C_delete' x1 l cd cs)
    (d_C_delete' x1 r cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> d_C_delete' x1 z cd cs)
    xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> d_C_delete' x1 e cd x) $!
    addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal.delete'" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.delete'" (showCons x2))

d_OP_delete_tick_dot_sanitize_dot_28 :: forall t0 . (Curry_Prelude.Curry
  t0) => C_InternalTrie t0 -> Cover -> ConstStore -> C_InternalTrie t0
d_OP_delete_tick_dot_sanitize_dot_28 x1 cd cs = case x1 of
  C_InternalTrie x2 x3 -> C_InternalTrie x2 (Curry_Prelude.d_C_filter
    (Curry_Prelude.d_OP_dot Curry_Prelude.d_C_not (Curry_Prelude.d_OP_dot
    d_C_null' Curry_Prelude.d_C_snd cd cs) cd cs) x3 cd cs)
  Choice_C_InternalTrie d i l r -> narrow d i
    (d_OP_delete_tick_dot_sanitize_dot_28 l cd cs)
    (d_OP_delete_tick_dot_sanitize_dot_28 r cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z ->
    d_OP_delete_tick_dot_sanitize_dot_28 z cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x ->
    d_OP_delete_tick_dot_sanitize_dot_28 e cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal.delete'.sanitize.28" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.delete'.sanitize.28" (showCons
    x1))

d_OP_delete_tick_dot_uscore_hash_lambda9 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char
  (C_InternalTrie t0)) -> Curry_Prelude.C_Maybe t0 -> C_InternalTrie t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe (C_InternalTrie t0)
d_OP_delete_tick_dot_uscore_hash_lambda9 x1 x2 x3 x4 x5 cd cs = let x6 = x5
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_Maybe_hash
  (d_C_delete' x2 x6 cd cs)
  (d_OP_delete_tick_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11 x1 x3 x6
  x4) cd cs

d_OP_delete_tick_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Char (C_InternalTrie t0)) -> C_InternalTrie t0
  -> Curry_Prelude.C_Maybe t0 -> C_InternalTrie t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (C_InternalTrie t0)
d_OP_delete_tick_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11 x1 x2 x3 x4 x5 cd cs =
  let x6 = x5
      x7 = Curry_Prelude.OP_Tuple2 x1 x6
      x8 = Curry_Prelude.d_C_filter (Curry_Prelude.d_OP_dot
        (Curry_Prelude.d_C_flip
        (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
        cd cs) x1) Curry_Prelude.d_C_fst cd cs) x2 cd cs
  in Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_Maybe_hash
  cd cs) (C_InternalTrie x4 (d_C__case_3 x3 x8 x7 (d_C_null' x3 cd cs) cd cs))
  cd cs

d_OP_delete_tick_dot_uscore_hash_lambda13 :: forall t0 . (Curry_Prelude.Curry
  t0) => C_InternalTrie t0 -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  (C_InternalTrie t0)
d_OP_delete_tick_dot_uscore_hash_lambda13 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_Maybe_hash
  cd cs) (d_OP_delete_tick_dot_sanitize_dot_28 x2 cd cs) cd cs

d_C_lookup' :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_InternalTrie t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe t0
d_C_lookup' x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> d_C__case_2 x2 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_1 x6 x5 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_lookup' l x2 cd cs)
    (d_C_lookup' r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_lookup' z x2
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_lookup' e x2 cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Trie.Internal.lookup'" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.lookup'" (showCons x1))

d_C_toList' :: forall t0 . (Curry_Prelude.Curry t0) => C_InternalTrie t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
d_C_toList' x1 cd cs = case x1 of
  C_InternalTrie x2 x3 -> d_C__case_0 x3 x2 cd cs
  Choice_C_InternalTrie d i l r -> narrow d i (d_C_toList' l cd cs) (d_C_toList'
    r cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> d_C_toList' z cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> d_C_toList' e cd x) $!
    addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal.toList'" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.toList'" (showCons x1))

d_OP_toList_tick_dot_uscore_hash_lambda16 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
d_OP_toList_tick_dot_uscore_hash_lambda16 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_C_map
    (d_OP_toList_tick_dot_uscore_hash_lambda16_dot_uscore_hash_lambda17 x2)
    (d_C_toList' x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_toList_tick_dot_uscore_hash_lambda16 l cd cs)
    (d_OP_toList_tick_dot_uscore_hash_lambda16 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_toList_tick_dot_uscore_hash_lambda16 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_toList_tick_dot_uscore_hash_lambda16 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.Internal.toList'._#lambda16" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.toList'._#lambda16" (showCons
    x1))

d_OP_toList_tick_dot_uscore_hash_lambda16_dot_uscore_hash_lambda17 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
d_OP_toList_tick_dot_uscore_hash_lambda16_dot_uscore_hash_lambda17 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_Cons x1 x3) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_toList_tick_dot_uscore_hash_lambda16_dot_uscore_hash_lambda17 x1 l cd
    cs) (d_OP_toList_tick_dot_uscore_hash_lambda16_dot_uscore_hash_lambda17 x1 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_toList_tick_dot_uscore_hash_lambda16_dot_uscore_hash_lambda17 x1 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_toList_tick_dot_uscore_hash_lambda16_dot_uscore_hash_lambda17 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.Internal.toList'._#lambda16._#lambda17" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.toList'._#lambda16._#lambda17"
    (showCons x2))

d_OP_toList_tick_dot_uscore_hash_lambda18 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
d_OP_toList_tick_dot_uscore_hash_lambda18 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_C_map
    (d_OP_toList_tick_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x2)
    (d_C_toList' x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_toList_tick_dot_uscore_hash_lambda18 l cd cs)
    (d_OP_toList_tick_dot_uscore_hash_lambda18 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_toList_tick_dot_uscore_hash_lambda18 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_toList_tick_dot_uscore_hash_lambda18 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.Internal.toList'._#lambda18" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.toList'._#lambda18" (showCons
    x1))

d_OP_toList_tick_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
d_OP_toList_tick_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_Cons x1 x3) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_toList_tick_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 l cd
    cs) (d_OP_toList_tick_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_toList_tick_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_toList_tick_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.Internal.toList'._#lambda18._#lambda19" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.toList'._#lambda18._#lambda19"
    (showCons x2))

d_C_second :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2) => (t1 -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_Tuple2 t2 t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t2 t0
d_C_second x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2 x3
    (Curry_Prelude.d_C_apply x1 x4 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_second x1 l cd cs)
    (d_C_second x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_second x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_second x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.Internal.second" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.second" (showCons x2))

nd_C_second :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2) => Func t1 t0 -> Curry_Prelude.OP_Tuple2 t2 t1
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t0
nd_C_second x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x3 (Curry_Prelude.nd_C_apply x1 x4 s0 cd
    cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_second x1 l s cd
    cs) (nd_C_second x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_second x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_second x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.Internal.second" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal.second" (showCons x2))

nd_C__case_11 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0)) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.C_Maybe t0 -> C_InternalTrie t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_11 x5 x1 x4 x3 s cd cs = case x3 of
  C_InternalTrie x6 x7 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Maybe_hash_0_hash_hash
    x1 x4 x6 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1)))) x5 x7 s1 cd cs) cd cs))
  Choice_C_InternalTrie d i l r -> narrow d i (nd_C__case_11 x5 x1 x4 l s cd cs)
    (nd_C__case_11 x5 x1 x4 r s cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> nd_C__case_11 x5 x1 x4
    z s cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> nd_C__case_11 x5 x1 x4 e s
    cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._case_11" [show x5, show x1, show x4, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_11" (showCons x3))

d_C__case_10 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0))
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Curry_Prelude.C_Maybe t0
  -> C_InternalTrie t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_10 x5 x1 x4 x3 cd cs = case x3 of
  C_InternalTrie x6 x7 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
    x1 x4 x6 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1)) x5 x7 cd cs) cd cs
  Choice_C_InternalTrie d i l r -> narrow d i (d_C__case_10 x5 x1 x4 l cd cs)
    (d_C__case_10 x5 x1 x4 r cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> d_C__case_10 x5 x1 x4 z
    cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> d_C__case_10 x5 x1 x4 e cd
    x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._case_10" [show x5, show x1, show x4, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_10" (showCons x3))

nd_C__case_10 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0)) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.C_Maybe t0 -> C_InternalTrie t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_10 x5 x1 x4 x3 s cd cs = case x3 of
  C_InternalTrie x6 x7 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
    x1 x4 x6 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1)))) x5 x7 s1 cd cs) cd cs))
  Choice_C_InternalTrie d i l r -> narrow d i (nd_C__case_10 x5 x1 x4 l s cd cs)
    (nd_C__case_10 x5 x1 x4 r s cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> nd_C__case_10 x5 x1 x4
    z s cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> nd_C__case_10 x5 x1 x4 e s
    cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._case_10" [show x5, show x1, show x4, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_10" (showCons x3))

d_C__case_9 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0))
  -> Curry_Prelude.C_Maybe t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x3 x2 cd cs = case x2 of
  Curry_Prelude.C_Nothing -> d_C__case_8 x3 cd cs
  Curry_Prelude.C_Just x6 -> Curry_Prelude.C_False
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_9 x3 l cd cs)
    (d_C__case_9 x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_9 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x -> d_C__case_9 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Data.Trie.Internal._case_9" [show x3, show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_9" (showCons x2))

d_C__case_8 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0)) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_8 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_True
  Curry_Prelude.OP_Cons x4 x5 -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_8 l cd cs)
    (d_C__case_8 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_8 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_8 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Trie.Internal._case_8" [show x3] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_8" (showCons x3))

d_C__case_6 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Char
  -> (Curry_Prelude.C_Maybe t0 -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_InternalTrie t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (C_InternalTrie
  t0)
d_C__case_6 x6 x2 x7 x3 cd cs = case x3 of
  C_InternalTrie x8 x9 -> d_C__case_5 x9 x6 x2 x7 x8 (Curry_Prelude.d_C_lookup
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 x9 cd cs) cd cs
  Choice_C_InternalTrie d i l r -> narrow d i (d_C__case_6 x6 x2 x7 l cd cs)
    (d_C__case_6 x6 x2 x7 r cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> d_C__case_6 x6 x2 x7 z
    cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> d_C__case_6 x6 x2 x7 e cd
    x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._case_6" [show x6, show x2, show x7, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_6" (showCons x3))

nd_C__case_6 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Char
  -> Func (Curry_Prelude.C_Maybe t0) t0 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_InternalTrie t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (C_InternalTrie t0)
nd_C__case_6 x6 x2 x7 x3 s cd cs = case x3 of
  C_InternalTrie x8 x9 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_5 x9 x6 x2 x7 x8 (Curry_Prelude.nd_C_lookup
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x6 x9 s0 cd cs) s1 cd cs))
  Choice_C_InternalTrie d i l r -> narrow d i (nd_C__case_6 x6 x2 x7 l s cd cs)
    (nd_C__case_6 x6 x2 x7 r s cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> nd_C__case_6 x6 x2 x7 z
    s cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> nd_C__case_6 x6 x2 x7 e s
    cd x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._case_6" [show x6, show x2, show x7, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_6" (showCons x3))

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0))
  -> Curry_Prelude.C_Char -> (Curry_Prelude.C_Maybe t0 -> Cover -> ConstStore
  -> t0) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe
  t0 -> Curry_Prelude.C_Maybe (C_InternalTrie t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (C_InternalTrie t0)
d_C__case_5 x9 x6 x2 x7 x8 x15 cd cs = case x15 of
  Curry_Prelude.C_Nothing -> let x10 = d_C_singleton' x7
                                   (Curry_Prelude.d_C_apply x2
                                   Curry_Prelude.C_Nothing cd cs) cd cs
    in Curry_Prelude.OP_Tuple2 Curry_Prelude.C_True (C_InternalTrie x8
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x6 x10) x9))
  Curry_Prelude.C_Just x11 -> let x12 = d_C_update' x7 x2 x11 cd cs
                                  x13 = d_OP_update_tick_dot_uscore_hash_selFP2_hash_incr
                                    x12 cd cs
                                  x14 = d_OP_update_tick_dot_uscore_hash_selFP3_hash_t_tick
                                    x12 cd cs
    in Curry_Prelude.OP_Tuple2 x13 (C_InternalTrie x8 (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x6 x14) (Curry_Prelude.d_C_filter
    (d_OP_update_tick_dot_uscore_hash_lambda4 x6) x9 cd cs)))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_5 x9 x6 x2 x7 x8
    l cd cs) (d_C__case_5 x9 x6 x2 x7 x8 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_5 x9
    x6 x2 x7 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x -> d_C__case_5 x9 x6
    x2 x7 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Data.Trie.Internal._case_5" [show x9, show x6, show x2, show x7, show x8
    , show x15] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_5" (showCons x15))

nd_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0))
  -> Curry_Prelude.C_Char -> Func (Curry_Prelude.C_Maybe t0) t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe t0
  -> Curry_Prelude.C_Maybe (C_InternalTrie t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (C_InternalTrie
  t0)
nd_C__case_5 x9 x6 x2 x7 x8 x15 s cd cs = case x15 of
  Curry_Prelude.C_Nothing -> let s0 = s
    in s0 `seq` (let x10 = d_C_singleton' x7 (Curry_Prelude.nd_C_apply x2
                       Curry_Prelude.C_Nothing s0 cd cs) cd cs
    in Curry_Prelude.OP_Tuple2 Curry_Prelude.C_True (C_InternalTrie x8
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x6 x10) x9)))
  Curry_Prelude.C_Just x11 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` (let x12 = nd_C_update' x7 x2 x11 s0 cd cs
                               x13 = d_OP_update_tick_dot_uscore_hash_selFP2_hash_incr
                                 x12 cd cs
                               x14 = d_OP_update_tick_dot_uscore_hash_selFP3_hash_t_tick
                                 x12 cd cs
    in Curry_Prelude.OP_Tuple2 x13 (C_InternalTrie x8 (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x6 x14) (Curry_Prelude.nd_C_filter (wrapDX id
    (d_OP_update_tick_dot_uscore_hash_lambda4 x6)) x9 s1 cd cs))))))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_5 x9 x6 x2 x7
    x8 l s cd cs) (nd_C__case_5 x9 x6 x2 x7 x8 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_5 x9
    x6 x2 x7 x8 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x -> nd_C__case_5 x9 x6
    x2 x7 x8 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Data.Trie.Internal._case_5" [show x9, show x6, show x2, show x7, show x8
    , show x15] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_5" (showCons x15))

d_C__case_7 :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.C_Maybe t0
  -> Cover -> ConstStore -> t0) -> C_InternalTrie t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (C_InternalTrie t0)
d_C__case_7 x2 x3 cd cs = case x3 of
  C_InternalTrie x4 x5 -> Curry_Prelude.OP_Tuple2
    (Data.Curry_Maybe.d_C_isNothing x4 cd cs) (C_InternalTrie
    (Curry_Prelude.d_OP_dollar (acceptCs id Curry_Prelude.C_Just)
    (Curry_Prelude.d_C_apply x2 x4 cd cs) cd cs) x5)
  Choice_C_InternalTrie d i l r -> narrow d i (d_C__case_7 x2 l cd cs)
    (d_C__case_7 x2 r cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> d_C__case_7 x2 z cd cs)
    xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> d_C__case_7 x2 e cd x) $!
    addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._case_7" [show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_7" (showCons x3))

nd_C__case_7 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.C_Maybe t0) t0 -> C_InternalTrie t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (C_InternalTrie
  t0)
nd_C__case_7 x2 x3 s cd cs = case x3 of
  C_InternalTrie x4 x5 -> let s2 = s
    in s2 `seq` Curry_Prelude.OP_Tuple2 (Data.Curry_Maybe.d_C_isNothing x4 cd
    cs) (C_InternalTrie (let s1 = leftSupply s2
                             s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id (acceptCs id
    Curry_Prelude.C_Just)) (Curry_Prelude.nd_C_apply x2 x4 s0 cd cs) s1 cd cs))
    x5)
  Choice_C_InternalTrie d i l r -> narrow d i (nd_C__case_7 x2 l s cd cs)
    (nd_C__case_7 x2 r s cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> nd_C__case_7 x2 z s cd
    cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> nd_C__case_7 x2 e s cd
    x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._case_7" [show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_7" (showCons x3))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Maybe t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char
  (C_InternalTrie t0)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe (C_InternalTrie t0)
d_C__case_4 x3 x4 x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_Prelude_dot_Maybe_hash
    x3 (Curry_Prelude.C_Just (C_InternalTrie Curry_Prelude.C_Nothing x4)) cd cs
  Curry_Prelude.OP_Cons x5 x6 -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_Maybe_hash
    (Curry_Prelude.d_C_lookup
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 x4 cd cs) (d_OP_delete_tick_dot_uscore_hash_lambda9 x5 x6 x4 x3) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 x3 x4 l cd cs)
    (d_C__case_4 x3 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 x3
    x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_4 x3 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Trie.Internal._case_4" [show x3, show x4, show x1] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_4" (showCons x1))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => C_InternalTrie t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char
  (C_InternalTrie t0)) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char
  (C_InternalTrie t0) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char
  (C_InternalTrie t0))
d_C__case_3 x3 x8 x7 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> x8
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x7 x8
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x3 x8 x7 l cd
    cs) (d_C__case_3 x3 x8 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x3 x8
    x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x3 x8 x7
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Trie.Internal._case_3" [show x3, show x8, show x7, show x9] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_3" (showCons x9))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> C_InternalTrie t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe t0
d_C__case_1 x6 x5 x2 cd cs = case x2 of
  C_InternalTrie x7 x8 -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_Maybe_hash
    (Curry_Prelude.d_C_lookup
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 x8 cd cs) (d_C_lookup' x6) cd cs
  Choice_C_InternalTrie d i l r -> narrow d i (d_C__case_1 x6 x5 l cd cs)
    (d_C__case_1 x6 x5 r cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> d_C__case_1 x6 x5 z cd
    cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> d_C__case_1 x6 x5 e cd
    x) $! addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._case_1" [show x6, show x5, show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_1" (showCons x2))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => C_InternalTrie t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Maybe t0
d_C__case_2 x2 cd cs = case x2 of
  C_InternalTrie x3 x4 -> x3
  Choice_C_InternalTrie d i l r -> narrow d i (d_C__case_2 l cd cs) (d_C__case_2
    r cd cs)
  Choices_C_InternalTrie d i xs -> narrows cs d i (\z -> d_C__case_2 z cd cs) xs
  Guard_C_InternalTrie d c e -> guardCons d c ((\x -> d_C__case_2 e cd x) $!
    addCs c cs)
  Fail_C_InternalTrie d info -> failCons d (traceFail
    "Data.Trie.Internal._case_2" [show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_2" (showCons x2))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (C_InternalTrie t0))
  -> Curry_Prelude.C_Maybe t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
d_C__case_0 x3 x2 cd cs = case x2 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap d_OP_toList_tick_dot_uscore_hash_lambda16 cd
    cs) x3 cd cs
  Curry_Prelude.C_Just x4 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    Curry_Prelude.OP_List x4) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap d_OP_toList_tick_dot_uscore_hash_lambda18 cd
    cs) x3 cd cs)
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_0 x3 l cd cs)
    (d_C__case_0 x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_0 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x -> d_C__case_0 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Data.Trie.Internal._case_0" [show x3, show x2] info)
  _ -> failCons cd (consFail "Data.Trie.Internal._case_0" (showCons x2))

