{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Analysis.Curry_Residuation
  ( C_ResiduationInfo (..)
  , d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_typeOf_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , nd_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  , d_C_showResInfo
  , d_C_residuationAnalysis
  , nd_C_residuationAnalysis )
  where

import Basics
import qualified Analysis.Curry_Types
import qualified Data.Curry_List
import qualified Data.Curry_Trie
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude
import qualified RW.Curry_Base
import qualified System.Curry_IO


data C_ResiduationInfo
  = C_MayResiduate
  | C_NoResiduateIf (Curry_Prelude.OP_List Curry_Prelude.C_Int)
  | C_NoResInfo
  | Choice_C_ResiduationInfo Cover ID C_ResiduationInfo C_ResiduationInfo
  | Choices_C_ResiduationInfo Cover ID [C_ResiduationInfo]
  | Fail_C_ResiduationInfo Cover FailInfo
  | Guard_C_ResiduationInfo Cover Constraints C_ResiduationInfo

instance Show C_ResiduationInfo where
  showsPrec d (Choice_C_ResiduationInfo cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_ResiduationInfo cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_ResiduationInfo cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_ResiduationInfo cd info) = showChar '!'
  showsPrec _ C_MayResiduate = showString "MayResiduate"
  showsPrec _ (C_NoResiduateIf x1) = showString "(NoResiduateIf" . (showChar
    ' ' . (shows x1 . showChar ')'))
  showsPrec _ C_NoResInfo = showString "NoResInfo"

instance Read C_ResiduationInfo where
  readsPrec d s = readParen False (\r -> [(C_MayResiduate, r0) | (_, r0) <-
    readQualified "Analysis.Residuation" "MayResiduate" r]) s ++ (readParen ((>)
    d 10) (\r -> [(C_NoResiduateIf x1, r1) | (_, r0) <- readQualified
    "Analysis.Residuation" "NoResiduateIf" r, (x1, r1) <- readsPrec 11 r0]) s ++
    readParen False (\r -> [(C_NoResInfo, r0) | (_, r0) <- readQualified
    "Analysis.Residuation" "NoResInfo" r]) s)

instance NonDet C_ResiduationInfo where
  choiceCons = Choice_C_ResiduationInfo
  choicesCons = Choices_C_ResiduationInfo
  failCons = Fail_C_ResiduationInfo
  guardCons = Guard_C_ResiduationInfo
  try (Choice_C_ResiduationInfo cd i x y) = tryChoice cd i x y
  try (Choices_C_ResiduationInfo cd i xs) = tryChoices cd i xs
  try (Fail_C_ResiduationInfo cd info) = Fail cd info
  try (Guard_C_ResiduationInfo cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_ResiduationInfo cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_ResiduationInfo cd i@(NarrowedID _ _) xs) = f cd
    i xs
  match _ _ f _ _ _ (Choices_C_ResiduationInfo cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_ResiduationInfo cd i _) = error
    ("Analysis.Residuation.ResiduationInfo.match: Choices with ChoiceID " ++
    show i)
  match _ _ _ f _ _ (Fail_C_ResiduationInfo cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_ResiduationInfo cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_ResiduationInfo where
  generate s c = Choices_C_ResiduationInfo c (freeID [0, 1, 0] s)
    [C_MayResiduate, C_NoResiduateIf (generate (leftSupply s) c), C_NoResInfo]

instance NormalForm C_ResiduationInfo where
  ($!!) cont C_MayResiduate d cs = cont C_MayResiduate d cs
  ($!!) cont (C_NoResiduateIf x1) d cs = ($!!) (\y1 d cs -> cont
    (C_NoResiduateIf y1) d cs) x1 d cs
  ($!!) cont C_NoResInfo d cs = cont C_NoResInfo d cs
  ($!!) cont (Choice_C_ResiduationInfo cd i x y) d cs = nfChoice cont cd i x y
    cd cs
  ($!!) cont (Choices_C_ResiduationInfo cd i xs) d cs = nfChoices cont cd i xs d
    cs
  ($!!) cont (Guard_C_ResiduationInfo cd c e) d cs = guardCons cd c (($!!) cont
    e d (addCs c cs))
  ($!!) _ (Fail_C_ResiduationInfo cd info) _ _ = failCons cd info
  ($##) cont C_MayResiduate d cs = cont C_MayResiduate d cs
  ($##) cont (C_NoResiduateIf x1) d cs = ($##) (\y1 d cs -> cont
    (C_NoResiduateIf y1) d cs) x1 d cs
  ($##) cont C_NoResInfo d cs = cont C_NoResInfo d cs
  ($##) cont (Choice_C_ResiduationInfo cd i x y) d cs = gnfChoice cont cd i x y
    cd cs
  ($##) cont (Choices_C_ResiduationInfo cd i xs) d cs = gnfChoices cont cd i xs
    d cs
  ($##) cont (Guard_C_ResiduationInfo cd c e) d cs = guardCons cd c (($##) cont
    e d (addCs c cs))
  ($##) _ (Fail_C_ResiduationInfo cd info) _ _ = failCons cd info
  showCons C_MayResiduate = "Analysis.Residuation.MayResiduate"
  showCons (C_NoResiduateIf _) = "Analysis.Residuation.NoResiduateIf _"
  showCons C_NoResInfo = "Analysis.Residuation.NoResInfo"
  showCons x = error
    ("Analysis.Residuation.ResiduationInfo.showCons: no constructor: " ++ show
    x)
  searchNF _ cont C_MayResiduate = cont C_MayResiduate
  searchNF search cont (C_NoResiduateIf x1) = search (\y1 -> cont
    (C_NoResiduateIf y1)) x1
  searchNF _ cont C_NoResInfo = cont C_NoResInfo
  searchNF _ _ x = error
    ("Analysis.Residuation.ResiduationInfo.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_ResiduationInfo where
  (=.=) C_MayResiduate C_MayResiduate d cs = C_True
  (=.=) (C_NoResiduateIf x1) (C_NoResiduateIf y1) d cs = (=:=) x1 y1 d cs
  (=.=) C_NoResInfo C_NoResInfo d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_MayResiduate C_MayResiduate d cs = C_True
  (=.<=) (C_NoResiduateIf x1) (C_NoResiduateIf y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) C_NoResInfo C_NoResInfo d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_MayResiduate = (i :=: ChooseN 0 0) : concat []
  bind cd i (C_NoResiduateIf x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID
    i) x3]
  bind cd i C_NoResInfo = (i :=: ChooseN 2 0) : concat []
  bind d i (Choice_C_ResiduationInfo cd j x y) = [ConstraintChoice cd j (bind d
    i x) (bind d i y)]
  bind d i (Choices_C_ResiduationInfo cd j@(FreeID _ _) xs) = bindOrNarrow d i
    cd j xs
  bind d i (Choices_C_ResiduationInfo cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_ResiduationInfo cd i _) = error
    ("Analysis.Residuation.ResiduationInfo.bind: Choices with ChoiceID: " ++
    show i)
  bind _ _ (Fail_C_ResiduationInfo cd info) = [Unsolvable info]
  bind d i (Guard_C_ResiduationInfo cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_MayResiduate = (i :=: ChooseN 0 0) : []
  lazyBind cd i (C_NoResiduateIf x3) = (i :=: ChooseN 1 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i C_NoResInfo = (i :=: ChooseN 2 0) : []
  lazyBind d i (Choice_C_ResiduationInfo cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_ResiduationInfo cd j@(FreeID _ _) xs) =
    lazyBindOrNarrow d i cd j xs
  lazyBind d i (Choices_C_ResiduationInfo cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_ResiduationInfo cd i _) = error
    ("Analysis.Residuation.ResiduationInfo.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_ResiduationInfo cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_ResiduationInfo cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_ResiduationInfo where

d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite
  C_ResiduationInfo
d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite (acceptCs
    id
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)
    (acceptCs (acceptCs id)
    d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)
    (acceptCs (acceptCs (acceptCs id))
    d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)
    d_OP_uscore_impl_hash_typeOf_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    (d_OP_uscore_impl_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs)
    (d_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs)
    (d_OP_uscore_impl_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l cd cs)
    (d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Residuation._inst#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._inst#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore
  -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite C_ResiduationInfo
nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` RW.Curry_Base.HO_OP_uscore_Dict_hash_ReadWrite (wrapDX (wrapDX
    id) (acceptCs id
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash))
    (wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
    nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash))
    (wrapDX (wrapDX (wrapDX (wrapDX id))) (acceptCs (acceptCs (acceptCs id))
    d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash))
    (wrapDX id
    d_OP_uscore_impl_hash_typeOf_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs))
    (nd_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    s0 cd cs) (wrapDX (wrapDX (wrapDX (wrapDX id)))
    (d_OP_uscore_impl_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Residuation._inst#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._inst#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Data.Curry_Trie.C_Trie
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  C_ResiduationInfo (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_25 x4 x1 x3 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Residuation._impl#readRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#readRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    (showCons x2))

d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP2_hash_a_tick :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP2_hash_a_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP2_hash_a_tick
    l cd cs)
    (d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP2_hash_a_tick
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP2_hash_a_tick
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP2_hash_a_tick
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._impl#readRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP2#a'"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#readRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP2#a'"
    (showCons x1))

d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP3_hash_r1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP3_hash_r1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP3_hash_r1
    l cd cs)
    (d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP3_hash_r1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP3_hash_r1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP3_hash_r1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._impl#readRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP3#r1"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#readRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP3#r1"
    (showCons x1))

d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: RW.Curry_Base.C_RWParameters
  -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_ResiduationInfo -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 x2 x3 cd cs =
  case x3 of
  C_MayResiduate -> Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showChar cd cs) (Curry_Prelude.C_Char '0'#) cd cs)
  C_NoResiduateIf x4 -> let x5 = Curry_Prelude.d_C_apply
                              (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
                              (RW.Curry_Base.d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
                              RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Int_hash
                              cd cs) x1 cd cs) x2 cd cs) x4 cd cs
                            x6 = d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1
                              x5 cd cs
                            x7 = d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1
                              x5 cd cs
    in Curry_Prelude.OP_Tuple2 x6 (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_showChar cd cs)
    (Curry_Prelude.C_Char '1'#) cd cs) x7 cd cs)
  C_NoResInfo -> Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showChar cd cs) (Curry_Prelude.C_Char '2'#) cd cs)
  Choice_C_ResiduationInfo d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 l cd cs)
    (d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 z cd cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 e cd x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    (showCons x3))

nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: RW.Curry_Base.C_RWParameters
  -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_ResiduationInfo -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 x2 x3 s cd cs =
  case x3 of
  C_MayResiduate -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.nd_C_apply (wrapDX
    (wrapDX id) (Curry_Prelude.d_C_showChar cd cs)) (Curry_Prelude.C_Char '0'#)
    s0 cd cs)
  C_NoResiduateIf x4 -> let s12 = s
    in s12 `seq` (let s13 = leftSupply s12
                      s14 = rightSupply s12
                      s6 = leftSupply s13
                      s7 = rightSupply s13
                      s8 = leftSupply s14
                      s11 = rightSupply s14
    in s13 `seq` (s14 `seq` (s6 `seq` (s7 `seq` (s8 `seq` (s11 `seq`
    (let x5 = let s5 = leftSupply s6
                  s4 = rightSupply s6
           in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply
                                                                 s4
                                                               s2 = rightSupply
                                                                 s4
           in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply
                                                                 s2
                                                               s0 = rightSupply
                                                                 s2
           in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
           (RW.Curry_Base.nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
           (wrapNX id
           RW.Curry_Base.nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Int_hash)
           s0 cd cs) x1 s1 cd cs)) x2 s3 cd cs)) x4 s5 cd cs)
         x6 = nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1
           x5 s7 cd cs
         x7 = nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1
           x5 s8 cd cs
    in Curry_Prelude.OP_Tuple2 x6 (let s10 = leftSupply s11
                                       s9 = rightSupply s11
    in s10 `seq` (s9 `seq` Curry_Prelude.nd_OP_dot (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id) (Curry_Prelude.d_C_showChar cd cs))
    (Curry_Prelude.C_Char '1'#) s9 cd cs) x7 s10 cd cs)))))))))
  C_NoResInfo -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.nd_C_apply (wrapDX
    (wrapDX id) (Curry_Prelude.d_C_showChar cd cs)) (Curry_Prelude.C_Char '2'#)
    s0 cd cs)
  Choice_C_ResiduationInfo d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 l s cd cs)
    (nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 r s cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 z s cd cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 e s cd x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    (showCons x3))

d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1 :: Curry_Prelude.OP_Tuple2
  (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1
    l cd cs)
    (d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP5#strs1"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP5#strs1"
    (showCons x1))

nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1 :: Curry_Prelude.OP_Tuple2
  (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1 x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1
    l s cd cs)
    (nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP5_hash_strs1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP5#strs1"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP5#strs1"
    (showCons x1))

d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1 :: Curry_Prelude.OP_Tuple2
  (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1
    l cd cs)
    (d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP6#show1"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP6#show1"
    (showCons x1))

nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1 :: Curry_Prelude.OP_Tuple2
  (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1 x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1
    l s cd cs)
    (nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP6_hash_show1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP6#show1"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#showRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#._#selFP6#show1"
    (showCons x1))

d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: RW.Curry_Base.C_RWParameters
  -> System.Curry_IO.C_Handle -> C_ResiduationInfo -> Data.Curry_Trie.C_Trie
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 x2 x3 x4 cd cs =
  case x3 of
  C_MayResiduate -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hPutChar x2 (Curry_Prelude.C_Char '0'#) cd cs)
    cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) x4 cd cs) cd cs
  C_NoResiduateIf x5 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hPutChar x2 (Curry_Prelude.C_Char '1'#) cd cs)
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (RW.Curry_Base.d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
    RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Int_hash
    cd cs) x1 cd cs) x2 cd cs) x5 cd cs) x4 cd cs) cd cs
  C_NoResInfo -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hPutChar x2 (Curry_Prelude.C_Char '2'#) cd cs)
    cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) x4 cd cs) cd cs
  Choice_C_ResiduationInfo d i l r -> narrow d i
    (d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 l x4 cd cs)
    (d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 r x4 cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 z x4 cd cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 x2 e x4 cd x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._impl#writeRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#writeRW#RW.Base.ReadWrite#Analysis.Residuation.ResiduationInfo#"
    (showCons x3))

d_OP_uscore_impl_hash_typeOf_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: C_ResiduationInfo
  -> Cover -> ConstStore -> RW.Curry_Base.C_RWType
d_OP_uscore_impl_hash_typeOf_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 cd cs =
  RW.Curry_Base.d_C_monoRWType (Curry_Prelude.toCurryString "ResiduationInfo")
  cd cs

d_OP_uscore_impl_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Cover
  -> ConstStore -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_ResiduationInfo) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_uscore_impl_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash cd cs =
  acceptCs id
  (RW.Curry_Base.d_OP_uscore_def_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite
  d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)

d_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Cover
  -> ConstStore -> RW.Curry_Base.C_RWParameters -> Cover -> ConstStore
  -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_ResiduationInfo -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Data.Curry_Trie.C_Trie
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash cd cs =
  acceptCs (acceptCs id)
  (RW.Curry_Base.d_OP_uscore_def_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite
  d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)

nd_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: IDSupply
  -> Cover -> ConstStore -> Func RW.Curry_Base.C_RWParameters (Func
  (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  (Curry_Prelude.OP_List C_ResiduationInfo) (Curry_Prelude.OP_Tuple2
  (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))))
nd_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash s cd cs =
  wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  (RW.Curry_Base.nd_OP_uscore_def_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite
  (wrapNX id
  nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)))

d_OP_uscore_impl_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Cover
  -> ConstStore -> RW.Curry_Base.C_RWParameters -> Cover -> ConstStore
  -> System.Curry_IO.C_Handle -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_ResiduationInfo -> Cover -> ConstStore -> Data.Curry_Trie.C_Trie
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash cd cs =
  acceptCs (acceptCs (acceptCs id))
  (RW.Curry_Base.d_OP_uscore_def_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite
  d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_ResiduationInfo
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Residuation._inst#Prelude.Data#Analysis.Residuation.ResiduationInfo#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._inst#Prelude.Data#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: C_ResiduationInfo
  -> C_ResiduationInfo -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 x2 s cd cs =
  case x1 of
  C_MayResiduate -> d_C__case_24 x2 cd cs
  C_NoResiduateIf x4 -> let s0 = s in s0 `seq` nd_C__case_23 x4 x2 s0 cd cs
  C_NoResInfo -> d_C__case_22 x2 cd cs
  Choice_C_ResiduationInfo d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r x2 s cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z x2 s cd cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._impl#===#Prelude.Data#Analysis.Residuation.ResiduationInfo#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#===#Prelude.Data#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: IDSupply
  -> Cover -> ConstStore -> C_ResiduationInfo
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s1 = leftSupply s2
                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice C_MayResiduate (C_NoResiduateIf
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  s0 cd cs)) s1 cd cs)) C_NoResInfo s3 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_ResiduationInfo
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Residuation._inst#Prelude.Show#Analysis.Residuation.ResiduationInfo#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._inst#Prelude.Show#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_ResiduationInfo
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Residuation._inst#Prelude.Show#Analysis.Residuation.ResiduationInfo#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._inst#Prelude.Show#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Cover
  -> ConstStore -> C_ResiduationInfo -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.C_Int
  -> C_ResiduationInfo -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 x2 cd cs =
  case x2 of
  C_MayResiduate -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "MayResiduate")
  C_NoResiduateIf x3 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "NoResiduateIf ")) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (11)) cd cs) x3 cd cs) cd cs) cd cs
  C_NoResInfo -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "NoResInfo")
  Choice_C_ResiduationInfo d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 z cd cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._impl#showsPrec#Prelude.Show#Analysis.Residuation.ResiduationInfo#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#showsPrec#Prelude.Show#Analysis.Residuation.ResiduationInfo#"
    (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_ResiduationInfo -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  cd cs

d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read
  C_ResiduationInfo
d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Read (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Residuation._inst#Prelude.Read#Analysis.Residuation.ResiduationInfo#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._inst#Prelude.Read#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read
  C_ResiduationInfo
nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Read (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash))
    (wrapDX id
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Residuation._inst#Prelude.Read#Analysis.Residuation.ResiduationInfo#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._inst#Prelude.Read#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ResiduationInfo
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_readParen Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda1
  cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_readParen (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs)
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6
  cd cs) x2 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_readParen
  Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda15
  cd cs) x2 cd cs) cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_ResiduationInfo (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda1 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ResiduationInfo (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ResiduationInfo (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_21 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "MayResiduate")
    cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._impl#readsPrec#Prelude.Read#Analysis.Residuation.ResiduationInfo#._#lambda1._#lambda4"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#readsPrec#Prelude.Read#Analysis.Residuation.ResiduationInfo#._#lambda1._#lambda4"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_ResiduationInfo (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ResiduationInfo (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ResiduationInfo (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_20 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "NoResiduateIf")
    cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._impl#readsPrec#Prelude.Read#Analysis.Residuation.ResiduationInfo#._#lambda6._#lambda9"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#readsPrec#Prelude.Read#Analysis.Residuation.ResiduationInfo#._#lambda6._#lambda9"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ResiduationInfo (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ResiduationInfo (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 (C_NoResiduateIf x3) x4) x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._impl#readsPrec#Prelude.Read#Analysis.Residuation.ResiduationInfo#._#lambda6._#lambda9._#lambda13"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#readsPrec#Prelude.Read#Analysis.Residuation.ResiduationInfo#._#lambda6._#lambda9._#lambda13"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda15 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_ResiduationInfo (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda15 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda15_dot_uscore_hash_lambda18)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda15_dot_uscore_hash_lambda18 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ResiduationInfo (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ResiduationInfo (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda15_dot_uscore_hash_lambda18 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_19 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "NoResInfo") cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda15_dot_uscore_hash_lambda18
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda15_dot_uscore_hash_lambda18
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda15_dot_uscore_hash_lambda18
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda15_dot_uscore_hash_lambda18
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._impl#readsPrec#Prelude.Read#Analysis.Residuation.ResiduationInfo#._#lambda15._#lambda18"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#readsPrec#Prelude.Read#Analysis.Residuation.ResiduationInfo#._#lambda15._#lambda18"
    (showCons x1))

d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_ResiduationInfo) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_readList_hash_Prelude_dot_Read
  d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
  cd cs

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_ResiduationInfo
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Residuation._inst#Prelude.Eq#Analysis.Residuation.ResiduationInfo#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._inst#Prelude.Eq#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_ResiduationInfo
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Residuation._inst#Prelude.Eq#Analysis.Residuation.ResiduationInfo#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._inst#Prelude.Eq#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: C_ResiduationInfo
  -> C_ResiduationInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash x1 x2 cd cs =
  case x1 of
  C_MayResiduate -> d_C__case_18 x2 cd cs
  C_NoResiduateIf x4 -> d_C__case_17 x4 x2 cd cs
  C_NoResInfo -> d_C__case_16 x2 cd cs
  Choice_C_ResiduationInfo d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    r x2 cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    z x2 cd cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._impl#==#Prelude.Eq#Analysis.Residuation.ResiduationInfo#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation._impl#==#Prelude.Eq#Analysis.Residuation.ResiduationInfo#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash :: Cover
  -> ConstStore -> C_ResiduationInfo -> Cover -> ConstStore -> C_ResiduationInfo
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash)

d_C_lubNRI :: C_ResiduationInfo -> C_ResiduationInfo -> Cover -> ConstStore
  -> C_ResiduationInfo
d_C_lubNRI x1 x2 cd cs = case x1 of
  C_MayResiduate -> C_MayResiduate
  C_NoResInfo -> x2
  C_NoResiduateIf x3 -> d_C__case_15 x3 x2 cd cs
  Choice_C_ResiduationInfo d i l r -> narrow d i (d_C_lubNRI l x2 cd cs)
    (d_C_lubNRI r x2 cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z -> d_C_lubNRI z x2 cd
    cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x -> d_C_lubNRI e x2 cd
    x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation.lubNRI" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation.lubNRI" (showCons x1))

d_C_unionS :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_unionS x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_List -> x3
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_14 x4 x1 x5 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_unionS x1 l x3 cd cs)
    (d_C_unionS x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_unionS x1 z
    x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_unionS x1 e x3
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Residuation.unionS" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Analysis.Residuation.unionS" (showCons x2))

nd_C_unionS :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_unionS x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_List -> x3
  Curry_Prelude.OP_Cons x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_14 x4 x1 x5 x3 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_unionS x1 l x3 s cd
    cs) (nd_C_unionS x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_unionS x1 z
    x3 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_unionS x1 e x3
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Residuation.unionS" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Analysis.Residuation.unionS" (showCons x2))

d_C_showResInfo :: Analysis.Curry_Types.C_AOutFormat -> C_ResiduationInfo
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showResInfo x1 x2 cd cs = case x1 of
  Analysis.Curry_Types.C_AText -> d_C__case_10 x2 cd cs
  Analysis.Curry_Types.C_ANote -> d_C__case_7 x2 cd cs
  Analysis.Curry_Types.Choice_C_AOutFormat d i l r -> narrow d i
    (d_C_showResInfo l x2 cd cs) (d_C_showResInfo r x2 cd cs)
  Analysis.Curry_Types.Choices_C_AOutFormat d i xs -> narrows cs d i (\z ->
    d_C_showResInfo z x2 cd cs) xs
  Analysis.Curry_Types.Guard_C_AOutFormat d c e -> guardCons d c ((\x ->
    d_C_showResInfo e x2 cd x) $! addCs c cs)
  Analysis.Curry_Types.Fail_C_AOutFormat d info -> failCons d (traceFail
    "Analysis.Residuation.showResInfo" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation.showResInfo" (showCons x1))

d_C_residuationAnalysis :: Cover -> ConstStore
  -> Analysis.Curry_Types.C_Analysis C_ResiduationInfo
d_C_residuationAnalysis cd cs = Analysis.Curry_Types.d_C_dependencyFuncAnalysis
  (Curry_Prelude.toCurryString "Residuation") C_NoResInfo (acceptCs id
  d_C_nrFunc) cd cs

nd_C_residuationAnalysis :: IDSupply -> Cover -> ConstStore
  -> Analysis.Curry_Types.C_Analysis C_ResiduationInfo
nd_C_residuationAnalysis s cd cs = let s0 = s
  in s0 `seq` Analysis.Curry_Types.nd_C_dependencyFuncAnalysis
  (Curry_Prelude.toCurryString "Residuation") C_NoResInfo (wrapDX (wrapDX id)
  (acceptCs id d_C_nrFunc)) s0 cd cs

d_C_nrFunc :: FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  C_ResiduationInfo) -> Cover -> ConstStore -> C_ResiduationInfo
d_C_nrFunc x1 x2 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Func x3 x4 x5 x6 x7 -> d_C_nrFuncRule x3 x4 x2 x7 cd
    cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i (d_C_nrFunc l x2
    cd cs) (d_C_nrFunc r x2 cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_C_nrFunc z x2 cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c ((\x ->
    d_C_nrFunc e x2 cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "Analysis.Residuation.nrFunc" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation.nrFunc" (showCons x1))

d_C_nrFuncRule :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) C_ResiduationInfo)
  -> FlatCurry.Curry_Types.C_Rule -> Cover -> ConstStore -> C_ResiduationInfo
d_C_nrFuncRule x1 x2 x3 x4 cd cs = case x4 of
  FlatCurry.Curry_Types.C_External x5 -> C_NoResiduateIf
    (Curry_Prelude.d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (1)) x2 cd cs)
  FlatCurry.Curry_Types.C_Rule x6 x7 -> d_OP_nrFuncRule_dot_nrExp_dot_52 x3
    (Curry_Prelude.d_C_map d_OP_nrFuncRule_dot_uscore_hash_lambda26 x6 cd cs) x7
    cd cs
  FlatCurry.Curry_Types.Choice_C_Rule d i l r -> narrow d i (d_C_nrFuncRule x1
    x2 x3 l cd cs) (d_C_nrFuncRule x1 x2 x3 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Rule d i xs -> narrows cs d i (\z ->
    d_C_nrFuncRule x1 x2 x3 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Rule d c e -> guardCons d c ((\x ->
    d_C_nrFuncRule x1 x2 x3 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Rule d info -> failCons d (traceFail
    "Analysis.Residuation.nrFuncRule" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Analysis.Residuation.nrFuncRule" (showCons x4))

d_OP_nrFuncRule_dot_nrExp_dot_52 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  C_ResiduationInfo) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int C_ResiduationInfo) -> FlatCurry.Curry_Types.C_Expr
  -> Cover -> ConstStore -> C_ResiduationInfo
d_OP_nrFuncRule_dot_nrExp_dot_52 x1 x2 x3 cd cs = case x3 of
  FlatCurry.Curry_Types.C_Lit x4 -> C_NoResiduateIf Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Var x5 -> Curry_Prelude.d_C_maybe C_MayResiduate
    Curry_Prelude.d_C_id (Curry_Prelude.d_C_lookup
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x5 x2 cd cs) cd cs
  FlatCurry.Curry_Types.C_Comb x6 x7 x8 -> let x9 = d_C__case_4 x8 x2 x1
                                                 (Curry_Prelude.d_C_null x8 cd
                                                 cs) cd cs
    in d_C__case_5 x9 x1 x7 x2 x8 x6 cd cs
  FlatCurry.Curry_Types.C_Case x12 x13 x14 -> let x15 = d_OP_nrFuncRule_dot_nrExp_dot_52
                                                    x1 x2 x13 cd cs
    in Curry_Prelude.d_C_foldr (acceptCs id d_C_lubNRI) x15
    (Curry_Prelude.d_C_map (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_nrBranch_dot_87
    x15 x2 x1) x14 cd cs) cd cs
  FlatCurry.Curry_Types.C_Free x16 x17 -> d_OP_nrFuncRule_dot_nrExp_dot_52 x1 x2
    x17 cd cs
  FlatCurry.Curry_Types.C_Let x18 x19 -> let x20 = Curry_Prelude.d_OP_plus_plus
                                               (Curry_Prelude.d_C_map
                                               d_OP_nrFuncRule_dot_nrExp_dot_52_dot_uscore_hash_lambda25
                                               x18 cd cs) x2 cd cs
    in d_OP_nrFuncRule_dot_nrExp_dot_52 x1
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_addBindings_dot_100 x1 x20 x18 cd cs)
    x19 cd cs
  FlatCurry.Curry_Types.C_Or x21 x22 -> d_C_lubNRI
    (d_OP_nrFuncRule_dot_nrExp_dot_52 x1 x2 x21 cd cs)
    (d_OP_nrFuncRule_dot_nrExp_dot_52 x1 x2 x22 cd cs) cd cs
  FlatCurry.Curry_Types.C_Typed x23 x24 -> d_OP_nrFuncRule_dot_nrExp_dot_52 x1
    x2 x23 cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i
    (d_OP_nrFuncRule_dot_nrExp_dot_52 x1 x2 l cd cs)
    (d_OP_nrFuncRule_dot_nrExp_dot_52 x1 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_OP_nrFuncRule_dot_nrExp_dot_52 x1 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x ->
    d_OP_nrFuncRule_dot_nrExp_dot_52 x1 x2 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "Analysis.Residuation.nrFuncRule.nrExp.52" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Analysis.Residuation.nrFuncRule.nrExp.52"
    (showCons x3))

d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResArgs_dot_60 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int C_ResiduationInfo) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  C_ResiduationInfo) -> C_ResiduationInfo -> Cover -> ConstStore
  -> C_ResiduationInfo
d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResArgs_dot_60 x1 x2 x3 x4 cd cs =
  case x4 of
  C_NoResInfo -> C_NoResInfo
  C_MayResiduate -> C_MayResiduate
  C_NoResiduateIf x5 -> d_C__case_3 x5 x3 x2 x1 (Curry_Prelude.d_C_null x5 cd
    cs) cd cs
  Choice_C_ResiduationInfo d i l r -> narrow d i
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResArgs_dot_60 x1 x2 x3 l cd
    cs) (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResArgs_dot_60 x1 x2 x3 r
    cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z ->
    d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResArgs_dot_60 x1 x2 x3 z cd
    cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x ->
    d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResArgs_dot_60 x1 x2 x3 e cd
    x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation.nrFuncRule.nrExp.52.checkNonResArgs.60" [show x1, show
    x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation.nrFuncRule.nrExp.52.checkNonResArgs.60" (showCons x4))

d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResArgs_dot_60_dot_uscore_hash_lambda21 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int C_ResiduationInfo) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  C_ResiduationInfo) -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> C_ResiduationInfo
d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResArgs_dot_60_dot_uscore_hash_lambda21 x1 x2 x3 x4 cd cs =
  d_OP_nrFuncRule_dot_nrExp_dot_52 x3 x2 (Curry_Prelude.d_OP_bang_bang x1
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  x4 (Curry_Prelude.C_Int (1)) cd cs) cd cs) cd cs

d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResPartArgs_dot_60 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int C_ResiduationInfo) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  C_ResiduationInfo) -> C_ResiduationInfo -> Cover -> ConstStore
  -> C_ResiduationInfo
d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResPartArgs_dot_60 x1 x2 x3 x4 cd cs =
  case x4 of
  C_NoResInfo -> C_NoResInfo
  C_MayResiduate -> C_MayResiduate
  C_NoResiduateIf x5 -> let x6 = Curry_Prelude.d_C_filter
                              (Curry_Prelude.d_C_flip (acceptCs id
                              Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash)
                              (Curry_Prelude.d_C_length x1 cd cs)) x5 cd cs
    in d_C__case_2 x6 x3 x2 x1 (Curry_Prelude.d_C_null x6 cd cs) cd cs
  Choice_C_ResiduationInfo d i l r -> narrow d i
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResPartArgs_dot_60 x1 x2 x3 l
    cd cs) (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResPartArgs_dot_60 x1
    x2 x3 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z ->
    d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResPartArgs_dot_60 x1 x2 x3 z
    cd cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x ->
    d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResPartArgs_dot_60 x1 x2 x3 e
    cd x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation.nrFuncRule.nrExp.52.checkNonResPartArgs.60" [show x1
    , show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation.nrFuncRule.nrExp.52.checkNonResPartArgs.60" (showCons
    x4))

d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResPartArgs_dot_60_dot_uscore_hash_lambda22 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int C_ResiduationInfo) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  C_ResiduationInfo) -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> C_ResiduationInfo
d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResPartArgs_dot_60_dot_uscore_hash_lambda22 x1 x2 x3 x4 cd cs =
  d_OP_nrFuncRule_dot_nrExp_dot_52 x3 x2 (Curry_Prelude.d_OP_bang_bang x1
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  x4 (Curry_Prelude.C_Int (1)) cd cs) cd cs) cd cs

d_OP_nrFuncRule_dot_nrExp_dot_52_dot_nrBranch_dot_87 :: C_ResiduationInfo
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  C_ResiduationInfo) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) C_ResiduationInfo)
  -> FlatCurry.Curry_Types.C_BranchExpr -> Cover -> ConstStore
  -> C_ResiduationInfo
d_OP_nrFuncRule_dot_nrExp_dot_52_dot_nrBranch_dot_87 x1 x2 x3 x4 cd cs =
  case x4 of
  FlatCurry.Curry_Types.C_Branch x5 x6 -> d_C__case_1 x6 x2 x1 x3 x5 cd cs
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_nrBranch_dot_87 x1 x2 x3 l cd cs)
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_nrBranch_dot_87 x1 x2 x3 r cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    d_OP_nrFuncRule_dot_nrExp_dot_52_dot_nrBranch_dot_87 x1 x2 x3 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    d_OP_nrFuncRule_dot_nrExp_dot_52_dot_nrBranch_dot_87 x1 x2 x3 e cd x) $!
    addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "Analysis.Residuation.nrFuncRule.nrExp.52.nrBranch.87" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation.nrFuncRule.nrExp.52.nrBranch.87" (showCons x4))

d_OP_nrFuncRule_dot_nrExp_dot_52_dot_nrBranch_dot_87_dot_uscore_hash_lambda24 :: C_ResiduationInfo
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int C_ResiduationInfo
d_OP_nrFuncRule_dot_nrExp_dot_52_dot_nrBranch_dot_87_dot_uscore_hash_lambda24 x1 x2 cd cs =
  Curry_Prelude.OP_Tuple2 x2 x1

d_OP_nrFuncRule_dot_nrExp_dot_52_dot_addBindings_dot_100 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  C_ResiduationInfo) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int C_ResiduationInfo) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int C_ResiduationInfo)
d_OP_nrFuncRule_dot_nrExp_dot_52_dot_addBindings_dot_100 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_0 x5 x2 x1 x4 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_addBindings_dot_100 x1 x2 l cd cs)
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_addBindings_dot_100 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_nrFuncRule_dot_nrExp_dot_52_dot_addBindings_dot_100 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_nrFuncRule_dot_nrExp_dot_52_dot_addBindings_dot_100 x1 x2 e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Residuation.nrFuncRule.nrExp.52.addBindings.100" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation.nrFuncRule.nrExp.52.addBindings.100" (showCons x3))

d_OP_nrFuncRule_dot_nrExp_dot_52_dot_uscore_hash_lambda25 :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int C_ResiduationInfo
d_OP_nrFuncRule_dot_nrExp_dot_52_dot_uscore_hash_lambda25 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.OP_Tuple2 x2 C_NoResInfo
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_uscore_hash_lambda25 l cd cs)
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_uscore_hash_lambda25 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_nrFuncRule_dot_nrExp_dot_52_dot_uscore_hash_lambda25 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_nrFuncRule_dot_nrExp_dot_52_dot_uscore_hash_lambda25 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation.nrFuncRule.nrExp.52._#lambda25" [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Residuation.nrFuncRule.nrExp.52._#lambda25" (showCons x1))

d_OP_nrFuncRule_dot_uscore_hash_lambda26 :: Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int C_ResiduationInfo
d_OP_nrFuncRule_dot_uscore_hash_lambda26 x1 cd cs = Curry_Prelude.OP_Tuple2 x1
  (C_NoResiduateIf (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List))

d_C_prelude :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_prelude cd cs = Curry_Prelude.toCurryString "Prelude"

d_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  C_ResiduationInfo (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_25 x4 x1 x3 cd cs = case x3 of
  (Curry_Prelude.C_Char '0'#) -> Curry_Prelude.OP_Tuple2 C_MayResiduate x4
  (Curry_Prelude.C_Char '1'#) -> let x5 = Curry_Prelude.d_C_apply
                                       (Curry_Prelude.d_C_apply
                                       (RW.Curry_Base.d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
                                       RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Int_hash
                                       cd cs) x1 cd cs) x4 cd cs
                                     x6 = d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP2_hash_a_tick
                                       x5 cd cs
                                     x7 = d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP3_hash_r1
                                       x5 cd cs
    in Curry_Prelude.OP_Tuple2 (C_NoResiduateIf x6) x7
  (Curry_Prelude.C_Char '2'#) -> Curry_Prelude.OP_Tuple2 C_NoResInfo x4
  Curry_Prelude.CurryChar l -> matchChar [('0', Curry_Prelude.OP_Tuple2
    C_MayResiduate x4), ('1', let x5 = Curry_Prelude.d_C_apply
                                    (Curry_Prelude.d_C_apply
                                    (RW.Curry_Base.d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
                                    RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Int_hash
                                    cd cs) x1 cd cs) x4 cd cs
                                  x6 = d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP2_hash_a_tick
                                    x5 cd cs
                                  x7 = d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_selFP3_hash_r1
                                    x5 cd cs
    in Curry_Prelude.OP_Tuple2 (C_NoResiduateIf x6) x7), ('2'
    , Curry_Prelude.OP_Tuple2 C_NoResInfo x4)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_25 x4 x1 l cd cs)
    (d_C__case_25 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_25 x4
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_25 x4 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "Analysis.Residuation._case_25" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_25" (showCons x3))

d_C__case_22 :: C_ResiduationInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_22 x2 cd cs = case x2 of
  C_MayResiduate -> Curry_Prelude.C_False
  C_NoResiduateIf x6 -> Curry_Prelude.C_False
  C_NoResInfo -> Curry_Prelude.C_True
  Choice_C_ResiduationInfo d i l r -> narrow d i (d_C__case_22 l cd cs)
    (d_C__case_22 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z -> d_C__case_22 z cd
    cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x -> d_C__case_22 e cd x) $!
    addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._case_22" [show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_22" (showCons x2))

nd_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Int -> C_ResiduationInfo
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_23 x4 x2 s cd cs = case x2 of
  C_MayResiduate -> Curry_Prelude.C_False
  C_NoResiduateIf x5 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
    x4 x5 s0 cd cs
  C_NoResInfo -> Curry_Prelude.C_False
  Choice_C_ResiduationInfo d i l r -> narrow d i (nd_C__case_23 x4 l s cd cs)
    (nd_C__case_23 x4 r s cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z -> nd_C__case_23 x4 z s
    cd cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x -> nd_C__case_23 x4 e s cd
    x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._case_23" [show x4, show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_23" (showCons x2))

d_C__case_24 :: C_ResiduationInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_24 x2 cd cs = case x2 of
  C_MayResiduate -> Curry_Prelude.C_True
  C_NoResiduateIf x3 -> Curry_Prelude.C_False
  C_NoResInfo -> Curry_Prelude.C_False
  Choice_C_ResiduationInfo d i l r -> narrow d i (d_C__case_24 l cd cs)
    (d_C__case_24 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z -> d_C__case_24 z cd
    cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x -> d_C__case_24 e cd x) $!
    addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._case_24" [show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_24" (showCons x2))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ResiduationInfo
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ResiduationInfo
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_21 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    C_MayResiduate x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x3 x2 x4 l cd
    cs) (d_C__case_21 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x3
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x3 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_21" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_21" (showCons x5))

d_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ResiduationInfo
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ResiduationInfo
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_20 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_foldr
    (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_Residuation_dot_ResiduationInfo_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13)
    Curry_Prelude.OP_List (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (11)) cd cs) x4 cd cs) cd cs) x2 cd cs
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x3 x2 x4 l cd
    cs) (d_C__case_20 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x3
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_20 x3 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_20" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_20" (showCons x5))

d_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ResiduationInfo
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ResiduationInfo
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_19 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    C_NoResInfo x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x3 x2 x4 l cd
    cs) (d_C__case_19 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x3
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_19 x3 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_19" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_19" (showCons x5))

d_C__case_16 :: C_ResiduationInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_16 x2 cd cs = case x2 of
  C_MayResiduate -> Curry_Prelude.C_False
  C_NoResiduateIf x6 -> Curry_Prelude.C_False
  C_NoResInfo -> Curry_Prelude.C_True
  Choice_C_ResiduationInfo d i l r -> narrow d i (d_C__case_16 l cd cs)
    (d_C__case_16 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z -> d_C__case_16 z cd
    cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x -> d_C__case_16 e cd x) $!
    addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._case_16" [show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_16" (showCons x2))

d_C__case_17 :: Curry_Prelude.OP_List Curry_Prelude.C_Int -> C_ResiduationInfo
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_17 x4 x2 cd cs = case x2 of
  C_MayResiduate -> Curry_Prelude.C_False
  C_NoResiduateIf x5 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x4 x5 cd cs
  C_NoResInfo -> Curry_Prelude.C_False
  Choice_C_ResiduationInfo d i l r -> narrow d i (d_C__case_17 x4 l cd cs)
    (d_C__case_17 x4 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z -> d_C__case_17 x4 z cd
    cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x -> d_C__case_17 x4 e cd
    x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._case_17" [show x4, show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_17" (showCons x2))

d_C__case_18 :: C_ResiduationInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_18 x2 cd cs = case x2 of
  C_MayResiduate -> Curry_Prelude.C_True
  C_NoResiduateIf x3 -> Curry_Prelude.C_False
  C_NoResInfo -> Curry_Prelude.C_False
  Choice_C_ResiduationInfo d i l r -> narrow d i (d_C__case_18 l cd cs)
    (d_C__case_18 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z -> d_C__case_18 z cd
    cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x -> d_C__case_18 e cd x) $!
    addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._case_18" [show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_18" (showCons x2))

d_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Int -> C_ResiduationInfo
  -> Cover -> ConstStore -> C_ResiduationInfo
d_C__case_15 x3 x2 cd cs = case x2 of
  C_MayResiduate -> C_MayResiduate
  C_NoResInfo -> C_NoResiduateIf x3
  C_NoResiduateIf x4 -> C_NoResiduateIf (d_C_unionS
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    x3 x4 cd cs)
  Choice_C_ResiduationInfo d i l r -> narrow d i (d_C__case_15 x3 l cd cs)
    (d_C__case_15 x3 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z -> d_C__case_15 x3 z cd
    cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x -> d_C__case_15 x3 e cd
    x) $! addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._case_15" [show x3, show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_15" (showCons x2))

d_C__case_14 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_14 x4 x1 x5 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x4 x5
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_13 x6 x4 x1 x7 x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq_hash_0_hash
    x1 cd cs) cd cs) x4 cd cs) x6 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_14 x4 x1 x5 l cd
    cs) (d_C__case_14 x4 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_14 x4
    x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_14 x4 x1
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Residuation._case_14" [show x4, show x1, show x5, show x3] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_14" (showCons x3))

nd_C__case_14 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_14 x4 x1 x5 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x4 x5
  Curry_Prelude.OP_Cons x6 x7 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_13 x6 x4 x1 x7 x5 (let s5 = leftSupply s6
                                                            s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq_hash_0_hash
    x1 s0 cd cs) s1 cd cs)) x4 s3 cd cs)) x6 s5 cd cs)) s7 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_14 x4 x1 x5 l s
    cd cs) (nd_C__case_14 x4 x1 x5 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_14 x4
    x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_14 x4 x1
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Residuation._case_14" [show x4, show x1, show x5, show x3] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_14" (showCons x3))

d_C__case_13 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_13 x6 x4 x1 x7 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x4 (d_C_unionS x1 x5 x7 cd cs)
  Curry_Prelude.C_False -> d_C__case_12 x6 x4 x1 x7 x5 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_lt x1 cd cs) x4 cd cs) x6 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x6 x4 x1 x7 x5
    l cd cs) (d_C__case_13 x6 x4 x1 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x6
    x4 x1 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x6 x4
    x1 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_13" [show x6, show x4, show x1, show x7, show x5
    , show x8] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_13" (showCons x8))

nd_C__case_13 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_13 x6 x4 x1 x7 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons x4 (nd_C_unionS x1 x5 x7 s0 cd cs)
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_12 x6 x4 x1 x7 x5 (let s3 = leftSupply s4
                                                            s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_lt x1 s0
    cd cs) x4 s1 cd cs)) x6 s3 cd cs)) s5 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_13 x6 x4 x1 x7
    x5 l s cd cs) (nd_C__case_13 x6 x4 x1 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_13 x6
    x4 x1 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_13 x6 x4
    x1 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_13" [show x6, show x4, show x1, show x7, show x5
    , show x8] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_13" (showCons x8))

d_C__case_12 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_12 x6 x4 x1 x7 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x4 (d_C_unionS x1 x5
    (Curry_Prelude.OP_Cons x6 x7) cd cs)
  Curry_Prelude.C_False -> d_C__case_11 x6 x4 x1 x7 x5 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_gt x1 cd cs) x4 cd cs) x6 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x6 x4 x1 x7 x5
    l cd cs) (d_C__case_12 x6 x4 x1 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x6
    x4 x1 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x6 x4
    x1 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_12" [show x6, show x4, show x1, show x7, show x5
    , show x8] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_12" (showCons x8))

nd_C__case_12 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_12 x6 x4 x1 x7 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons x4 (nd_C_unionS x1 x5
    (Curry_Prelude.OP_Cons x6 x7) s0 cd cs)
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_11 x6 x4 x1 x7 x5 (let s3 = leftSupply s4
                                                            s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_gt x1 s0
    cd cs) x4 s1 cd cs)) x6 s3 cd cs)) s5 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_12 x6 x4 x1 x7
    x5 l s cd cs) (nd_C__case_12 x6 x4 x1 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_12 x6
    x4 x1 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_12 x6 x4
    x1 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_12" [show x6, show x4, show x1, show x7, show x5
    , show x8] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_12" (showCons x8))

d_C__case_11 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_11 x6 x4 x1 x7 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x6 (d_C_unionS x1
    (Curry_Prelude.OP_Cons x4 x5) x7 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x6 x4 x1 x7 x5
    l cd cs) (d_C__case_11 x6 x4 x1 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x6
    x4 x1 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x6 x4
    x1 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_11" [show x6, show x4, show x1, show x7, show x5
    , show x8] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_11" (showCons x8))

nd_C__case_11 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_11 x6 x4 x1 x7 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons x6 (nd_C_unionS x1 (Curry_Prelude.OP_Cons
    x4 x5) x7 s0 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_11 x6 x4 x1 x7
    x5 l s cd cs) (nd_C__case_11 x6 x4 x1 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_11 x6
    x4 x1 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_11 x6 x4
    x1 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_11" [show x6, show x4, show x1, show x7, show x5
    , show x8] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_11" (showCons x8))

d_C__case_7 :: C_ResiduationInfo -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_7 x2 cd cs = case x2 of
  C_MayResiduate -> Curry_Prelude.toCurryString "residuate"
  C_NoResiduateIf x8 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "non-residuating") (d_C__case_6 x8
    (Curry_Prelude.d_C_null x8 cd cs) cd cs) cd cs
  C_NoResInfo -> Curry_Prelude.toCurryString "???"
  Choice_C_ResiduationInfo d i l r -> narrow d i (d_C__case_7 l cd cs)
    (d_C__case_7 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z -> d_C__case_7 z cd cs)
    xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x -> d_C__case_7 e cd x) $!
    addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._case_7" [show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_7" (showCons x2))

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_6 x8 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " if ") (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString ",") (Curry_Prelude.d_C_map
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x8 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x8 l cd cs)
    (d_C__case_6 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x8 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x8 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_6" [show x8, show x9] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_6" (showCons x9))

d_C__case_10 :: C_ResiduationInfo -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_10 x2 cd cs = case x2 of
  C_MayResiduate -> Curry_Prelude.toCurryString
    "may residuate or has non-ground result"
  C_NoResiduateIf x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "does not residuate") (d_C__case_9 x3 cd cs) cd
    cs
  C_NoResInfo -> Curry_Prelude.toCurryString "unknown residuation behavior"
  Choice_C_ResiduationInfo d i l r -> narrow d i (d_C__case_10 l cd cs)
    (d_C__case_10 r cd cs)
  Choices_C_ResiduationInfo d i xs -> narrows cs d i (\z -> d_C__case_10 z cd
    cs) xs
  Guard_C_ResiduationInfo d c e -> guardCons d c ((\x -> d_C__case_10 e cd x) $!
    addCs c cs)
  Fail_C_ResiduationInfo d info -> failCons d (traceFail
    "Analysis.Residuation._case_10" [show x2] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_10" (showCons x2))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_9 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_8 x3 x4 x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_9 l cd cs)
    (d_C__case_9 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_9 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_9 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Residuation._case_9" [show x3] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_9" (showCons x3))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_8 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " if argument ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x4 cd cs) (Curry_Prelude.toCurryString " is ground") cd cs) cd cs
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " if arguments ") (Curry_Prelude.d_OP_plus_plus
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ",")
    (Curry_Prelude.d_C_map
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) cd cs) (Curry_Prelude.toCurryString " are ground") cd cs)
    cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_8 x3 x4 l cd cs)
    (d_C__case_8 x3 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_8 x3
    x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_8 x3 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Residuation._case_8" [show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_8" (showCons x5))

d_C__case_4 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  C_ResiduationInfo) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) C_ResiduationInfo)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_ResiduationInfo
d_C__case_4 x8 x2 x1 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> C_NoResiduateIf Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_foldr1 (acceptCs id d_C_lubNRI)
    (Curry_Prelude.d_C_map (d_OP_nrFuncRule_dot_nrExp_dot_52 x1 x2) x8 cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x8 x2 x1 l cd
    cs) (d_C__case_4 x8 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x8 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x8 x2 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_4" [show x8, show x2, show x1, show x9] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_4" (showCons x9))

d_C__case_5 :: C_ResiduationInfo -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  C_ResiduationInfo) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  C_ResiduationInfo) -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_CombType -> Cover -> ConstStore
  -> C_ResiduationInfo
d_C__case_5 x9 x1 x7 x2 x8 x6 cd cs = case x6 of
  FlatCurry.Curry_Types.C_FuncCall -> Curry_Prelude.d_C_maybe C_NoResInfo
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResArgs_dot_60 x8 x2 x1)
    (Curry_Prelude.d_C_lookup
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
    x7 x1 cd cs) cd cs
  FlatCurry.Curry_Types.C_FuncPartCall x10 -> Curry_Prelude.d_C_maybe
    C_NoResInfo (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResPartArgs_dot_60
    x8 x2 x1) (Curry_Prelude.d_C_lookup
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
    x7 x1 cd cs) cd cs
  FlatCurry.Curry_Types.C_ConsCall -> x9
  FlatCurry.Curry_Types.C_ConsPartCall x11 -> x9
  FlatCurry.Curry_Types.Choice_C_CombType d i l r -> narrow d i (d_C__case_5 x9
    x1 x7 x2 x8 l cd cs) (d_C__case_5 x9 x1 x7 x2 x8 r cd cs)
  FlatCurry.Curry_Types.Choices_C_CombType d i xs -> narrows cs d i (\z ->
    d_C__case_5 x9 x1 x7 x2 x8 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CombType d c e -> guardCons d c ((\x ->
    d_C__case_5 x9 x1 x7 x2 x8 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CombType d info -> failCons d (traceFail
    "Analysis.Residuation._case_5" [show x9, show x1, show x7, show x2, show x8
    , show x6] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_5" (showCons x6))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) C_ResiduationInfo) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int C_ResiduationInfo)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_ResiduationInfo
d_C__case_3 x5 x3 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> C_NoResiduateIf Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_foldr1 (acceptCs id d_C_lubNRI)
    (Curry_Prelude.d_C_map
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResArgs_dot_60_dot_uscore_hash_lambda21
    x1 x2 x3) x5 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x5 x3 x2 x1 l
    cd cs) (d_C__case_3 x5 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x5 x3
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x5 x3 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_3" [show x5, show x3, show x2, show x1, show x6]
    info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_3" (showCons x6))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) C_ResiduationInfo) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int C_ResiduationInfo)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_ResiduationInfo
d_C__case_2 x6 x3 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> C_NoResiduateIf Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_foldr1 (acceptCs id d_C_lubNRI)
    (Curry_Prelude.d_C_map
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_checkNonResPartArgs_dot_60_dot_uscore_hash_lambda22
    x1 x2 x3) x6 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x6 x3 x2 x1 l
    cd cs) (d_C__case_2 x6 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x6 x3
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x6 x3 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Residuation._case_2" [show x6, show x3, show x2, show x1, show x7]
    info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_2" (showCons x7))

d_C__case_1 :: FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int C_ResiduationInfo)
  -> C_ResiduationInfo -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) C_ResiduationInfo)
  -> FlatCurry.Curry_Types.C_Pattern -> Cover -> ConstStore -> C_ResiduationInfo
d_C__case_1 x6 x2 x1 x3 x5 cd cs = case x5 of
  FlatCurry.Curry_Types.C_LPattern x7 -> d_OP_nrFuncRule_dot_nrExp_dot_52 x3 x2
    x6 cd cs
  FlatCurry.Curry_Types.C_Pattern x8 x9 -> d_OP_nrFuncRule_dot_nrExp_dot_52 x3
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_map
    (d_OP_nrFuncRule_dot_nrExp_dot_52_dot_nrBranch_dot_87_dot_uscore_hash_lambda24
    x1) x9 cd cs) x2 cd cs) x6 cd cs
  FlatCurry.Curry_Types.Choice_C_Pattern d i l r -> narrow d i (d_C__case_1 x6
    x2 x1 x3 l cd cs) (d_C__case_1 x6 x2 x1 x3 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Pattern d i xs -> narrows cs d i (\z ->
    d_C__case_1 x6 x2 x1 x3 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Pattern d c e -> guardCons d c ((\x ->
    d_C__case_1 x6 x2 x1 x3 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Pattern d info -> failCons d (traceFail
    "Analysis.Residuation._case_1" [show x6, show x2, show x1, show x3, show x5]
    info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_1" (showCons x5))

d_C__case_0 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int C_ResiduationInfo)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) C_ResiduationInfo) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  C_ResiduationInfo)
d_C__case_0 x5 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_OP_nrFuncRule_dot_nrExp_dot_52_dot_addBindings_dot_100
    x1 (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x6
    (d_OP_nrFuncRule_dot_nrExp_dot_52 x1 x2 x7 cd cs)) x2) x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_0 x5 x2 x1 l
    cd cs) (d_C__case_0 x5 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_0 x5
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_0 x5 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Residuation._case_0" [show x5, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "Analysis.Residuation._case_0" (showCons x4))

