{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module FlatCurry.Curry_Match
  ( nd_C_withExp, nd_C_funWithExp, nd_C_funWithinExp )
  where

import Basics
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude


nd_C_withExp :: FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Expr
nd_C_withExp x1 s cd cs = let s73 = s
  in s73 `seq` (let s72 = leftSupply s73
                    s74 = rightSupply s73
                    s67 = leftSupply s74
                    s71 = rightSupply s74
  in s72 `seq` (s74 `seq` (s67 `seq` (s71 `seq` choice (let s66 = leftSupply s67
                                                            s68 = rightSupply
                                                              s67
                                                            s45 = leftSupply s68
                                                            s64 = rightSupply
                                                              s68
  in s66 `seq` (s68 `seq` (s45 `seq` (s64 `seq` choice (let s44 = leftSupply s45
                                                            s46 = rightSupply
                                                              s45
                                                            s33 = leftSupply s46
                                                            s42 = rightSupply
                                                              s46
  in s44 `seq` (s46 `seq` (s33 `seq` (s42 `seq` choice (let s32 = leftSupply s33
                                                            s34 = rightSupply
                                                              s33
                                                            s27 = leftSupply s34
                                                            s31 = rightSupply
                                                              s34
  in s32 `seq` (s34 `seq` (s27 `seq` (s31 `seq` choice (let s26 = leftSupply s27
                                                            s28 = rightSupply
                                                              s27
                                                            s10 = leftSupply s28
                                                            s24 = rightSupply
                                                              s28
  in s26 `seq` (s28 `seq` (s10 `seq` (s24 `seq` choice (let s9 = leftSupply s10
                                                            s7 = rightSupply s10
  in s9 `seq` (s7 `seq` choice x1 (let s0 = leftSupply s7
                                       s8 = rightSupply s7
                                       s1 = leftSupply s8
                                       s6 = rightSupply s8
  in s0 `seq` (s8 `seq` (s1 `seq` (s6 `seq` FlatCurry.Curry_Types.C_Comb
  (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_CombType_hash)
  s0 cd cs) (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  s1 cd cs) (let s2 = leftSupply s6
                 s5 = rightSupply s6
  in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))
  s2 cd cs) (let s3 = leftSupply s5
                 s4 = rightSupply s5
  in s3 `seq` (s4 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (nd_C_withExp x1 s3 cd cs) Curry_Prelude.OP_List) (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))
  s4 cd cs) cd cs)) cd cs)))))) s9 cd cs)) (let s23 = leftSupply s24
                                                s25 = rightSupply s24
                                                s13 = leftSupply s25
                                                s22 = rightSupply s25
  in s23 `seq` (s25 `seq` (s13 `seq` (s22 `seq` Curry_Prelude.nd_OP_qmark
  (let s11 = leftSupply s13
       s12 = rightSupply s13
  in s11 `seq` (s12 `seq` FlatCurry.Curry_Types.C_Let
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))))
  s11 cd cs) (nd_C_withExp x1 s12 cd cs))) (let s20 = leftSupply s22
                                                s21 = rightSupply s22
  in s20 `seq` (s21 `seq` FlatCurry.Curry_Types.C_Let (let s14 = leftSupply s20
                                                           s19 = rightSupply s20
  in s14 `seq` (s19 `seq` Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))))
  s14 cd cs) (let s17 = leftSupply s19
                  s18 = rightSupply s19
  in s17 `seq` (s18 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (let s15 = leftSupply s17
       s16 = rightSupply s17
  in s15 `seq` (s16 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_unknown
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  s15 cd cs) (nd_C_withExp x1 s16 cd cs))) Curry_Prelude.OP_List)
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))))
  s18 cd cs) cd cs)) cd cs)) (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  s21 cd cs))) s23 cd cs)))) s26 cd cs)))) (let s29 = leftSupply s31
                                                s30 = rightSupply s31
  in s29 `seq` (s30 `seq` FlatCurry.Curry_Types.C_Free
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)))
  s29 cd cs) (nd_C_withExp x1 s30 cd cs))) s32 cd cs)))) (let s41 = leftSupply
                                                                s42
                                                              s43 = rightSupply
                                                                s42
                                                              s37 = leftSupply
                                                                s43
                                                              s40 = rightSupply
                                                                s43
  in s41 `seq` (s43 `seq` (s37 `seq` (s40 `seq` Curry_Prelude.nd_OP_qmark
  (let s35 = leftSupply s37
       s36 = rightSupply s37
  in s35 `seq` (s36 `seq` FlatCurry.Curry_Types.C_Or (nd_C_withExp x1 s35 cd cs)
  (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  s36 cd cs))) (let s38 = leftSupply s40
                    s39 = rightSupply s40
  in s38 `seq` (s39 `seq` FlatCurry.Curry_Types.C_Or (Curry_Prelude.nd_C_unknown
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  s38 cd cs) (nd_C_withExp x1 s39 cd cs))) s41 cd cs)))) s44 cd cs))))
  (let s63 = leftSupply s64
       s65 = rightSupply s64
       s50 = leftSupply s65
       s61 = rightSupply s65
  in s63 `seq` (s65 `seq` (s50 `seq` (s61 `seq` Curry_Prelude.nd_OP_qmark
  (let s47 = leftSupply s50
       s51 = rightSupply s50
       s48 = leftSupply s51
       s49 = rightSupply s51
  in s47 `seq` (s51 `seq` (s48 `seq` (s49 `seq` FlatCurry.Curry_Types.C_Case
  (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_CaseType_hash)
  s47 cd cs) (nd_C_withExp x1 s48 cd cs) (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_BranchExpr_hash)))
  s49 cd cs))))) (let s52 = leftSupply s61
                      s62 = rightSupply s61
                      s53 = leftSupply s62
                      s60 = rightSupply s62
  in s52 `seq` (s62 `seq` (s53 `seq` (s60 `seq` FlatCurry.Curry_Types.C_Case
  (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_CaseType_hash)
  s52 cd cs) (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  s53 cd cs) (let s54 = leftSupply s60
                  s59 = rightSupply s60
  in s54 `seq` (s59 `seq` Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_BranchExpr_hash)))
  s54 cd cs) (let s57 = leftSupply s59
                  s58 = rightSupply s59
  in s57 `seq` (s58 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (let s55 = leftSupply s57
       s56 = rightSupply s57
  in s55 `seq` (s56 `seq` FlatCurry.Curry_Types.C_Branch
  (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Pattern_hash)
  s55 cd cs) (nd_C_withExp x1 s56 cd cs))) Curry_Prelude.OP_List)
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_BranchExpr_hash)))
  s58 cd cs) cd cs)) cd cs)))))) s63 cd cs)))) s66 cd cs))))
  (let s69 = leftSupply s71
       s70 = rightSupply s71
  in s69 `seq` (s70 `seq` FlatCurry.Curry_Types.C_Typed (nd_C_withExp x1 s69 cd
  cs) (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  s70 cd cs))) s72 cd cs))))

nd_C_funWithExp :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_FuncDecl
nd_C_funWithExp x1 x2 s cd cs = let s6 = s
  in s6 `seq` (let s7 = leftSupply s6
                   s8 = rightSupply s6
                   s0 = leftSupply s7
                   s1 = rightSupply s7
                   s2 = leftSupply s8
                   s5 = rightSupply s8
  in s7 `seq` (s8 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s5 `seq`
  FlatCurry.Curry_Types.C_Func x1 (Curry_Prelude.nd_C_unknown (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  s0 cd cs) (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Visibility_hash)
  s1 cd cs) (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  s2 cd cs) (let s3 = leftSupply s5
                 s4 = rightSupply s5
  in s3 `seq` (s4 `seq` FlatCurry.Curry_Types.C_Rule (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)))
  s3 cd cs) (nd_C_withExp x2 s4 cd cs)))))))))

nd_C_inExp :: FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Expr
nd_C_inExp x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (nd_C__case_0 x3 x2 x1 s0 cd cs)
  (d_C___cond_0_inExp x3 (Curry_Prelude.d_OP_eq_colon_eq x1 x2 cd cs) cd cs) s1
  cd cs))

d_C___cond_0_inExp :: forall . FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Expr
d_C___cond_0_inExp x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C___cond_0_inExp x1 l cd
    cs) (d_C___cond_0_inExp x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_C___cond_0_inExp x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C___cond_0_inExp
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Match.__cond_0_inExp" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Match.__cond_0_inExp" (showCons x2))

nd_C_withElem :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> t0 -> t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_withElem x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` (let x5 = generate s0 cd
                             x6 = generate s1 cd
  in Curry_Prelude.d_OP_plus_plus x5 (Curry_Prelude.OP_Cons x2
  (Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x4
  (Curry_Prelude.d_OP_plus_plus x5 (Curry_Prelude.OP_Cons x3 x6) cd cs) cd cs)
  x6 cd cs)) cd cs)))

nd_C_funWithinExp :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_FuncDecl
nd_C_funWithinExp x1 x2 x3 x4 s cd cs = let s6 = s
  in s6 `seq` (let s7 = leftSupply s6
                   s8 = rightSupply s6
                   s0 = leftSupply s7
                   s1 = rightSupply s7
                   s2 = leftSupply s8
                   s5 = rightSupply s8
  in s7 `seq` (s8 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s5 `seq`
  FlatCurry.Curry_Types.C_Func x1 (Curry_Prelude.nd_C_unknown (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  s0 cd cs) (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Visibility_hash)
  s1 cd cs) (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  s2 cd cs) (let s3 = leftSupply s5
                 s4 = rightSupply s5
  in s3 `seq` (s4 `seq` FlatCurry.Curry_Types.C_Rule (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)))
  s3 cd cs) (nd_C_inExp x2 x3 x4 s4 cd cs)))))))))

nd_C__case_0 :: FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Expr
nd_C__case_0 x3 x2 x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Comb x4 x5 x6 -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` (let x7 = generate s0 cd
    in FlatCurry.Curry_Types.C_Comb x4 x5 (let s2 = leftSupply s3
                                               s1 = rightSupply s3
    in s2 `seq` (s1 `seq` nd_C_withElem (wrapNX id
    FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
    (nd_C_inExp x7 x2 x3 s1 cd cs) x7 x6 s2 cd cs)))))
  FlatCurry.Curry_Types.C_Let x8 x9 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s0 = leftSupply s10
                     s6 = rightSupply s10
    in s8 `seq` (s10 `seq` (s0 `seq` (s6 `seq` choice
    (FlatCurry.Curry_Types.C_Let x8 (nd_C_inExp x9 x2 x3 s0 cd cs))
    (let s1 = leftSupply s6
         s7 = rightSupply s6
         s2 = leftSupply s7
         s5 = rightSupply s7
    in s1 `seq` (s7 `seq` (s2 `seq` (s5 `seq` (let x10 = generate s1 cd
                                                   x11 = generate s2 cd
    in FlatCurry.Curry_Types.C_Let (let s4 = leftSupply s5
                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` nd_C_withElem (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
    (wrapNX id
    FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))
    (Curry_Prelude.OP_Tuple2 x10 (nd_C_inExp x11 x2 x3 s3 cd cs))
    (Curry_Prelude.OP_Tuple2 x10 x11) x8 s4 cd cs)) x9))))) s8 cd cs))))
  FlatCurry.Curry_Types.C_Free x12 x13 -> let s0 = s
    in s0 `seq` FlatCurry.Curry_Types.C_Free x12 (nd_C_inExp x13 x2 x3 s0 cd cs)
  FlatCurry.Curry_Types.C_Or x14 x15 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (FlatCurry.Curry_Types.C_Or
    (nd_C_inExp x14 x2 x3 s0 cd cs) x15) (FlatCurry.Curry_Types.C_Or x14
    (nd_C_inExp x15 x2 x3 s1 cd cs)) s2 cd cs))))
  FlatCurry.Curry_Types.C_Case x16 x17 x18 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s0 = leftSupply s10
                     s6 = rightSupply s10
    in s8 `seq` (s10 `seq` (s0 `seq` (s6 `seq` choice
    (FlatCurry.Curry_Types.C_Case x16 (nd_C_inExp x17 x2 x3 s0 cd cs) x18)
    (let s1 = leftSupply s6
         s7 = rightSupply s6
         s2 = leftSupply s7
         s5 = rightSupply s7
    in s1 `seq` (s7 `seq` (s2 `seq` (s5 `seq` (let x19 = generate s1 cd
                                                   x20 = generate s2 cd
    in FlatCurry.Curry_Types.C_Case x16 x17 (let s4 = leftSupply s5
                                                 s3 = rightSupply s5
    in s4 `seq` (s3 `seq` nd_C_withElem (wrapNX id
    FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_BranchExpr_hash)
    (FlatCurry.Curry_Types.C_Branch x19 (nd_C_inExp x20 x2 x3 s3 cd cs))
    (FlatCurry.Curry_Types.C_Branch x19 x20) x18 s4 cd cs))))))) s8 cd cs))))
  FlatCurry.Curry_Types.C_Typed x21 x22 -> let s0 = s
    in s0 `seq` FlatCurry.Curry_Types.C_Typed (nd_C_inExp x21 x2 x3 s0 cd cs)
    x22
  FlatCurry.Curry_Types.C_Var x23 -> Curry_Prelude.d_C_failed cd cs
  FlatCurry.Curry_Types.C_Lit x24 -> Curry_Prelude.d_C_failed cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (nd_C__case_0 x3 x2
    l s cd cs) (nd_C__case_0 x3 x2 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    nd_C__case_0 x3 x2 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> nd_C__case_0
    x3 x2 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Match._case_0" [show x3, show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Match._case_0" (showCons x1))

