{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Analysis.Curry_TotallyDefined
  ( C_Completeness (..)
  , d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_typeOf_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , nd_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  , d_C_showSibling
  , d_C_siblingCons
  , nd_C_siblingCons
  , d_C_showSiblingAndDecl
  , d_C_siblingConsAndDecl
  , nd_C_siblingConsAndDecl
  , d_C_patCompAnalysis
  , nd_C_patCompAnalysis
  , d_C_showComplete
  , d_C_totalAnalysis
  , nd_C_totalAnalysis
  , d_C_showTotally
  , d_C_showTotalFunc
  , d_C_totalFuncAnalysis
  , nd_C_totalFuncAnalysis )
  where

import Basics
import qualified Analysis.Curry_Deterministic
import qualified Analysis.Curry_ProgInfo
import qualified Analysis.Curry_Types
import qualified Data.Curry_List
import qualified Data.Curry_Trie
import qualified FlatCurry.Curry_Goodies
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude
import qualified RW.Curry_Base
import qualified System.Curry_IO


data C_Completeness
  = C_Complete
  | C_InComplete
  | C_InCompleteOr
  | Choice_C_Completeness Cover ID C_Completeness C_Completeness
  | Choices_C_Completeness Cover ID [C_Completeness]
  | Fail_C_Completeness Cover FailInfo
  | Guard_C_Completeness Cover Constraints C_Completeness

instance Show C_Completeness where
  showsPrec d (Choice_C_Completeness cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Completeness cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Completeness cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Completeness cd info) = showChar '!'
  showsPrec _ C_Complete = showString "Complete"
  showsPrec _ C_InComplete = showString "InComplete"
  showsPrec _ C_InCompleteOr = showString "InCompleteOr"

instance Read C_Completeness where
  readsPrec _ s = readParen False (\r -> [(C_Complete, r0) | (_, r0) <-
    readQualified "Analysis.TotallyDefined" "Complete" r]) s ++ (readParen False
    (\r -> [(C_InComplete, r0) | (_, r0) <- readQualified
    "Analysis.TotallyDefined" "InComplete" r]) s ++ readParen False (\r ->
    [(C_InCompleteOr, r0) | (_, r0) <- readQualified "Analysis.TotallyDefined"
    "InCompleteOr" r]) s)

instance NonDet C_Completeness where
  choiceCons = Choice_C_Completeness
  choicesCons = Choices_C_Completeness
  failCons = Fail_C_Completeness
  guardCons = Guard_C_Completeness
  try (Choice_C_Completeness cd i x y) = tryChoice cd i x y
  try (Choices_C_Completeness cd i xs) = tryChoices cd i xs
  try (Fail_C_Completeness cd info) = Fail cd info
  try (Guard_C_Completeness cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Completeness cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Completeness cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_Completeness cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Completeness cd i _) = error
    ("Analysis.TotallyDefined.Completeness.match: Choices with ChoiceID " ++
    show i)
  match _ _ _ f _ _ (Fail_C_Completeness cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Completeness cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Completeness where
  generate s c = Choices_C_Completeness c (freeID [0, 0, 0] s) [C_Complete
    , C_InComplete, C_InCompleteOr]

instance NormalForm C_Completeness where
  ($!!) cont C_Complete d cs = cont C_Complete d cs
  ($!!) cont C_InComplete d cs = cont C_InComplete d cs
  ($!!) cont C_InCompleteOr d cs = cont C_InCompleteOr d cs
  ($!!) cont (Choice_C_Completeness cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_Completeness cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Completeness cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Completeness cd info) _ _ = failCons cd info
  ($##) cont C_Complete d cs = cont C_Complete d cs
  ($##) cont C_InComplete d cs = cont C_InComplete d cs
  ($##) cont C_InCompleteOr d cs = cont C_InCompleteOr d cs
  ($##) cont (Choice_C_Completeness cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_Completeness cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_Completeness cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Completeness cd info) _ _ = failCons cd info
  showCons C_Complete = "Analysis.TotallyDefined.Complete"
  showCons C_InComplete = "Analysis.TotallyDefined.InComplete"
  showCons C_InCompleteOr = "Analysis.TotallyDefined.InCompleteOr"
  showCons x = error
    ("Analysis.TotallyDefined.Completeness.showCons: no constructor: " ++ show
    x)
  searchNF _ cont C_Complete = cont C_Complete
  searchNF _ cont C_InComplete = cont C_InComplete
  searchNF _ cont C_InCompleteOr = cont C_InCompleteOr
  searchNF _ _ x = error
    ("Analysis.TotallyDefined.Completeness.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_Completeness where
  (=.=) C_Complete C_Complete d cs = C_True
  (=.=) C_InComplete C_InComplete d cs = C_True
  (=.=) C_InCompleteOr C_InCompleteOr d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Complete C_Complete d cs = C_True
  (=.<=) C_InComplete C_InComplete d cs = C_True
  (=.<=) C_InCompleteOr C_InCompleteOr d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Complete = (i :=: ChooseN 0 0) : concat []
  bind cd i C_InComplete = (i :=: ChooseN 1 0) : concat []
  bind cd i C_InCompleteOr = (i :=: ChooseN 2 0) : concat []
  bind d i (Choice_C_Completeness cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_Completeness cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_Completeness cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_Completeness cd i _) = error
    ("Analysis.TotallyDefined.Completeness.bind: Choices with ChoiceID: " ++
    show i)
  bind _ _ (Fail_C_Completeness cd info) = [Unsolvable info]
  bind d i (Guard_C_Completeness cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Complete = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_InComplete = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_InCompleteOr = (i :=: ChooseN 2 0) : []
  lazyBind d i (Choice_C_Completeness cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Completeness cd j@(FreeID _ _) xs) = lazyBindOrNarrow
    d i cd j xs
  lazyBind d i (Choices_C_Completeness cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Completeness cd i _) = error
    ("Analysis.TotallyDefined.Completeness.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_Completeness cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Completeness cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_Completeness where

d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite
  C_Completeness
d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite (acceptCs
    id
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)
    (acceptCs (acceptCs id)
    d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)
    (acceptCs (acceptCs (acceptCs id))
    d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)
    d_OP_uscore_impl_hash_typeOf_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    (d_OP_uscore_impl_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs)
    (d_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs)
    (d_OP_uscore_impl_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l cd cs)
    (d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.TotallyDefined._inst#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._inst#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore
  -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite C_Completeness
nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` RW.Curry_Base.HO_OP_uscore_Dict_hash_ReadWrite (wrapDX (wrapDX
    id) (acceptCs id
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash))
    (wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
    nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash))
    (wrapDX (wrapDX (wrapDX (wrapDX id))) (acceptCs (acceptCs (acceptCs id))
    d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash))
    (wrapDX id
    d_OP_uscore_impl_hash_typeOf_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs))
    (nd_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    s0 cd cs) (wrapDX (wrapDX (wrapDX (wrapDX id)))
    (d_OP_uscore_impl_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.TotallyDefined._inst#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._inst#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Data.Curry_Trie.C_Trie
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  C_Completeness (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_30 x4 x3 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.TotallyDefined._impl#readRW#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._impl#readRW#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    (showCons x2))

d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: RW.Curry_Base.C_RWParameters
  -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_Completeness -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 x2 x3 cd cs =
  case x3 of
  C_Complete -> Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showChar cd cs) (Curry_Prelude.C_Char '0'#) cd cs)
  C_InComplete -> Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showChar cd cs) (Curry_Prelude.C_Char '1'#) cd cs)
  C_InCompleteOr -> Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showChar cd cs) (Curry_Prelude.C_Char '2'#) cd cs)
  Choice_C_Completeness d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 l cd cs)
    (d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 z cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 e cd x) $! addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._impl#showRW#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._impl#showRW#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    (showCons x3))

nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: RW.Curry_Base.C_RWParameters
  -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_Completeness -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 x2 x3 s cd cs =
  case x3 of
  C_Complete -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.nd_C_apply (wrapDX
    (wrapDX id) (Curry_Prelude.d_C_showChar cd cs)) (Curry_Prelude.C_Char '0'#)
    s0 cd cs)
  C_InComplete -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.nd_C_apply (wrapDX
    (wrapDX id) (Curry_Prelude.d_C_showChar cd cs)) (Curry_Prelude.C_Char '1'#)
    s0 cd cs)
  C_InCompleteOr -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.nd_C_apply (wrapDX
    (wrapDX id) (Curry_Prelude.d_C_showChar cd cs)) (Curry_Prelude.C_Char '2'#)
    s0 cd cs)
  Choice_C_Completeness d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 l s cd cs)
    (nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 r s cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 z s cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_showRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 e s cd x) $! addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._impl#showRW#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._impl#showRW#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    (showCons x3))

d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: RW.Curry_Base.C_RWParameters
  -> System.Curry_IO.C_Handle -> C_Completeness -> Data.Curry_Trie.C_Trie
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 x2 x3 x4 cd cs =
  case x3 of
  C_Complete -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hPutChar x2 (Curry_Prelude.C_Char '0'#) cd cs)
    cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) x4 cd cs) cd cs
  C_InComplete -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hPutChar x2 (Curry_Prelude.C_Char '1'#) cd cs)
    cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) x4 cd cs) cd cs
  C_InCompleteOr -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hPutChar x2 (Curry_Prelude.C_Char '2'#) cd cs)
    cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) x4 cd cs) cd cs
  Choice_C_Completeness d i l r -> narrow d i
    (d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 l x4 cd cs)
    (d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 r x4 cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 z x4 cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_writeRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 x2 e x4 cd x) $! addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._impl#writeRW#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._impl#writeRW#RW.Base.ReadWrite#Analysis.TotallyDefined.Completeness#"
    (showCons x3))

d_OP_uscore_impl_hash_typeOf_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: C_Completeness
  -> Cover -> ConstStore -> RW.Curry_Base.C_RWType
d_OP_uscore_impl_hash_typeOf_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 cd cs =
  RW.Curry_Base.d_C_monoRWType (Curry_Prelude.toCurryString "Completeness") cd
  cs

d_OP_uscore_impl_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Cover
  -> ConstStore -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_Completeness) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_uscore_impl_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash cd cs =
  acceptCs id
  (RW.Curry_Base.d_OP_uscore_def_hash_readListRW_hash_RW_dot_Base_dot_ReadWrite
  d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)

d_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Cover
  -> ConstStore -> RW.Curry_Base.C_RWParameters -> Cover -> ConstStore
  -> Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Completeness -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Data.Curry_Trie.C_Trie
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash cd cs =
  acceptCs (acceptCs id)
  (RW.Curry_Base.d_OP_uscore_def_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite
  d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)

nd_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: IDSupply
  -> Cover -> ConstStore -> Func RW.Curry_Base.C_RWParameters (Func
  (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  (Curry_Prelude.OP_List C_Completeness) (Curry_Prelude.OP_Tuple2
  (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))))
nd_OP_uscore_impl_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash s cd cs =
  wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  (RW.Curry_Base.nd_OP_uscore_def_hash_showListRW_hash_RW_dot_Base_dot_ReadWrite
  (wrapNX id
  nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)))

d_OP_uscore_impl_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Cover
  -> ConstStore -> RW.Curry_Base.C_RWParameters -> Cover -> ConstStore
  -> System.Curry_IO.C_Handle -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Completeness -> Cover -> ConstStore -> Data.Curry_Trie.C_Trie
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Data.Curry_Trie.C_Trie (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash cd cs =
  acceptCs (acceptCs (acceptCs id))
  (RW.Curry_Base.d_OP_uscore_def_hash_writeListRW_hash_RW_dot_Base_dot_ReadWrite
  d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Completeness
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.TotallyDefined._inst#Prelude.Data#Analysis.TotallyDefined.Completeness#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._inst#Prelude.Data#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: C_Completeness
  -> C_Completeness -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 x2 cd cs =
  case x1 of
  C_Complete -> d_C__case_29 x2 cd cs
  C_InComplete -> d_C__case_28 x2 cd cs
  C_InCompleteOr -> d_C__case_27 x2 cd cs
  Choice_C_Completeness d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r x2 cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z x2 cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._impl#===#Prelude.Data#Analysis.TotallyDefined.Completeness#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._impl#===#Prelude.Data#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: IDSupply
  -> Cover -> ConstStore -> C_Completeness
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_Complete C_InComplete s0 cd cs)
  C_InCompleteOr s1 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_Completeness
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.TotallyDefined._inst#Prelude.Eq#Analysis.TotallyDefined.Completeness#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._inst#Prelude.Eq#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_Completeness
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.TotallyDefined._inst#Prelude.Eq#Analysis.TotallyDefined.Completeness#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._inst#Prelude.Eq#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: C_Completeness
  -> C_Completeness -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 x2 cd cs =
  case x1 of
  C_Complete -> d_C__case_26 x2 cd cs
  C_InComplete -> d_C__case_25 x2 cd cs
  C_InCompleteOr -> d_C__case_24 x2 cd cs
  Choice_C_Completeness d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r x2 cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z x2 cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._impl#==#Prelude.Eq#Analysis.TotallyDefined.Completeness#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._impl#==#Prelude.Eq#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Cover
  -> ConstStore -> C_Completeness -> Cover -> ConstStore -> C_Completeness
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_Completeness
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.TotallyDefined._inst#Prelude.Show#Analysis.TotallyDefined.Completeness#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._inst#Prelude.Show#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_Completeness
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.TotallyDefined._inst#Prelude.Show#Analysis.TotallyDefined.Completeness#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._inst#Prelude.Show#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Cover
  -> ConstStore -> C_Completeness -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.C_Int
  -> C_Completeness -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 x2 cd cs =
  case x2 of
  C_Complete -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "Complete")
  C_InComplete -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "InComplete")
  C_InCompleteOr -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "InCompleteOr")
  Choice_C_Completeness d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 z cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._impl#showsPrec#Prelude.Show#Analysis.TotallyDefined.Completeness#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._impl#showsPrec#Prelude.Show#Analysis.TotallyDefined.Completeness#"
    (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Completeness -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  cd cs

d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read
  C_Completeness
d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Read (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.TotallyDefined._inst#Prelude.Read#Analysis.TotallyDefined.Completeness#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._inst#Prelude.Read#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read
  C_Completeness
nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Read (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash))
    (wrapDX id
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.TotallyDefined._inst#Prelude.Read#Analysis.TotallyDefined.Completeness#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._inst#Prelude.Read#Analysis.TotallyDefined.Completeness#"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Completeness
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_readParen Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda1
  cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_readParen Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda6
  cd cs) x2 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_readParen
  Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda11
  cd cs) x2 cd cs) cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_Completeness (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda1 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_Completeness (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Completeness
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_23 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "Complete") cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.TotallyDefined._impl#readsPrec#Prelude.Read#Analysis.TotallyDefined.Completeness#._#lambda1._#lambda4"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._impl#readsPrec#Prelude.Read#Analysis.TotallyDefined.Completeness#._#lambda1._#lambda4"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda6 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_Completeness (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda6 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_Completeness (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Completeness
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_22 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "InComplete") cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.TotallyDefined._impl#readsPrec#Prelude.Read#Analysis.TotallyDefined.Completeness#._#lambda6._#lambda9"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._impl#readsPrec#Prelude.Read#Analysis.TotallyDefined.Completeness#._#lambda6._#lambda9"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda11 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_Completeness (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda11 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_Completeness (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Completeness
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_21 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "InCompleteOr")
    cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.TotallyDefined._impl#readsPrec#Prelude.Read#Analysis.TotallyDefined.Completeness#._#lambda11._#lambda14"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined._impl#readsPrec#Prelude.Read#Analysis.TotallyDefined.Completeness#._#lambda11._#lambda14"
    (showCons x1))

d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_Completeness) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_readList_hash_Prelude_dot_Read
  d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  cd cs

d_C_showSibling :: Analysis.Curry_Types.C_AOutFormat -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showSibling x1 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
  cd cs

d_C_siblingCons :: Cover -> ConstStore -> Analysis.Curry_Types.C_Analysis
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int))
d_C_siblingCons cd cs = Analysis.Curry_Types.d_C_simpleConstructorAnalysis
  (Curry_Prelude.toCurryString "SiblingCons") (acceptCs id
  d_OP_siblingCons_dot_consNamesArOfType_dot_5) cd cs

nd_C_siblingCons :: IDSupply -> Cover -> ConstStore
  -> Analysis.Curry_Types.C_Analysis (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int))
nd_C_siblingCons s cd cs = let s0 = s
  in s0 `seq` Analysis.Curry_Types.nd_C_simpleConstructorAnalysis
  (Curry_Prelude.toCurryString "SiblingCons") (wrapDX (wrapDX id) (acceptCs id
  d_OP_siblingCons_dot_consNamesArOfType_dot_5)) s0 cd cs

d_OP_siblingCons_dot_consNamesArOfType_dot_5 :: FlatCurry.Curry_Types.C_ConsDecl
  -> FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int)
d_OP_siblingCons_dot_consNamesArOfType_dot_5 x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Type x3 x4 x5 x6 -> Curry_Prelude.d_C_map
    d_OP_siblingCons_dot_consNamesArOfType_dot_5_dot_uscore_hash_lambda16
    (Curry_Prelude.d_C_filter
    (d_OP_siblingCons_dot_consNamesArOfType_dot_5_dot_uscore_hash_lambda17 x1)
    x6 cd cs) cd cs
  FlatCurry.Curry_Types.C_TypeSyn x7 x8 x9 x10 -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeNew x11 x12 x13 x14 -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i
    (d_OP_siblingCons_dot_consNamesArOfType_dot_5 x1 l cd cs)
    (d_OP_siblingCons_dot_consNamesArOfType_dot_5 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    d_OP_siblingCons_dot_consNamesArOfType_dot_5 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c ((\x ->
    d_OP_siblingCons_dot_consNamesArOfType_dot_5 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "Analysis.TotallyDefined.siblingCons.consNamesArOfType.5" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined.siblingCons.consNamesArOfType.5" (showCons x2))

d_OP_siblingCons_dot_consNamesArOfType_dot_5_dot_uscore_hash_lambda16 :: FlatCurry.Curry_Types.C_ConsDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int
d_OP_siblingCons_dot_consNamesArOfType_dot_5_dot_uscore_hash_lambda16 x1 cd cs =
  Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply
  (FlatCurry.Curry_Goodies.d_C_consName cd cs) x1 cd cs)
  (Curry_Prelude.d_C_apply (FlatCurry.Curry_Goodies.d_C_consArity cd cs) x1 cd
  cs)

d_OP_siblingCons_dot_consNamesArOfType_dot_5_dot_uscore_hash_lambda17 :: FlatCurry.Curry_Types.C_ConsDecl
  -> FlatCurry.Curry_Types.C_ConsDecl -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_siblingCons_dot_consNamesArOfType_dot_5_dot_uscore_hash_lambda17 x1 x2 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  cd cs) (Curry_Prelude.d_C_apply (FlatCurry.Curry_Goodies.d_C_consName cd cs)
  x2 cd cs) cd cs) (Curry_Prelude.d_C_apply
  (FlatCurry.Curry_Goodies.d_C_consName cd cs) x1 cd cs) cd cs

d_C_showSiblingAndDecl :: Analysis.Curry_Types.C_AOutFormat -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeDecl
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showSiblingAndDecl x1 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeDecl_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash))
  cd cs

d_C_siblingConsAndDecl :: Cover -> ConstStore -> Analysis.Curry_Types.C_Analysis
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeDecl
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int)))
d_C_siblingConsAndDecl cd cs =
  Analysis.Curry_Types.d_C_simpleConstructorAnalysis
  (Curry_Prelude.toCurryString "SiblingConsAndDecl") (acceptCs id
  d_OP_siblingConsAndDecl_dot_consNamesArOfType_dot_31) cd cs

nd_C_siblingConsAndDecl :: IDSupply -> Cover -> ConstStore
  -> Analysis.Curry_Types.C_Analysis (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeDecl (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)))
nd_C_siblingConsAndDecl s cd cs = let s0 = s
  in s0 `seq` Analysis.Curry_Types.nd_C_simpleConstructorAnalysis
  (Curry_Prelude.toCurryString "SiblingConsAndDecl") (wrapDX (wrapDX id)
  (acceptCs id d_OP_siblingConsAndDecl_dot_consNamesArOfType_dot_31)) s0 cd cs

d_OP_siblingConsAndDecl_dot_consNamesArOfType_dot_31 :: FlatCurry.Curry_Types.C_ConsDecl
  -> FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeDecl
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int))
d_OP_siblingConsAndDecl_dot_consNamesArOfType_dot_31 x1 x2 cd cs =
  let x3 = d_C__case_20 x1 x2 cd cs in Curry_Prelude.OP_Tuple2 x2 x3

d_OP_siblingConsAndDecl_dot_consNamesArOfType_dot_31_dot_uscore_hash_lambda19 :: FlatCurry.Curry_Types.C_ConsDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int
d_OP_siblingConsAndDecl_dot_consNamesArOfType_dot_31_dot_uscore_hash_lambda19 x1 cd cs =
  Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply
  (FlatCurry.Curry_Goodies.d_C_consName cd cs) x1 cd cs)
  (Curry_Prelude.d_C_apply (FlatCurry.Curry_Goodies.d_C_consArity cd cs) x1 cd
  cs)

d_OP_siblingConsAndDecl_dot_consNamesArOfType_dot_31_dot_uscore_hash_lambda20 :: FlatCurry.Curry_Types.C_ConsDecl
  -> FlatCurry.Curry_Types.C_ConsDecl -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_siblingConsAndDecl_dot_consNamesArOfType_dot_31_dot_uscore_hash_lambda20 x1 x2 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  cd cs) (Curry_Prelude.d_C_apply (FlatCurry.Curry_Goodies.d_C_consName cd cs)
  x2 cd cs) cd cs) (Curry_Prelude.d_C_apply
  (FlatCurry.Curry_Goodies.d_C_consName cd cs) x1 cd cs) cd cs

d_C_patCompAnalysis :: Cover -> ConstStore -> Analysis.Curry_Types.C_Analysis
  C_Completeness
d_C_patCompAnalysis cd cs = Analysis.Curry_Types.d_C_combinedSimpleFuncAnalysis
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Char_hash))
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Int_hash))
  (RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
  (RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
  RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Char_hash)
  (RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
  RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Char_hash))
  RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Int_hash))
  (Curry_Prelude.toCurryString "PatComplete") (d_C_siblingCons cd cs) (acceptCs
  id d_C_analysePatComplete) cd cs

nd_C_patCompAnalysis :: IDSupply -> Cover -> ConstStore
  -> Analysis.Curry_Types.C_Analysis C_Completeness
nd_C_patCompAnalysis s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Analysis.Curry_Types.nd_C_combinedSimpleFuncAnalysis
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Int_hash)))))
  (wrapNX id
  (RW.Curry_Base.nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (RW.Curry_Base.nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (RW.Curry_Base.nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (RW.Curry_Base.nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  RW.Curry_Base.nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (RW.Curry_Base.nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  RW.Curry_Base.nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  RW.Curry_Base.nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Int_hash)))))
  (Curry_Prelude.toCurryString "PatComplete") (nd_C_siblingCons s0 cd cs)
  (wrapDX (wrapDX id) (acceptCs id d_C_analysePatComplete)) s1 cd cs))

d_C_showComplete :: Analysis.Curry_Types.C_AOutFormat -> C_Completeness -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showComplete x1 x2 cd cs = case x2 of
  C_Complete -> d_C__case_19 x1 cd cs
  C_InComplete -> Curry_Prelude.toCurryString "incomplete"
  C_InCompleteOr -> Curry_Prelude.toCurryString "incomplete in each disjunction"
  Choice_C_Completeness d i l r -> narrow d i (d_C_showComplete x1 l cd cs)
    (d_C_showComplete x1 r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C_showComplete x1 z
    cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C_showComplete x1 e cd
    x) $! addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined.showComplete" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined.showComplete" (showCons
    x2))

d_C_analysePatComplete :: Analysis.Curry_ProgInfo.C_ProgInfo
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int))
  -> FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore -> C_Completeness
d_C_analysePatComplete x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Func x3 x4 x5 x6 x7 -> d_C__case_18 x7 x1 x3 cd cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i
    (d_C_analysePatComplete x1 l cd cs) (d_C_analysePatComplete x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_C_analysePatComplete x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c ((\x ->
    d_C_analysePatComplete x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "Analysis.TotallyDefined.analysePatComplete" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined.analysePatComplete"
    (showCons x2))

d_OP_analysePatComplete_dot_anaFun_dot_70 :: Analysis.Curry_ProgInfo.C_ProgInfo
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int)) -> FlatCurry.Curry_Types.C_Rule
  -> Cover -> ConstStore -> C_Completeness
d_OP_analysePatComplete_dot_anaFun_dot_70 x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Rule x3 x4 -> d_C_isComplete x1 x4 cd cs
  FlatCurry.Curry_Types.C_External x5 -> C_Complete
  FlatCurry.Curry_Types.Choice_C_Rule d i l r -> narrow d i
    (d_OP_analysePatComplete_dot_anaFun_dot_70 x1 l cd cs)
    (d_OP_analysePatComplete_dot_anaFun_dot_70 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Rule d i xs -> narrows cs d i (\z ->
    d_OP_analysePatComplete_dot_anaFun_dot_70 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Rule d c e -> guardCons d c ((\x ->
    d_OP_analysePatComplete_dot_anaFun_dot_70 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Rule d info -> failCons d (traceFail
    "Analysis.TotallyDefined.analysePatComplete.anaFun.70" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined.analysePatComplete.anaFun.70" (showCons x2))

d_C_isComplete :: Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> C_Completeness
d_C_isComplete x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Var x3 -> C_Complete
  FlatCurry.Curry_Types.C_Lit x4 -> C_Complete
  FlatCurry.Curry_Types.C_Comb x5 x6 x7 -> d_C__case_15 x6 x7 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x6 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "failed")) cd cs) cd cs
  FlatCurry.Curry_Types.C_Free x8 x9 -> C_Complete
  FlatCurry.Curry_Types.C_Let x10 x11 -> C_Complete
  FlatCurry.Curry_Types.C_Or x12 x13 -> d_C_combineOrResults (d_C_isComplete x1
    x12 cd cs) (d_C_isComplete x1 x13 cd cs) cd cs
  FlatCurry.Curry_Types.C_Case x14 x15 x16 -> d_C__case_12 x1 x16 cd cs
  FlatCurry.Curry_Types.C_Typed x24 x25 -> d_C_isComplete x1 x24 cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C_isComplete x1 l
    cd cs) (d_C_isComplete x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C_isComplete x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x ->
    d_C_isComplete x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "Analysis.TotallyDefined.isComplete" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined.isComplete" (showCons x2))

d_OP_isComplete_dot_checkAllCons_dot_118 :: Analysis.Curry_ProgInfo.C_ProgInfo
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_BranchExpr -> Cover -> ConstStore -> C_Completeness
d_OP_isComplete_dot_checkAllCons_dot_118 x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_List -> C_Complete
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_9 x1 x5 x4 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_isComplete_dot_checkAllCons_dot_118 x1 l x3 cd cs)
    (d_OP_isComplete_dot_checkAllCons_dot_118 x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_isComplete_dot_checkAllCons_dot_118 x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_isComplete_dot_checkAllCons_dot_118 x1 e x3 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.TotallyDefined.isComplete.checkAllCons.118" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "Analysis.TotallyDefined.isComplete.checkAllCons.118" (showCons x2))

d_C_combineOrResults :: C_Completeness -> C_Completeness -> Cover -> ConstStore
  -> C_Completeness
d_C_combineOrResults x1 x2 cd cs = case x1 of
  C_Complete -> C_Complete
  C_InComplete -> d_C__case_6 x2 cd cs
  C_InCompleteOr -> d_C__case_5 x2 cd cs
  Choice_C_Completeness d i l r -> narrow d i (d_C_combineOrResults l x2 cd cs)
    (d_C_combineOrResults r x2 cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C_combineOrResults z
    x2 cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C_combineOrResults e x2
    cd x) $! addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined.combineOrResults" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined.combineOrResults"
    (showCons x1))

d_C_combineAndResults :: C_Completeness -> C_Completeness -> Cover -> ConstStore
  -> C_Completeness
d_C_combineAndResults x1 x2 cd cs = case x1 of
  C_InComplete -> C_InComplete
  C_Complete -> d_C__case_4 x2 cd cs
  C_InCompleteOr -> d_C__case_3 x2 cd cs
  Choice_C_Completeness d i l r -> narrow d i (d_C_combineAndResults l x2 cd cs)
    (d_C_combineAndResults r x2 cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C_combineAndResults z
    x2 cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C_combineAndResults e x2
    cd x) $! addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined.combineAndResults" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined.combineAndResults"
    (showCons x1))

d_C_totalAnalysis :: Cover -> ConstStore -> Analysis.Curry_Types.C_Analysis
  Curry_Prelude.C_Bool
d_C_totalAnalysis cd cs =
  Analysis.Curry_Types.d_C_combinedDependencyFuncAnalysis
  d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash
  (Curry_Prelude.toCurryString "Total") (d_C_patCompAnalysis cd cs)
  Curry_Prelude.C_True (acceptCs (acceptCs id) d_C_analyseTotally) cd cs

nd_C_totalAnalysis :: IDSupply -> Cover -> ConstStore
  -> Analysis.Curry_Types.C_Analysis Curry_Prelude.C_Bool
nd_C_totalAnalysis s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Analysis.Curry_Types.nd_C_combinedDependencyFuncAnalysis
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)
  (wrapNX id
  nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)
  (Curry_Prelude.toCurryString "Total") (nd_C_patCompAnalysis s0 cd cs)
  Curry_Prelude.C_True (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs id)
  d_C_analyseTotally)) s1 cd cs))

d_C_analyseTotally :: Analysis.Curry_ProgInfo.C_ProgInfo C_Completeness
  -> FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Bool) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_analyseTotally x1 x2 x3 cd cs = Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_C_maybe Curry_Prelude.C_False (Curry_Prelude.d_C_flip
  (acceptCs id
  d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_TotallyDefined_dot_Completeness_hash)
  C_Complete) (Analysis.Curry_ProgInfo.d_C_lookupProgInfo
  (Curry_Prelude.d_C_apply (FlatCurry.Curry_Goodies.d_C_funcName cd cs) x2 cd
  cs) x1 cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all
  Curry_Prelude.d_C_snd cd cs) x3 cd cs) cd cs

d_C_showTotally :: Analysis.Curry_Types.C_AOutFormat -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showTotally x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> d_C__case_2 x1 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.toCurryString "partially defined"
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C_showTotally x1 l cd cs)
    (d_C_showTotally x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C_showTotally
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C_showTotally x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined.showTotally" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined.showTotally" (showCons
    x2))

d_C_showTotalFunc :: Analysis.Curry_Types.C_AOutFormat -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showTotalFunc x1 x2 cd cs = case x1 of
  Analysis.Curry_Types.C_AText -> d_C__case_1 x2 cd cs
  Analysis.Curry_Types.C_ANote -> d_C__case_0 x2 cd cs
  Analysis.Curry_Types.Choice_C_AOutFormat d i l r -> narrow d i
    (d_C_showTotalFunc l x2 cd cs) (d_C_showTotalFunc r x2 cd cs)
  Analysis.Curry_Types.Choices_C_AOutFormat d i xs -> narrows cs d i (\z ->
    d_C_showTotalFunc z x2 cd cs) xs
  Analysis.Curry_Types.Guard_C_AOutFormat d c e -> guardCons d c ((\x ->
    d_C_showTotalFunc e x2 cd x) $! addCs c cs)
  Analysis.Curry_Types.Fail_C_AOutFormat d info -> failCons d (traceFail
    "Analysis.TotallyDefined.showTotalFunc" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined.showTotalFunc" (showCons
    x1))

d_C_totalFuncAnalysis :: Cover -> ConstStore -> Analysis.Curry_Types.C_Analysis
  Curry_Prelude.C_Bool
d_C_totalFuncAnalysis cd cs =
  Analysis.Curry_Types.d_C_combinedDependencyFuncAnalysis
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Bool_hash
  RW.Curry_Base.d_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Bool_hash
  (Curry_Prelude.toCurryString "TotalFunc") (d_C_totalAnalysis cd cs)
  Curry_Prelude.C_True (acceptCs (acceptCs id) d_C_analyseTotalFunc) cd cs

nd_C_totalFuncAnalysis :: IDSupply -> Cover -> ConstStore
  -> Analysis.Curry_Types.C_Analysis Curry_Prelude.C_Bool
nd_C_totalFuncAnalysis s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Analysis.Curry_Types.nd_C_combinedDependencyFuncAnalysis
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Bool_hash)
  (wrapNX id
  RW.Curry_Base.nd_OP_uscore_inst_hash_RW_dot_Base_dot_ReadWrite_hash_Prelude_dot_Bool_hash)
  (Curry_Prelude.toCurryString "TotalFunc") (nd_C_totalAnalysis s0 cd cs)
  Curry_Prelude.C_True (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs id)
  d_C_analyseTotalFunc)) s1 cd cs))

d_C_analyseTotalFunc :: Analysis.Curry_ProgInfo.C_ProgInfo Curry_Prelude.C_Bool
  -> FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Bool) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_analyseTotalFunc x1 x2 x3 cd cs = Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_C_maybe Curry_Prelude.C_False Curry_Prelude.d_C_id
  (Analysis.Curry_ProgInfo.d_C_lookupProgInfo (Curry_Prelude.d_C_apply
  (FlatCurry.Curry_Goodies.d_C_funcName cd cs) x2 cd cs) x1 cd cs) cd cs)
  (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_not
  (Analysis.Curry_Deterministic.d_C_isNondetDefined x2 cd cs) cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all Curry_Prelude.d_C_snd cd cs)
  x3 cd cs) cd cs) cd cs

d_C_prelude :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_prelude cd cs = Curry_Prelude.toCurryString "Prelude"

d_C__case_30 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  C_Completeness (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_30 x4 x3 cd cs = case x3 of
  (Curry_Prelude.C_Char '0'#) -> Curry_Prelude.OP_Tuple2 C_Complete x4
  (Curry_Prelude.C_Char '1'#) -> Curry_Prelude.OP_Tuple2 C_InComplete x4
  (Curry_Prelude.C_Char '2'#) -> Curry_Prelude.OP_Tuple2 C_InCompleteOr x4
  Curry_Prelude.CurryChar l -> matchChar [('0', Curry_Prelude.OP_Tuple2
    C_Complete x4), ('1', Curry_Prelude.OP_Tuple2 C_InComplete x4), ('2'
    , Curry_Prelude.OP_Tuple2 C_InCompleteOr x4)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_30 x4 l cd cs)
    (d_C__case_30 x4 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_30 x4 z
    cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_30 x4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_30" [show x4, show x3] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_30" (showCons x3))

d_C__case_27 :: C_Completeness -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_27 x2 cd cs = case x2 of
  C_Complete -> Curry_Prelude.C_False
  C_InComplete -> Curry_Prelude.C_False
  C_InCompleteOr -> Curry_Prelude.C_True
  Choice_C_Completeness d i l r -> narrow d i (d_C__case_27 l cd cs)
    (d_C__case_27 r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C__case_27 z cd cs)
    xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C__case_27 e cd x) $!
    addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_27" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_27" (showCons x2))

d_C__case_28 :: C_Completeness -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_28 x2 cd cs = case x2 of
  C_Complete -> Curry_Prelude.C_False
  C_InComplete -> Curry_Prelude.C_True
  C_InCompleteOr -> Curry_Prelude.C_False
  Choice_C_Completeness d i l r -> narrow d i (d_C__case_28 l cd cs)
    (d_C__case_28 r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C__case_28 z cd cs)
    xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C__case_28 e cd x) $!
    addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_28" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_28" (showCons x2))

d_C__case_29 :: C_Completeness -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_29 x2 cd cs = case x2 of
  C_Complete -> Curry_Prelude.C_True
  C_InComplete -> Curry_Prelude.C_False
  C_InCompleteOr -> Curry_Prelude.C_False
  Choice_C_Completeness d i l r -> narrow d i (d_C__case_29 l cd cs)
    (d_C__case_29 r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C__case_29 z cd cs)
    xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C__case_29 e cd x) $!
    addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_29" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_29" (showCons x2))

d_C__case_24 :: C_Completeness -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_24 x2 cd cs = case x2 of
  C_Complete -> Curry_Prelude.C_False
  C_InComplete -> Curry_Prelude.C_False
  C_InCompleteOr -> Curry_Prelude.C_True
  Choice_C_Completeness d i l r -> narrow d i (d_C__case_24 l cd cs)
    (d_C__case_24 r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C__case_24 z cd cs)
    xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C__case_24 e cd x) $!
    addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_24" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_24" (showCons x2))

d_C__case_25 :: C_Completeness -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_25 x2 cd cs = case x2 of
  C_Complete -> Curry_Prelude.C_False
  C_InComplete -> Curry_Prelude.C_True
  C_InCompleteOr -> Curry_Prelude.C_False
  Choice_C_Completeness d i l r -> narrow d i (d_C__case_25 l cd cs)
    (d_C__case_25 r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C__case_25 z cd cs)
    xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C__case_25 e cd x) $!
    addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_25" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_25" (showCons x2))

d_C__case_26 :: C_Completeness -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_26 x2 cd cs = case x2 of
  C_Complete -> Curry_Prelude.C_True
  C_InComplete -> Curry_Prelude.C_False
  C_InCompleteOr -> Curry_Prelude.C_False
  Choice_C_Completeness d i l r -> narrow d i (d_C__case_26 l cd cs)
    (d_C__case_26 r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C__case_26 z cd cs)
    xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C__case_26 e cd x) $!
    addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_26" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_26" (showCons x2))

d_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Completeness
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Completeness
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_23 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    C_Complete x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x3 x2 x4 l cd
    cs) (d_C__case_23 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x3
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_23 x3 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_23" [show x3, show x2, show x4, show x5]
    info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_23" (showCons x5))

d_C__case_22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Completeness
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Completeness
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_22 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    C_InComplete x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_22 x3 x2 x4 l cd
    cs) (d_C__case_22 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_22 x3
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_22 x3 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_22" [show x3, show x2, show x4, show x5]
    info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_22" (showCons x5))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Completeness
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Completeness
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_21 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    C_InCompleteOr x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x3 x2 x4 l cd
    cs) (d_C__case_21 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x3
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x3 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_21" [show x3, show x2, show x4, show x5]
    info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_21" (showCons x5))

d_C__case_20 :: FlatCurry.Curry_Types.C_ConsDecl
  -> FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Int)
d_C__case_20 x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Type x4 x5 x6 x7 -> Curry_Prelude.d_C_map
    d_OP_siblingConsAndDecl_dot_consNamesArOfType_dot_31_dot_uscore_hash_lambda19
    (Curry_Prelude.d_C_filter
    (d_OP_siblingConsAndDecl_dot_consNamesArOfType_dot_31_dot_uscore_hash_lambda20
    x1) x7 cd cs) cd cs
  FlatCurry.Curry_Types.C_TypeSyn x8 x9 x10 x11 -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeNew x12 x13 x14 x15 -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i (d_C__case_20 x1
    l cd cs) (d_C__case_20 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    d_C__case_20 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c ((\x ->
    d_C__case_20 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_20" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_20" (showCons x2))

d_C__case_19 :: Analysis.Curry_Types.C_AOutFormat -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_19 x1 cd cs = case x1 of
  Analysis.Curry_Types.C_AText -> Curry_Prelude.toCurryString "complete"
  Analysis.Curry_Types.C_ANote -> Curry_Prelude.OP_List
  Analysis.Curry_Types.Choice_C_AOutFormat d i l r -> narrow d i (d_C__case_19 l
    cd cs) (d_C__case_19 r cd cs)
  Analysis.Curry_Types.Choices_C_AOutFormat d i xs -> narrows cs d i (\z ->
    d_C__case_19 z cd cs) xs
  Analysis.Curry_Types.Guard_C_AOutFormat d c e -> guardCons d c ((\x ->
    d_C__case_19 e cd x) $! addCs c cs)
  Analysis.Curry_Types.Fail_C_AOutFormat d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_19" [show x1] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_19" (showCons x1))

d_C__case_18 :: FlatCurry.Curry_Types.C_Rule
  -> Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> C_Completeness
d_C__case_18 x7 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let x10 = Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "=:=")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString
                                         "constrEq") (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "=:<=")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString
                                         "nonstrictEq") (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString
                                         "unifEqLinear") (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "sqrt")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString
                                         "sqrtFloat")
                                         Curry_Prelude.OP_List))))))
    in d_C__case_17 x10 x9 x8 x7 x1 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (d_C_prelude cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x9 cd cs) x10 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_18 x7 x1 l cd
    cs) (d_C__case_18 x7 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_18
    x7 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_18 x7
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_18" [show x7, show x1, show x3] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_18" (showCons x3))

d_C__case_17 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> FlatCurry.Curry_Types.C_Rule
  -> Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Completeness
d_C__case_17 x10 x9 x8 x7 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> C_InComplete
  Curry_Prelude.C_False -> d_C__case_16 x7 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x10 x9 x8 x7
    x1 l cd cs) (d_C__case_17 x10 x9 x8 x7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x10
    x9 x8 x7 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_17 x10 x9
    x8 x7 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_17" [show x10, show x9, show x8, show x7
    , show x1, show x11] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_17" (showCons x11))

d_C__case_16 :: FlatCurry.Curry_Types.C_Rule
  -> Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Completeness
d_C__case_16 x7 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_OP_analysePatComplete_dot_anaFun_dot_70 x1 x7 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x7 x1 l cd cs)
    (d_C__case_16 x7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x7
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x7 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_16" [show x7, show x1, show x8] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_16" (showCons x8))

d_C__case_12 :: Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_BranchExpr -> Cover -> ConstStore -> C_Completeness
d_C__case_12 x1 x16 cd cs = case x16 of
  Curry_Prelude.OP_List -> C_InComplete
  Curry_Prelude.OP_Cons x17 x18 -> d_C__case_11 x1 x18 x17 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_12 x1 l cd cs)
    (d_C__case_12 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_12 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_12 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_12" [show x1, show x16] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_12" (showCons x16))

d_C__case_11 :: Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_BranchExpr -> FlatCurry.Curry_Types.C_BranchExpr
  -> Cover -> ConstStore -> C_Completeness
d_C__case_11 x1 x18 x17 cd cs = case x17 of
  FlatCurry.Curry_Types.C_Branch x19 x20 -> d_C__case_10 x20 x1 x18 x19 cd cs
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i (d_C__case_11
    x1 x18 l cd cs) (d_C__case_11 x1 x18 r cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    d_C__case_11 x1 x18 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    d_C__case_11 x1 x18 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_11" [show x1, show x18, show x17] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_11" (showCons x17))

d_C__case_10 :: FlatCurry.Curry_Types.C_Expr
  -> Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_BranchExpr -> FlatCurry.Curry_Types.C_Pattern -> Cover
  -> ConstStore -> C_Completeness
d_C__case_10 x20 x1 x18 x19 cd cs = case x19 of
  FlatCurry.Curry_Types.C_LPattern x21 -> C_InComplete
  FlatCurry.Curry_Types.C_Pattern x22 x23 -> d_C_combineAndResults
    (d_OP_isComplete_dot_checkAllCons_dot_118 x1 (Curry_Prelude.d_C_maybe
    Curry_Prelude.OP_List (Curry_Prelude.d_C_map Curry_Prelude.d_C_fst)
    (Analysis.Curry_ProgInfo.d_C_lookupProgInfo x22 x1 cd cs) cd cs) x18 cd cs)
    (d_C_isComplete x1 x20 cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Pattern d i l r -> narrow d i (d_C__case_10 x20
    x1 x18 l cd cs) (d_C__case_10 x20 x1 x18 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Pattern d i xs -> narrows cs d i (\z ->
    d_C__case_10 x20 x1 x18 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Pattern d c e -> guardCons d c ((\x ->
    d_C__case_10 x20 x1 x18 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Pattern d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_10" [show x20, show x1, show x18, show x19]
    info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_10" (showCons x19))

d_C__case_15 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Completeness
d_C__case_15 x6 x7 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> C_InComplete
  Curry_Prelude.C_False -> d_C__case_14 x7 x6 x1 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x6 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "commit")) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x7 cd cs) (Curry_Prelude.C_Int (1)) cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x6 x7 x1 l cd
    cs) (d_C__case_15 x6 x7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x6
    x7 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x6 x7
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_15" [show x6, show x7, show x1, show x8]
    info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_15" (showCons x8))

d_C__case_14 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Completeness
d_C__case_14 x7 x6 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_isComplete x1 (Curry_Prelude.d_C_head x7 cd cs) cd
    cs
  Curry_Prelude.C_False -> d_C__case_13 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x7 x6 x1 l cd
    cs) (d_C__case_14 x7 x6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x7
    x6 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x7 x6
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_14" [show x7, show x6, show x1, show x8]
    info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_14" (showCons x8))

d_C__case_13 :: Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Completeness
d_C__case_13 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> C_Complete
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 l cd cs)
    (d_C__case_13 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_13" [show x1] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_13" (showCons x1))

d_C__case_9 :: Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_BranchExpr -> Cover
  -> ConstStore -> C_Completeness
d_C__case_9 x1 x5 x4 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> C_InComplete
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_8 x1 x7 x5 x4 x6 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_9 x1 x5 x4 l cd
    cs) (d_C__case_9 x1 x5 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_9 x1
    x5 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_9 x1 x5
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_9" [show x1, show x5, show x4, show x3] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_9" (showCons x3))

d_C__case_8 :: Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_BranchExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_BranchExpr -> Cover
  -> ConstStore -> C_Completeness
d_C__case_8 x1 x7 x5 x4 x6 cd cs = case x6 of
  FlatCurry.Curry_Types.C_Branch x8 x9 -> d_C__case_7 x9 x1 x7 x5 x4 x8 cd cs
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i (d_C__case_8
    x1 x7 x5 x4 l cd cs) (d_C__case_8 x1 x7 x5 x4 r cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    d_C__case_8 x1 x7 x5 x4 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    d_C__case_8 x1 x7 x5 x4 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_8" [show x1, show x7, show x5, show x4, show
    x6] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_8" (showCons x6))

d_C__case_7 :: FlatCurry.Curry_Types.C_Expr
  -> Analysis.Curry_ProgInfo.C_ProgInfo (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_BranchExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Pattern -> Cover
  -> ConstStore -> C_Completeness
d_C__case_7 x9 x1 x7 x5 x4 x8 cd cs = case x8 of
  FlatCurry.Curry_Types.C_LPattern x10 -> C_InComplete
  FlatCurry.Curry_Types.C_Pattern x11 x12 -> d_C_combineAndResults
    (d_OP_isComplete_dot_checkAllCons_dot_118 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Data.Curry_List.d_C_delete
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
    cd cs) x11 cd cs) (Curry_Prelude.OP_Cons x4 x5) cd cs) x7 cd cs)
    (d_C_isComplete x1 x9 cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Pattern d i l r -> narrow d i (d_C__case_7 x9
    x1 x7 x5 x4 l cd cs) (d_C__case_7 x9 x1 x7 x5 x4 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Pattern d i xs -> narrows cs d i (\z ->
    d_C__case_7 x9 x1 x7 x5 x4 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Pattern d c e -> guardCons d c ((\x ->
    d_C__case_7 x9 x1 x7 x5 x4 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Pattern d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_7" [show x9, show x1, show x7, show x5, show
    x4, show x8] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_7" (showCons x8))

d_C__case_5 :: C_Completeness -> Cover -> ConstStore -> C_Completeness
d_C__case_5 x2 cd cs = case x2 of
  C_Complete -> C_Complete
  C_InComplete -> C_InCompleteOr
  C_InCompleteOr -> C_InCompleteOr
  Choice_C_Completeness d i l r -> narrow d i (d_C__case_5 l cd cs) (d_C__case_5
    r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C__case_5 z cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C__case_5 e cd x) $!
    addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_5" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_5" (showCons x2))

d_C__case_6 :: C_Completeness -> Cover -> ConstStore -> C_Completeness
d_C__case_6 x2 cd cs = case x2 of
  C_Complete -> C_Complete
  C_InComplete -> C_InCompleteOr
  C_InCompleteOr -> C_InCompleteOr
  Choice_C_Completeness d i l r -> narrow d i (d_C__case_6 l cd cs) (d_C__case_6
    r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C__case_6 z cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C__case_6 e cd x) $!
    addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_6" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_6" (showCons x2))

d_C__case_3 :: C_Completeness -> Cover -> ConstStore -> C_Completeness
d_C__case_3 x2 cd cs = case x2 of
  C_Complete -> C_InCompleteOr
  C_InComplete -> C_InComplete
  C_InCompleteOr -> C_InCompleteOr
  Choice_C_Completeness d i l r -> narrow d i (d_C__case_3 l cd cs) (d_C__case_3
    r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C__case_3 z cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C__case_3 e cd x) $!
    addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_3" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_3" (showCons x2))

d_C__case_4 :: C_Completeness -> Cover -> ConstStore -> C_Completeness
d_C__case_4 x2 cd cs = case x2 of
  C_Complete -> C_Complete
  C_InComplete -> C_InComplete
  C_InCompleteOr -> C_InCompleteOr
  Choice_C_Completeness d i l r -> narrow d i (d_C__case_4 l cd cs) (d_C__case_4
    r cd cs)
  Choices_C_Completeness d i xs -> narrows cs d i (\z -> d_C__case_4 z cd cs) xs
  Guard_C_Completeness d c e -> guardCons d c ((\x -> d_C__case_4 e cd x) $!
    addCs c cs)
  Fail_C_Completeness d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_4" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_4" (showCons x2))

d_C__case_2 :: Analysis.Curry_Types.C_AOutFormat -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_2 x1 cd cs = case x1 of
  Analysis.Curry_Types.C_AText -> Curry_Prelude.toCurryString "totally defined"
  Analysis.Curry_Types.C_ANote -> Curry_Prelude.OP_List
  Analysis.Curry_Types.Choice_C_AOutFormat d i l r -> narrow d i (d_C__case_2 l
    cd cs) (d_C__case_2 r cd cs)
  Analysis.Curry_Types.Choices_C_AOutFormat d i xs -> narrows cs d i (\z ->
    d_C__case_2 z cd cs) xs
  Analysis.Curry_Types.Guard_C_AOutFormat d c e -> guardCons d c ((\x ->
    d_C__case_2 e cd x) $! addCs c cs)
  Analysis.Curry_Types.Fail_C_AOutFormat d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_2" [show x1] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_2" (showCons x1))

d_C__case_0 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.toCurryString
    "partial/non-deterministic"
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 l cd cs)
    (d_C__case_0 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_0" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_0" (showCons x2))

d_C__case_1 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString
    "totally and functionally defined"
  Curry_Prelude.C_False -> Curry_Prelude.toCurryString
    "partially or non-deterministically defined"
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 l cd cs)
    (d_C__case_1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.TotallyDefined._case_1" [show x2] info)
  _ -> failCons cd (consFail "Analysis.TotallyDefined._case_1" (showCons x2))

