{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module HTML.Curry_CategorizedList
  ( d_C_list2CategorizedHtml
  , nd_C_list2CategorizedHtml
  , d_C_categorizeByItemKey
  , nd_C_categorizeByItemKey
  , d_C_stringList2ItemList
  , nd_C_stringList2ItemList )
  where

import Basics
import qualified Data.Curry_Char
import qualified Data.Curry_List
import qualified HTML.Curry_Base
import qualified Curry_Prelude


d_C_list2CategorizedHtml :: forall t0 t1 t2 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List t0))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> (t1 -> Cover -> ConstStore -> t2 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_list2CategorizedHtml x1 x2 x3 x4 x5 cd cs = Curry_Prelude.OP_Cons
  (d_C_categories2LinkList x1 x2 x4 cd cs) (Curry_Prelude.d_C_map
  (d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x3 x4 x1 x2 x5) x4 cd cs)

nd_C_list2CategorizedHtml :: forall t0 t1 t2 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  t0)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func t1 (Func t2
  Curry_Prelude.C_Bool) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_list2CategorizedHtml x1 x2 x3 x4 x5 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` Curry_Prelude.OP_Cons (nd_C_categories2LinkList x1 x2 x4
  s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x3 x4 x1 x2 x5)) x4 s1 cd
  cs)))

d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List t0)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> (t1 -> Cover -> ConstStore
  -> t2 -> Cover -> ConstStore -> Curry_Prelude.C_Bool)
  -> Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> t0
d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 x6 cd cs =
  case x6 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_anchor x3 (HTML.Curry_Base.d_C_string2urlencoded
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x4 cd cs) x7 cd cs) cd cs)
    cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_h2 x3 cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_htxt x3 x8 cd cs) Curry_Prelude.OP_List) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap
    (d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x3) cd cs) (Curry_Prelude.d_C_filter
    (d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3
    x7 x5) x1 cd cs) cd cs) (Curry_Prelude.OP_Cons (d_C_categories2LinkList x3
    x4 x2 cd cs) Curry_Prelude.OP_List) cd cs)) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 l cd cs)
    (d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1" [show x1, show x2
    , show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1" (showCons x6))

nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List t0)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func Curry_Prelude.OP_Unit
  (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Func t1 (Func t2
  Curry_Prelude.C_Bool) -> Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> t0
nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 x6 s cd cs =
  case x6 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> let s19 = s
    in s19 `seq` (let s18 = leftSupply s19
                      s20 = rightSupply s19
                      s4 = leftSupply s20
                      s17 = rightSupply s20
    in s18 `seq` (s20 `seq` (s4 `seq` (s17 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_anchor x3
    (HTML.Curry_Base.d_C_string2urlencoded (let s1 = leftSupply s2
                                                s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x4
    s0 cd cs) x7 s1 cd cs)) cd cs) s3 cd cs)) (let s8 = leftSupply s17
                                                   s16 = rightSupply s17
    in s8 `seq` (s16 `seq` Curry_Prelude.OP_Cons (let s7 = leftSupply s8
                                                      s9 = rightSupply s8
                                                      s5 = leftSupply s9
                                                      s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_h2 x3 s5 cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.nd_C_htxt x3 x8 s6 cd cs) Curry_Prelude.OP_List) s7 cd
    cs)))) (let s13 = leftSupply s16
                s15 = rightSupply s16
    in s13 `seq` (s15 `seq` Curry_Prelude.d_OP_plus_plus (let s12 = leftSupply
                                                                s13
                                                              s14 = rightSupply
                                                                s13
                                                              s10 = leftSupply
                                                                s14
                                                              s11 = rightSupply
                                                                s14
    in s12 `seq` (s14 `seq` (s10 `seq` (s11 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_concatMap (wrapNX id
    (nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x3)) s10 cd cs) (Curry_Prelude.nd_C_filter (wrapNX id
    (nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3
    x7 x5)) x1 s11 cd cs) s12 cd cs)))) (Curry_Prelude.OP_Cons
    (nd_C_categories2LinkList x3 x4 x2 s15 cd cs) Curry_Prelude.OP_List) cd
    cs)))) s18 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 l s cd
    cs) (nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 r s
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1" [show x1, show x2
    , show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1" (showCons x6))

d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_OP_plus_plus x4
    (Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_breakline x1 cd cs)
    Curry_Prelude.OP_List) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x1 l cd cs)
    (d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1._#lambda2" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1._#lambda2" (showCons
    x2))

nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus x4 (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.nd_C_breakline x1 s0 cd cs) Curry_Prelude.OP_List) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x1 l s cd cs)
    (nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1._#lambda2" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1._#lambda2" (showCons
    x2))

d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3 :: forall t0
  t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t2 -> (t1 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  t0) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x4 cd cs) x1 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3
    x1 x2 l cd cs)
    (d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3
    x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1._#lambda3" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1._#lambda3" (showCons
    x3))

nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3 :: forall t0
  t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t2 -> Func t1 (Func t2 Curry_Prelude.C_Bool) -> Curry_Prelude.OP_Tuple2
  t1 (Curry_Prelude.OP_List t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3 x1 x2 x3 s cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x4 s0 cd cs) x1 s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3
    x1 x2 l s cd cs)
    (nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3
    x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3
    x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_list2CategorizedHtml_dot_uscore_hash_lambda1_dot_uscore_hash_lambda3
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1._#lambda3" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail
    "HTML.CategorizedList.list2CategorizedHtml._#lambda1._#lambda3" (showCons
    x3))

d_C_categories2LinkList :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> t0
d_C_categories2LinkList x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_par x1 cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_center x1 cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
  (d_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2) cd cs) x3 cd cs) cd
  cs) Curry_Prelude.OP_List) cd cs

nd_C_categories2LinkList :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func Curry_Prelude.OP_Unit
  (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_categories2LinkList x1 x2 x3 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s0 = leftSupply s10
                   s6 = rightSupply s10
  in s8 `seq` (s10 `seq` (s0 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_par x1 s0 cd cs) (Curry_Prelude.OP_Cons
  (let s5 = leftSupply s6
       s7 = rightSupply s6
       s1 = leftSupply s7
       s4 = rightSupply s7
  in s5 `seq` (s7 `seq` (s1 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_center x1 s1 cd cs) (let s3 = leftSupply s4
                                                 s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap
  (wrapNX id (nd_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2)) s2 cd
  cs) x3 s3 cd cs)) s5 cd cs)))) Curry_Prelude.OP_List) s8 cd cs))))

d_OP_categories2LinkList_dot_uscore_hash_lambda4 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '#'#) (HTML.Curry_Base.d_C_string2urlencoded
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x2 cd cs) x4 cd cs) cd cs))
    cd cs) (Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_htxt x1 x5 cd cs)
    Curry_Prelude.OP_List) cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_nbsp x1 cd cs) Curry_Prelude.OP_List)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2 l cd cs)
    (d_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.CategorizedList.categories2LinkList._#lambda4" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail
    "HTML.CategorizedList.categories2LinkList._#lambda4" (showCons x3))

nd_OP_categories2LinkList_dot_uscore_hash_lambda4 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s10 = s
    in s10 `seq` (let s7 = leftSupply s10
                      s9 = rightSupply s10
    in s7 `seq` (s9 `seq` Curry_Prelude.OP_Cons (let s6 = leftSupply s7
                                                     s8 = rightSupply s7
                                                     s4 = leftSupply s8
                                                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_href x1 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '#'#) (HTML.Curry_Base.d_C_string2urlencoded
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x2
    s0 cd cs) x4 s1 cd cs)) cd cs)) s3 cd cs)) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.nd_C_htxt x1 x5 s5 cd cs) Curry_Prelude.OP_List) s6 cd
    cs)))) (Curry_Prelude.OP_Cons (HTML.Curry_Base.nd_C_nbsp x1 s9 cd cs)
    Curry_Prelude.OP_List)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2 l s cd cs)
    (nd_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_categories2LinkList_dot_uscore_hash_lambda4 x1 x2 e s cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.CategorizedList.categories2LinkList._#lambda4" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail
    "HTML.CategorizedList.categories2LinkList._#lambda4" (showCons x3))

d_C_categorizeByItemKey :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List t0)) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_categorizeByItemKey x1 x2 cd cs = d_C_list2CategorizedHtml x1
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
  x2 (Curry_Prelude.d_C_map d_OP_categorizeByItemKey_dot_uscore_hash_lambda5
  (Curry_Prelude.d_C_apply (d_C_listHeads cd cs) (Curry_Prelude.d_C_map
  Curry_Prelude.d_C_fst x2 cd cs) cd cs) cd cs) (acceptCs id
  d_C_categorizeStringHead) cd cs

nd_C_categorizeByItemKey :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_categorizeByItemKey x1 x2 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C_list2CategorizedHtml x1 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
  x2 (let s3 = leftSupply s4
          s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_map (wrapDX id
  d_OP_categorizeByItemKey_dot_uscore_hash_lambda5) (let s1 = leftSupply s2
                                                         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (wrapDX id (d_C_listHeads cd
  cs)) (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_fst) x2 s0 cd cs) s1
  cd cs)) s3 cd cs)) (wrapDX (wrapDX id) (acceptCs id d_C_categorizeStringHead))
  s5 cd cs))

d_OP_categorizeByItemKey_dot_uscore_hash_lambda5 :: Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_categorizeByItemKey_dot_uscore_hash_lambda5 x1 cd cs =
  Curry_Prelude.OP_Tuple2 (Data.Curry_Char.d_C_toUpper x1 cd cs)
  (Curry_Prelude.OP_Cons (Data.Curry_Char.d_C_toUpper x1 cd cs)
  Curry_Prelude.OP_List)

d_C_stringList2ItemList :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0))
d_C_stringList2ItemList x1 cd cs = Curry_Prelude.d_C_map
  (d_OP_stringList2ItemList_dot_uscore_hash_lambda6 x1)

nd_C_stringList2ItemList :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List t0)))
nd_C_stringList2ItemList x1 s cd cs = wrapNX id (Curry_Prelude.nd_C_map (wrapNX
  id (nd_OP_stringList2ItemList_dot_uscore_hash_lambda6 x1)))

d_OP_stringList2ItemList_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)
d_OP_stringList2ItemList_dot_uscore_hash_lambda6 x1 x2 cd cs =
  Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_htxt x1
  x2 cd cs) Curry_Prelude.OP_List)

nd_OP_stringList2ItemList_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML
  t0) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)
nd_OP_stringList2ItemList_dot_uscore_hash_lambda6 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.OP_Cons
  (HTML.Curry_Base.nd_C_htxt x1 x2 s0 cd cs) Curry_Prelude.OP_List)

d_C_listHeads :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_listHeads cd cs = Curry_Prelude.d_OP_dot (Data.Curry_List.d_C_nubBy
  (acceptCs id d_C_isUpperEqual)) (Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_listHeads_dot_uscore_hash_lambda7) Curry_Prelude.OP_List) cd cs

d_OP_listHeads_dot_uscore_hash_lambda7 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_listHeads_dot_uscore_hash_lambda7 x1 x2 cd cs = d_C__case_0 x1 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 Curry_Prelude.OP_List cd cs) cd cs

d_C_categorizeStringHead :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_categorizeStringHead x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x3 x4 -> d_C_isUpperEqual x3 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_categorizeStringHead l
    x2 cd cs) (d_C_categorizeStringHead r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_categorizeStringHead z x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_categorizeStringHead e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.CategorizedList.categorizeStringHead" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.CategorizedList.categorizeStringHead"
    (showCons x1))

d_C_isUpperEqual :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isUpperEqual x1 x2 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Data.Curry_Char.d_C_toUpper x1 cd cs) (Data.Curry_Char.d_C_toUpper x2 cd cs)
  cd cs

d_C_main :: Cover -> ConstStore -> Curry_Prelude.C_IO HTML.Curry_Base.C_HtmlPage
d_C_main cd cs = Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (HTML.Curry_Base.d_C_page (Curry_Prelude.toCurryString "CatTest")
  (d_C_categorizeByItemKey
  HTML.Curry_Base.d_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash
  (Curry_Prelude.d_C_apply (d_C_stringList2ItemList
  HTML.Curry_Base.d_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash
  cd cs) (d_C_testList cd cs) cd cs) cd cs) cd cs) cd cs

nd_C_main :: IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  HTML.Curry_Base.C_HtmlPage
nd_C_main s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s0 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s0 `seq` (s7 `seq` Curry_Prelude.nd_OP_dollar
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (let s6 = leftSupply s7
                 s5 = rightSupply s7
  in s6 `seq` (s5 `seq` HTML.Curry_Base.nd_C_page (Curry_Prelude.toCurryString
  "CatTest") (let s4 = leftSupply s5
                  s3 = rightSupply s5
  in s4 `seq` (s3 `seq` nd_C_categorizeByItemKey (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash)
  (let s2 = leftSupply s3
       s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_stringList2ItemList
  (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash)
  s1 cd cs) (d_C_testList cd cs) s2 cd cs)) s4 cd cs)) s6 cd cs)) s8 cd cs))))

d_C_testList :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_testList cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "bbcd")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "acde")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "ab")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "cde")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "b")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "xt")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "gbbcd")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "uacde")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Oab")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Qcde")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Tb")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "mxt")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "mxtr")
  Curry_Prelude.OP_List))))))))))))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_head x1 cd
    cs) x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x1 x2 l cd cs)
    (d_C__case_0 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x1 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.CategorizedList._case_0" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "HTML.CategorizedList._case_0" (showCons x3))

