{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module HTML.Styles.Curry_Bootstrap4
  ( d_C_bootstrapPage
  , nd_C_bootstrapPage
  , d_C_bootstrapPage2
  , nd_C_bootstrapPage2
  , d_C_titledSideMenu
  , nd_C_titledSideMenu
  , nd_C_primButton
  , nd_C_primSmButton
  , nd_C_scndButton
  , nd_C_scndSmButton
  , nd_C_infoButton
  , nd_C_infoSmButton
  , d_C_hrefPrimButton
  , nd_C_hrefPrimButton
  , d_C_hrefPrimSmButton
  , nd_C_hrefPrimSmButton
  , d_C_hrefScndButton
  , nd_C_hrefScndButton
  , d_C_hrefScndSmButton
  , nd_C_hrefScndSmButton
  , d_C_hrefInfoButton
  , nd_C_hrefInfoButton
  , d_C_hrefInfoSmButton
  , nd_C_hrefInfoSmButton
  , d_C_hrefSuccButton
  , nd_C_hrefSuccButton
  , d_C_hrefSuccSmButton
  , nd_C_hrefSuccSmButton
  , d_C_hrefWarnButton
  , nd_C_hrefWarnButton
  , d_C_hrefWarnSmButton
  , nd_C_hrefWarnSmButton
  , d_C_hrefDangButton
  , nd_C_hrefDangButton
  , d_C_hrefDangSmButton
  , nd_C_hrefDangSmButton
  , d_C_hrefLightButton
  , nd_C_hrefLightButton
  , d_C_hrefLightSmButton
  , nd_C_hrefLightSmButton
  , d_C_hrefDarkButton
  , nd_C_hrefDarkButton
  , d_C_hrefDarkSmButton
  , nd_C_hrefDarkSmButton
  , d_C_hrefPrimBlock
  , nd_C_hrefPrimBlock
  , d_C_hrefScndBlock
  , nd_C_hrefScndBlock
  , d_C_hrefInfoBlock
  , nd_C_hrefInfoBlock
  , d_C_hrefPrimSmBlock
  , nd_C_hrefPrimSmBlock
  , d_C_hrefScndSmBlock
  , nd_C_hrefScndSmBlock
  , d_C_hrefInfoSmBlock
  , nd_C_hrefInfoSmBlock
  , d_C_hrefPrimBadge
  , nd_C_hrefPrimBadge
  , d_C_hrefScndBadge
  , nd_C_hrefScndBadge
  , d_C_hrefSuccBadge
  , nd_C_hrefSuccBadge
  , d_C_hrefInfoBadge
  , nd_C_hrefInfoBadge
  , d_C_hrefWarnBadge
  , nd_C_hrefWarnBadge
  , d_C_hrefDangBadge
  , nd_C_hrefDangBadge
  , d_C_hrefLightBadge
  , nd_C_hrefLightBadge
  , d_C_hrefDarkBadge
  , nd_C_hrefDarkBadge
  , d_C_ehrefPrimBadge
  , nd_C_ehrefPrimBadge
  , d_C_ehrefScndBadge
  , nd_C_ehrefScndBadge
  , d_C_ehrefSuccBadge
  , nd_C_ehrefSuccBadge
  , d_C_ehrefInfoBadge
  , nd_C_ehrefInfoBadge
  , d_C_ehrefWarnBadge
  , nd_C_ehrefWarnBadge
  , d_C_ehrefDangBadge
  , nd_C_ehrefDangBadge
  , d_C_ehrefLightBadge
  , nd_C_ehrefLightBadge
  , d_C_ehrefDarkBadge
  , nd_C_ehrefDarkBadge
  , d_C_hrefNav
  , nd_C_hrefNav
  , d_C_hrefNavActive
  , nd_C_hrefNavActive
  , d_C_ehrefNav
  , nd_C_ehrefNav
  , d_C_ehref
  , nd_C_ehref
  , d_C_eTarget
  , nd_C_eTarget
  , d_C_kbdInput
  , nd_C_kbdInput
  , d_C_staticButton
  , nd_C_staticButton
  , d_C_stdModal
  , nd_C_stdModal
  , d_C_modalLaunchPrimButton
  , nd_C_modalLaunchPrimButton
  , d_C_modalClosePrimButton
  , nd_C_modalClosePrimButton
  , d_C_scriptShowModal
  , nd_C_scriptShowModal )
  where

import Basics
import qualified HTML.Curry_Base
import qualified Curry_Prelude


d_C_bootstrapPage :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Cover -> ConstStore
  -> HTML.Curry_Base.C_HtmlPage
d_C_bootstrapPage x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 cd cs =
  let x13 = Curry_Prelude.d_C_map d_OP_bootstrapPage_dot_uscore_hash_lambda1
  in d_C_bootstrapPage2 x1 x2 x3 x4 x5 (Curry_Prelude.d_C_apply x13 x6 cd cs)
  (Curry_Prelude.d_C_apply x13 x7 cd cs) x8 x9 x10 x11 x12 cd cs

nd_C_bootstrapPage :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> IDSupply -> Cover -> ConstStore
  -> HTML.Curry_Base.C_HtmlPage
nd_C_bootstrapPage x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 s cd cs = let s3 = s
  in s3 `seq` (let x13 = wrapNX id (Curry_Prelude.nd_C_map (wrapNX id
                     nd_OP_bootstrapPage_dot_uscore_hash_lambda1))
  in let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_C_bootstrapPage2 x1 x2 x3 x4 x5
  (Curry_Prelude.nd_C_apply x13 x6 s0 cd cs) (Curry_Prelude.nd_C_apply x13 x7 s1
  cd cs) x8 x9 x10 x11 x12 s2 cd cs))))

d_OP_bootstrapPage_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml)
d_OP_bootstrapPage_dot_uscore_hash_lambda1 x1 cd cs = Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "nav-item") x1

nd_OP_bootstrapPage_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml)
nd_OP_bootstrapPage_dot_uscore_hash_lambda1 x1 s cd cs = Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "nav-item") x1

d_C_bootstrapPage2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml)) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Cover -> ConstStore
  -> HTML.Curry_Base.C_HtmlPage
d_C_bootstrapPage2 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 cd cs =
  let x13 = Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_pageMetaInfo cd cs)
        (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
        (Curry_Prelude.toCurryString "name") (Curry_Prelude.toCurryString
        "viewport")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
        (Curry_Prelude.toCurryString "content") (Curry_Prelude.toCurryString
        "width=device-width, initial-scale=1, shrink-to-fit=no"))
        Curry_Prelude.OP_List)) cd cs
      x14 = d_C__case_6 x1 (Curry_Prelude.d_C_null x1 cd cs) cd cs
  in HTML.Curry_Base.C_HtmlPage x4 (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_pageEnc
  cd cs) (Curry_Prelude.toCurryString "utf-8") cd cs) (Curry_Prelude.OP_Cons x13
  Curry_Prelude.OP_List)) (Curry_Prelude.d_OP_plus_plus x14
  (Curry_Prelude.d_C_map (HTML.Curry_Base.d_C_pageCSS cd cs) x2 cd cs) cd cs) cd
  cs) (d_C_bootstrapBody
  HTML.Curry_Base.d_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash
  x3 x5 x6 x7 x8 x9 x10 x11 x12 cd cs)

nd_C_bootstrapPage2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml)) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> IDSupply -> Cover -> ConstStore
  -> HTML.Curry_Base.C_HtmlPage
nd_C_bootstrapPage2 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 s cd cs = let s13 = s
  in s13 `seq` (let s2 = leftSupply s13
                    s14 = rightSupply s13
                    s3 = leftSupply s14
                    s12 = rightSupply s14
  in s2 `seq` (s14 `seq` (s3 `seq` (s12 `seq` (let x13 = let s1 = leftSupply s2
                                                             s0 = rightSupply s2
                                                     in s1 `seq` (s0 `seq`
                                                     Curry_Prelude.nd_C_apply
                                                     (HTML.Curry_Base.nd_C_pageMetaInfo
                                                     s0 cd cs)
                                                     (Curry_Prelude.OP_Cons
                                                     (Curry_Prelude.OP_Tuple2
                                                     (Curry_Prelude.toCurryString
                                                     "name")
                                                     (Curry_Prelude.toCurryString
                                                     "viewport"))
                                                     (Curry_Prelude.OP_Cons
                                                     (Curry_Prelude.OP_Tuple2
                                                     (Curry_Prelude.toCurryString
                                                     "content")
                                                     (Curry_Prelude.toCurryString
                                                     "width=device-width, initial-scale=1, shrink-to-fit=no"))
                                                     Curry_Prelude.OP_List)) s1
                                                     cd cs)
                                                   x14 = nd_C__case_6 x1
                                                     (Curry_Prelude.d_C_null x1
                                                     cd cs) s3 cd cs
  in let s10 = leftSupply s12
         s11 = rightSupply s12
  in s10 `seq` (s11 `seq` HTML.Curry_Base.C_HtmlPage x4 (let s6 = leftSupply s10
                                                             s9 = rightSupply
                                                               s10
  in s6 `seq` (s9 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (let s5 = leftSupply s6
       s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_pageEnc
  s4 cd cs) (Curry_Prelude.toCurryString "utf-8") s5 cd cs))
  (Curry_Prelude.OP_Cons x13 Curry_Prelude.OP_List))
  (Curry_Prelude.d_OP_plus_plus x14 (let s8 = leftSupply s9
                                         s7 = rightSupply s9
  in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_map (HTML.Curry_Base.nd_C_pageCSS s7
  cd cs) x2 s8 cd cs)) cd cs) cd cs)) (nd_C_bootstrapBody (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash)
  x3 x5 x6 x7 x8 x9 x10 x11 x12 s11 cd cs)))))))

d_C_bootstrapBody :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List t0)) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_bootstrapBody x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs = let x11 = d_C__case_3
                                                               x8 x1
                                                               (Curry_Prelude.d_C_null
                                                               x8 cd cs) cd cs
  in Curry_Prelude.d_OP_plus_plus (d_C_topNavigationBar x1 x3 x4 x5 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_blockstyle x1 (Curry_Prelude.toCurryString
  "container-fluid") cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_blockstyle x1
  (Curry_Prelude.toCurryString "row") cd cs) (d_C__case_5 x6 x9 x11 x1 x7
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x6 (Curry_Prelude.C_Int (0)) cd cs) cd cs) cd cs) Curry_Prelude.OP_List)
  (d_C__case_4 x10 x1 (Curry_Prelude.d_C_null x10 cd cs) cd cs) cd cs) cd cs)
  Curry_Prelude.OP_List) (Curry_Prelude.d_C_map
  (d_OP_bootstrapBody_dot_uscore_hash_lambda2 x1) x2 cd cs) cd cs) cd cs

nd_C_bootstrapBody :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)) -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_bootstrapBody x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s16 = s
  in s16 `seq` (let s0 = leftSupply s16
                    s15 = rightSupply s16
  in s0 `seq` (s15 `seq` (let x11 = nd_C__case_3 x8 x1 (Curry_Prelude.d_C_null
                                x8 cd cs) s0 cd cs
  in let s1 = leftSupply s15
         s14 = rightSupply s15
  in s1 `seq` (s14 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_topNavigationBar x1
  x3 x4 x5 s1 cd cs) (let s11 = leftSupply s14
                          s13 = rightSupply s14
  in s11 `seq` (s13 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (let s10 = leftSupply s11
       s12 = rightSupply s11
       s2 = leftSupply s12
       s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s2 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_blockstyle x1 (Curry_Prelude.toCurryString
  "container-fluid") s2 cd cs) (let s6 = leftSupply s9
                                    s8 = rightSupply s9
  in s6 `seq` (s8 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (let s5 = leftSupply s6
       s7 = rightSupply s6
       s3 = leftSupply s7
       s4 = rightSupply s7
  in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_blockstyle x1 (Curry_Prelude.toCurryString "row") s3 cd
  cs) (nd_C__case_5 x6 x9 x11 x1 x7
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x6 (Curry_Prelude.C_Int (0)) cd cs) s4 cd cs) s5 cd cs))))
  Curry_Prelude.OP_List) (nd_C__case_4 x10 x1 (Curry_Prelude.d_C_null x10 cd cs)
  s8 cd cs) cd cs)) s10 cd cs)))) Curry_Prelude.OP_List) (Curry_Prelude.nd_C_map
  (wrapNX id (nd_OP_bootstrapBody_dot_uscore_hash_lambda2 x1)) x2 s13 cd cs) cd
  cs)) cd cs))))

d_OP_bootstrapBody_dot_bsCols_dot_10 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_bootstrapBody_dot_bsCols_dot_10 x1 x2 cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "col-sm-") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x1 cd cs) x2 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "col-md-")
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x1 cd cs) x2 cd cs) cd cs) cd
  cs) cd cs) cd cs

nd_OP_bootstrapBody_dot_bsCols_dot_10 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_OP_bootstrapBody_dot_bsCols_dot_10 x1 x2 s cd cs = let s6 = s
  in s6 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "col-sm-") (let s2 = leftSupply s6
                  s5 = rightSupply s6
  in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x1 s0
  cd cs) x2 s1 cd cs)) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString " ") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "col-md-") (let s4 = leftSupply s5
                                               s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x1 s3
  cd cs) x2 s4 cd cs)) cd cs) cd cs) cd cs)) cd cs

d_OP_bootstrapBody_dot_uscore_hash_lambda2 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> t0
d_OP_bootstrapBody_dot_uscore_hash_lambda2 x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
  "script") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "src") x2) Curry_Prelude.OP_List) cd cs)
  Curry_Prelude.OP_List cd cs

nd_OP_bootstrapBody_dot_uscore_hash_lambda2 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML
  t0) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> t0
nd_OP_bootstrapBody_dot_uscore_hash_lambda2 x1 x2 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
  "script") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "src") x2) Curry_Prelude.OP_List) s3 cd cs))
  Curry_Prelude.OP_List s5 cd cs))

d_C_topNavigationBar :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List t0)) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_topNavigationBar x1 x2 x3 x4 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
    "nav") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
    "navbar navbar-expand-md navbar-dark fixed-top bg-dark"))
    Curry_Prelude.OP_List) cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_addClass x1 (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_href x1 x5 cd cs) x6 cd cs)
    (Curry_Prelude.toCurryString "navbar-brand") cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
    "button") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "type") (Curry_Prelude.toCurryString "button"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "class") (Curry_Prelude.toCurryString "navbar-toggler"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "data-toggle") (Curry_Prelude.toCurryString "collapse"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "data-target") (Curry_Prelude.toCurryString "#topnavbar"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "aria-expanded") (Curry_Prelude.toCurryString "false"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "aria-controls") (Curry_Prelude.toCurryString "topnavbar"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "aria-label") (Curry_Prelude.toCurryString "Toggle navigation"))
    Curry_Prelude.OP_List))))))) cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_textstyle x1 (Curry_Prelude.toCurryString
    "navbar-toggler-icon") Curry_Prelude.OP_List cd cs) Curry_Prelude.OP_List)
    cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_dollar
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
    "div") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "id") (Curry_Prelude.toCurryString
    "topnavbar")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
    "collapse navbar-collapse")) Curry_Prelude.OP_List)) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_ulistWithItemClass x1 (Curry_Prelude.toCurryString
    "navbar-nav mr-auto") x3 cd cs) Curry_Prelude.OP_List) (d_C__case_2 x4 x1
    (Curry_Prelude.d_C_null x4 cd cs) cd cs) cd cs) cd cs)
    Curry_Prelude.OP_List))) cd cs) Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_topNavigationBar x1
    l x3 x4 cd cs) (d_C_topNavigationBar x1 r x3 x4 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_topNavigationBar x1 z x3 x4 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_C_topNavigationBar x1 e x3 x4 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4.topNavigationBar" [show x1, show x2, show x3, show
    x4] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4.topNavigationBar" (showCons
    x2))

nd_C_topNavigationBar :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_topNavigationBar x1 x2 x3 x4 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s33 = s
    in s33 `seq` Curry_Prelude.OP_Cons (let s32 = leftSupply s33
                                            s34 = rightSupply s33
                                            s4 = leftSupply s34
                                            s31 = rightSupply s34
    in s32 `seq` (s34 `seq` (s4 `seq` (s31 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
    "nav") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
    "navbar navbar-expand-md navbar-dark fixed-top bg-dark"))
    Curry_Prelude.OP_List) s3 cd cs)) (let s9 = leftSupply s31
                                           s30 = rightSupply s31
    in s9 `seq` (s30 `seq` Curry_Prelude.OP_Cons (let s8 = leftSupply s9
                                                      s7 = rightSupply s9
    in s8 `seq` (s7 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s6 = leftSupply
                                                                  s7
                                                                s5 = rightSupply
                                                                  s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
    x5 s5 cd cs) x6 s6 cd cs)) (Curry_Prelude.toCurryString "navbar-brand") s8
    cd cs)) (let s17 = leftSupply s30
                 s28 = rightSupply s30
    in s17 `seq` (s28 `seq` Curry_Prelude.OP_Cons (let s16 = leftSupply s17
                                                       s18 = rightSupply s17
                                                       s14 = leftSupply s18
                                                       s15 = rightSupply s18
    in s16 `seq` (s18 `seq` (s14 `seq` (s15 `seq` Curry_Prelude.nd_C_apply
    (let s13 = leftSupply s14
         s12 = rightSupply s14
    in s13 `seq` (s12 `seq` Curry_Prelude.nd_C_apply (let s11 = leftSupply s12
                                                          s10 = rightSupply s12
    in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s10 cd cs) (Curry_Prelude.toCurryString
    "button") s11 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "type") (Curry_Prelude.toCurryString "button"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "class") (Curry_Prelude.toCurryString "navbar-toggler"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "data-toggle") (Curry_Prelude.toCurryString "collapse"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "data-target") (Curry_Prelude.toCurryString "#topnavbar"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "aria-expanded") (Curry_Prelude.toCurryString "false"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "aria-controls") (Curry_Prelude.toCurryString "topnavbar"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "aria-label") (Curry_Prelude.toCurryString "Toggle navigation"))
    Curry_Prelude.OP_List))))))) s13 cd cs)) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.nd_C_textstyle x1 (Curry_Prelude.toCurryString
    "navbar-toggler-icon") Curry_Prelude.OP_List s15 cd cs)
    Curry_Prelude.OP_List) s16 cd cs)))) (Curry_Prelude.OP_Cons
    (let s27 = leftSupply s28
         s29 = rightSupply s28
         s23 = leftSupply s29
         s26 = rightSupply s29
    in s27 `seq` (s29 `seq` (s23 `seq` (s26 `seq` Curry_Prelude.nd_OP_dollar
    (let s22 = leftSupply s23
         s21 = rightSupply s23
    in s22 `seq` (s21 `seq` Curry_Prelude.nd_C_apply (let s20 = leftSupply s21
                                                          s19 = rightSupply s21
    in s20 `seq` (s19 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s19 cd cs) (Curry_Prelude.toCurryString
    "div") s20 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "id") (Curry_Prelude.toCurryString
    "topnavbar")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
    "collapse navbar-collapse")) Curry_Prelude.OP_List)) s22 cd cs))
    (let s24 = leftSupply s26
         s25 = rightSupply s26
    in s24 `seq` (s25 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.nd_C_ulistWithItemClass x1 (Curry_Prelude.toCurryString
    "navbar-nav mr-auto") x3 s24 cd cs) Curry_Prelude.OP_List) (nd_C__case_2 x4
    x1 (Curry_Prelude.d_C_null x4 cd cs) s25 cd cs) cd cs)) s27 cd cs))))
    Curry_Prelude.OP_List))))) s32 cd cs)))) Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_topNavigationBar x1
    l x3 x4 s cd cs) (nd_C_topNavigationBar x1 r x3 x4 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_topNavigationBar x1 z x3 x4 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_C_topNavigationBar x1 e x3 x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4.topNavigationBar" [show x1, show x2, show x3, show
    x4] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4.topNavigationBar" (showCons
    x2))

d_C_titledSideMenu :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_titledSideMenu x1 x2 x3 cd cs = Curry_Prelude.d_OP_plus_plus (d_C__case_1 x2
  x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs) (Curry_Prelude.OP_Cons
  (HTML.Curry_Base.d_C_ulistWithClass x1 (Curry_Prelude.toCurryString
  "nav flex-column") (Curry_Prelude.toCurryString "nav-item") x3 cd cs)
  Curry_Prelude.OP_List) cd cs

nd_C_titledSideMenu :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_titledSideMenu x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C__case_1 x2 x1
  (Curry_Prelude.d_C_null x2 cd cs) s0 cd cs) (Curry_Prelude.OP_Cons
  (HTML.Curry_Base.nd_C_ulistWithClass x1 (Curry_Prelude.toCurryString
  "nav flex-column") (Curry_Prelude.toCurryString "nav-item") x3 s1 cd cs)
  Curry_Prelude.OP_List) cd cs))

nd_C_primButton :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Func
  HTML.Curry_Base.C_HtmlRef (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.C_IO HTML.Curry_Base.C_HtmlPage) -> IDSupply -> Cover
  -> ConstStore -> HTML.Curry_Base.C_HtmlExp
nd_C_primButton x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_HtmlExp_hash)
  (HTML.Curry_Base.nd_C_button x1 x2 s0 cd cs) (Curry_Prelude.toCurryString
  "btn btn-primary") s1 cd cs))

nd_C_primSmButton :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Func
  HTML.Curry_Base.C_HtmlRef (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.C_IO HTML.Curry_Base.C_HtmlPage) -> IDSupply -> Cover
  -> ConstStore -> HTML.Curry_Base.C_HtmlExp
nd_C_primSmButton x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_HtmlExp_hash)
  (HTML.Curry_Base.nd_C_button x1 x2 s0 cd cs) (Curry_Prelude.toCurryString
  "btn btn-sm btn-primary") s1 cd cs))

nd_C_scndButton :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Func
  HTML.Curry_Base.C_HtmlRef (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.C_IO HTML.Curry_Base.C_HtmlPage) -> IDSupply -> Cover
  -> ConstStore -> HTML.Curry_Base.C_HtmlExp
nd_C_scndButton x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_HtmlExp_hash)
  (HTML.Curry_Base.nd_C_button x1 x2 s0 cd cs) (Curry_Prelude.toCurryString
  "btn btn-secondary") s1 cd cs))

nd_C_scndSmButton :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Func
  HTML.Curry_Base.C_HtmlRef (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.C_IO HTML.Curry_Base.C_HtmlPage) -> IDSupply -> Cover
  -> ConstStore -> HTML.Curry_Base.C_HtmlExp
nd_C_scndSmButton x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_HtmlExp_hash)
  (HTML.Curry_Base.nd_C_button x1 x2 s0 cd cs) (Curry_Prelude.toCurryString
  "btn btn-sm btn-secondary") s1 cd cs))

nd_C_infoButton :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Func
  HTML.Curry_Base.C_HtmlRef (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.C_IO HTML.Curry_Base.C_HtmlPage) -> IDSupply -> Cover
  -> ConstStore -> HTML.Curry_Base.C_HtmlExp
nd_C_infoButton x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_HtmlExp_hash)
  (HTML.Curry_Base.nd_C_button x1 x2 s0 cd cs) (Curry_Prelude.toCurryString
  "btn btn-info") s1 cd cs))

nd_C_infoSmButton :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Func
  HTML.Curry_Base.C_HtmlRef (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.C_IO HTML.Curry_Base.C_HtmlPage) -> IDSupply -> Cover
  -> ConstStore -> HTML.Curry_Base.C_HtmlExp
nd_C_infoSmButton x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_HtmlExp_hash)
  (HTML.Curry_Base.nd_C_button x1 x2 s0 cd cs) (Curry_Prelude.toCurryString
  "btn btn-sm btn-info") s1 cd cs))

d_C_hrefPrimButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefPrimButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-primary") cd cs

nd_C_hrefPrimButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefPrimButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-primary") s3
  cd cs))

d_C_hrefPrimSmButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefPrimSmButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-primary") cd cs

nd_C_hrefPrimSmButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefPrimSmButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-primary") s3 cd cs))

d_C_hrefScndButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefScndButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-secondary") cd cs

nd_C_hrefScndButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefScndButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-secondary")
  s3 cd cs))

d_C_hrefScndSmButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefScndSmButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-secondary") cd cs

nd_C_hrefScndSmButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefScndSmButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-secondary") s3 cd cs))

d_C_hrefInfoButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefInfoButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-info") cd cs

nd_C_hrefInfoButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefInfoButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-info") s3 cd
  cs))

d_C_hrefInfoSmButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefInfoSmButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-info") cd cs

nd_C_hrefInfoSmButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefInfoSmButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-sm btn-info")
  s3 cd cs))

d_C_hrefSuccButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefSuccButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-success") cd cs

nd_C_hrefSuccButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefSuccButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-success") s3
  cd cs))

d_C_hrefSuccSmButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefSuccSmButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-success") cd cs

nd_C_hrefSuccSmButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefSuccSmButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-success") s3 cd cs))

d_C_hrefWarnButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefWarnButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-warning") cd cs

nd_C_hrefWarnButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefWarnButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-warning") s3
  cd cs))

d_C_hrefWarnSmButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefWarnSmButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-warning") cd cs

nd_C_hrefWarnSmButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefWarnSmButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-warning") s3 cd cs))

d_C_hrefDangButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefDangButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-danger") cd cs

nd_C_hrefDangButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefDangButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-danger") s3
  cd cs))

d_C_hrefDangSmButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefDangSmButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-danger") cd cs

nd_C_hrefDangSmButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefDangSmButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-danger") s3 cd cs))

d_C_hrefLightButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefLightButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-light") cd cs

nd_C_hrefLightButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefLightButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-light") s3 cd
  cs))

d_C_hrefLightSmButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefLightSmButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-light") cd cs

nd_C_hrefLightSmButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefLightSmButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-light") s3 cd cs))

d_C_hrefDarkButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefDarkButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-dark") cd cs

nd_C_hrefDarkButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefDarkButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-dark") s3 cd
  cs))

d_C_hrefDarkSmButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefDarkSmButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-dark") cd cs

nd_C_hrefDarkSmButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefDarkSmButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-sm btn-dark")
  s3 cd cs))

d_C_hrefPrimBlock :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefPrimBlock x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-primary btn-block") cd cs

nd_C_hrefPrimBlock :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefPrimBlock x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-primary btn-block") s3 cd cs))

d_C_hrefScndBlock :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefScndBlock x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-secondary btn-block") cd cs

nd_C_hrefScndBlock :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefScndBlock x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-secondary btn-block") s3 cd cs))

d_C_hrefInfoBlock :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefInfoBlock x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-info btn-block") cd cs

nd_C_hrefInfoBlock :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefInfoBlock x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-info btn-block") s3 cd cs))

d_C_hrefPrimSmBlock :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefPrimSmBlock x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-primary btn-block") cd cs

nd_C_hrefPrimSmBlock :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefPrimSmBlock x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-primary btn-block") s3 cd cs))

d_C_hrefScndSmBlock :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefScndSmBlock x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-secondary btn-block") cd cs

nd_C_hrefScndSmBlock :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefScndSmBlock x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-secondary btn-block") s3 cd cs))

d_C_hrefInfoSmBlock :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefInfoSmBlock x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-info btn-block") cd cs

nd_C_hrefInfoSmBlock :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefInfoSmBlock x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-info btn-block") s3 cd cs))

d_C_hrefPrimBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefPrimBadge x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "badge badge-primary") cd cs

nd_C_hrefPrimBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefPrimBadge x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "badge badge-primary")
  s3 cd cs))

d_C_hrefScndBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefScndBadge x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "badge badge-secondary") cd cs

nd_C_hrefScndBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefScndBadge x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "badge badge-secondary") s3 cd cs))

d_C_hrefSuccBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefSuccBadge x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "badge badge-success") cd cs

nd_C_hrefSuccBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefSuccBadge x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "badge badge-success")
  s3 cd cs))

d_C_hrefInfoBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefInfoBadge x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "badge badge-info") cd cs

nd_C_hrefInfoBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefInfoBadge x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "badge badge-info") s3
  cd cs))

d_C_hrefWarnBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefWarnBadge x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "badge badge-warning") cd cs

nd_C_hrefWarnBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefWarnBadge x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "badge badge-warning")
  s3 cd cs))

d_C_hrefDangBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefDangBadge x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "badge badge-danger") cd cs

nd_C_hrefDangBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefDangBadge x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "badge badge-danger")
  s3 cd cs))

d_C_hrefLightBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefLightBadge x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "badge badge-light") cd cs

nd_C_hrefLightBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefLightBadge x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "badge badge-light")
  s3 cd cs))

d_C_hrefDarkBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefDarkBadge x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "badge badge-dark") cd cs

nd_C_hrefDarkBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefDarkBadge x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "badge badge-dark") s3
  cd cs))

d_C_ehrefPrimBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_ehrefPrimBadge x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (d_C_eTarget x1)
  (d_C_hrefPrimBadge x1 x2 x3 cd cs) cd cs

nd_C_ehrefPrimBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_ehrefPrimBadge x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_eTarget x1))
  (nd_C_hrefPrimBadge x1 x2 x3 s0 cd cs) s1 cd cs))

d_C_ehrefScndBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_ehrefScndBadge x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (d_C_eTarget x1)
  (d_C_hrefScndBadge x1 x2 x3 cd cs) cd cs

nd_C_ehrefScndBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_ehrefScndBadge x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_eTarget x1))
  (nd_C_hrefScndBadge x1 x2 x3 s0 cd cs) s1 cd cs))

d_C_ehrefSuccBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_ehrefSuccBadge x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (d_C_eTarget x1)
  (d_C_hrefSuccBadge x1 x2 x3 cd cs) cd cs

nd_C_ehrefSuccBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_ehrefSuccBadge x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_eTarget x1))
  (nd_C_hrefSuccBadge x1 x2 x3 s0 cd cs) s1 cd cs))

d_C_ehrefInfoBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_ehrefInfoBadge x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (d_C_eTarget x1)
  (d_C_hrefInfoBadge x1 x2 x3 cd cs) cd cs

nd_C_ehrefInfoBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_ehrefInfoBadge x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_eTarget x1))
  (nd_C_hrefInfoBadge x1 x2 x3 s0 cd cs) s1 cd cs))

d_C_ehrefWarnBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_ehrefWarnBadge x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (d_C_eTarget x1)
  (d_C_hrefWarnBadge x1 x2 x3 cd cs) cd cs

nd_C_ehrefWarnBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_ehrefWarnBadge x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_eTarget x1))
  (nd_C_hrefWarnBadge x1 x2 x3 s0 cd cs) s1 cd cs))

d_C_ehrefDangBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_ehrefDangBadge x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (d_C_eTarget x1)
  (d_C_hrefDangBadge x1 x2 x3 cd cs) cd cs

nd_C_ehrefDangBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_ehrefDangBadge x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_eTarget x1))
  (nd_C_hrefDangBadge x1 x2 x3 s0 cd cs) s1 cd cs))

d_C_ehrefLightBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_ehrefLightBadge x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (d_C_eTarget x1)
  (d_C_hrefLightBadge x1 x2 x3 cd cs) cd cs

nd_C_ehrefLightBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_ehrefLightBadge x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_eTarget x1))
  (nd_C_hrefLightBadge x1 x2 x3 s0 cd cs) s1 cd cs))

d_C_ehrefDarkBadge :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_ehrefDarkBadge x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (d_C_eTarget x1)
  (d_C_hrefDarkBadge x1 x2 x3 cd cs) cd cs

nd_C_ehrefDarkBadge :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_ehrefDarkBadge x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_eTarget x1))
  (nd_C_hrefDarkBadge x1 x2 x3 s0 cd cs) s1 cd cs))

d_C_hrefNav :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C_hrefNav x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "nav-link") cd cs

nd_C_hrefNav :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefNav x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "nav-link") s3 cd cs))

d_C_hrefNavActive :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefNavActive x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1 (d_C_ehref x1
  x2 x3 cd cs) (Curry_Prelude.toCurryString "nav-link active") cd cs

nd_C_hrefNavActive :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefNavActive x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass x1 (nd_C_ehref x1 x2 x3 s0
  cd cs) (Curry_Prelude.toCurryString "nav-link active") s1 cd cs))

d_C_ehrefNav :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C_ehrefNav x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1 (d_C_ehref x1 x2
  x3 cd cs) (Curry_Prelude.toCurryString "nav-link") cd cs

nd_C_ehrefNav :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_ehrefNav x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass x1 (nd_C_ehref x1 x2 x3 s0
  cd cs) (Curry_Prelude.toCurryString "nav-link") s1 cd cs))

d_C_ehref :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C_ehref x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (d_C_eTarget x1)
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs) cd
  cs

nd_C_ehref :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_ehref x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_eTarget x1))
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) s3 cd cs))

d_C_eTarget :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> t0
  -> Cover -> ConstStore -> t0
d_C_eTarget x1 x2 cd cs = HTML.Curry_Base.d_C_addAttr x1 x2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "target")
  (Curry_Prelude.toCurryString "_blank")) cd cs

nd_C_eTarget :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_eTarget x1 x2 s cd cs = let s0 = s
  in s0 `seq` HTML.Curry_Base.nd_C_addAttr x1 x2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "target") (Curry_Prelude.toCurryString "_blank"))
  s0 cd cs

d_C_kbdInput :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> t0
d_C_kbdInput x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString "kbd")
  cd cs) Curry_Prelude.OP_List cd cs

nd_C_kbdInput :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) t0
nd_C_kbdInput x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
  "kbd") s1 cd cs)) Curry_Prelude.OP_List s3 cd cs))

d_C_staticButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_staticButton x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
  "button") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "type") (Curry_Prelude.toCurryString "button"))
  Curry_Prelude.OP_List) cd cs

nd_C_staticButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) t0
nd_C_staticButton x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
  "button") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "type") (Curry_Prelude.toCurryString "button"))
  Curry_Prelude.OP_List) s3 cd cs))

d_C_modal :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C_modal x1 x2 x3 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString "div")
  cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal fade")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "id") x2) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "tabindex")
  (Curry_Prelude.toCurryString "-1")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "role")
  (Curry_Prelude.toCurryString "dialog")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "aria-labelledby") x3)
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "aria-hidden") (Curry_Prelude.toCurryString "true"))
  Curry_Prelude.OP_List)))))) cd cs

nd_C_modal :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) t0
nd_C_modal x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
  "div") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal fade")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "id") x2) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "tabindex")
  (Curry_Prelude.toCurryString "-1")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "role")
  (Curry_Prelude.toCurryString "dialog")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "aria-labelledby") x3)
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "aria-hidden") (Curry_Prelude.toCurryString "true"))
  Curry_Prelude.OP_List)))))) s3 cd cs))

d_C_modalDialog :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_modalDialog x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString "div")
  cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-dialog")) Curry_Prelude.OP_List) cd cs

nd_C_modalDialog :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) t0
nd_C_modalDialog x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
  "div") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-dialog")) Curry_Prelude.OP_List) s3 cd cs))

d_C_modalContent :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_modalContent x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString "div")
  cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-content")) Curry_Prelude.OP_List) cd cs

nd_C_modalContent :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) t0
nd_C_modalContent x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
  "div") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-content")) Curry_Prelude.OP_List) s3 cd cs))

d_C_modalHeader :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_modalHeader x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString "div")
  cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-header")) Curry_Prelude.OP_List) cd cs

nd_C_modalHeader :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) t0
nd_C_modalHeader x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
  "div") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-header")) Curry_Prelude.OP_List) s3 cd cs))

d_C_modalBody :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> t0
d_C_modalBody x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString "div")
  cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-body")) Curry_Prelude.OP_List) cd cs

nd_C_modalBody :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) t0
nd_C_modalBody x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
  "div") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-body")) Curry_Prelude.OP_List) s3 cd cs))

d_C_modalFooter :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_modalFooter x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString "div")
  cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-footer")) Curry_Prelude.OP_List) cd cs

nd_C_modalFooter :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) t0
nd_C_modalFooter x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
  "div") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-footer")) Curry_Prelude.OP_List) s3 cd cs))

d_C_modalDismiss :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_modalDismiss cd cs = Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "data-dismiss") (Curry_Prelude.toCurryString "modal")

d_C_modalToggle :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_modalToggle cd cs = Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "data-toggle") (Curry_Prelude.toCurryString "modal")

d_C_stdModalClose :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Cover -> ConstStore -> t0
d_C_stdModalClose x1 cd cs = HTML.Curry_Base.d_C_addAttrs x1
  (Curry_Prelude.d_C_apply (d_C_staticButton x1 cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_htmlText x1 cd cs)
  (Curry_Prelude.toCurryString "&times;") cd cs) Curry_Prelude.OP_List) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "class") (Curry_Prelude.toCurryString "close")) (Curry_Prelude.OP_Cons
  (d_C_modalDismiss cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "aria-hidden") (Curry_Prelude.toCurryString
  "true")) Curry_Prelude.OP_List))) cd cs

nd_C_stdModalClose :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_stdModalClose x1 s cd cs = let s8 = s
  in s8 `seq` (let s7 = leftSupply s8
                   s5 = rightSupply s8
  in s7 `seq` (s5 `seq` HTML.Curry_Base.nd_C_addAttrs x1 (let s4 = leftSupply s5
                                                              s6 = rightSupply
                                                                s5
                                                              s0 = leftSupply s6
                                                              s3 = rightSupply
                                                                s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (nd_C_staticButton x1 s0 cd cs) (Curry_Prelude.OP_Cons (let s2 = leftSupply s3
                                                              s1 = rightSupply
                                                                s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_htmlText
  x1 s1 cd cs) (Curry_Prelude.toCurryString "&times;") s2 cd cs))
  Curry_Prelude.OP_List) s4 cd cs)))) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "class")
  (Curry_Prelude.toCurryString "close")) (Curry_Prelude.OP_Cons
  (d_C_modalDismiss cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "aria-hidden") (Curry_Prelude.toCurryString
  "true")) Curry_Prelude.OP_List))) s7 cd cs))

d_C_stdModal :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_stdModal x1 x2 x3 x4 x5 x6 cd cs = let x7 = Curry_Prelude.d_OP_plus_plus x3
                                             (Curry_Prelude.toCurryString
                                             "Label") cd cs
  in HTML.Curry_Base.d_C_addAttrs x1 (Curry_Prelude.d_C_apply (d_C_modal x1 x3
  x7 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_modalDialog x1
  cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_modalContent x1 cd
  cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_modalHeader x1 cd cs)
  (Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_addAttr x1
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString "h5")
  cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-title")) Curry_Prelude.OP_List) cd cs) x4 cd cs)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "id") x7) cd cs)
  (Curry_Prelude.OP_Cons (d_C_stdModalClose x1 cd cs) Curry_Prelude.OP_List)) cd
  cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_modalBody x1 cd cs)
  x5 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_modalFooter x1
  cd cs) x6 cd cs) Curry_Prelude.OP_List))) cd cs) Curry_Prelude.OP_List) cd cs)
  Curry_Prelude.OP_List) cd cs) (d_C__case_0 x2 cd cs) cd cs

nd_C_stdModal :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore -> t0
nd_C_stdModal x1 x2 x3 x4 x5 x6 s cd cs = let s36 = s
  in s36 `seq` (let x7 = Curry_Prelude.d_OP_plus_plus x3
                      (Curry_Prelude.toCurryString "Label") cd cs
  in let s35 = leftSupply s36
         s33 = rightSupply s36
  in s35 `seq` (s33 `seq` HTML.Curry_Base.nd_C_addAttrs x1 (let s32 = leftSupply
                                                                  s33
                                                                s34 = rightSupply
                                                                  s33
                                                                s0 = leftSupply
                                                                  s34
                                                                s30 = rightSupply
                                                                  s34
  in s32 `seq` (s34 `seq` (s0 `seq` (s30 `seq` Curry_Prelude.nd_C_apply
  (nd_C_modal x1 x3 x7 s0 cd cs) (Curry_Prelude.OP_Cons (let s29 = leftSupply
                                                               s30
                                                             s31 = rightSupply
                                                               s30
                                                             s1 = leftSupply s31
                                                             s27 = rightSupply
                                                               s31
  in s29 `seq` (s31 `seq` (s1 `seq` (s27 `seq` Curry_Prelude.nd_C_apply
  (nd_C_modalDialog x1 s1 cd cs) (Curry_Prelude.OP_Cons (let s26 = leftSupply
                                                               s27
                                                             s28 = rightSupply
                                                               s27
                                                             s2 = leftSupply s28
                                                             s25 = rightSupply
                                                               s28
  in s26 `seq` (s28 `seq` (s2 `seq` (s25 `seq` Curry_Prelude.nd_C_apply
  (nd_C_modalContent x1 s2 cd cs) (let s16 = leftSupply s25
                                       s24 = rightSupply s25
  in s16 `seq` (s24 `seq` Curry_Prelude.OP_Cons (let s15 = leftSupply s16
                                                     s17 = rightSupply s16
                                                     s3 = leftSupply s17
                                                     s14 = rightSupply s17
  in s15 `seq` (s17 `seq` (s3 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
  (nd_C_modalHeader x1 s3 cd cs) (let s12 = leftSupply s14
                                      s13 = rightSupply s14
  in s12 `seq` (s13 `seq` Curry_Prelude.OP_Cons (let s11 = leftSupply s12
                                                     s10 = rightSupply s12
  in s11 `seq` (s10 `seq` HTML.Curry_Base.nd_C_addAttr x1 (let s9 = leftSupply
                                                                 s10
                                                               s8 = rightSupply
                                                                 s10
  in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s4 cd cs) (Curry_Prelude.toCurryString
  "h5") s5 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
  "modal-title")) Curry_Prelude.OP_List) s7 cd cs)) x4 s9 cd cs))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "id") x7) s11 cd cs))
  (Curry_Prelude.OP_Cons (nd_C_stdModalClose x1 s13 cd cs)
  Curry_Prelude.OP_List))) s15 cd cs)))) (let s20 = leftSupply s24
                                              s23 = rightSupply s24
  in s20 `seq` (s23 `seq` Curry_Prelude.OP_Cons (let s19 = leftSupply s20
                                                     s18 = rightSupply s20
  in s19 `seq` (s18 `seq` Curry_Prelude.nd_C_apply (nd_C_modalBody x1 s18 cd cs)
  x5 s19 cd cs)) (Curry_Prelude.OP_Cons (let s22 = leftSupply s23
                                             s21 = rightSupply s23
  in s22 `seq` (s21 `seq` Curry_Prelude.nd_C_apply (nd_C_modalFooter x1 s21 cd
  cs) x6 s22 cd cs)) Curry_Prelude.OP_List))))) s26 cd cs))))
  Curry_Prelude.OP_List) s29 cd cs)))) Curry_Prelude.OP_List) s32 cd cs))))
  (d_C__case_0 x2 cd cs) s35 cd cs))

d_C_modalLaunchPrimButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> t0
d_C_modalLaunchPrimButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addAttrs x1
  (Curry_Prelude.d_C_apply (d_C_staticButton x1 cd cs) (Curry_Prelude.OP_Cons
  (HTML.Curry_Base.d_C_htxt x1 x3 cd cs) Curry_Prelude.OP_List) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "class") (Curry_Prelude.toCurryString "btn btn-primary"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "data-toggle") (Curry_Prelude.toCurryString "modal")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "data-target")
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '#'#) x2))
  Curry_Prelude.OP_List))) cd cs

nd_C_modalLaunchPrimButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> t0
nd_C_modalLaunchPrimButton x1 x2 x3 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` HTML.Curry_Base.nd_C_addAttrs x1 (let s2 = leftSupply s3
                                                              s4 = rightSupply
                                                                s3
                                                              s0 = leftSupply s4
                                                              s1 = rightSupply
                                                                s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (nd_C_staticButton x1 s0 cd cs) (Curry_Prelude.OP_Cons
  (HTML.Curry_Base.nd_C_htxt x1 x3 s1 cd cs) Curry_Prelude.OP_List) s2 cd cs))))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "class") (Curry_Prelude.toCurryString "btn btn-primary"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "data-toggle") (Curry_Prelude.toCurryString "modal")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "data-target")
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '#'#) x2))
  Curry_Prelude.OP_List))) s5 cd cs))

d_C_modalClosePrimButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> t0
d_C_modalClosePrimButton x1 x2 cd cs = HTML.Curry_Base.d_C_addAttrs x1
  (Curry_Prelude.d_C_apply (d_C_staticButton x1 cd cs) (Curry_Prelude.OP_Cons
  (HTML.Curry_Base.d_C_htxt x1 x2 cd cs) Curry_Prelude.OP_List) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "class") (Curry_Prelude.toCurryString "btn btn-primary"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "data-dismiss") (Curry_Prelude.toCurryString "modal")) Curry_Prelude.OP_List))
  cd cs

nd_C_modalClosePrimButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_modalClosePrimButton x1 x2 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` HTML.Curry_Base.nd_C_addAttrs x1 (let s2 = leftSupply s3
                                                              s4 = rightSupply
                                                                s3
                                                              s0 = leftSupply s4
                                                              s1 = rightSupply
                                                                s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (nd_C_staticButton x1 s0 cd cs) (Curry_Prelude.OP_Cons
  (HTML.Curry_Base.nd_C_htxt x1 x2 s1 cd cs) Curry_Prelude.OP_List) s2 cd cs))))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "class") (Curry_Prelude.toCurryString "btn btn-primary"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "data-dismiss") (Curry_Prelude.toCurryString "modal")) Curry_Prelude.OP_List))
  s5 cd cs))

d_C_scriptShowModal :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
d_C_scriptShowModal x1 cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_hStruct
  HTML.Curry_Base.d_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash
  (Curry_Prelude.toCurryString "script") cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_OP_dollar
  (HTML.Curry_Base.d_OP_uscore_impl_hash_htmlText_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash
  cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "$(document).ready(function(){ $(\"#") (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.toCurryString "\").modal('show'); });") cd cs) cd cs) cd cs)
  Curry_Prelude.OP_List) cd cs) Curry_Prelude.OP_List

nd_C_scriptShowModal :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
nd_C_scriptShowModal x1 s cd cs = let s5 = s
  in s5 `seq` Curry_Prelude.OP_Cons (let s4 = leftSupply s5
                                         s6 = rightSupply s5
                                         s0 = leftSupply s6
                                         s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_hStruct (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash)
  (Curry_Prelude.toCurryString "script") s0 cd cs) (Curry_Prelude.OP_Cons
  (let s2 = leftSupply s3
       s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_OP_dollar
  (HTML.Curry_Base.nd_OP_uscore_impl_hash_htmlText_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash
  s1 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "$(document).ready(function(){ $(\"#") (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.toCurryString "\").modal('show'); });") cd cs) cd cs) s2 cd
  cs)) Curry_Prelude.OP_List) s4 cd cs)))) Curry_Prelude.OP_List

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_PageParam
d_C__case_6 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_pageLinkInfo cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "rel")
    (Curry_Prelude.toCurryString "shortcut icon")) (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "href") x1)
    Curry_Prelude.OP_List)) cd cs) Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x1 l cd cs)
    (d_C__case_6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_6" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_6" (showCons x2))

nd_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_PageParam
nd_C__case_6 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` Curry_Prelude.OP_Cons (let s1 = leftSupply s2
                                           s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_pageLinkInfo s0 cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "rel")
    (Curry_Prelude.toCurryString "shortcut icon")) (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "href") x1)
    Curry_Prelude.OP_List)) s1 cd cs)) Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_6 x1 l s cd cs)
    (nd_C__case_6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_6 x1 z
    s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_6 x1 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_6" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_6" (showCons x2))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_3 x8 x1 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
    "header") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
    "jumbotron")) Curry_Prelude.OP_List) cd cs) x8 cd cs) Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x8 x1 l cd cs)
    (d_C__case_3 x8 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x8 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x8 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_3" [show x8, show x1, show x9] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_3" (showCons x9))

nd_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Func Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_3 x8 x1 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` Curry_Prelude.OP_Cons (let s5 = leftSupply s6
                                           s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
    "header") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
    "jumbotron")) Curry_Prelude.OP_List) s3 cd cs)) x8 s5 cd cs))
    Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x8 x1 l s cd
    cs) (nd_C__case_3 x8 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x8
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_3 x8 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_3" [show x8, show x1, show x9] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_3" (showCons x9))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_4 x10 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_hrule x1
    cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_footer x1 cd cs) x10 cd cs) Curry_Prelude.OP_List)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x10 x1 l cd cs)
    (d_C__case_4 x10 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x10
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x10 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_4" [show x10, show x1, show x11] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_4" (showCons x11))

nd_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Func Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_4 x10 x1 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.OP_Cons (HTML.Curry_Base.nd_C_hrule x1
    s0 cd cs) (Curry_Prelude.OP_Cons (let s2 = leftSupply s3
                                          s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_footer
    x1 s1 cd cs) x10 s2 cd cs)) Curry_Prelude.OP_List)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x10 x1 l s cd
    cs) (nd_C__case_4 x10 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x10
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x10 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_4" [show x10, show x1, show x11] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_4" (showCons x11))

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_5 x6 x9 x11 x1 x7 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_blockstyle x1 (d_OP_bootstrapBody_dot_bsCols_dot_10
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (12)) cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus x11
    x9 cd cs) cd cs) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_blockstyle x1 (d_OP_bootstrapBody_dot_bsCols_dot_10
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    x6 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_blockstyle x1 (Curry_Prelude.toCurryString "card") cd
    cs) x7 cd cs) Curry_Prelude.OP_List) cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_blockstyle x1
    (d_OP_bootstrapBody_dot_bsCols_dot_10
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (12)) x6 cd cs) cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus x11 x9 cd cs) cd cs) Curry_Prelude.OP_List)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x6 x9 x11 x1 x7
    l cd cs) (d_C__case_5 x6 x9 x11 x1 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x6 x9
    x11 x1 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x6 x9
    x11 x1 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_5" [show x6, show x9, show x11, show x1, show
    x7, show x12] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_5" (showCons x12))

nd_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_5 x6 x9 x11 x1 x7 x12 s cd cs = case x12 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` Curry_Prelude.OP_Cons (let s3 = leftSupply s4
                                           s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_blockstyle x1
    (nd_OP_bootstrapBody_dot_bsCols_dot_10 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    (Curry_Prelude.C_Int (12)) s0 cd cs) s1 cd cs))
    (Curry_Prelude.d_OP_plus_plus x11 x9 cd cs) s3 cd cs)) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s14 = s
    in s14 `seq` (let s7 = leftSupply s14
                      s13 = rightSupply s14
    in s7 `seq` (s13 `seq` Curry_Prelude.OP_Cons (let s6 = leftSupply s7
                                                      s8 = rightSupply s7
                                                      s2 = leftSupply s8
                                                      s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_blockstyle x1
    (nd_OP_bootstrapBody_dot_bsCols_dot_10 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    x6 s0 cd cs) s1 cd cs)) (Curry_Prelude.OP_Cons (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_blockstyle x1 (Curry_Prelude.toCurryString "card") s3
    cd cs) x7 s4 cd cs)) Curry_Prelude.OP_List) s6 cd cs))))
    (Curry_Prelude.OP_Cons (let s12 = leftSupply s13
                                s11 = rightSupply s13
    in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (let s10 = leftSupply s11
                                                          s9 = rightSupply s11
    in s10 `seq` (s9 `seq` HTML.Curry_Base.nd_C_blockstyle x1
    (nd_OP_bootstrapBody_dot_bsCols_dot_10 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (12)) x6 cd cs) s9 cd cs) s10 cd cs))
    (Curry_Prelude.d_OP_plus_plus x11 x9 cd cs) s12 cd cs))
    Curry_Prelude.OP_List)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_5 x6 x9 x11 x1
    x7 l s cd cs) (nd_C__case_5 x6 x9 x11 x1 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_5 x6
    x9 x11 x1 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_5 x6 x9
    x11 x1 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_5" [show x6, show x9, show x11, show x1, show
    x7, show x12] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_5" (showCons x12))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List t0)) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_2 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_ulistWithItemClass x1 (Curry_Prelude.toCurryString
    "navbar-nav navbar-right") x4 cd cs) Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x4 x1 l cd cs)
    (d_C__case_2 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x4 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x4 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_2" [show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_2" (showCons x5))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List t0)) -> Func Curry_Prelude.OP_Unit
  (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_2 x4 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (HTML.Curry_Base.nd_C_ulistWithItemClass
    x1 (Curry_Prelude.toCurryString "navbar-nav navbar-right") x4 s0 cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x4 x1 l s cd
    cs) (nd_C__case_2 x4 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x4
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x4 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_2" [show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_2" (showCons x5))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_1 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_h5 x1 cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_htxt x1 x2 cd cs) Curry_Prelude.OP_List) cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x2 x1 l cd cs)
    (d_C__case_1 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x2 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_1" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_1" (showCons x3))

nd_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_1 x2 x1 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s3 = s
    in s3 `seq` Curry_Prelude.OP_Cons (let s2 = leftSupply s3
                                           s4 = rightSupply s3
                                           s0 = leftSupply s4
                                           s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_h5 x1 s0 cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.nd_C_htxt x1 x2 s1 cd cs) Curry_Prelude.OP_List) s2 cd
    cs)))) Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_1 x2 x1 l s cd
    cs) (nd_C__case_1 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_1 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_1 x2 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_1" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_1" (showCons x3))

d_C__case_0 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_0 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "data-backdrop") (Curry_Prelude.toCurryString
    "static")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "data-keyboard") (Curry_Prelude.toCurryString
    "false")) Curry_Prelude.OP_List)
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 l cd cs)
    (d_C__case_0 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap4._case_0" [show x2] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap4._case_0" (showCons x2))

