{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Curry_Trie
  ( C_Trie (..)
  , d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
  , d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
  , nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
  , d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
  , nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  , d_C_empty
  , d_C_null
  , d_C_size
  , d_C_singleton
  , nd_C_singleton
  , d_C_insert
  , d_C_update
  , nd_C_update
  , d_C_delete
  , d_C_lookup
  , d_C_containsKey
  , nd_C_containsKey
  , d_C_fromList
  , nd_C_fromList
  , d_C_toList )
  where

import Basics
import qualified Data.Curry_Maybe
import qualified Data.Trie.Curry_Internal
import qualified Curry_Prelude


data C_Trie t0
  = C_Trie Curry_Prelude.C_Int (Data.Trie.Curry_Internal.C_InternalTrie t0)
  | Choice_C_Trie Cover ID (C_Trie t0) (C_Trie t0)
  | Choices_C_Trie Cover ID [C_Trie t0]
  | Fail_C_Trie Cover FailInfo
  | Guard_C_Trie Cover Constraints (C_Trie t0)

instance (Curry t0) => Show (C_Trie t0) where
  showsPrec d (Choice_C_Trie cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Trie cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Trie cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Trie cd info) = showChar '!'
  showsPrec _ (C_Trie x1 x2) = showString "(Trie" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))

instance (Curry t0) => Read (C_Trie t0) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Trie x1 x2, r2) | (_, r0) <-
    readQualified "Data.Trie" "Trie" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1]) s

instance NonDet (C_Trie t0) where
  choiceCons = Choice_C_Trie
  choicesCons = Choices_C_Trie
  failCons = Fail_C_Trie
  guardCons = Guard_C_Trie
  try (Choice_C_Trie cd i x y) = tryChoice cd i x y
  try (Choices_C_Trie cd i xs) = tryChoices cd i xs
  try (Fail_C_Trie cd info) = Fail cd info
  try (Guard_C_Trie cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Trie cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Trie cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Trie cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Trie cd i _) = error
    ("Data.Trie.Trie.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Trie cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Trie cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0) => Generable (C_Trie t0) where
  generate s c = Choices_C_Trie c (freeID [2] s) [C_Trie (generate (leftSupply
    s) c) (generate (rightSupply s) c)]

instance (Curry t0) => NormalForm (C_Trie t0) where
  ($!!) cont (C_Trie x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Trie y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Trie cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Trie cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Trie cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Trie cd info) _ _ = failCons cd info
  ($##) cont (C_Trie x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Trie y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Trie cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Trie cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Trie cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Trie cd info) _ _ = failCons cd info
  showCons (C_Trie _ _) = "Data.Trie.Trie _ _"
  showCons x = error ("Data.Trie.Trie.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Trie x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Trie y1 y2)) x2) x1
  searchNF _ _ x = error ("Data.Trie.Trie.searchNF: no constructor: " ++ show x)

instance (Curry t0) => Unifiable (C_Trie t0) where
  (=.=) (C_Trie x1 x2) (C_Trie y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Trie x1 x2) (C_Trie y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Trie x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind d i (Choice_C_Trie cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Trie cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Trie cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Trie cd i _) = error
    ("Data.Trie.Trie.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Trie cd info) = [Unsolvable info]
  bind d i (Guard_C_Trie cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Trie x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_Trie cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Trie cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Trie cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Trie cd i _) = error
    ("Data.Trie.Trie.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Trie cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Trie cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0) => Curry (C_Trie t0) where

d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Functor C_Trie
d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Functor (acceptCs
    id
    d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash)
    (d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash z
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie._inst#Prelude.Functor#Data.Trie.Trie#" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie._inst#Prelude.Functor#Data.Trie.Trie#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Functor C_Trie
nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Functor (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash))
    (nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie._inst#Prelude.Functor#Data.Trie.Trie#" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie._inst#Prelude.Functor#Data.Trie.Trie#"
    (showCons x1))

d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t1 -> Cover
  -> ConstStore -> t0) -> C_Trie t1 -> Cover -> ConstStore -> C_Trie t0
d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash x1 x2 cd cs =
  case x2 of
  C_Trie x3 x4 -> C_Trie x3
    (Data.Trie.Curry_Internal.d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1 x4 cd cs)
  Choice_C_Trie d i l r -> narrow d i
    (d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    x1 r cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    x1 z cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail
    "Data.Trie._impl#fmap#Prelude.Functor#Data.Trie.Trie#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Data.Trie._impl#fmap#Prelude.Functor#Data.Trie.Trie#" (showCons x2))

nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t1 t0 -> C_Trie
  t1 -> IDSupply -> Cover -> ConstStore -> C_Trie t0
nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash x1 x2 s cd cs =
  case x2 of
  C_Trie x3 x4 -> let s0 = s
    in s0 `seq` C_Trie x3
    (Data.Trie.Curry_Internal.nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash
    x1 x4 s0 cd cs)
  Choice_C_Trie d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    x1 l s cd cs)
    (nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    x1 r s cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    x1 z s cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash
    x1 e s cd x) $! addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail
    "Data.Trie._impl#fmap#Prelude.Functor#Data.Trie.Trie#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Data.Trie._impl#fmap#Prelude.Functor#Data.Trie.Trie#" (showCons x2))

d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Cover -> ConstStore -> C_Trie t0 -> Cover -> ConstStore -> C_Trie
  t1
d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_lt_dollar_hash_Prelude_dot_Functor
  d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash cd
  cs

nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Func (C_Trie t0) (C_Trie t1))
nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash s cd cs =
  let s0 = s
  in s0 `seq`
  Curry_Prelude.nd_OP_uscore_def_hash_lt_dollar_hash_Prelude_dot_Functor (wrapNX
  id
  nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Data_dot_Trie_dot_Trie_hash)
  s0 cd cs

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data (C_Trie t0)
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie._inst#Prelude.Data#Data.Trie.Trie#0##" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie._inst#Prelude.Data#Data.Trie.Trie#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> C_Trie t0 -> C_Trie t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x2 of
  C_Trie x4 x5 -> let s0 = s in s0 `seq` nd_C__case_3 x5 x1 x4 x3 s0 cd cs
  Choice_C_Trie d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 l x3 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 r x3 s cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 z x3 s cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 e x3 s cd x) $! addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail
    "Data.Trie._impl#===#Prelude.Data#Data.Trie.Trie#0##" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "Data.Trie._impl#===#Prelude.Data#Data.Trie.Trie#0##" (showCons x2))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> IDSupply -> Cover -> ConstStore -> C_Trie t0
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Trie
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s0 cd cs)
  (Data.Trie.Curry_Internal.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
  x1 s1 cd cs)))

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show (C_Trie t0)
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 cd cs) (acceptCs id
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1))
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie._inst#Prelude.Show#Data.Trie.Trie#0##" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie._inst#Prelude.Show#Data.Trie.Trie#0##"
    (showCons x2))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show (C_Trie t0)
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Show
    (nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 s0 cd cs) (wrapDX (wrapNX id) (acceptCs id
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 s1 cd cs)))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie._inst#Prelude.Show#Data.Trie.Trie#0##" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie._inst#Prelude.Show#Data.Trie.Trie#0##"
    (showCons x2))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Cover -> ConstStore -> C_Trie
  t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  x1)

nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> IDSupply -> Cover -> ConstStore -> Func (C_Trie t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 s cd cs =
  wrapNX id (Curry_Prelude.nd_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  x1)))

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_Int -> C_Trie
  t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 x2 x3 cd cs =
  case x3 of
  C_Trie x4 x5 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x2 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Trie "))
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (11)) cd cs) x4 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " "))
    (Data.Trie.Curry_Internal.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 (Curry_Prelude.C_Int (11)) x5 cd cs) cd cs) cd cs) cd cs) cd cs
  Choice_C_Trie d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 x2 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 x2 r cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 x2 z cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 x2 e cd x) $! addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail
    "Data.Trie._impl#showsPrec#Prelude.Show#Data.Trie.Trie#0##" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail
    "Data.Trie._impl#showsPrec#Prelude.Show#Data.Trie.Trie#0##" (showCons x3))

nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Int -> C_Trie t0 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x3 of
  C_Trie x4 x5 -> let s15 = s
    in s15 `seq` (let s14 = leftSupply s15
                      s16 = rightSupply s15
                      s2 = leftSupply s16
                      s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s2 `seq` (s13 `seq` Curry_Prelude.nd_C_showParen
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) (Curry_Prelude.C_Int (10)) s0 cd cs) x2 s1 cd cs))
    (let s12 = leftSupply s13
         s10 = rightSupply s13
    in s12 `seq` (s10 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Trie ")))
    (let s9 = leftSupply s10
         s11 = rightSupply s10
         s5 = leftSupply s11
         s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s5 `seq` (s8 `seq` Curry_Prelude.nd_OP_dot
    (let s4 = leftSupply s5
         s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX (wrapDX id))
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) (Curry_Prelude.C_Int (11)) s3 cd cs) x4 s4 cd cs))
    (let s7 = leftSupply s8
         s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " ")))
    (Data.Trie.Curry_Internal.nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 (Curry_Prelude.C_Int (11)) x5 s6 cd cs) s7 cd cs)) s9 cd cs)))) s12 cd
    cs)) s14 cd cs))))
  Choice_C_Trie d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 x2 l s cd cs)
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 x2 r s cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 x2 z s cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 x2 e s cd x) $! addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail
    "Data.Trie._impl#showsPrec#Prelude.Show#Data.Trie.Trie#0##" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail
    "Data.Trie._impl#showsPrec#Prelude.Show#Data.Trie.Trie#0##" (showCons x3))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_Trie t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  x1) cd cs

nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List (C_Trie t0))
  (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 s cd cs =
  let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  x1)) s0 cd cs

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq (C_Trie t0)
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1))
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie._inst#Prelude.Eq#Data.Trie.Trie#0##" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie._inst#Prelude.Eq#Data.Trie.Trie#0##"
    (showCons x2))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq (C_Trie t0)
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Trie._inst#Prelude.Eq#Data.Trie.Trie#0##" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Trie._inst#Prelude.Eq#Data.Trie.Trie#0##"
    (showCons x2))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> C_Trie t0 -> C_Trie t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 x2 x3 cd cs =
  case x2 of
  C_Trie x4 x5 -> d_C__case_2 x5 x1 x4 x3 cd cs
  Choice_C_Trie d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 l x3 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 r x3 cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 z x3 cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 e x3 cd x) $! addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail
    "Data.Trie._impl#==#Prelude.Eq#Data.Trie.Trie#0##" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "Data.Trie._impl#==#Prelude.Eq#Data.Trie.Trie#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> C_Trie t0 -> C_Trie t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x2 of
  C_Trie x4 x5 -> let s0 = s in s0 `seq` nd_C__case_2 x5 x1 x4 x3 s0 cd cs
  Choice_C_Trie d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 l x3 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 r x3 s cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 z x3 s cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
    x1 e x3 s cd x) $! addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail
    "Data.Trie._impl#==#Prelude.Eq#Data.Trie.Trie#0##" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "Data.Trie._impl#==#Prelude.Eq#Data.Trie.Trie#0##"
    (showCons x2))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Cover -> ConstStore -> C_Trie
  t0 -> Cover -> ConstStore -> C_Trie t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  x1))

nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> IDSupply -> Cover -> ConstStore -> Func (C_Trie t0) (Func (C_Trie t0)
  Curry_Prelude.C_Bool)
nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash x1 s cd cs =
  wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Trie_hash_0_hash_hash
  x1))))

d_C_empty :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => C_Trie t0
d_C_empty cd cs = C_Trie (Curry_Prelude.C_Int (0))
  (Data.Trie.Curry_Internal.d_C_empty' cd cs)

d_C_null :: forall t0 . (Curry_Prelude.Curry t0) => C_Trie t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_null x1 cd cs = case x1 of
  C_Trie x2 x3 -> Data.Trie.Curry_Internal.d_C_null' x3 cd cs
  Choice_C_Trie d i l r -> narrow d i (d_C_null l cd cs) (d_C_null r cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z -> d_C_null z cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x -> d_C_null e cd x) $! addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail "Data.Trie.null" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.null" (showCons x1))

d_C_size :: forall t0 . (Curry_Prelude.Curry t0) => C_Trie t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C_size x1 cd cs = case x1 of
  C_Trie x2 x3 -> x2
  Choice_C_Trie d i l r -> narrow d i (d_C_size l cd cs) (d_C_size r cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z -> d_C_size z cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x -> d_C_size e cd x) $! addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail "Data.Trie.size" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.size" (showCons x1))

d_C_singleton :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> C_Trie t0
d_C_singleton cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_OP_dot (acceptCs
  id (C_Trie (Curry_Prelude.C_Int (1))))) (acceptCs id
  Data.Trie.Curry_Internal.d_C_singleton') cd cs

nd_C_singleton :: IDSupply -> Cover -> ConstStore
  -> forall t0 . (Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Func t0 (C_Trie t0))
nd_C_singleton s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id (Curry_Prelude.nd_OP_dot
  (wrapDX id (acceptCs id (C_Trie (Curry_Prelude.C_Int (1))))))) (wrapDX (wrapDX
  id) (acceptCs id Data.Trie.Curry_Internal.d_C_singleton')) s0 cd cs

d_C_insert :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> C_Trie t0 -> Cover -> ConstStore -> C_Trie t0
d_C_insert x1 x2 x3 cd cs = d_C_update x1 (Curry_Prelude.d_C_const x2) x3 cd cs

d_C_update :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.C_Maybe t0 -> Cover -> ConstStore
  -> t0) -> C_Trie t0 -> Cover -> ConstStore -> C_Trie t0
d_C_update x1 x2 x3 cd cs = case x3 of
  C_Trie x4 x5 -> let x6 = Data.Trie.Curry_Internal.d_C_update' x1 x2 x5 cd cs
                      x7 = d_OP_update_dot_uscore_hash_selFP2_hash_incr x6 cd cs
                      x8 = d_OP_update_dot_uscore_hash_selFP3_hash_t x6 cd cs
    in C_Trie (d_C__case_1 x4 x7 cd cs) x8
  Choice_C_Trie d i l r -> narrow d i (d_C_update x1 x2 l cd cs) (d_C_update x1
    x2 r cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z -> d_C_update x1 x2 z cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x -> d_C_update x1 x2 e cd x) $! addCs
    c cs)
  Fail_C_Trie d info -> failCons d (traceFail "Data.Trie.update" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.update" (showCons x3))

nd_C_update :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.C_Maybe t0) t0 -> C_Trie t0
  -> IDSupply -> Cover -> ConstStore -> C_Trie t0
nd_C_update x1 x2 x3 s cd cs = case x3 of
  C_Trie x4 x5 -> let s0 = s
    in s0 `seq` (let x6 = Data.Trie.Curry_Internal.nd_C_update' x1 x2 x5 s0 cd
                       cs
                     x7 = d_OP_update_dot_uscore_hash_selFP2_hash_incr x6 cd cs
                     x8 = d_OP_update_dot_uscore_hash_selFP3_hash_t x6 cd cs
    in C_Trie (d_C__case_1 x4 x7 cd cs) x8)
  Choice_C_Trie d i l r -> narrow d i (nd_C_update x1 x2 l s cd cs) (nd_C_update
    x1 x2 r s cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z -> nd_C_update x1 x2 z s cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x -> nd_C_update x1 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail "Data.Trie.update" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail "Data.Trie.update" (showCons x3))

d_OP_update_dot_uscore_hash_selFP2_hash_incr :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool
  (Data.Trie.Curry_Internal.C_InternalTrie t0) -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_update_dot_uscore_hash_selFP2_hash_incr x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_update_dot_uscore_hash_selFP2_hash_incr l cd cs)
    (d_OP_update_dot_uscore_hash_selFP2_hash_incr r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_update_dot_uscore_hash_selFP2_hash_incr z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_update_dot_uscore_hash_selFP2_hash_incr e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.update._#selFP2#incr" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.update._#selFP2#incr" (showCons x1))

d_OP_update_dot_uscore_hash_selFP3_hash_t :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool
  (Data.Trie.Curry_Internal.C_InternalTrie t0) -> Cover -> ConstStore
  -> Data.Trie.Curry_Internal.C_InternalTrie t0
d_OP_update_dot_uscore_hash_selFP3_hash_t x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_update_dot_uscore_hash_selFP3_hash_t l cd cs)
    (d_OP_update_dot_uscore_hash_selFP3_hash_t r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_update_dot_uscore_hash_selFP3_hash_t z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_update_dot_uscore_hash_selFP3_hash_t e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Trie.update._#selFP3#t" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.update._#selFP3#t" (showCons x1))

d_C_delete :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Trie t0 -> Cover -> ConstStore -> C_Trie t0
d_C_delete x1 x2 cd cs = case x2 of
  C_Trie x3 x4 -> d_C__case_0 x4 x1 x3 (Data.Trie.Curry_Internal.d_C_delete' x1
    x4 cd cs) cd cs
  Choice_C_Trie d i l r -> narrow d i (d_C_delete x1 l cd cs) (d_C_delete x1 r
    cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z -> d_C_delete x1 z cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x -> d_C_delete x1 e cd x) $! addCs c
    cs)
  Fail_C_Trie d info -> failCons d (traceFail "Data.Trie.delete" [show x1, show
    x2] info)
  _ -> failCons cd (consFail "Data.Trie.delete" (showCons x2))

d_C_lookup :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Trie t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe t0
d_C_lookup x1 x2 cd cs = case x2 of
  C_Trie x3 x4 -> Data.Trie.Curry_Internal.d_C_lookup' x1 x4 cd cs
  Choice_C_Trie d i l r -> narrow d i (d_C_lookup x1 l cd cs) (d_C_lookup x1 r
    cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z -> d_C_lookup x1 z cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x -> d_C_lookup x1 e cd x) $! addCs c
    cs)
  Fail_C_Trie d info -> failCons d (traceFail "Data.Trie.lookup" [show x1, show
    x2] info)
  _ -> failCons cd (consFail "Data.Trie.lookup" (showCons x2))

d_C_containsKey :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => C_Trie t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_containsKey cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_OP_dot
  Data.Curry_Maybe.d_C_isJust) (acceptCs id (Curry_Prelude.d_C_flip (acceptCs id
  d_C_lookup))) cd cs

nd_C_containsKey :: IDSupply -> Cover -> ConstStore
  -> forall t0 . (Curry_Prelude.Curry t0) => Func (C_Trie t0) (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool)
nd_C_containsKey s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id (Curry_Prelude.nd_OP_dot
  (wrapDX id Data.Curry_Maybe.d_C_isJust))) (wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id d_C_lookup))))) s0
  cd cs

d_C_fromList :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0) -> Cover -> ConstStore -> C_Trie t0
d_C_fromList cd cs = Curry_Prelude.d_C_foldr (Curry_Prelude.d_C_uncurry
  (acceptCs (acceptCs id) d_C_insert)) (d_C_empty cd cs)

nd_C_fromList :: IDSupply -> Cover -> ConstStore
  -> forall t0 . (Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0))
  (C_Trie t0)
nd_C_fromList s cd cs = wrapNX id (Curry_Prelude.nd_C_foldr (wrapNX id
  (Curry_Prelude.nd_C_uncurry (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs
  id) d_C_insert)))) (d_C_empty cd cs))

d_C_toList :: forall t0 . (Curry_Prelude.Curry t0) => C_Trie t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
d_C_toList x1 cd cs = case x1 of
  C_Trie x2 x3 -> Data.Trie.Curry_Internal.d_C_toList' x3 cd cs
  Choice_C_Trie d i l r -> narrow d i (d_C_toList l cd cs) (d_C_toList r cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z -> d_C_toList z cd cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x -> d_C_toList e cd x) $! addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail "Data.Trie.toList" [show x1] info)
  _ -> failCons cd (consFail "Data.Trie.toList" (showCons x1))

nd_C__case_3 :: forall t0 . (Curry_Prelude.Curry
  t0) => Data.Trie.Curry_Internal.C_InternalTrie t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.C_Int -> C_Trie t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_3 x5 x1 x4 x3 s cd cs = case x3 of
  C_Trie x6 x7 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x4 s0 cd cs) x6 s1 cd cs))
    (Data.Trie.Curry_Internal.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x5 x7 s3 cd cs) cd cs))
  Choice_C_Trie d i l r -> narrow d i (nd_C__case_3 x5 x1 x4 l s cd cs)
    (nd_C__case_3 x5 x1 x4 r s cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z -> nd_C__case_3 x5 x1 x4 z s cd
    cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x -> nd_C__case_3 x5 x1 x4 e s cd x) $!
    addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail "Data.Trie._case_3" [show x5, show
    x1, show x4, show x3] info)
  _ -> failCons cd (consFail "Data.Trie._case_3" (showCons x3))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry
  t0) => Data.Trie.Curry_Internal.C_InternalTrie t0 -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.C_Int -> C_Trie t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_2 x5 x1 x4 x3 cd cs = case x3 of
  C_Trie x6 x7 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x4 x6 cd cs)
    (Data.Trie.Curry_Internal.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x5 x7 cd cs) cd cs
  Choice_C_Trie d i l r -> narrow d i (d_C__case_2 x5 x1 x4 l cd cs)
    (d_C__case_2 x5 x1 x4 r cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z -> d_C__case_2 x5 x1 x4 z cd cs)
    xs
  Guard_C_Trie d c e -> guardCons d c ((\x -> d_C__case_2 x5 x1 x4 e cd x) $!
    addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail "Data.Trie._case_2" [show x5, show
    x1, show x4, show x3] info)
  _ -> failCons cd (consFail "Data.Trie._case_2" (showCons x3))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry
  t0) => Data.Trie.Curry_Internal.C_InternalTrie t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.C_Int -> C_Trie t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_2 x5 x1 x4 x3 s cd cs = case x3 of
  C_Trie x6 x7 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x4 x6 cd cs)
    (Data.Trie.Curry_Internal.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Trie_dot_Internal_dot_InternalTrie_hash_0_hash_hash
    x1 x5 x7 s0 cd cs) cd cs
  Choice_C_Trie d i l r -> narrow d i (nd_C__case_2 x5 x1 x4 l s cd cs)
    (nd_C__case_2 x5 x1 x4 r s cd cs)
  Choices_C_Trie d i xs -> narrows cs d i (\z -> nd_C__case_2 x5 x1 x4 z s cd
    cs) xs
  Guard_C_Trie d c e -> guardCons d c ((\x -> nd_C__case_2 x5 x1 x4 e s cd x) $!
    addCs c cs)
  Fail_C_Trie d info -> failCons d (traceFail "Data.Trie._case_2" [show x5, show
    x1, show x4, show x3] info)
  _ -> failCons cd (consFail "Data.Trie._case_2" (showCons x3))

d_C__case_1 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C__case_1 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x4 (Curry_Prelude.C_Int (1)) cd cs
  Curry_Prelude.C_False -> x4
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x4 l cd cs)
    (d_C__case_1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x4 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Trie._case_1"
    [show x4, show x7] info)
  _ -> failCons cd (consFail "Data.Trie._case_1" (showCons x7))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry
  t0) => Data.Trie.Curry_Internal.C_InternalTrie t0 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe
  (Data.Trie.Curry_Internal.C_InternalTrie t0) -> Cover -> ConstStore -> C_Trie
  t0
d_C__case_0 x4 x1 x3 x6 cd cs = case x6 of
  Curry_Prelude.C_Nothing -> C_Trie x3 x4
  Curry_Prelude.C_Just x5 -> C_Trie
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (1)) cd cs) x5
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_0 x4 x1 x3 l cd
    cs) (d_C__case_0 x4 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_0 x4
    x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x -> d_C__case_0 x4 x1
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail "Data.Trie._case_0"
    [show x4, show x1, show x3, show x6] info)
  _ -> failCons cd (consFail "Data.Trie._case_0" (showCons x6))

