{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_MakeFile
  ( C_MakeElement (..)
  , C_SpecialTarget (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
  , d_C_showMakeFile )
  where

import Basics
import qualified Data.Curry_List
import qualified Curry_Prelude


data C_MakeElement
  = C_DefineVariable (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  | C_Rule (Curry_Prelude.OP_List C_SpecialTarget) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char))
  | C_Comment (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Empty
  | Choice_C_MakeElement Cover ID C_MakeElement C_MakeElement
  | Choices_C_MakeElement Cover ID [C_MakeElement]
  | Fail_C_MakeElement Cover FailInfo
  | Guard_C_MakeElement Cover Constraints C_MakeElement

instance Show C_MakeElement where
  showsPrec d (Choice_C_MakeElement cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_MakeElement cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_MakeElement cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_MakeElement cd info) = showChar '!'
  showsPrec _ (C_DefineVariable x1 x2) = showString "(DefineVariable" .
    (showChar ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_Rule x1 x2 x3 x4) = showString "(Rule" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' .
    (shows x4 . showChar ')'))))))))
  showsPrec _ (C_Comment x1) = showString "(Comment" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ C_Empty = showString "Empty"

instance Read C_MakeElement where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_DefineVariable x1 x2, r2) | (_
    , r0) <- readQualified "MakeFile" "DefineVariable" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r ->
    [(C_Rule x1 x2 x3 x4, r4) | (_, r0) <- readQualified "MakeFile" "Rule" r,
    (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <-
    readsPrec 11 r2, (x4, r4) <- readsPrec 11 r3]) s ++ (readParen ((>) d 10)
    (\r -> [(C_Comment x1, r1) | (_, r0) <- readQualified "MakeFile" "Comment"
    r, (x1, r1) <- readsPrec 11 r0]) s ++ readParen False (\r -> [(C_Empty
    , r0) | (_, r0) <- readQualified "MakeFile" "Empty" r]) s))

instance NonDet C_MakeElement where
  choiceCons = Choice_C_MakeElement
  choicesCons = Choices_C_MakeElement
  failCons = Fail_C_MakeElement
  guardCons = Guard_C_MakeElement
  try (Choice_C_MakeElement cd i x y) = tryChoice cd i x y
  try (Choices_C_MakeElement cd i xs) = tryChoices cd i xs
  try (Fail_C_MakeElement cd info) = Fail cd info
  try (Guard_C_MakeElement cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_MakeElement cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_MakeElement cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_MakeElement cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_MakeElement cd i _) = error
    ("MakeFile.MakeElement.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_MakeElement cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_MakeElement cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_MakeElement where
  generate s c = Choices_C_MakeElement c (freeID [2, 4, 1, 0] s)
    [C_DefineVariable (generate (leftSupply s) c) (generate (rightSupply s) c)
    , C_Rule (generate (leftSupply (leftSupply s)) c) (generate (rightSupply
    (leftSupply s)) c) (generate (leftSupply (rightSupply s)) c) (generate
    (rightSupply (rightSupply s)) c), C_Comment (generate (leftSupply s) c)
    , C_Empty]

instance NormalForm C_MakeElement where
  ($!!) cont (C_DefineVariable x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (C_DefineVariable y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Rule x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_Rule y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Comment x1) d cs = ($!!) (\y1 d cs -> cont (C_Comment y1) d cs)
    x1 d cs
  ($!!) cont C_Empty d cs = cont C_Empty d cs
  ($!!) cont (Choice_C_MakeElement cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_MakeElement cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_MakeElement cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_MakeElement cd info) _ _ = failCons cd info
  ($##) cont (C_DefineVariable x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (C_DefineVariable y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_Rule x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_Rule y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_Comment x1) d cs = ($##) (\y1 d cs -> cont (C_Comment y1) d cs)
    x1 d cs
  ($##) cont C_Empty d cs = cont C_Empty d cs
  ($##) cont (Choice_C_MakeElement cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_MakeElement cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_MakeElement cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_MakeElement cd info) _ _ = failCons cd info
  showCons (C_DefineVariable _ _) = "MakeFile.DefineVariable _ _"
  showCons (C_Rule _ _ _ _) = "MakeFile.Rule _ _ _ _"
  showCons (C_Comment _) = "MakeFile.Comment _"
  showCons C_Empty = "MakeFile.Empty"
  showCons x = error ("MakeFile.MakeElement.showCons: no constructor: " ++ show
    x)
  searchNF search cont (C_DefineVariable x1 x2) = search (\y1 -> search (\y2 ->
    cont (C_DefineVariable y1 y2)) x2) x1
  searchNF search cont (C_Rule x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_Rule y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF search cont (C_Comment x1) = search (\y1 -> cont (C_Comment y1)) x1
  searchNF _ cont C_Empty = cont C_Empty
  searchNF _ _ x = error ("MakeFile.MakeElement.searchNF: no constructor: " ++
    show x)

instance Unifiable C_MakeElement where
  (=.=) (C_DefineVariable x1 x2) (C_DefineVariable y1 y2) d cs = (&) ((=:=) x1
    y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_Rule x1 x2 x3 x4) (C_Rule y1 y2 y3 y4) d cs = (&) ((=:=) x1 y1 d cs)
    ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs) d cs) d
    cs) d cs
  (=.=) (C_Comment x1) (C_Comment y1) d cs = (=:=) x1 y1 d cs
  (=.=) C_Empty C_Empty d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_DefineVariable x1 x2) (C_DefineVariable y1 y2) d cs = (&) ((=:<=) x1
    y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_Rule x1 x2 x3 x4) (C_Rule y1 y2 y3 y4) d cs = (&) ((=:<=) x1 y1 d
    cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d cs) d
    cs) d cs) d cs
  (=.<=) (C_Comment x1) (C_Comment y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) C_Empty C_Empty d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_DefineVariable x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_Rule x3 x4 x5 x6) = (i :=: ChooseN 1 4) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID (rightID
    i)) x5, bind cd (rightID (rightID i)) x6]
  bind cd i (C_Comment x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i)
    x3]
  bind cd i C_Empty = (i :=: ChooseN 3 0) : concat []
  bind d i (Choice_C_MakeElement cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_MakeElement cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_MakeElement cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_MakeElement cd i _) = error
    ("MakeFile.MakeElement.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_MakeElement cd info) = [Unsolvable info]
  bind d i (Guard_C_MakeElement cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_DefineVariable x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_Rule x3 x4 x5 x6) = (i :=: ChooseN 1 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind cd i (C_Comment x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i C_Empty = (i :=: ChooseN 3 0) : []
  lazyBind d i (Choice_C_MakeElement cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_MakeElement cd j@(FreeID _ _) xs) = lazyBindOrNarrow d
    i cd j xs
  lazyBind d i (Choices_C_MakeElement cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_MakeElement cd i _) = error
    ("MakeFile.MakeElement.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_MakeElement cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_MakeElement cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_MakeElement where

data C_SpecialTarget
  = C_PHONY
  | C_NOTPARALLEL
  | Choice_C_SpecialTarget Cover ID C_SpecialTarget C_SpecialTarget
  | Choices_C_SpecialTarget Cover ID [C_SpecialTarget]
  | Fail_C_SpecialTarget Cover FailInfo
  | Guard_C_SpecialTarget Cover Constraints C_SpecialTarget

instance Show C_SpecialTarget where
  showsPrec d (Choice_C_SpecialTarget cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_SpecialTarget cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_SpecialTarget cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_SpecialTarget cd info) = showChar '!'
  showsPrec _ C_PHONY = showString "PHONY"
  showsPrec _ C_NOTPARALLEL = showString "NOTPARALLEL"

instance Read C_SpecialTarget where
  readsPrec _ s = readParen False (\r -> [(C_PHONY, r0) | (_, r0) <-
    readQualified "MakeFile" "PHONY" r]) s ++ readParen False (\r ->
    [(C_NOTPARALLEL, r0) | (_, r0) <- readQualified "MakeFile" "NOTPARALLEL" r])
    s

instance NonDet C_SpecialTarget where
  choiceCons = Choice_C_SpecialTarget
  choicesCons = Choices_C_SpecialTarget
  failCons = Fail_C_SpecialTarget
  guardCons = Guard_C_SpecialTarget
  try (Choice_C_SpecialTarget cd i x y) = tryChoice cd i x y
  try (Choices_C_SpecialTarget cd i xs) = tryChoices cd i xs
  try (Fail_C_SpecialTarget cd info) = Fail cd info
  try (Guard_C_SpecialTarget cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_SpecialTarget cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_SpecialTarget cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_SpecialTarget cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_SpecialTarget cd i _) = error
    ("MakeFile.SpecialTarget.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_SpecialTarget cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_SpecialTarget cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_SpecialTarget where
  generate s c = Choices_C_SpecialTarget c (freeID [0, 0] s) [C_PHONY
    , C_NOTPARALLEL]

instance NormalForm C_SpecialTarget where
  ($!!) cont C_PHONY d cs = cont C_PHONY d cs
  ($!!) cont C_NOTPARALLEL d cs = cont C_NOTPARALLEL d cs
  ($!!) cont (Choice_C_SpecialTarget cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_SpecialTarget cd i xs) d cs = nfChoices cont cd i xs d
    cs
  ($!!) cont (Guard_C_SpecialTarget cd c e) d cs = guardCons cd c (($!!) cont e
    d (addCs c cs))
  ($!!) _ (Fail_C_SpecialTarget cd info) _ _ = failCons cd info
  ($##) cont C_PHONY d cs = cont C_PHONY d cs
  ($##) cont C_NOTPARALLEL d cs = cont C_NOTPARALLEL d cs
  ($##) cont (Choice_C_SpecialTarget cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_SpecialTarget cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_SpecialTarget cd c e) d cs = guardCons cd c (($##) cont e
    d (addCs c cs))
  ($##) _ (Fail_C_SpecialTarget cd info) _ _ = failCons cd info
  showCons C_PHONY = "MakeFile.PHONY"
  showCons C_NOTPARALLEL = "MakeFile.NOTPARALLEL"
  showCons x = error ("MakeFile.SpecialTarget.showCons: no constructor: " ++
    show x)
  searchNF _ cont C_PHONY = cont C_PHONY
  searchNF _ cont C_NOTPARALLEL = cont C_NOTPARALLEL
  searchNF _ _ x = error ("MakeFile.SpecialTarget.searchNF: no constructor: " ++
    show x)

instance Unifiable C_SpecialTarget where
  (=.=) C_PHONY C_PHONY d cs = C_True
  (=.=) C_NOTPARALLEL C_NOTPARALLEL d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_PHONY C_PHONY d cs = C_True
  (=.<=) C_NOTPARALLEL C_NOTPARALLEL d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_PHONY = (i :=: ChooseN 0 0) : concat []
  bind cd i C_NOTPARALLEL = (i :=: ChooseN 1 0) : concat []
  bind d i (Choice_C_SpecialTarget cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_SpecialTarget cd j@(FreeID _ _) xs) = bindOrNarrow d i cd
    j xs
  bind d i (Choices_C_SpecialTarget cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_SpecialTarget cd i _) = error
    ("MakeFile.SpecialTarget.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_SpecialTarget cd info) = [Unsolvable info]
  bind d i (Guard_C_SpecialTarget cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_PHONY = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_NOTPARALLEL = (i :=: ChooseN 1 0) : []
  lazyBind d i (Choice_C_SpecialTarget cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_SpecialTarget cd j@(FreeID _ _) xs) = lazyBindOrNarrow
    d i cd j xs
  lazyBind d i (Choices_C_SpecialTarget cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_SpecialTarget cd i _) = error
    ("MakeFile.SpecialTarget.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_SpecialTarget cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_SpecialTarget cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_SpecialTarget where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_MakeElement
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "MakeFile._inst#Prelude.Data#MakeFile.MakeElement#" [show x1] info)
  _ -> failCons cd (consFail "MakeFile._inst#Prelude.Data#MakeFile.MakeElement#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash :: C_MakeElement
  -> C_MakeElement -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash x1 x2 s cd cs =
  case x1 of
  C_DefineVariable x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_7 x4 x3 x2 s0 cd cs
  C_Rule x12 x13 x14 x15 -> let s0 = s
    in s0 `seq` nd_C__case_6 x15 x14 x13 x12 x2 s0 cd cs
  C_Comment x23 -> let s0 = s in s0 `seq` nd_C__case_5 x23 x2 s0 cd cs
  C_Empty -> d_C__case_4 x2 cd cs
  Choice_C_MakeElement d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash
    r x2 s cd cs)
  Choices_C_MakeElement d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash
    z x2 s cd cs) xs
  Guard_C_MakeElement d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_MakeElement d info -> failCons d (traceFail
    "MakeFile._impl#===#Prelude.Data#MakeFile.MakeElement#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "MakeFile._impl#===#Prelude.Data#MakeFile.MakeElement#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash :: IDSupply
  -> Cover -> ConstStore -> C_MakeElement
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_MakeFile_dot_MakeElement_hash s cd cs =
  let s18 = s
  in s18 `seq` (let s17 = leftSupply s18
                    s15 = rightSupply s18
  in s17 `seq` (s15 `seq` choice (let s14 = leftSupply s15
                                      s16 = rightSupply s15
                                      s11 = leftSupply s16
                                      s13 = rightSupply s16
  in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s2 = leftSupply s12
                                                            s7 = rightSupply s12
  in s10 `seq` (s12 `seq` (s2 `seq` (s7 `seq` choice (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_DefineVariable
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s1 cd cs))) (let s8 = leftSupply s7
                   s9 = rightSupply s7
                   s3 = leftSupply s8
                   s4 = rightSupply s8
                   s5 = leftSupply s9
                   s6 = rightSupply s9
  in s8 `seq` (s9 `seq` (s3 `seq` (s4 `seq` (s5 `seq` (s6 `seq` C_Rule
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash)
  s3 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s4 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s5 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s6 cd cs))))))) s10 cd cs)))) (C_Comment
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s13 cd cs)) s14 cd cs)))) C_Empty s17 cd cs))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_SpecialTarget
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "MakeFile._inst#Prelude.Data#MakeFile.SpecialTarget#" [show x1] info)
  _ -> failCons cd (consFail
    "MakeFile._inst#Prelude.Data#MakeFile.SpecialTarget#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash :: C_SpecialTarget
  -> C_SpecialTarget -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash x1 x2 cd cs =
  case x1 of
  C_PHONY -> d_C__case_3 x2 cd cs
  C_NOTPARALLEL -> d_C__case_2 x2 cd cs
  Choice_C_SpecialTarget d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
    r x2 cd cs)
  Choices_C_SpecialTarget d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
    z x2 cd cs) xs
  Guard_C_SpecialTarget d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_SpecialTarget d info -> failCons d (traceFail
    "MakeFile._impl#===#Prelude.Data#MakeFile.SpecialTarget#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "MakeFile._impl#===#Prelude.Data#MakeFile.SpecialTarget#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash :: IDSupply
  -> Cover -> ConstStore -> C_SpecialTarget
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash s cd cs =
  let s0 = s in s0 `seq` choice C_PHONY C_NOTPARALLEL s0 cd cs

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_SpecialTarget
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "MakeFile._inst#Prelude.Show#MakeFile.SpecialTarget#" [show x1] info)
  _ -> failCons cd (consFail
    "MakeFile._inst#Prelude.Show#MakeFile.SpecialTarget#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_SpecialTarget
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "MakeFile._inst#Prelude.Show#MakeFile.SpecialTarget#" [show x1] info)
  _ -> failCons cd (consFail
    "MakeFile._inst#Prelude.Show#MakeFile.SpecialTarget#" (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash :: Cover
  -> ConstStore -> C_SpecialTarget -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash :: Curry_Prelude.C_Int
  -> C_SpecialTarget -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash x1 x2 cd cs =
  case x2 of
  C_PHONY -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "PHONY")
  C_NOTPARALLEL -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "NOTPARALLEL")
  Choice_C_SpecialTarget d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    x1 r cd cs)
  Choices_C_SpecialTarget d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    x1 z cd cs) xs
  Guard_C_SpecialTarget d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_SpecialTarget d info -> failCons d (traceFail
    "MakeFile._impl#showsPrec#Prelude.Show#MakeFile.SpecialTarget#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "MakeFile._impl#showsPrec#Prelude.Show#MakeFile.SpecialTarget#" (showCons
    x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SpecialTarget -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash cd
  cs

d_C_showMakeFile :: Cover -> ConstStore -> Curry_Prelude.OP_List C_MakeElement
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showMakeFile cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_unlines cd
  cs) (Curry_Prelude.d_C_map d_C_showMakeElement) cd cs

d_C_showMakeElement :: C_MakeElement -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showMakeElement x1 cd cs = case x1 of
  C_Empty -> Curry_Prelude.OP_List
  C_Comment x2 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "# ") x2 cd cs
  C_DefineVariable x3 x4 -> Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " = ")
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString " \\\n\t  ")
    (d_C_unwordsUpTo (Curry_Prelude.C_Int (70)) x4 cd cs) cd cs) cd cs) cd cs
  C_Rule x5 x6 x7 x8 -> Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unlines cd
    cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_map
    (d_OP_showMakeElement_dot_uscore_hash_lambda1 x6) x5 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_OP_plus_plus x6 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString ": ") (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString " \\\n\t  ") (d_C_unwordsUpTo
    (Curry_Prelude.C_Int (70)) x7 cd cs) cd cs) cd cs) cd cs)
    Curry_Prelude.OP_List) (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\t")) x8 cd cs) cd cs) cd cs) cd cs
  Choice_C_MakeElement d i l r -> narrow d i (d_C_showMakeElement l cd cs)
    (d_C_showMakeElement r cd cs)
  Choices_C_MakeElement d i xs -> narrows cs d i (\z -> d_C_showMakeElement z cd
    cs) xs
  Guard_C_MakeElement d c e -> guardCons d c ((\x -> d_C_showMakeElement e cd
    x) $! addCs c cs)
  Fail_C_MakeElement d info -> failCons d (traceFail "MakeFile.showMakeElement"
    [show x1] info)
  _ -> failCons cd (consFail "MakeFile.showMakeElement" (showCons x1))

d_OP_showMakeElement_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_SpecialTarget -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showMakeElement_dot_uscore_hash_lambda1 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (d_C_showSpecialTarget x2 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ": ") x1 cd cs) cd
  cs

d_C_showSpecialTarget :: C_SpecialTarget -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showSpecialTarget x1 cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.C_Char
  '.'#) (Curry_Prelude.d_C_apply
  (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_MakeFile_dot_SpecialTarget_hash
  cd cs) x1 cd cs)

d_C_unwordsUpTo :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_unwordsUpTo x1 x2 cd cs = d_OP_unwordsUpTo_dot_fillWords_dot_15 x1
  (Curry_Prelude.C_Int (0)) Curry_Prelude.OP_List x2 cd cs

d_OP_unwordsUpTo_dot_fillWords_dot_15 :: Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_unwordsUpTo_dot_fillWords_dot_15 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x5 x6 -> let x7 = Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
                                       x2 (Curry_Prelude.d_C_length x5 cd cs) cd
                                       cs
    in d_C__case_1 x2 x1 x7 x6 x5 x3 (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x7 cd cs) x1 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x2 (Curry_Prelude.C_Int (0)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_unwordsUpTo_dot_fillWords_dot_15 x1 x2 x3 l cd cs)
    (d_OP_unwordsUpTo_dot_fillWords_dot_15 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_unwordsUpTo_dot_fillWords_dot_15 x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_unwordsUpTo_dot_fillWords_dot_15 x1 x2 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "MakeFile.unwordsUpTo.fillWords.15" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "MakeFile.unwordsUpTo.fillWords.15" (showCons x4))

d_C__case_4 :: C_MakeElement -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x2 cd cs = case x2 of
  C_DefineVariable x31 x32 -> Curry_Prelude.C_False
  C_Rule x33 x34 x35 x36 -> Curry_Prelude.C_False
  C_Comment x37 -> Curry_Prelude.C_False
  C_Empty -> Curry_Prelude.C_True
  Choice_C_MakeElement d i l r -> narrow d i (d_C__case_4 l cd cs) (d_C__case_4
    r cd cs)
  Choices_C_MakeElement d i xs -> narrows cs d i (\z -> d_C__case_4 z cd cs) xs
  Guard_C_MakeElement d c e -> guardCons d c ((\x -> d_C__case_4 e cd x) $!
    addCs c cs)
  Fail_C_MakeElement d info -> failCons d (traceFail "MakeFile._case_4" [show
    x2] info)
  _ -> failCons cd (consFail "MakeFile._case_4" (showCons x2))

nd_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_MakeElement
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_5 x23 x2 s cd cs = case x2 of
  C_DefineVariable x24 x25 -> Curry_Prelude.C_False
  C_Rule x26 x27 x28 x29 -> Curry_Prelude.C_False
  C_Comment x30 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x23 x30 s0 cd cs
  C_Empty -> Curry_Prelude.C_False
  Choice_C_MakeElement d i l r -> narrow d i (nd_C__case_5 x23 l s cd cs)
    (nd_C__case_5 x23 r s cd cs)
  Choices_C_MakeElement d i xs -> narrows cs d i (\z -> nd_C__case_5 x23 z s cd
    cs) xs
  Guard_C_MakeElement d c e -> guardCons d c ((\x -> nd_C__case_5 x23 e s cd
    x) $! addCs c cs)
  Fail_C_MakeElement d info -> failCons d (traceFail "MakeFile._case_5" [show
    x23, show x2] info)
  _ -> failCons cd (consFail "MakeFile._case_5" (showCons x2))

nd_C__case_6 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_SpecialTarget -> C_MakeElement -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_6 x15 x14 x13 x12 x2 s cd cs = case x2 of
  C_DefineVariable x16 x17 -> Curry_Prelude.C_False
  C_Rule x18 x19 x20 x21 -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s2 = leftSupply s4
                                                          s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_MakeFile_dot_SpecialTarget_hash)
    x12 x18 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x13 x19 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x14 x20 s3 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x15 x21 s5 cd cs) cd cs))
  C_Comment x22 -> Curry_Prelude.C_False
  C_Empty -> Curry_Prelude.C_False
  Choice_C_MakeElement d i l r -> narrow d i (nd_C__case_6 x15 x14 x13 x12 l s
    cd cs) (nd_C__case_6 x15 x14 x13 x12 r s cd cs)
  Choices_C_MakeElement d i xs -> narrows cs d i (\z -> nd_C__case_6 x15 x14 x13
    x12 z s cd cs) xs
  Guard_C_MakeElement d c e -> guardCons d c ((\x -> nd_C__case_6 x15 x14 x13
    x12 e s cd x) $! addCs c cs)
  Fail_C_MakeElement d info -> failCons d (traceFail "MakeFile._case_6" [show
    x15, show x14, show x13, show x12, show x2] info)
  _ -> failCons cd (consFail "MakeFile._case_6" (showCons x2))

nd_C__case_7 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_MakeElement -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_7 x4 x3 x2 s cd cs = case x2 of
  C_DefineVariable x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x5 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x4 x6 s1 cd cs) cd cs))
  C_Rule x7 x8 x9 x10 -> Curry_Prelude.C_False
  C_Comment x11 -> Curry_Prelude.C_False
  C_Empty -> Curry_Prelude.C_False
  Choice_C_MakeElement d i l r -> narrow d i (nd_C__case_7 x4 x3 l s cd cs)
    (nd_C__case_7 x4 x3 r s cd cs)
  Choices_C_MakeElement d i xs -> narrows cs d i (\z -> nd_C__case_7 x4 x3 z s
    cd cs) xs
  Guard_C_MakeElement d c e -> guardCons d c ((\x -> nd_C__case_7 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_MakeElement d info -> failCons d (traceFail "MakeFile._case_7" [show x4
    , show x3, show x2] info)
  _ -> failCons cd (consFail "MakeFile._case_7" (showCons x2))

d_C__case_2 :: C_SpecialTarget -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_2 x2 cd cs = case x2 of
  C_PHONY -> Curry_Prelude.C_False
  C_NOTPARALLEL -> Curry_Prelude.C_True
  Choice_C_SpecialTarget d i l r -> narrow d i (d_C__case_2 l cd cs)
    (d_C__case_2 r cd cs)
  Choices_C_SpecialTarget d i xs -> narrows cs d i (\z -> d_C__case_2 z cd cs)
    xs
  Guard_C_SpecialTarget d c e -> guardCons d c ((\x -> d_C__case_2 e cd x) $!
    addCs c cs)
  Fail_C_SpecialTarget d info -> failCons d (traceFail "MakeFile._case_2" [show
    x2] info)
  _ -> failCons cd (consFail "MakeFile._case_2" (showCons x2))

d_C__case_3 :: C_SpecialTarget -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x2 cd cs = case x2 of
  C_PHONY -> Curry_Prelude.C_True
  C_NOTPARALLEL -> Curry_Prelude.C_False
  Choice_C_SpecialTarget d i l r -> narrow d i (d_C__case_3 l cd cs)
    (d_C__case_3 r cd cs)
  Choices_C_SpecialTarget d i xs -> narrows cs d i (\z -> d_C__case_3 z cd cs)
    xs
  Guard_C_SpecialTarget d c e -> guardCons d c ((\x -> d_C__case_3 e cd x) $!
    addCs c cs)
  Fail_C_SpecialTarget d info -> failCons d (traceFail "MakeFile._case_3" [show
    x2] info)
  _ -> failCons cd (consFail "MakeFile._case_3" (showCons x2))

d_C__case_1 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_1 x2 x1 x7 x6 x5 x3 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_OP_unwordsUpTo_dot_fillWords_dot_15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x7 (Curry_Prelude.C_Int (1)) cd cs) (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.d_OP_plus_plus (d_C__case_0 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x2 (Curry_Prelude.C_Int (0)) cd cs) cd cs) x5 cd cs) cd cs) x6 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x3
    (d_OP_unwordsUpTo_dot_fillWords_dot_15 x1 (Curry_Prelude.C_Int (0))
    Curry_Prelude.OP_List (Curry_Prelude.OP_Cons x5 x6) cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x2 x1 x7 x6 x5
    x3 l cd cs) (d_C__case_1 x2 x1 x7 x6 x5 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x2 x1
    x7 x6 x5 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x2 x1 x7
    x6 x5 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "MakeFile._case_1"
    [show x2, show x1, show x7, show x6, show x5, show x3, show x8] info)
  _ -> failCons cd (consFail "MakeFile._case_1" (showCons x8))

d_C__case_0 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.toCurryString " "
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x2 l cd cs)
    (d_C__case_0 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x2 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "MakeFile._case_0"
    [show x2, show x3] info)
  _ -> failCons cd (consFail "MakeFile._case_0" (showCons x3))

