{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_PFLP
  ( C_Dist (..)
  , d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  , d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  , nd_C_enum
  , nd_C_uniform
  , d_C_certainly
  , d_OP_gt_gt_gt_eq
  , nd_OP_gt_gt_gt_eq
  , d_C_joinWith
  , nd_C_joinWith
  , d_OP_qmark_qmark
  , nd_OP_qmark_qmark
  , d_C_pick
  , nd_C_pick
  , d_C_replicateDist
  , nd_C_replicateDist )
  where

import Basics
import qualified Control.Search.Curry_Unsafe
import qualified Curry_Prelude


data C_Dist t0
  = C_Dist t0 Curry_Prelude.C_Float
  | Choice_C_Dist Cover ID (C_Dist t0) (C_Dist t0)
  | Choices_C_Dist Cover ID [C_Dist t0]
  | Fail_C_Dist Cover FailInfo
  | Guard_C_Dist Cover Constraints (C_Dist t0)

instance (Curry t0) => Show (C_Dist t0) where
  showsPrec d (Choice_C_Dist cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Dist cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Dist cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Dist cd info) = showChar '!'
  showsPrec _ (C_Dist x1 x2) = showString "(Dist" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))

instance (Curry t0) => Read (C_Dist t0) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Dist x1 x2, r2) | (_, r0) <-
    readQualified "PFLP" "Dist" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1]) s

instance NonDet (C_Dist t0) where
  choiceCons = Choice_C_Dist
  choicesCons = Choices_C_Dist
  failCons = Fail_C_Dist
  guardCons = Guard_C_Dist
  try (Choice_C_Dist cd i x y) = tryChoice cd i x y
  try (Choices_C_Dist cd i xs) = tryChoices cd i xs
  try (Fail_C_Dist cd info) = Fail cd info
  try (Guard_C_Dist cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Dist cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Dist cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Dist cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Dist cd i _) = error
    ("PFLP.Dist.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Dist cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Dist cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0) => Generable (C_Dist t0) where
  generate s c = Choices_C_Dist c (freeID [2] s) [C_Dist (generate (leftSupply
    s) c) (generate (rightSupply s) c)]

instance (Curry t0) => NormalForm (C_Dist t0) where
  ($!!) cont (C_Dist x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Dist y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Dist cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Dist cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Dist cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Dist cd info) _ _ = failCons cd info
  ($##) cont (C_Dist x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Dist y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Dist cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Dist cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Dist cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Dist cd info) _ _ = failCons cd info
  showCons (C_Dist _ _) = "PFLP.Dist _ _"
  showCons x = error ("PFLP.Dist.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Dist x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Dist y1 y2)) x2) x1
  searchNF _ _ x = error ("PFLP.Dist.searchNF: no constructor: " ++ show x)

instance (Curry t0) => Unifiable (C_Dist t0) where
  (=.=) (C_Dist x1 x2) (C_Dist y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Dist x1 x2) (C_Dist y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Dist x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind d i (Choice_C_Dist cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Dist cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Dist cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Dist cd i _) = error
    ("PFLP.Dist.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Dist cd info) = [Unsolvable info]
  bind d i (Guard_C_Dist cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Dist x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_Dist cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Dist cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Dist cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Dist cd i _) = error
    ("PFLP.Dist.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Dist cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Dist cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0) => Curry (C_Dist t0) where

d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Functor C_Dist
d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Functor (acceptCs
    id
    d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash)
    (d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash z cd cs)
    xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "PFLP._inst#Prelude.Functor#PFLP.Dist#" [show x1] info)
  _ -> failCons cd (consFail "PFLP._inst#Prelude.Functor#PFLP.Dist#" (showCons
    x1))

nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Functor C_Dist
nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Functor (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash))
    (nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash l s cd
    cs) (nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "PFLP._inst#Prelude.Functor#PFLP.Dist#" [show x1] info)
  _ -> failCons cd (consFail "PFLP._inst#Prelude.Functor#PFLP.Dist#" (showCons
    x1))

d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t1 -> Cover
  -> ConstStore -> t0) -> C_Dist t1 -> Cover -> ConstStore -> C_Dist t0
d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash x1 x2 cd cs =
  case x2 of
  C_Dist x3 x4 -> C_Dist (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
  Choice_C_Dist d i l r -> narrow d i
    (d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    x1 r cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    x1 z cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail
    "PFLP._impl#fmap#Prelude.Functor#PFLP.Dist#" [show x1, show x2] info)
  _ -> failCons cd (consFail "PFLP._impl#fmap#Prelude.Functor#PFLP.Dist#"
    (showCons x2))

nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t1 t0 -> C_Dist
  t1 -> IDSupply -> Cover -> ConstStore -> C_Dist t0
nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash x1 x2 s cd cs =
  case x2 of
  C_Dist x3 x4 -> let s0 = s
    in s0 `seq` C_Dist (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) x4
  Choice_C_Dist d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    x1 l s cd cs)
    (nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    x1 r s cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    x1 z s cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    x1 e s cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail
    "PFLP._impl#fmap#Prelude.Functor#PFLP.Dist#" [show x1, show x2] info)
  _ -> failCons cd (consFail "PFLP._impl#fmap#Prelude.Functor#PFLP.Dist#"
    (showCons x2))

d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Cover -> ConstStore -> C_Dist t0 -> Cover -> ConstStore -> C_Dist
  t1
d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_lt_dollar_hash_Prelude_dot_Functor
  d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash cd cs

nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Func (C_Dist t0) (C_Dist t1))
nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash s cd cs =
  let s0 = s
  in s0 `seq`
  Curry_Prelude.nd_OP_uscore_def_hash_lt_dollar_hash_Prelude_dot_Functor (wrapNX
  id nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash) s0 cd
  cs

d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Applicative C_Dist
d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Applicative
    d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash
    (d_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    cd cs)
    (d_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    cd cs)
    (d_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    cd cs)
    (d_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    cd cs)
    (d_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash l cd
    cs) (d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "PFLP._inst#Prelude.Applicative#PFLP.Dist#" [show x1] info)
  _ -> failCons cd (consFail "PFLP._inst#Prelude.Applicative#PFLP.Dist#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Applicative C_Dist
nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s5 = s
    in s5 `seq` (let s6 = leftSupply s5
                     s7 = rightSupply s5
                     s0 = leftSupply s6
                     s1 = rightSupply s6
                     s2 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s4 = rightSupply s8
    in s6 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s8 `seq` (s3 `seq`
    (s4 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Applicative (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_PFLP_dot_Dist_hash)
    (nd_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    s0 cd cs)
    (nd_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    s1 cd cs)
    (nd_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    s2 cd cs)
    (nd_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    s3 cd cs)
    (nd_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    s4 cd cs)))))))))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash l s
    cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "PFLP._inst#Prelude.Applicative#PFLP.Dist#" [show x1] info)
  _ -> failCons cd (consFail "PFLP._inst#Prelude.Applicative#PFLP.Dist#"
    (showCons x1))

d_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: Cover
  -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> C_Dist t0
d_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash cd cs =
  d_C_certainly

nd_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (C_Dist t0)
nd_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash s cd cs =
  wrapDX id d_C_certainly

d_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Dist (t1 -> Cover -> ConstStore -> t0) -> Cover -> ConstStore
  -> C_Dist t1 -> Cover -> ConstStore -> C_Dist t0
d_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash cd cs =
  acceptCs id (d_C_joinWith (acceptCs id Curry_Prelude.d_OP_dollar))

nd_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (C_Dist (Func t1 t0)) (Func (C_Dist t1)
  (C_Dist t0))
nd_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash s cd cs =
  wrapDX (wrapNX id) (acceptCs id (nd_C_joinWith (wrapDX (wrapNX id) (acceptCs
  id Curry_Prelude.nd_OP_dollar))))

d_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Dist t1 -> Cover -> ConstStore -> C_Dist t0 -> Cover -> ConstStore
  -> C_Dist t0
d_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash cd cs =
  acceptCs id
  (Curry_Prelude.d_OP_uscore_def_hash_star_gt_hash_Prelude_dot_Applicative
  d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash)

nd_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (C_Dist t1) (Func (C_Dist t0) (C_Dist t0))
nd_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash s cd cs =
  wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_def_hash_star_gt_hash_Prelude_dot_Applicative
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash)))

d_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Dist t1 -> Cover -> ConstStore -> C_Dist t0 -> Cover -> ConstStore
  -> C_Dist t1
d_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_lt_star_hash_Prelude_dot_Applicative
  d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash cd cs

nd_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (C_Dist t1) (Func (C_Dist t0) (C_Dist t1))
nd_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash s cd cs =
  let s0 = s
  in s0 `seq`
  Curry_Prelude.nd_OP_uscore_def_hash_lt_star_hash_Prelude_dot_Applicative
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash) s0 cd
  cs

d_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: Cover
  -> ConstStore -> forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> Cover -> ConstStore
  -> C_Dist t2 -> Cover -> ConstStore -> C_Dist t1 -> Cover -> ConstStore
  -> C_Dist t0
d_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash cd cs =
  acceptCs id
  (Curry_Prelude.d_OP_uscore_def_hash_liftA2_hash_Prelude_dot_Applicative
  d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash)

nd_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func (Func t2 (Func t1
  t0)) (Func (C_Dist t2) (Func (C_Dist t1) (C_Dist t0)))
nd_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash s cd cs =
  wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_def_hash_liftA2_hash_Prelude_dot_Applicative
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash)))

d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Monad C_Dist
d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Monad
    d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash
    (d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
    cd cs)
    (d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
    cd cs)
    (d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "PFLP._inst#Prelude.Monad#PFLP.Dist#" [show x1] info)
  _ -> failCons cd (consFail "PFLP._inst#Prelude.Monad#PFLP.Dist#" (showCons
    x1))

nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Monad
  C_Dist
nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s3 = s
    in s3 `seq` (let s0 = leftSupply s3
                     s4 = rightSupply s3
                     s1 = leftSupply s4
                     s2 = rightSupply s4
    in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq`
    Curry_Prelude.HO_OP_uscore_Dict_hash_Monad (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_PFLP_dot_Dist_hash)
    (nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
    s0 cd cs)
    (nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
    s1 cd cs)
    (nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
    s2 cd cs)))))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "PFLP._inst#Prelude.Monad#PFLP.Dist#" [show x1] info)
  _ -> failCons cd (consFail "PFLP._inst#Prelude.Monad#PFLP.Dist#" (showCons
    x1))

d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Dist t1 -> Cover -> ConstStore -> (t1 -> Cover -> ConstStore
  -> C_Dist t0) -> Cover -> ConstStore -> C_Dist t0
d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash cd cs =
  acceptCs id d_OP_gt_gt_gt_eq

nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (C_Dist t1) (Func (Func t1 (C_Dist t0))
  (C_Dist t0))
nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash s cd cs =
  wrapDX (wrapNX id) (acceptCs id nd_OP_gt_gt_gt_eq)

d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Dist t1 -> Cover -> ConstStore -> C_Dist t0 -> Cover -> ConstStore
  -> C_Dist t0
d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_gt_gt_hash_Prelude_dot_Monad
  d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash)

nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (C_Dist t1) (Func (C_Dist t0) (C_Dist t0))
nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash s cd cs =
  wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_def_hash_gt_gt_hash_Prelude_dot_Monad (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash)))

d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash :: Cover
  -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> C_Dist t0
d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash cd cs =
  d_C_certainly

nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (C_Dist t0)
nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash s cd cs =
  wrapDX id d_C_certainly

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data (C_Dist t0)
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "PFLP._inst#Prelude.Data#PFLP.Dist#0##" [show x1, show x2] info)
  _ -> failCons cd (consFail "PFLP._inst#Prelude.Data#PFLP.Dist#0##" (showCons
    x2))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_Dist t0 -> C_Dist t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash x1 x2 x3 cd cs =
  case x2 of
  C_Dist x4 x5 -> d_C__case_5 x5 x4 x1 x3 cd cs
  Choice_C_Dist d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 l x3 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 r x3 cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 z x3 cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 e x3 cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail
    "PFLP._impl#===#Prelude.Data#PFLP.Dist#0##" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "PFLP._impl#===#Prelude.Data#PFLP.Dist#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> C_Dist t0 -> C_Dist t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x2 of
  C_Dist x4 x5 -> let s0 = s in s0 `seq` nd_C__case_5 x5 x4 x1 x3 s0 cd cs
  Choice_C_Dist d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 l x3 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 r x3 s cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 z x3 s cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 e x3 s cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail
    "PFLP._impl#===#Prelude.Data#PFLP.Dist#0##" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "PFLP._impl#===#Prelude.Data#PFLP.Dist#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> IDSupply -> Cover -> ConstStore -> C_Dist t0
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_PFLP_dot_Dist_hash_0_hash_hash x1 s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Dist (Curry_Prelude.nd_C_aValue x1 s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
  s1 cd cs)))

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show (C_Dist t0)
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 cd cs) (acceptCs id
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1))
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "PFLP._inst#Prelude.Show#PFLP.Dist#0##" [show x1, show x2] info)
  _ -> failCons cd (consFail "PFLP._inst#Prelude.Show#PFLP.Dist#0##" (showCons
    x2))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show (C_Dist t0)
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Show
    (nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 s0 cd cs) (wrapDX (wrapNX id) (acceptCs id
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 s1 cd cs)))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "PFLP._inst#Prelude.Show#PFLP.Dist#0##" [show x1, show x2] info)
  _ -> failCons cd (consFail "PFLP._inst#Prelude.Show#PFLP.Dist#0##" (showCons
    x2))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Cover -> ConstStore -> C_Dist
  t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash x1 cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  x1)

nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> IDSupply -> Cover -> ConstStore -> Func (C_Dist t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash x1 s cd cs =
  wrapNX id (Curry_Prelude.nd_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  x1)))

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_Int -> C_Dist
  t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash x1 x2 x3 cd cs =
  case x3 of
  C_Dist x4 x5 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x2 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Dist {"))
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "event = ")) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showsPrec x1 cd cs) (Curry_Prelude.C_Int (0)) cd cs) x4
    cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString ", ")) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "prob = "))
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
    cd cs) (Curry_Prelude.C_Int (0)) cd cs) x5 cd cs)
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "}")) cd cs) cd
    cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Choice_C_Dist d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 x2 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 x2 r cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 x2 z cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 x2 e cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail
    "PFLP._impl#showsPrec#Prelude.Show#PFLP.Dist#0##" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "PFLP._impl#showsPrec#Prelude.Show#PFLP.Dist#0##"
    (showCons x3))

nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Int -> C_Dist t0 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x3 of
  C_Dist x4 x5 -> let s25 = s
    in s25 `seq` (let s24 = leftSupply s25
                      s26 = rightSupply s25
                      s2 = leftSupply s26
                      s23 = rightSupply s26
    in s24 `seq` (s26 `seq` (s2 `seq` (s23 `seq` Curry_Prelude.nd_C_showParen
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) (Curry_Prelude.C_Int (10)) s0 cd cs) x2 s1 cd cs))
    (let s22 = leftSupply s23
         s21 = rightSupply s23
    in s22 `seq` (s21 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Dist {")))
    (let s20 = leftSupply s21
         s18 = rightSupply s21
    in s20 `seq` (s18 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "event = ")))
    (let s17 = leftSupply s18
         s19 = rightSupply s18
         s7 = leftSupply s19
         s16 = rightSupply s19
    in s17 `seq` (s19 `seq` (s7 `seq` (s16 `seq` Curry_Prelude.nd_OP_dot
    (let s6 = leftSupply s7
         s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_showsPrec
    x1 s3 cd cs) (Curry_Prelude.C_Int (0)) s4 cd cs)) x4 s6 cd cs))
    (let s15 = leftSupply s16
         s14 = rightSupply s16
    in s15 `seq` (s14 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString ", ")))
    (let s13 = leftSupply s14
         s12 = rightSupply s14
    in s13 `seq` (s12 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "prob = ")))
    (let s11 = leftSupply s12
         s10 = rightSupply s12
    in s11 `seq` (s10 `seq` Curry_Prelude.nd_OP_dot (let s9 = leftSupply s10
                                                         s8 = rightSupply s10
    in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX (wrapDX id))
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
    cd cs)) (Curry_Prelude.C_Int (0)) s8 cd cs) x5 s9 cd cs)) (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "}"))) s11 cd
    cs)) s13 cd cs)) s15 cd cs)) s17 cd cs)))) s20 cd cs)) s22 cd cs)) s24 cd
    cs))))
  Choice_C_Dist d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 x2 l s cd cs)
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 x2 r s cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 x2 z s cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
    x1 x2 e s cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail
    "PFLP._impl#showsPrec#Prelude.Show#PFLP.Dist#0##" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "PFLP._impl#showsPrec#Prelude.Show#PFLP.Dist#0##"
    (showCons x3))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_Dist t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash x1 cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  x1) cd cs

nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List (C_Dist t0))
  (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash x1 s cd cs =
  let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_PFLP_dot_Dist_hash_0_hash_hash
  x1)) s0 cd cs

d_C_event :: forall t0 . (Curry_Prelude.Curry t0) => C_Dist t0 -> Cover
  -> ConstStore -> t0
d_C_event x1 cd cs = case x1 of
  C_Dist x2 x3 -> x2
  Choice_C_Dist d i l r -> narrow d i (d_C_event l cd cs) (d_C_event r cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z -> d_C_event z cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x -> d_C_event e cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail "PFLP.event" [show x1] info)
  _ -> failCons cd (consFail "PFLP.event" (showCons x1))

d_C_prob :: forall t0 . (Curry_Prelude.Curry t0) => C_Dist t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Float
d_C_prob x1 cd cs = case x1 of
  C_Dist x2 x3 -> x3
  Choice_C_Dist d i l r -> narrow d i (d_C_prob l cd cs) (d_C_prob r cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z -> d_C_prob z cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x -> d_C_prob e cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail "PFLP.prob" [show x1] info)
  _ -> failCons cd (consFail "PFLP.prob" (showCons x1))

nd_C_member :: IDSupply -> Cover -> ConstStore
  -> forall t0 . (Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List t0) t0
nd_C_member s cd cs = wrapNX id (Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id)
  (acceptCs id Curry_Prelude.nd_OP_qmark)) (Curry_Prelude.d_C_failed cd cs))

nd_C_enum :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Float -> IDSupply -> Cover
  -> ConstStore -> C_Dist t0
nd_C_enum x1 x2 s cd cs = let s10 = s
  in s10 `seq` (let x3 = Curry_Prelude.d_C_take (Curry_Prelude.d_C_length x1 cd
                      cs) x2 cd cs
  in let s9 = leftSupply s10
         s8 = rightSupply s10
  in s9 `seq` (s8 `seq` nd_C__case_4 x3 x1 (let s4 = leftSupply s8
                                                s7 = rightSupply s8
  in s4 `seq` (s7 `seq` Curry_Prelude.d_OP_amp_amp (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Float_hash
  cd cs))
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash
  (Curry_Prelude.C_Float 1.0##) (Curry_Prelude.nd_C_foldl (wrapDX (wrapDX id)
  (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash))
  (Curry_Prelude.C_Float 0.0##) x3 s0 cd cs) cd cs) s1 cd cs))
  (Curry_Prelude.C_Float 1.0e-4##) s3 cd cs)) (let s6 = leftSupply s7
                                                   s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_all (wrapNX
  id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Float_hash
  cd cs)) (Curry_Prelude.C_Float 0.0##))) s5 cd cs) x3 s6 cd cs)) cd cs)) s9 cd
  cs))

nd_C_uniform :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> C_Dist t0
nd_C_uniform x1 s cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "PFLP.uniform: list of events must be non-empty") cd cs
  Curry_Prelude.OP_Cons x2 x3 -> let s0 = s
    in s0 `seq` nd_C_enum x1 (Curry_Prelude.d_C_repeat
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_hash_Prelude_dot_Fractional_hash_Prelude_dot_Float_hash
    (Curry_Prelude.C_Float 1.0##)
    (Curry_Prelude.d_OP_uscore_impl_hash_fromInt_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash
    (Curry_Prelude.d_C_length x1 cd cs) cd cs) cd cs) cd cs) s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_uniform l s cd cs)
    (nd_C_uniform r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_uniform z s
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_uniform e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "PFLP.uniform"
    [show x1] info)
  _ -> failCons cd (consFail "PFLP.uniform" (showCons x1))

d_C_certainly :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> C_Dist t0
d_C_certainly x1 cd cs = C_Dist x1 (Curry_Prelude.C_Float 1.0##)

d_OP_gt_gt_gt_eq :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Dist t1 -> (t1 -> Cover -> ConstStore -> C_Dist t0) -> Cover
  -> ConstStore -> C_Dist t0
d_OP_gt_gt_gt_eq x1 x2 cd cs =
  let x3 = d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP5_hash_x x1 cd cs
      x4 = d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP6_hash_p x1 cd cs
      x5 = Curry_Prelude.d_C_apply x2 x3 cd cs
      x6 = d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP3_hash_y x5 cd cs
      x7 = d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP4_hash_q x5 cd cs
  in C_Dist x6
  (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash
  x4 x7 cd cs)

nd_OP_gt_gt_gt_eq :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Dist t1 -> Func t1 (C_Dist t0) -> IDSupply -> Cover -> ConstStore
  -> C_Dist t0
nd_OP_gt_gt_gt_eq x1 x2 s cd cs = let s0 = s
  in s0 `seq` (let x3 = d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP5_hash_x x1 cd cs
                   x4 = d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP6_hash_p x1 cd cs
                   x5 = Curry_Prelude.nd_C_apply x2 x3 s0 cd cs
                   x6 = d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP3_hash_y x5 cd cs
                   x7 = d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP4_hash_q x5 cd cs
  in C_Dist x6
  (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash
  x4 x7 cd cs))

d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP5_hash_x :: forall t0 . (Curry_Prelude.Curry
  t0) => C_Dist t0 -> Cover -> ConstStore -> t0
d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP5_hash_x x1 cd cs = case x1 of
  C_Dist x2 x3 -> x2
  Choice_C_Dist d i l r -> narrow d i
    (d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP5_hash_x l cd cs)
    (d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP5_hash_x r cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z ->
    d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP5_hash_x z cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x ->
    d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP5_hash_x e cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail "PFLP.>>>=._#selFP5#x" [show x1]
    info)
  _ -> failCons cd (consFail "PFLP.>>>=._#selFP5#x" (showCons x1))

d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP6_hash_p :: forall t0 . (Curry_Prelude.Curry
  t0) => C_Dist t0 -> Cover -> ConstStore -> Curry_Prelude.C_Float
d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP6_hash_p x1 cd cs = case x1 of
  C_Dist x2 x3 -> x3
  Choice_C_Dist d i l r -> narrow d i
    (d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP6_hash_p l cd cs)
    (d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP6_hash_p r cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z ->
    d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP6_hash_p z cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x ->
    d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP6_hash_p e cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail "PFLP.>>>=._#selFP6#p" [show x1]
    info)
  _ -> failCons cd (consFail "PFLP.>>>=._#selFP6#p" (showCons x1))

d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP3_hash_y :: forall t0 . (Curry_Prelude.Curry
  t0) => C_Dist t0 -> Cover -> ConstStore -> t0
d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP3_hash_y x1 cd cs = case x1 of
  C_Dist x2 x3 -> x2
  Choice_C_Dist d i l r -> narrow d i
    (d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP3_hash_y l cd cs)
    (d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP3_hash_y r cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z ->
    d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP3_hash_y z cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x ->
    d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP3_hash_y e cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail "PFLP.>>>=._#selFP3#y" [show x1]
    info)
  _ -> failCons cd (consFail "PFLP.>>>=._#selFP3#y" (showCons x1))

d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP4_hash_q :: forall t0 . (Curry_Prelude.Curry
  t0) => C_Dist t0 -> Cover -> ConstStore -> Curry_Prelude.C_Float
d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP4_hash_q x1 cd cs = case x1 of
  C_Dist x2 x3 -> x3
  Choice_C_Dist d i l r -> narrow d i
    (d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP4_hash_q l cd cs)
    (d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP4_hash_q r cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z ->
    d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP4_hash_q z cd cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x ->
    d_OP_gt_gt_gt_eq_dot_uscore_hash_selFP4_hash_q e cd x) $! addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail "PFLP.>>>=._#selFP4#q" [show x1]
    info)
  _ -> failCons cd (consFail "PFLP.>>>=._#selFP4#q" (showCons x1))

d_C_joinWith :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0) -> C_Dist t2 -> C_Dist t1 -> Cover -> ConstStore
  -> C_Dist t0
d_C_joinWith x1 x2 x3 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  cd cs) x2 cd cs) (d_OP_joinWith_dot_uscore_hash_lambda7 x3 x1) cd cs

nd_C_joinWith :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func t2 (Func t1 t0) -> C_Dist t2 -> C_Dist t1
  -> IDSupply -> Cover -> ConstStore -> C_Dist t0
nd_C_joinWith x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  s0 cd cs) x2 s1 cd cs)) (wrapNX id (nd_OP_joinWith_dot_uscore_hash_lambda7 x3
  x1)) s3 cd cs))

d_OP_joinWith_dot_uscore_hash_lambda7 :: forall t0 t1 t2 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => C_Dist t1 -> (t2
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t2 -> Cover
  -> ConstStore -> C_Dist t0
d_OP_joinWith_dot_uscore_hash_lambda7 x1 x2 x3 cd cs = let x4 = x3
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  cd cs) x1 cd cs)
  (d_OP_joinWith_dot_uscore_hash_lambda7_dot_uscore_hash_lambda9 x4 x2) cd cs

nd_OP_joinWith_dot_uscore_hash_lambda7 :: forall t0 t1 t2 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => C_Dist t1 -> Func t2
  (Func t1 t0) -> t2 -> IDSupply -> Cover -> ConstStore -> C_Dist t0
nd_OP_joinWith_dot_uscore_hash_lambda7 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let x4 = x3
  in let s3 = leftSupply s4
         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  s0 cd cs) x1 s1 cd cs)) (wrapNX id
  (nd_OP_joinWith_dot_uscore_hash_lambda7_dot_uscore_hash_lambda9 x4 x2)) s3 cd
  cs))

d_OP_joinWith_dot_uscore_hash_lambda7_dot_uscore_hash_lambda9 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t2 -> (t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> t1 -> Cover -> ConstStore -> C_Dist t0
d_OP_joinWith_dot_uscore_hash_lambda7_dot_uscore_hash_lambda9 x1 x2 x3 cd cs =
  let x4 = x3
  in Curry_Prelude.d_C_apply
  (d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x2 x1 cd cs) x4 cd
  cs) cd cs

nd_OP_joinWith_dot_uscore_hash_lambda7_dot_uscore_hash_lambda9 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t2 -> Func t2 (Func t1 t0) -> t1 -> IDSupply -> Cover -> ConstStore
  -> C_Dist t0
nd_OP_joinWith_dot_uscore_hash_lambda7_dot_uscore_hash_lambda9 x1 x2 x3 s cd cs =
  let s5 = s
  in s5 `seq` (let x4 = x3
  in let s4 = leftSupply s5
         s6 = rightSupply s5
         s0 = leftSupply s6
         s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_PFLP_dot_Dist_hash
  s0 cd cs) (let s2 = leftSupply s3
                 s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2 x1
  s1 cd cs) x4 s2 cd cs)) s4 cd cs))))

d_C_filterDist :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> C_Dist t0 -> Cover -> ConstStore
  -> C_Dist t0
d_C_filterDist x1 x2 cd cs = d_C__case_2 x2 x1 (Curry_Prelude.d_C_apply x1
  (d_C_event x2 cd cs) cd cs) cd cs

nd_C_filterDist :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> C_Dist t0 -> IDSupply -> Cover -> ConstStore -> C_Dist
  t0
nd_C_filterDist x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_2 x2 x1 (Curry_Prelude.nd_C_apply x1
  (d_C_event x2 cd cs) s0 cd cs) s1 cd cs))

d_OP_qmark_qmark :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Cover -> ConstStore -> C_Dist t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Float
d_OP_qmark_qmark x1 cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_foldr
  (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash)
  (Curry_Prelude.C_Float 0.0##)) (Curry_Prelude.d_OP_dot
  Control.Search.Curry_Unsafe.d_C_allValues (Curry_Prelude.d_OP_dot d_C_prob
  (d_C_filterDist x1) cd cs) cd cs) cd cs

nd_OP_qmark_qmark :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Func (C_Dist t0)
  Curry_Prelude.C_Float
nd_OP_qmark_qmark x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
  (Curry_Prelude.nd_C_foldr (wrapDX (wrapDX id) (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash))
  (Curry_Prelude.C_Float 0.0##))) (let s1 = leftSupply s2
                                       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
  Control.Search.Curry_Unsafe.d_C_allValues) (Curry_Prelude.nd_OP_dot (wrapDX id
  d_C_prob) (wrapNX id (nd_C_filterDist x1)) s0 cd cs) s1 cd cs)) s3 cd cs))

d_C_pick :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> t0) -> Cover -> ConstStore -> t0
d_C_pick x1 cd cs = Curry_Prelude.d_C_apply x1 Curry_Prelude.OP_Unit cd cs

nd_C_pick :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  t0 -> IDSupply -> Cover -> ConstStore -> t0
nd_C_pick x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_apply x1 Curry_Prelude.OP_Unit s0 cd cs

d_C_replicateDist :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore -> C_Dist t0) -> Cover
  -> ConstStore -> C_Dist (Curry_Prelude.OP_List t0)
d_C_replicateDist x1 x2 cd cs = d_C__case_1 x1 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x1 (Curry_Prelude.C_Int (0)) cd cs) cd cs

nd_C_replicateDist :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Func Curry_Prelude.OP_Unit (C_Dist t0)
  -> IDSupply -> Cover -> ConstStore -> C_Dist (Curry_Prelude.OP_List t0)
nd_C_replicateDist x1 x2 s cd cs = let s0 = s
  in s0 `seq` nd_C__case_1 x1 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x1 (Curry_Prelude.C_Int (0)) cd cs) s0 cd cs

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Float
  -> t0 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_Dist t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x5 x4 x1 x3 cd cs = case x3 of
  C_Dist x6 x7 -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq_eq x1 cd cs) x4 cd cs) x6
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
    cd cs) x5 cd cs) x7 cd cs) cd cs
  Choice_C_Dist d i l r -> narrow d i (d_C__case_5 x5 x4 x1 l cd cs)
    (d_C__case_5 x5 x4 x1 r cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z -> d_C__case_5 x5 x4 x1 z cd cs)
    xs
  Guard_C_Dist d c e -> guardCons d c ((\x -> d_C__case_5 x5 x4 x1 e cd x) $!
    addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail "PFLP._case_5" [show x5, show x4
    , show x1, show x3] info)
  _ -> failCons cd (consFail "PFLP._case_5" (showCons x3))

nd_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Float
  -> t0 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data
  t0) -> C_Dist t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_5 x5 x4 x1 x3 s cd cs = case x3 of
  C_Dist x6 x7 -> let s8 = s
    in s8 `seq` (let s4 = leftSupply s8
                     s7 = rightSupply s8
    in s4 `seq` (s7 `seq` Curry_Prelude.d_OP_amp_amp (let s3 = leftSupply s4
                                                          s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq_eq
    x1 s0 cd cs) x4 s1 cd cs)) x6 s3 cd cs)) (let s6 = leftSupply s7
                                                  s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
    cd cs)) x5 s5 cd cs) x7 s6 cd cs)) cd cs))
  Choice_C_Dist d i l r -> narrow d i (nd_C__case_5 x5 x4 x1 l s cd cs)
    (nd_C__case_5 x5 x4 x1 r s cd cs)
  Choices_C_Dist d i xs -> narrows cs d i (\z -> nd_C__case_5 x5 x4 x1 z s cd
    cs) xs
  Guard_C_Dist d c e -> guardCons d c ((\x -> nd_C__case_5 x5 x4 x1 e s cd x) $!
    addCs c cs)
  Fail_C_Dist d info -> failCons d (traceFail "PFLP._case_5" [show x5, show x4
    , show x1, show x3] info)
  _ -> failCons cd (consFail "PFLP._case_5" (showCons x3))

nd_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Float -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> C_Dist t0
nd_C__case_4 x3 x1 x4 s cd cs = case x4 of
  Curry_Prelude.C_True -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (nd_C_member s0 cd cs) (Curry_Prelude.nd_C_zipWith (wrapDX (wrapDX id)
    (acceptCs (acceptCs id) C_Dist)) x1 x3 s1 cd cs) s2 cd cs))))
  Curry_Prelude.C_False -> d_C__case_3 (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x3 x1 l s cd
    cs) (nd_C__case_4 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x3
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x3 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "PFLP._case_4" [show
    x3, show x1, show x4] info)
  _ -> failCons cd (consFail "PFLP._case_4" (showCons x4))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_Dist t0
d_C__case_3 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_error (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString
    "PFLP.enum: probabilities do not add up to 1.0 ")
    (Curry_Prelude.toCurryString "or are not strictly positive") cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 l cd cs)
    (d_C__case_3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "PFLP._case_3" [show
    x1] info)
  _ -> failCons cd (consFail "PFLP._case_3" (showCons x1))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => C_Dist t0 -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Dist t0
d_C__case_2 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x2 x1 l cd cs)
    (d_C__case_2 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x2 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "PFLP._case_2" [show
    x2, show x1, show x3] info)
  _ -> failCons cd (consFail "PFLP._case_2" (showCons x3))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => C_Dist t0 -> Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> C_Dist t0
nd_C__case_2 x2 x1 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x2 x1 l s cd
    cs) (nd_C__case_2 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x2 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "PFLP._case_2" [show
    x2, show x1, show x3] info)
  _ -> failCons cd (consFail "PFLP._case_2" (showCons x3))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore -> C_Dist t0)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Dist
  (Curry_Prelude.OP_List t0)
d_C__case_1 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> d_C_certainly Curry_Prelude.OP_List cd cs
  Curry_Prelude.C_False -> d_C__case_0 x2 x1 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x1 x2 l cd cs)
    (d_C__case_1 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x1 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "PFLP._case_1" [show
    x1, show x2, show x3] info)
  _ -> failCons cd (consFail "PFLP._case_1" (showCons x3))

nd_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Func Curry_Prelude.OP_Unit (C_Dist t0) -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> C_Dist (Curry_Prelude.OP_List t0)
nd_C__case_1 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> d_C_certainly Curry_Prelude.OP_List cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_0 x2 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_1 x1 x2 l s cd
    cs) (nd_C__case_1 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_1 x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_1 x1 x2 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "PFLP._case_1" [show
    x1, show x2, show x3] info)
  _ -> failCons cd (consFail "PFLP._case_1" (showCons x3))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> C_Dist t0) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Dist
  (Curry_Prelude.OP_List t0)
d_C__case_0 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> d_C_joinWith (acceptCs (acceptCs id)
    Curry_Prelude.OP_Cons) (d_C_pick x2 cd cs) (d_C_replicateDist
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs) x2 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x2 x1 l cd cs)
    (d_C__case_0 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x2 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "PFLP._case_0" [show
    x2, show x1, show x3] info)
  _ -> failCons cd (consFail "PFLP._case_0" (showCons x3))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (C_Dist t0) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Dist
  (Curry_Prelude.OP_List t0)
nd_C__case_0 x2 x1 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_C_joinWith (wrapDX (wrapDX id)
    (acceptCs (acceptCs id) Curry_Prelude.OP_Cons)) (nd_C_pick x2 s0 cd cs)
    (nd_C_replicateDist
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs) x2 s1 cd cs) s2 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x2 x1 l s cd
    cs) (nd_C__case_0 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x2 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "PFLP._case_0" [show
    x2, show x1, show x3] info)
  _ -> failCons cd (consFail "PFLP._case_0" (showCons x3))

