{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.Prolog.Curry_Types
  ( C_PlClause (..)
  , C_PlGoal (..)
  , C_PlTerm (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash )
  where

import Basics
import qualified Curry_Prelude


data C_PlClause
  = C_PlClause (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List C_PlTerm) (Curry_Prelude.OP_List C_PlGoal)
  | C_PlDirective (Curry_Prelude.OP_List C_PlGoal)
  | C_PlQuery (Curry_Prelude.OP_List C_PlGoal)
  | Choice_C_PlClause Cover ID C_PlClause C_PlClause
  | Choices_C_PlClause Cover ID [C_PlClause]
  | Fail_C_PlClause Cover FailInfo
  | Guard_C_PlClause Cover Constraints C_PlClause

instance Show C_PlClause where
  showsPrec d (Choice_C_PlClause cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_PlClause cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_PlClause cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_PlClause cd info) = showChar '!'
  showsPrec _ (C_PlClause x1 x2 x3) = showString "(PlClause" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))
  showsPrec _ (C_PlDirective x1) = showString "(PlDirective" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_PlQuery x1) = showString "(PlQuery" . (showChar ' ' . (shows
    x1 . showChar ')'))

instance Read C_PlClause where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_PlClause x1 x2 x3, r3) | (_
    , r0) <- readQualified "Language.Prolog.Types" "PlClause" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2])
    s ++ (readParen ((>) d 10) (\r -> [(C_PlDirective x1, r1) | (_, r0) <-
    readQualified "Language.Prolog.Types" "PlDirective" r, (x1, r1) <- readsPrec
    11 r0]) s ++ readParen ((>) d 10) (\r -> [(C_PlQuery x1, r1) | (_, r0) <-
    readQualified "Language.Prolog.Types" "PlQuery" r, (x1, r1) <- readsPrec 11
    r0]) s)

instance NonDet C_PlClause where
  choiceCons = Choice_C_PlClause
  choicesCons = Choices_C_PlClause
  failCons = Fail_C_PlClause
  guardCons = Guard_C_PlClause
  try (Choice_C_PlClause cd i x y) = tryChoice cd i x y
  try (Choices_C_PlClause cd i xs) = tryChoices cd i xs
  try (Fail_C_PlClause cd info) = Fail cd info
  try (Guard_C_PlClause cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_PlClause cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_PlClause cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_PlClause cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_PlClause cd i _) = error
    ("Language.Prolog.Types.PlClause.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_PlClause cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_PlClause cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_PlClause where
  generate s c = Choices_C_PlClause c (freeID [3, 1, 1] s) [C_PlClause (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (rightSupply s) c), C_PlDirective (generate (leftSupply s) c)
    , C_PlQuery (generate (leftSupply s) c)]

instance NormalForm C_PlClause where
  ($!!) cont (C_PlClause x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_PlClause y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d
    cs
  ($!!) cont (C_PlDirective x1) d cs = ($!!) (\y1 d cs -> cont (C_PlDirective
    y1) d cs) x1 d cs
  ($!!) cont (C_PlQuery x1) d cs = ($!!) (\y1 d cs -> cont (C_PlQuery y1) d cs)
    x1 d cs
  ($!!) cont (Choice_C_PlClause cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_PlClause cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_PlClause cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_PlClause cd info) _ _ = failCons cd info
  ($##) cont (C_PlClause x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_PlClause y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d
    cs
  ($##) cont (C_PlDirective x1) d cs = ($##) (\y1 d cs -> cont (C_PlDirective
    y1) d cs) x1 d cs
  ($##) cont (C_PlQuery x1) d cs = ($##) (\y1 d cs -> cont (C_PlQuery y1) d cs)
    x1 d cs
  ($##) cont (Choice_C_PlClause cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_PlClause cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_PlClause cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_PlClause cd info) _ _ = failCons cd info
  showCons (C_PlClause _ _ _) = "Language.Prolog.Types.PlClause _ _ _"
  showCons (C_PlDirective _) = "Language.Prolog.Types.PlDirective _"
  showCons (C_PlQuery _) = "Language.Prolog.Types.PlQuery _"
  showCons x = error
    ("Language.Prolog.Types.PlClause.showCons: no constructor: " ++ show x)
  searchNF search cont (C_PlClause x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_PlClause y1 y2 y3)) x3) x2) x1
  searchNF search cont (C_PlDirective x1) = search (\y1 -> cont (C_PlDirective
    y1)) x1
  searchNF search cont (C_PlQuery x1) = search (\y1 -> cont (C_PlQuery y1)) x1
  searchNF _ _ x = error
    ("Language.Prolog.Types.PlClause.searchNF: no constructor: " ++ show x)

instance Unifiable C_PlClause where
  (=.=) (C_PlClause x1 x2 x3) (C_PlClause y1 y2 y3) d cs = (&) ((=:=) x1 y1 d
    cs) ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_PlDirective x1) (C_PlDirective y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_PlQuery x1) (C_PlQuery y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_PlClause x1 x2 x3) (C_PlClause y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d
    cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) (C_PlDirective x1) (C_PlDirective y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_PlQuery x1) (C_PlQuery y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_PlClause x3 x4 x5) = (i :=: ChooseN 0 3) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i)
    x5]
  bind cd i (C_PlDirective x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID
    i) x3]
  bind cd i (C_PlQuery x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i)
    x3]
  bind d i (Choice_C_PlClause cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_PlClause cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_PlClause cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_PlClause cd i _) = error
    ("Language.Prolog.Types.PlClause.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_PlClause cd info) = [Unsolvable info]
  bind d i (Guard_C_PlClause cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_PlClause x3 x4 x5) = (i :=: ChooseN 0 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_PlDirective x3) = (i :=: ChooseN 1 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_PlQuery x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_PlClause cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_PlClause cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_PlClause cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_PlClause cd i _) = error
    ("Language.Prolog.Types.PlClause.lazyBind: Choices with ChoiceID: " ++ show
    i)
  lazyBind _ _ (Fail_C_PlClause cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_PlClause cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_PlClause where

data C_PlGoal
  = C_PlLit (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    C_PlTerm)
  | C_PlNeg (Curry_Prelude.OP_List C_PlGoal)
  | C_PlCond (Curry_Prelude.OP_List C_PlGoal) (Curry_Prelude.OP_List C_PlGoal)
    (Curry_Prelude.OP_List C_PlGoal)
  | Choice_C_PlGoal Cover ID C_PlGoal C_PlGoal
  | Choices_C_PlGoal Cover ID [C_PlGoal]
  | Fail_C_PlGoal Cover FailInfo
  | Guard_C_PlGoal Cover Constraints C_PlGoal

instance Show C_PlGoal where
  showsPrec d (Choice_C_PlGoal cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_PlGoal cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_PlGoal cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_PlGoal cd info) = showChar '!'
  showsPrec _ (C_PlLit x1 x2) = showString "(PlLit" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_PlNeg x1) = showString "(PlNeg" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_PlCond x1 x2 x3) = showString "(PlCond" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))

instance Read C_PlGoal where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_PlLit x1 x2, r2) | (_, r0) <-
    readQualified "Language.Prolog.Types" "PlLit" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r ->
    [(C_PlNeg x1, r1) | (_, r0) <- readQualified "Language.Prolog.Types" "PlNeg"
    r, (x1, r1) <- readsPrec 11 r0]) s ++ readParen ((>) d 10) (\r -> [(C_PlCond
    x1 x2 x3, r3) | (_, r0) <- readQualified "Language.Prolog.Types" "PlCond" r,
    (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <-
    readsPrec 11 r2]) s)

instance NonDet C_PlGoal where
  choiceCons = Choice_C_PlGoal
  choicesCons = Choices_C_PlGoal
  failCons = Fail_C_PlGoal
  guardCons = Guard_C_PlGoal
  try (Choice_C_PlGoal cd i x y) = tryChoice cd i x y
  try (Choices_C_PlGoal cd i xs) = tryChoices cd i xs
  try (Fail_C_PlGoal cd info) = Fail cd info
  try (Guard_C_PlGoal cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_PlGoal cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_PlGoal cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_PlGoal cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_PlGoal cd i _) = error
    ("Language.Prolog.Types.PlGoal.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_PlGoal cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_PlGoal cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_PlGoal where
  generate s c = Choices_C_PlGoal c (freeID [2, 1, 3] s) [C_PlLit (generate
    (leftSupply s) c) (generate (rightSupply s) c), C_PlNeg (generate
    (leftSupply s) c), C_PlCond (generate (leftSupply (leftSupply s)) c)
    (generate (rightSupply (leftSupply s)) c) (generate (rightSupply s) c)]

instance NormalForm C_PlGoal where
  ($!!) cont (C_PlLit x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_PlLit y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_PlNeg x1) d cs = ($!!) (\y1 d cs -> cont (C_PlNeg y1) d cs) x1 d
    cs
  ($!!) cont (C_PlCond x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_PlCond y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_PlGoal cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_PlGoal cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_PlGoal cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_PlGoal cd info) _ _ = failCons cd info
  ($##) cont (C_PlLit x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_PlLit y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_PlNeg x1) d cs = ($##) (\y1 d cs -> cont (C_PlNeg y1) d cs) x1 d
    cs
  ($##) cont (C_PlCond x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_PlCond y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_PlGoal cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_PlGoal cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_PlGoal cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_PlGoal cd info) _ _ = failCons cd info
  showCons (C_PlLit _ _) = "Language.Prolog.Types.PlLit _ _"
  showCons (C_PlNeg _) = "Language.Prolog.Types.PlNeg _"
  showCons (C_PlCond _ _ _) = "Language.Prolog.Types.PlCond _ _ _"
  showCons x = error
    ("Language.Prolog.Types.PlGoal.showCons: no constructor: " ++ show x)
  searchNF search cont (C_PlLit x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_PlLit y1 y2)) x2) x1
  searchNF search cont (C_PlNeg x1) = search (\y1 -> cont (C_PlNeg y1)) x1
  searchNF search cont (C_PlCond x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_PlCond y1 y2 y3)) x3) x2) x1
  searchNF _ _ x = error
    ("Language.Prolog.Types.PlGoal.searchNF: no constructor: " ++ show x)

instance Unifiable C_PlGoal where
  (=.=) (C_PlLit x1 x2) (C_PlLit y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2
    y2 d cs) d cs
  (=.=) (C_PlNeg x1) (C_PlNeg y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_PlCond x1 x2 x3) (C_PlCond y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs)
    ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_PlLit x1 x2) (C_PlLit y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=)
    x2 y2 d cs) d cs
  (=.<=) (C_PlNeg x1) (C_PlNeg y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_PlCond x1 x2 x3) (C_PlCond y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs)
    ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_PlLit x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_PlNeg x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_PlCond x3 x4 x5) = (i :=: ChooseN 2 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind d i (Choice_C_PlGoal cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_PlGoal cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_PlGoal cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_PlGoal cd i _) = error
    ("Language.Prolog.Types.PlGoal.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_PlGoal cd info) = [Unsolvable info]
  bind d i (Guard_C_PlGoal cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_PlLit x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_PlNeg x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_PlCond x3 x4 x5) = (i :=: ChooseN 2 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind d i (Choice_C_PlGoal cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_PlGoal cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_PlGoal cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_PlGoal cd i _) = error
    ("Language.Prolog.Types.PlGoal.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_PlGoal cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_PlGoal cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_PlGoal where

data C_PlTerm
  = C_PlVar (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_PlAtom (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_PlInt Curry_Prelude.C_Int
  | C_PlFloat Curry_Prelude.C_Float
  | C_PlStruct (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List C_PlTerm)
  | Choice_C_PlTerm Cover ID C_PlTerm C_PlTerm
  | Choices_C_PlTerm Cover ID [C_PlTerm]
  | Fail_C_PlTerm Cover FailInfo
  | Guard_C_PlTerm Cover Constraints C_PlTerm

instance Show C_PlTerm where
  showsPrec d (Choice_C_PlTerm cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_PlTerm cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_PlTerm cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_PlTerm cd info) = showChar '!'
  showsPrec _ (C_PlVar x1) = showString "(PlVar" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_PlAtom x1) = showString "(PlAtom" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_PlInt x1) = showString "(PlInt" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_PlFloat x1) = showString "(PlFloat" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_PlStruct x1 x2) = showString "(PlStruct" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_PlTerm where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_PlVar x1, r1) | (_, r0) <-
    readQualified "Language.Prolog.Types" "PlVar" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_PlAtom x1, r1) | (_, r0) <-
    readQualified "Language.Prolog.Types" "PlAtom" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_PlInt x1, r1) | (_, r0) <-
    readQualified "Language.Prolog.Types" "PlInt" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_PlFloat x1, r1) | (_, r0) <-
    readQualified "Language.Prolog.Types" "PlFloat" r, (x1, r1) <- readsPrec 11
    r0]) s ++ readParen ((>) d 10) (\r -> [(C_PlStruct x1 x2, r2) | (_, r0) <-
    readQualified "Language.Prolog.Types" "PlStruct" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1]) s)))

instance NonDet C_PlTerm where
  choiceCons = Choice_C_PlTerm
  choicesCons = Choices_C_PlTerm
  failCons = Fail_C_PlTerm
  guardCons = Guard_C_PlTerm
  try (Choice_C_PlTerm cd i x y) = tryChoice cd i x y
  try (Choices_C_PlTerm cd i xs) = tryChoices cd i xs
  try (Fail_C_PlTerm cd info) = Fail cd info
  try (Guard_C_PlTerm cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_PlTerm cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_PlTerm cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_PlTerm cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_PlTerm cd i _) = error
    ("Language.Prolog.Types.PlTerm.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_PlTerm cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_PlTerm cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_PlTerm where
  generate s c = Choices_C_PlTerm c (freeID [1, 1, 1, 1, 2] s) [C_PlVar
    (generate (leftSupply s) c), C_PlAtom (generate (leftSupply s) c), C_PlInt
    (generate (leftSupply s) c), C_PlFloat (generate (leftSupply s) c)
    , C_PlStruct (generate (leftSupply s) c) (generate (rightSupply s) c)]

instance NormalForm C_PlTerm where
  ($!!) cont (C_PlVar x1) d cs = ($!!) (\y1 d cs -> cont (C_PlVar y1) d cs) x1 d
    cs
  ($!!) cont (C_PlAtom x1) d cs = ($!!) (\y1 d cs -> cont (C_PlAtom y1) d cs) x1
    d cs
  ($!!) cont (C_PlInt x1) d cs = ($!!) (\y1 d cs -> cont (C_PlInt y1) d cs) x1 d
    cs
  ($!!) cont (C_PlFloat x1) d cs = ($!!) (\y1 d cs -> cont (C_PlFloat y1) d cs)
    x1 d cs
  ($!!) cont (C_PlStruct x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_PlStruct y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_PlTerm cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_PlTerm cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_PlTerm cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_PlTerm cd info) _ _ = failCons cd info
  ($##) cont (C_PlVar x1) d cs = ($##) (\y1 d cs -> cont (C_PlVar y1) d cs) x1 d
    cs
  ($##) cont (C_PlAtom x1) d cs = ($##) (\y1 d cs -> cont (C_PlAtom y1) d cs) x1
    d cs
  ($##) cont (C_PlInt x1) d cs = ($##) (\y1 d cs -> cont (C_PlInt y1) d cs) x1 d
    cs
  ($##) cont (C_PlFloat x1) d cs = ($##) (\y1 d cs -> cont (C_PlFloat y1) d cs)
    x1 d cs
  ($##) cont (C_PlStruct x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_PlStruct y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_PlTerm cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_PlTerm cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_PlTerm cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_PlTerm cd info) _ _ = failCons cd info
  showCons (C_PlVar _) = "Language.Prolog.Types.PlVar _"
  showCons (C_PlAtom _) = "Language.Prolog.Types.PlAtom _"
  showCons (C_PlInt _) = "Language.Prolog.Types.PlInt _"
  showCons (C_PlFloat _) = "Language.Prolog.Types.PlFloat _"
  showCons (C_PlStruct _ _) = "Language.Prolog.Types.PlStruct _ _"
  showCons x = error
    ("Language.Prolog.Types.PlTerm.showCons: no constructor: " ++ show x)
  searchNF search cont (C_PlVar x1) = search (\y1 -> cont (C_PlVar y1)) x1
  searchNF search cont (C_PlAtom x1) = search (\y1 -> cont (C_PlAtom y1)) x1
  searchNF search cont (C_PlInt x1) = search (\y1 -> cont (C_PlInt y1)) x1
  searchNF search cont (C_PlFloat x1) = search (\y1 -> cont (C_PlFloat y1)) x1
  searchNF search cont (C_PlStruct x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_PlStruct y1 y2)) x2) x1
  searchNF _ _ x = error
    ("Language.Prolog.Types.PlTerm.searchNF: no constructor: " ++ show x)

instance Unifiable C_PlTerm where
  (=.=) (C_PlVar x1) (C_PlVar y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_PlAtom x1) (C_PlAtom y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_PlInt x1) (C_PlInt y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_PlFloat x1) (C_PlFloat y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_PlStruct x1 x2) (C_PlStruct y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_PlVar x1) (C_PlVar y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_PlAtom x1) (C_PlAtom y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_PlInt x1) (C_PlInt y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_PlFloat x1) (C_PlFloat y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_PlStruct x1 x2) (C_PlStruct y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_PlVar x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_PlAtom x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_PlInt x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_PlFloat x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_PlStruct x3 x4) = (i :=: ChooseN 4 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_PlTerm cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_PlTerm cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_PlTerm cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_PlTerm cd i _) = error
    ("Language.Prolog.Types.PlTerm.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_PlTerm cd info) = [Unsolvable info]
  bind d i (Guard_C_PlTerm cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_PlVar x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_PlAtom x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_PlInt x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_PlFloat x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_PlStruct x3 x4) = (i :=: ChooseN 4 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_PlTerm cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_PlTerm cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_PlTerm cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_PlTerm cd i _) = error
    ("Language.Prolog.Types.PlTerm.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_PlTerm cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_PlTerm cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_PlTerm where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_PlClause
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Prolog.Types._inst#Prelude.Data#Language.Prolog.Types.PlClause#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._inst#Prelude.Data#Language.Prolog.Types.PlClause#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash :: C_PlClause
  -> C_PlClause -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash x1 x2 s cd cs =
  case x1 of
  C_PlClause x3 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_21 x5 x4 x3 x2 s0 cd cs
  C_PlDirective x11 -> let s0 = s in s0 `seq` nd_C__case_20 x11 x2 s0 cd cs
  C_PlQuery x17 -> let s0 = s in s0 `seq` nd_C__case_19 x17 x2 s0 cd cs
  Choice_C_PlClause d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    r x2 s cd cs)
  Choices_C_PlClause d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    z x2 s cd cs) xs
  Guard_C_PlClause d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_PlClause d info -> failCons d (traceFail
    "Language.Prolog.Types._impl#===#Prelude.Data#Language.Prolog.Types.PlClause#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._impl#===#Prelude.Data#Language.Prolog.Types.PlClause#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash :: IDSupply
  -> Cover -> ConstStore -> C_PlClause
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash s cd cs =
  let s11 = s
  in s11 `seq` (let s10 = leftSupply s11
                    s12 = rightSupply s11
                    s7 = leftSupply s12
                    s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s3 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s0 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s1 = leftSupply s4
                                                        s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` C_PlClause
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash)
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
  s2 cd cs))))) (C_PlDirective
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
  s5 cd cs)) s6 cd cs)))) (C_PlQuery
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
  s9 cd cs)) s10 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_PlGoal
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Prolog.Types._inst#Prelude.Data#Language.Prolog.Types.PlGoal#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._inst#Prelude.Data#Language.Prolog.Types.PlGoal#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash :: C_PlGoal
  -> C_PlGoal -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash x1 x2 s cd cs =
  case x1 of
  C_PlLit x3 x4 -> let s0 = s in s0 `seq` nd_C__case_18 x4 x3 x2 s0 cd cs
  C_PlNeg x11 -> let s0 = s in s0 `seq` nd_C__case_17 x11 x2 s0 cd cs
  C_PlCond x18 x19 x20 -> let s0 = s
    in s0 `seq` nd_C__case_16 x20 x19 x18 x2 s0 cd cs
  Choice_C_PlGoal d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    r x2 s cd cs)
  Choices_C_PlGoal d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    z x2 s cd cs) xs
  Guard_C_PlGoal d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_PlGoal d info -> failCons d (traceFail
    "Language.Prolog.Types._impl#===#Prelude.Data#Language.Prolog.Types.PlGoal#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._impl#===#Prelude.Data#Language.Prolog.Types.PlGoal#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash :: IDSupply
  -> Cover -> ConstStore -> C_PlGoal
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash s cd cs =
  let s13 = s
  in s13 `seq` (let s12 = leftSupply s13
                    s14 = rightSupply s13
                    s5 = leftSupply s14
                    s10 = rightSupply s14
  in s12 `seq` (s14 `seq` (s5 `seq` (s10 `seq` choice (let s4 = leftSupply s5
                                                           s6 = rightSupply s5
                                                           s2 = leftSupply s6
                                                           s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` choice (let s0 = leftSupply s2
                                                        s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_PlLit
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash)
  s1 cd cs))) (C_PlNeg
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
  s3 cd cs)) s4 cd cs)))) (let s7 = leftSupply s10
                               s11 = rightSupply s10
                               s8 = leftSupply s11
                               s9 = rightSupply s11
  in s7 `seq` (s11 `seq` (s8 `seq` (s9 `seq` C_PlCond
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
  s7 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
  s8 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
  s9 cd cs))))) s12 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_PlTerm
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Prolog.Types._inst#Prelude.Data#Language.Prolog.Types.PlTerm#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._inst#Prelude.Data#Language.Prolog.Types.PlTerm#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash :: C_PlTerm
  -> C_PlTerm -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash x1 x2 s cd cs =
  case x1 of
  C_PlVar x3 -> let s0 = s in s0 `seq` nd_C__case_15 x3 x2 s0 cd cs
  C_PlAtom x10 -> let s0 = s in s0 `seq` nd_C__case_14 x10 x2 s0 cd cs
  C_PlInt x17 -> d_C__case_13 x17 x2 cd cs
  C_PlFloat x24 -> d_C__case_12 x24 x2 cd cs
  C_PlStruct x31 x32 -> let s0 = s in s0 `seq` nd_C__case_11 x32 x31 x2 s0 cd cs
  Choice_C_PlTerm d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    r x2 s cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    z x2 s cd cs) xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail
    "Language.Prolog.Types._impl#===#Prelude.Data#Language.Prolog.Types.PlTerm#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._impl#===#Prelude.Data#Language.Prolog.Types.PlTerm#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash :: IDSupply
  -> Cover -> ConstStore -> C_PlTerm
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash s cd cs =
  let s17 = s
  in s17 `seq` (let s16 = leftSupply s17
                    s18 = rightSupply s17
                    s11 = leftSupply s18
                    s15 = rightSupply s18
  in s16 `seq` (s18 `seq` (s11 `seq` (s15 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s3 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_PlVar
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)) (C_PlAtom
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)) s2 cd cs)))) (C_PlInt
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s5 cd cs)) s6 cd cs)))) (C_PlFloat
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
  s9 cd cs)) s10 cd cs)))) (let s13 = leftSupply s15
                                s14 = rightSupply s15
  in s13 `seq` (s14 `seq` C_PlStruct
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s13 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash)
  s14 cd cs))) s16 cd cs))))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_PlClause
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlClause#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlClause#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_PlClause
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlClause#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlClause#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash :: C_PlClause
  -> C_PlClause -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash x1 x2 cd cs =
  case x1 of
  C_PlClause x3 x4 x5 -> d_C__case_10 x5 x4 x3 x2 cd cs
  C_PlDirective x11 -> d_C__case_9 x11 x2 cd cs
  C_PlQuery x17 -> d_C__case_8 x17 x2 cd cs
  Choice_C_PlClause d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    r x2 cd cs)
  Choices_C_PlClause d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    z x2 cd cs) xs
  Guard_C_PlClause d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_PlClause d info -> failCons d (traceFail
    "Language.Prolog.Types._impl#==#Prelude.Eq#Language.Prolog.Types.PlClause#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._impl#==#Prelude.Eq#Language.Prolog.Types.PlClause#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash :: Cover
  -> ConstStore -> C_PlClause -> Cover -> ConstStore -> C_PlClause -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlClause_hash)

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_PlGoal
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlGoal#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlGoal#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_PlGoal
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlGoal#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlGoal#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash :: C_PlGoal
  -> C_PlGoal -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash x1 x2 cd cs =
  case x1 of
  C_PlLit x3 x4 -> d_C__case_7 x4 x3 x2 cd cs
  C_PlNeg x11 -> d_C__case_6 x11 x2 cd cs
  C_PlCond x18 x19 x20 -> d_C__case_5 x20 x19 x18 x2 cd cs
  Choice_C_PlGoal d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    r x2 cd cs)
  Choices_C_PlGoal d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    z x2 cd cs) xs
  Guard_C_PlGoal d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_PlGoal d info -> failCons d (traceFail
    "Language.Prolog.Types._impl#==#Prelude.Eq#Language.Prolog.Types.PlGoal#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._impl#==#Prelude.Eq#Language.Prolog.Types.PlGoal#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash :: Cover
  -> ConstStore -> C_PlGoal -> Cover -> ConstStore -> C_PlGoal -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_PlTerm
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlTerm#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlTerm#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_PlTerm
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlTerm#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._inst#Prelude.Eq#Language.Prolog.Types.PlTerm#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash :: C_PlTerm
  -> C_PlTerm -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash x1 x2 cd cs =
  case x1 of
  C_PlVar x3 -> d_C__case_4 x3 x2 cd cs
  C_PlAtom x10 -> d_C__case_3 x10 x2 cd cs
  C_PlInt x17 -> d_C__case_2 x17 x2 cd cs
  C_PlFloat x24 -> d_C__case_1 x24 x2 cd cs
  C_PlStruct x31 x32 -> d_C__case_0 x32 x31 x2 cd cs
  Choice_C_PlTerm d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    r x2 cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    z x2 cd cs) xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail
    "Language.Prolog.Types._impl#==#Prelude.Eq#Language.Prolog.Types.PlTerm#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Prolog.Types._impl#==#Prelude.Eq#Language.Prolog.Types.PlTerm#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash :: Cover
  -> ConstStore -> C_PlTerm -> Cover -> ConstStore -> C_PlTerm -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash)

nd_C__case_19 :: Curry_Prelude.OP_List C_PlGoal -> C_PlClause -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_19 x17 x2 s cd cs = case x2 of
  C_PlClause x18 x19 x20 -> Curry_Prelude.C_False
  C_PlDirective x21 -> Curry_Prelude.C_False
  C_PlQuery x22 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
    x17 x22 s0 cd cs
  Choice_C_PlClause d i l r -> narrow d i (nd_C__case_19 x17 l s cd cs)
    (nd_C__case_19 x17 r s cd cs)
  Choices_C_PlClause d i xs -> narrows cs d i (\z -> nd_C__case_19 x17 z s cd
    cs) xs
  Guard_C_PlClause d c e -> guardCons d c ((\x -> nd_C__case_19 x17 e s cd x) $!
    addCs c cs)
  Fail_C_PlClause d info -> failCons d (traceFail
    "Language.Prolog.Types._case_19" [show x17, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_19" (showCons x2))

nd_C__case_20 :: Curry_Prelude.OP_List C_PlGoal -> C_PlClause -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_20 x11 x2 s cd cs = case x2 of
  C_PlClause x12 x13 x14 -> Curry_Prelude.C_False
  C_PlDirective x15 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
    x11 x15 s0 cd cs
  C_PlQuery x16 -> Curry_Prelude.C_False
  Choice_C_PlClause d i l r -> narrow d i (nd_C__case_20 x11 l s cd cs)
    (nd_C__case_20 x11 r s cd cs)
  Choices_C_PlClause d i xs -> narrows cs d i (\z -> nd_C__case_20 x11 z s cd
    cs) xs
  Guard_C_PlClause d c e -> guardCons d c ((\x -> nd_C__case_20 x11 e s cd x) $!
    addCs c cs)
  Fail_C_PlClause d info -> failCons d (traceFail
    "Language.Prolog.Types._case_20" [show x11, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_20" (showCons x2))

nd_C__case_21 :: Curry_Prelude.OP_List C_PlGoal -> Curry_Prelude.OP_List
  C_PlTerm -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlClause
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_21 x5 x4 x3 x2 s cd cs = case x2 of
  C_PlClause x6 x7 x8 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x6 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash)
    x4 x7 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
    x5 x8 s3 cd cs) cd cs))
  C_PlDirective x9 -> Curry_Prelude.C_False
  C_PlQuery x10 -> Curry_Prelude.C_False
  Choice_C_PlClause d i l r -> narrow d i (nd_C__case_21 x5 x4 x3 l s cd cs)
    (nd_C__case_21 x5 x4 x3 r s cd cs)
  Choices_C_PlClause d i xs -> narrows cs d i (\z -> nd_C__case_21 x5 x4 x3 z s
    cd cs) xs
  Guard_C_PlClause d c e -> guardCons d c ((\x -> nd_C__case_21 x5 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_PlClause d info -> failCons d (traceFail
    "Language.Prolog.Types._case_21" [show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_21" (showCons x2))

nd_C__case_16 :: Curry_Prelude.OP_List C_PlGoal -> Curry_Prelude.OP_List
  C_PlGoal -> Curry_Prelude.OP_List C_PlGoal -> C_PlGoal -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_16 x20 x19 x18 x2 s cd cs = case x2 of
  C_PlLit x21 x22 -> Curry_Prelude.C_False
  C_PlNeg x23 -> Curry_Prelude.C_False
  C_PlCond x24 x25 x26 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
    x18 x24 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
    x19 x25 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
    x20 x26 s3 cd cs) cd cs))
  Choice_C_PlGoal d i l r -> narrow d i (nd_C__case_16 x20 x19 x18 l s cd cs)
    (nd_C__case_16 x20 x19 x18 r s cd cs)
  Choices_C_PlGoal d i xs -> narrows cs d i (\z -> nd_C__case_16 x20 x19 x18 z s
    cd cs) xs
  Guard_C_PlGoal d c e -> guardCons d c ((\x -> nd_C__case_16 x20 x19 x18 e s cd
    x) $! addCs c cs)
  Fail_C_PlGoal d info -> failCons d (traceFail "Language.Prolog.Types._case_16"
    [show x20, show x19, show x18, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_16" (showCons x2))

nd_C__case_17 :: Curry_Prelude.OP_List C_PlGoal -> C_PlGoal -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_17 x11 x2 s cd cs = case x2 of
  C_PlLit x12 x13 -> Curry_Prelude.C_False
  C_PlNeg x14 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash)
    x11 x14 s0 cd cs
  C_PlCond x15 x16 x17 -> Curry_Prelude.C_False
  Choice_C_PlGoal d i l r -> narrow d i (nd_C__case_17 x11 l s cd cs)
    (nd_C__case_17 x11 r s cd cs)
  Choices_C_PlGoal d i xs -> narrows cs d i (\z -> nd_C__case_17 x11 z s cd cs)
    xs
  Guard_C_PlGoal d c e -> guardCons d c ((\x -> nd_C__case_17 x11 e s cd x) $!
    addCs c cs)
  Fail_C_PlGoal d info -> failCons d (traceFail "Language.Prolog.Types._case_17"
    [show x11, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_17" (showCons x2))

nd_C__case_18 :: Curry_Prelude.OP_List C_PlTerm -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_PlGoal -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_18 x4 x3 x2 s cd cs = case x2 of
  C_PlLit x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x5 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash)
    x4 x6 s1 cd cs) cd cs))
  C_PlNeg x7 -> Curry_Prelude.C_False
  C_PlCond x8 x9 x10 -> Curry_Prelude.C_False
  Choice_C_PlGoal d i l r -> narrow d i (nd_C__case_18 x4 x3 l s cd cs)
    (nd_C__case_18 x4 x3 r s cd cs)
  Choices_C_PlGoal d i xs -> narrows cs d i (\z -> nd_C__case_18 x4 x3 z s cd
    cs) xs
  Guard_C_PlGoal d c e -> guardCons d c ((\x -> nd_C__case_18 x4 x3 e s cd x) $!
    addCs c cs)
  Fail_C_PlGoal d info -> failCons d (traceFail "Language.Prolog.Types._case_18"
    [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_18" (showCons x2))

nd_C__case_11 :: Curry_Prelude.OP_List C_PlTerm -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_PlTerm -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_11 x32 x31 x2 s cd cs = case x2 of
  C_PlVar x33 -> Curry_Prelude.C_False
  C_PlAtom x34 -> Curry_Prelude.C_False
  C_PlInt x35 -> Curry_Prelude.C_False
  C_PlFloat x36 -> Curry_Prelude.C_False
  C_PlStruct x37 x38 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x31 x37 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash)
    x32 x38 s1 cd cs) cd cs))
  Choice_C_PlTerm d i l r -> narrow d i (nd_C__case_11 x32 x31 l s cd cs)
    (nd_C__case_11 x32 x31 r s cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z -> nd_C__case_11 x32 x31 z s cd
    cs) xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x -> nd_C__case_11 x32 x31 e s cd
    x) $! addCs c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail "Language.Prolog.Types._case_11"
    [show x32, show x31, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_11" (showCons x2))

d_C__case_12 :: Curry_Prelude.C_Float -> C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_12 x24 x2 cd cs = case x2 of
  C_PlVar x25 -> Curry_Prelude.C_False
  C_PlAtom x26 -> Curry_Prelude.C_False
  C_PlInt x27 -> Curry_Prelude.C_False
  C_PlFloat x28 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
    cd cs) x24 cd cs) x28 cd cs
  C_PlStruct x29 x30 -> Curry_Prelude.C_False
  Choice_C_PlTerm d i l r -> narrow d i (d_C__case_12 x24 l cd cs) (d_C__case_12
    x24 r cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z -> d_C__case_12 x24 z cd cs) xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x -> d_C__case_12 x24 e cd x) $!
    addCs c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail "Language.Prolog.Types._case_12"
    [show x24, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_12" (showCons x2))

d_C__case_13 :: Curry_Prelude.C_Int -> C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_13 x17 x2 cd cs = case x2 of
  C_PlVar x18 -> Curry_Prelude.C_False
  C_PlAtom x19 -> Curry_Prelude.C_False
  C_PlInt x20 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x17 cd cs) x20 cd cs
  C_PlFloat x21 -> Curry_Prelude.C_False
  C_PlStruct x22 x23 -> Curry_Prelude.C_False
  Choice_C_PlTerm d i l r -> narrow d i (d_C__case_13 x17 l cd cs) (d_C__case_13
    x17 r cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z -> d_C__case_13 x17 z cd cs) xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x -> d_C__case_13 x17 e cd x) $!
    addCs c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail "Language.Prolog.Types._case_13"
    [show x17, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_13" (showCons x2))

nd_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlTerm
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_14 x10 x2 s cd cs = case x2 of
  C_PlVar x11 -> Curry_Prelude.C_False
  C_PlAtom x12 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x10 x12 s0 cd cs
  C_PlInt x13 -> Curry_Prelude.C_False
  C_PlFloat x14 -> Curry_Prelude.C_False
  C_PlStruct x15 x16 -> Curry_Prelude.C_False
  Choice_C_PlTerm d i l r -> narrow d i (nd_C__case_14 x10 l s cd cs)
    (nd_C__case_14 x10 r s cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z -> nd_C__case_14 x10 z s cd cs)
    xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x -> nd_C__case_14 x10 e s cd x) $!
    addCs c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail "Language.Prolog.Types._case_14"
    [show x10, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_14" (showCons x2))

nd_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlTerm
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_15 x3 x2 s cd cs = case x2 of
  C_PlVar x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x4 s0 cd cs
  C_PlAtom x5 -> Curry_Prelude.C_False
  C_PlInt x6 -> Curry_Prelude.C_False
  C_PlFloat x7 -> Curry_Prelude.C_False
  C_PlStruct x8 x9 -> Curry_Prelude.C_False
  Choice_C_PlTerm d i l r -> narrow d i (nd_C__case_15 x3 l s cd cs)
    (nd_C__case_15 x3 r s cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z -> nd_C__case_15 x3 z s cd cs)
    xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x -> nd_C__case_15 x3 e s cd x) $!
    addCs c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail "Language.Prolog.Types._case_15"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_15" (showCons x2))

d_C__case_8 :: Curry_Prelude.OP_List C_PlGoal -> C_PlClause -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_8 x17 x2 cd cs = case x2 of
  C_PlClause x18 x19 x20 -> Curry_Prelude.C_False
  C_PlDirective x21 -> Curry_Prelude.C_False
  C_PlQuery x22 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    x17 x22 cd cs
  Choice_C_PlClause d i l r -> narrow d i (d_C__case_8 x17 l cd cs) (d_C__case_8
    x17 r cd cs)
  Choices_C_PlClause d i xs -> narrows cs d i (\z -> d_C__case_8 x17 z cd cs) xs
  Guard_C_PlClause d c e -> guardCons d c ((\x -> d_C__case_8 x17 e cd x) $!
    addCs c cs)
  Fail_C_PlClause d info -> failCons d (traceFail
    "Language.Prolog.Types._case_8" [show x17, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_8" (showCons x2))

d_C__case_9 :: Curry_Prelude.OP_List C_PlGoal -> C_PlClause -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x11 x2 cd cs = case x2 of
  C_PlClause x12 x13 x14 -> Curry_Prelude.C_False
  C_PlDirective x15 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    x11 x15 cd cs
  C_PlQuery x16 -> Curry_Prelude.C_False
  Choice_C_PlClause d i l r -> narrow d i (d_C__case_9 x11 l cd cs) (d_C__case_9
    x11 r cd cs)
  Choices_C_PlClause d i xs -> narrows cs d i (\z -> d_C__case_9 x11 z cd cs) xs
  Guard_C_PlClause d c e -> guardCons d c ((\x -> d_C__case_9 x11 e cd x) $!
    addCs c cs)
  Fail_C_PlClause d info -> failCons d (traceFail
    "Language.Prolog.Types._case_9" [show x11, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_9" (showCons x2))

d_C__case_10 :: Curry_Prelude.OP_List C_PlGoal -> Curry_Prelude.OP_List C_PlTerm
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlClause -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_10 x5 x4 x3 x2 cd cs = case x2 of
  C_PlClause x6 x7 x8 -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x6 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    x4 x7 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    x5 x8 cd cs) cd cs
  C_PlDirective x9 -> Curry_Prelude.C_False
  C_PlQuery x10 -> Curry_Prelude.C_False
  Choice_C_PlClause d i l r -> narrow d i (d_C__case_10 x5 x4 x3 l cd cs)
    (d_C__case_10 x5 x4 x3 r cd cs)
  Choices_C_PlClause d i xs -> narrows cs d i (\z -> d_C__case_10 x5 x4 x3 z cd
    cs) xs
  Guard_C_PlClause d c e -> guardCons d c ((\x -> d_C__case_10 x5 x4 x3 e cd
    x) $! addCs c cs)
  Fail_C_PlClause d info -> failCons d (traceFail
    "Language.Prolog.Types._case_10" [show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_10" (showCons x2))

d_C__case_5 :: Curry_Prelude.OP_List C_PlGoal -> Curry_Prelude.OP_List C_PlGoal
  -> Curry_Prelude.OP_List C_PlGoal -> C_PlGoal -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_5 x20 x19 x18 x2 cd cs = case x2 of
  C_PlLit x21 x22 -> Curry_Prelude.C_False
  C_PlNeg x23 -> Curry_Prelude.C_False
  C_PlCond x24 x25 x26 -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    x18 x24 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    x19 x25 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    x20 x26 cd cs) cd cs
  Choice_C_PlGoal d i l r -> narrow d i (d_C__case_5 x20 x19 x18 l cd cs)
    (d_C__case_5 x20 x19 x18 r cd cs)
  Choices_C_PlGoal d i xs -> narrows cs d i (\z -> d_C__case_5 x20 x19 x18 z cd
    cs) xs
  Guard_C_PlGoal d c e -> guardCons d c ((\x -> d_C__case_5 x20 x19 x18 e cd
    x) $! addCs c cs)
  Fail_C_PlGoal d info -> failCons d (traceFail "Language.Prolog.Types._case_5"
    [show x20, show x19, show x18, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_5" (showCons x2))

d_C__case_6 :: Curry_Prelude.OP_List C_PlGoal -> C_PlGoal -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_6 x11 x2 cd cs = case x2 of
  C_PlLit x12 x13 -> Curry_Prelude.C_False
  C_PlNeg x14 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlGoal_hash
    x11 x14 cd cs
  C_PlCond x15 x16 x17 -> Curry_Prelude.C_False
  Choice_C_PlGoal d i l r -> narrow d i (d_C__case_6 x11 l cd cs) (d_C__case_6
    x11 r cd cs)
  Choices_C_PlGoal d i xs -> narrows cs d i (\z -> d_C__case_6 x11 z cd cs) xs
  Guard_C_PlGoal d c e -> guardCons d c ((\x -> d_C__case_6 x11 e cd x) $! addCs
    c cs)
  Fail_C_PlGoal d info -> failCons d (traceFail "Language.Prolog.Types._case_6"
    [show x11, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_6" (showCons x2))

d_C__case_7 :: Curry_Prelude.OP_List C_PlTerm -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_PlGoal -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_7 x4 x3 x2 cd cs = case x2 of
  C_PlLit x5 x6 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x5 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    x4 x6 cd cs) cd cs
  C_PlNeg x7 -> Curry_Prelude.C_False
  C_PlCond x8 x9 x10 -> Curry_Prelude.C_False
  Choice_C_PlGoal d i l r -> narrow d i (d_C__case_7 x4 x3 l cd cs) (d_C__case_7
    x4 x3 r cd cs)
  Choices_C_PlGoal d i xs -> narrows cs d i (\z -> d_C__case_7 x4 x3 z cd cs) xs
  Guard_C_PlGoal d c e -> guardCons d c ((\x -> d_C__case_7 x4 x3 e cd x) $!
    addCs c cs)
  Fail_C_PlGoal d info -> failCons d (traceFail "Language.Prolog.Types._case_7"
    [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_7" (showCons x2))

d_C__case_0 :: Curry_Prelude.OP_List C_PlTerm -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_0 x32 x31 x2 cd cs = case x2 of
  C_PlVar x33 -> Curry_Prelude.C_False
  C_PlAtom x34 -> Curry_Prelude.C_False
  C_PlInt x35 -> Curry_Prelude.C_False
  C_PlFloat x36 -> Curry_Prelude.C_False
  C_PlStruct x37 x38 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x31 x37 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_Prolog_dot_Types_dot_PlTerm_hash
    x32 x38 cd cs) cd cs
  Choice_C_PlTerm d i l r -> narrow d i (d_C__case_0 x32 x31 l cd cs)
    (d_C__case_0 x32 x31 r cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z -> d_C__case_0 x32 x31 z cd cs)
    xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x -> d_C__case_0 x32 x31 e cd x) $!
    addCs c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail "Language.Prolog.Types._case_0"
    [show x32, show x31, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_0" (showCons x2))

d_C__case_1 :: Curry_Prelude.C_Float -> C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_1 x24 x2 cd cs = case x2 of
  C_PlVar x25 -> Curry_Prelude.C_False
  C_PlAtom x26 -> Curry_Prelude.C_False
  C_PlInt x27 -> Curry_Prelude.C_False
  C_PlFloat x28 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Float_hash
    x24 x28 cd cs
  C_PlStruct x29 x30 -> Curry_Prelude.C_False
  Choice_C_PlTerm d i l r -> narrow d i (d_C__case_1 x24 l cd cs) (d_C__case_1
    x24 r cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z -> d_C__case_1 x24 z cd cs) xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x -> d_C__case_1 x24 e cd x) $! addCs
    c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail "Language.Prolog.Types._case_1"
    [show x24, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_1" (showCons x2))

d_C__case_2 :: Curry_Prelude.C_Int -> C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_2 x17 x2 cd cs = case x2 of
  C_PlVar x18 -> Curry_Prelude.C_False
  C_PlAtom x19 -> Curry_Prelude.C_False
  C_PlInt x20 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x17 x20 cd cs
  C_PlFloat x21 -> Curry_Prelude.C_False
  C_PlStruct x22 x23 -> Curry_Prelude.C_False
  Choice_C_PlTerm d i l r -> narrow d i (d_C__case_2 x17 l cd cs) (d_C__case_2
    x17 r cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z -> d_C__case_2 x17 z cd cs) xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x -> d_C__case_2 x17 e cd x) $! addCs
    c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail "Language.Prolog.Types._case_2"
    [show x17, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_2" (showCons x2))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlTerm -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x10 x2 cd cs = case x2 of
  C_PlVar x11 -> Curry_Prelude.C_False
  C_PlAtom x12 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x10 x12 cd cs
  C_PlInt x13 -> Curry_Prelude.C_False
  C_PlFloat x14 -> Curry_Prelude.C_False
  C_PlStruct x15 x16 -> Curry_Prelude.C_False
  Choice_C_PlTerm d i l r -> narrow d i (d_C__case_3 x10 l cd cs) (d_C__case_3
    x10 r cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z -> d_C__case_3 x10 z cd cs) xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x -> d_C__case_3 x10 e cd x) $! addCs
    c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail "Language.Prolog.Types._case_3"
    [show x10, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_3" (showCons x2))

d_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlTerm -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x3 x2 cd cs = case x2 of
  C_PlVar x4 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x4 cd cs
  C_PlAtom x5 -> Curry_Prelude.C_False
  C_PlInt x6 -> Curry_Prelude.C_False
  C_PlFloat x7 -> Curry_Prelude.C_False
  C_PlStruct x8 x9 -> Curry_Prelude.C_False
  Choice_C_PlTerm d i l r -> narrow d i (d_C__case_4 x3 l cd cs) (d_C__case_4 x3
    r cd cs)
  Choices_C_PlTerm d i xs -> narrows cs d i (\z -> d_C__case_4 x3 z cd cs) xs
  Guard_C_PlTerm d c e -> guardCons d c ((\x -> d_C__case_4 x3 e cd x) $! addCs
    c cs)
  Fail_C_PlTerm d info -> failCons d (traceFail "Language.Prolog.Types._case_4"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Types._case_4" (showCons x2))

