{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Solver.SMTLIB.Curry_Z3 ( d_C_z3 ) where

import Basics
import qualified Curry_Prelude
import qualified Solver.SMTLIB.Curry_Types


d_C_z3 :: Cover -> ConstStore -> Solver.SMTLIB.Curry_Types.C_SMTSolver
d_C_z3 cd cs = Solver.SMTLIB.Curry_Types.C_SMTSolver
  (Curry_Prelude.toCurryString "z3") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString "-smt2") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString "-in") Curry_Prelude.OP_List))

