module CC.Config where

--- Package version as a string.
packageVersion :: String
packageVersion = "4.0.0"

--- Returns the location (installation directory) of the package.
getPackagePath :: IO String
getPackagePath = return "/var/www/webapps/curry-info/.curry_info_cache/checkouts/verify-3.1.0/.cpm/packages/currycheck-4.0.0"

--- Package location (deprecated, use 'getPackagePath').
packagePath :: String
packagePath = "/var/www/webapps/curry-info/.curry_info_cache/checkouts/verify-3.1.0/.cpm/packages/currycheck-4.0.0"

--- Returns the load path for the package (if it is the main package).
getPackageLoadPath :: IO [String]
getPackageLoadPath = do
  pp <- getPackagePath
  return ["."]

--- Load path for the package (deprecated, use 'getPackageLoadPath').
packageLoadPath :: String
packageLoadPath = ""

--- Returns the location of the executable installed by this package.
getPackageExecutable :: IO String
getPackageExecutable = return "/var/www/webapps/curry-info/.cpm/bin/curry-check"

--- Location of the executable (deprecated, use 'getPackageExecutable').
packageExecutable :: String
packageExecutable = "/var/www/webapps/curry-info/.cpm/bin/curry-check"
