{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_Main ( nd_C_main ) where

import Basics
import qualified Curry_BPMN2BPEL
import qualified Control.Search.Curry_AllValues
import qualified Curry_Grappa
import qualified Curry_Prelude


nd_C_main :: IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
nd_C_main s cd cs = let s8 = s
  in s8 `seq` (let s7 = leftSupply s8
                   s5 = rightSupply s8
  in s7 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                      s6 = rightSupply s5
                                                      s0 = leftSupply s6
                                                      s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Control.Search.Curry_AllValues.d_C_getOneValue (let s2 = leftSupply
                                                                   s3
                                                                 s1 = rightSupply
                                                                   s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_BPMN2BPEL.nd_C_processS
  s1 cd cs) (Curry_BPMN2BPEL.d_C_ex cd cs) s2 cd cs)) cd cs) s4 cd cs))))
  (wrapDX id d_OP_main_dot_uscore_hash_lambda2) s7 cd cs))

d_OP_main_dot_uscore_hash_lambda2 :: Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_BPMN2BPEL.C_BPELComp)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_BPMN2BPEL.C_BPMNComp
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_main_dot_uscore_hash_lambda2 x1 cd cs = case x1 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_C_putStrLn
    (Curry_Prelude.toCurryString "No solution") cd cs
  Curry_Prelude.C_Just x2 -> let x3 = Curry_Grappa.d_C_getSemRep x2 cd cs
    in Curry_Prelude.d_C_putStrLn (Curry_BPMN2BPEL.d_C_bpel2xml x3 cd cs) cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_main_dot_uscore_hash_lambda2 l cd cs)
    (d_OP_main_dot_uscore_hash_lambda2 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_main_dot_uscore_hash_lambda2 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    d_OP_main_dot_uscore_hash_lambda2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Main.main._#lambda2" [show x1] info)
  _ -> failCons cd (consFail "Main.main._#lambda2" (showCons x1))

