{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CPM.Repository.Curry_IndexDB_ERD ( d_C_cpmIndexERD ) where

import Basics
import qualified Database.Curry_ERD
import qualified Curry_Prelude


d_C_cpmIndexERD :: Cover -> ConstStore -> Database.Curry_ERD.C_ERD
d_C_cpmIndexERD cd cs = Database.Curry_ERD.C_ERD (Curry_Prelude.toCurryString
  "RepositoryDB") (Curry_Prelude.OP_Cons (Database.Curry_ERD.C_Entity
  (Curry_Prelude.toCurryString "IndexEntry") (Curry_Prelude.OP_Cons
  (Database.Curry_ERD.C_Attribute (Curry_Prelude.toCurryString "Name")
  (Database.Curry_ERD.C_StringDom Curry_Prelude.C_Nothing)
  Database.Curry_ERD.C_NoKey Curry_Prelude.C_False) (Curry_Prelude.OP_Cons
  (Database.Curry_ERD.C_Attribute (Curry_Prelude.toCurryString "Version")
  (Database.Curry_ERD.C_StringDom Curry_Prelude.C_Nothing)
  Database.Curry_ERD.C_NoKey Curry_Prelude.C_False) (Curry_Prelude.OP_Cons
  (Database.Curry_ERD.C_Attribute (Curry_Prelude.toCurryString "Dependencies")
  (Database.Curry_ERD.C_StringDom Curry_Prelude.C_Nothing)
  Database.Curry_ERD.C_NoKey Curry_Prelude.C_True) (Curry_Prelude.OP_Cons
  (Database.Curry_ERD.C_Attribute (Curry_Prelude.toCurryString
  "CompilerCompatibility") (Database.Curry_ERD.C_StringDom
  Curry_Prelude.C_Nothing) Database.Curry_ERD.C_NoKey Curry_Prelude.C_True)
  (Curry_Prelude.OP_Cons (Database.Curry_ERD.C_Attribute
  (Curry_Prelude.toCurryString "Synopsis") (Database.Curry_ERD.C_StringDom
  Curry_Prelude.C_Nothing) Database.Curry_ERD.C_NoKey Curry_Prelude.C_True)
  (Curry_Prelude.OP_Cons (Database.Curry_ERD.C_Attribute
  (Curry_Prelude.toCurryString "Category") (Database.Curry_ERD.C_StringDom
  Curry_Prelude.C_Nothing) Database.Curry_ERD.C_NoKey Curry_Prelude.C_True)
  (Curry_Prelude.OP_Cons (Database.Curry_ERD.C_Attribute
  (Curry_Prelude.toCurryString "SourceDirs") (Database.Curry_ERD.C_StringDom
  Curry_Prelude.C_Nothing) Database.Curry_ERD.C_NoKey Curry_Prelude.C_True)
  (Curry_Prelude.OP_Cons (Database.Curry_ERD.C_Attribute
  (Curry_Prelude.toCurryString "ExportedModules")
  (Database.Curry_ERD.C_StringDom Curry_Prelude.C_Nothing)
  Database.Curry_ERD.C_NoKey Curry_Prelude.C_True) (Curry_Prelude.OP_Cons
  (Database.Curry_ERD.C_Attribute (Curry_Prelude.toCurryString "ExecutableSpec")
  (Database.Curry_ERD.C_StringDom Curry_Prelude.C_Nothing)
  Database.Curry_ERD.C_NoKey Curry_Prelude.C_True)
  Curry_Prelude.OP_List)))))))))) Curry_Prelude.OP_List) Curry_Prelude.OP_List

