{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CurryDoc.Curry_PackageConfig
  ( d_C_packageVersion
  , d_C_getPackagePath
  , d_C_packagePath
  , d_C_getPackageLoadPath
  , d_C_packageLoadPath
  , d_C_getPackageExecutable
  , d_C_packageExecutable )
  where

import Basics
import qualified Curry_Prelude


d_C_packageVersion :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_packageVersion cd cs = Curry_Prelude.toCurryString "4.0.0"

d_C_getPackagePath :: Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getPackagePath cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.toCurryString
  "/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0") cd
  cs

d_C_packagePath :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_packagePath cd cs = Curry_Prelude.toCurryString
  "/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0"

d_C_getPackageLoadPath :: Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_getPackageLoadPath cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getPackagePath cd cs) cd cs)
  d_OP_getPackageLoadPath_dot_uscore_hash_lambda2 cd cs

d_OP_getPackageLoadPath_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_getPackageLoadPath_dot_uscore_hash_lambda2 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/src") cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString
  "/.cpm/packages/markdown-3.3.0/src") cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString
  "/.cpm/packages/global-3.2.0/src") cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString
  "/.cpm/packages/rewriting-3.0.0/src") cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString
  "/.cpm/packages/flatcurry-type-annotated-3.4.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/flatcurry-annotated-3.3.0/src")
  cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/cryptohash-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/html2-3.5.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/html2-3.5.0/scripts") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/curry-resources-1.0.0/src") cd
  cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/det-parse-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/json-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/socket-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/csv-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/cpm-query-0.1.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/cass-4.1.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/scc-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/xml-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/transformers-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/extra-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/string-trie-0.0.2/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/rw-data-1.1.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/redblacktree-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/profiling-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/flatcurry-4.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/containers-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/cass-analysis-4.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/read-legacy-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/random-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/queue-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/wl-pprint-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/frontend-exec-3.3.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/propertyfile-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/process-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/io-extra-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/execpath-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/time-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/filepath-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/directory-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/currypath-3.0.0/src") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/.cpm/packages/abstract-curry-4.0.0/src") cd cs)
  Curry_Prelude.OP_List))))))))))))))))))))))))))))))))))))))))) cd cs

d_C_packageLoadPath :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_packageLoadPath cd cs = Curry_Prelude.toCurryString
  "/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/markdown-3.3.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/global-3.2.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/rewriting-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/flatcurry-type-annotated-3.4.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/flatcurry-annotated-3.3.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/cryptohash-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/html2-3.5.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/html2-3.5.0/scripts:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/curry-resources-1.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/det-parse-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/json-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/socket-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/csv-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/cpm-query-0.1.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/cass-4.1.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/scc-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/xml-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/transformers-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/extra-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/string-trie-0.0.2/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/rw-data-1.1.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/redblacktree-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/profiling-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/flatcurry-4.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/containers-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/cass-analysis-4.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/read-legacy-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/random-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/queue-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/wl-pprint-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/frontend-exec-3.3.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/propertyfile-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/process-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/io-extra-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/execpath-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/time-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/filepath-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/directory-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/currypath-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/currydoc-4.0.0/.cpm/packages/abstract-curry-4.0.0/src"

d_C_getPackageExecutable :: Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getPackageExecutable cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.toCurryString
  "/var/www/webapps/curry-info/.cpm/bin/curry-doc") cd cs

d_C_packageExecutable :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_packageExecutable cd cs = Curry_Prelude.toCurryString
  "/var/www/webapps/curry-info/.cpm/bin/curry-doc"

