{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CPP.ICode.Curry_ParseMonad
  ( C_PM (..)
  , d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash
  , d_C_warnPM
  , d_C_bindPM
  , nd_C_bindPM
  , d_C_liftPM
  , nd_C_liftPM
  , d_C_cleanPM
  , d_C_warnOKPM
  , d_C_throwPM
  , d_C_throwMultiPM
  , d_C_singlePM
  , d_C_discardWarningsPM
  , d_C_getWarningsPM
  , d_C_mapWarnsPM
  , nd_C_mapWarnsPM
  , d_C_crumplePM
  , d_C_swapIOPM
  , nd_C_swapIOPM
  , d_C_sequencePM
  , d_C_fstPM
  , nd_C_fstPM
  , d_C_sndPM
  , nd_C_sndPM
  , d_C_combinePMs
  , nd_C_combinePMs )
  where

import Basics
import qualified CPP.ICode.Curry_ParseError
import qualified CPP.ICode.Curry_ParsePos
import qualified CPP.ICode.Curry_ParseWarning
import qualified Curry_Prelude


newtype C_PM t0 = C_PM (CPP.ICode.Curry_ParseWarning.C_WM
    (CPP.ICode.Curry_ParseError.C_PR t0))

instance (Curry t0) => Show (C_PM t0) where
  showsPrec _ (C_PM x1) = showString "(PM" . (showChar ' ' . (shows x1 .
    showChar ')'))

instance (Curry t0) => Read (C_PM t0) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_PM x1, r1) | (_, r0) <-
    readQualified "CPP.ICode.ParseMonad" "PM" r, (x1, r1) <- readsPrec 11 r0]) s

instance (Curry t0) => NonDet (C_PM t0) where
  choiceCons cd i (C_PM x) (C_PM y) = C_PM (choiceCons cd i x y)
  choicesCons cd i xs = C_PM (choicesCons cd i (map (\(C_PM v) -> v) xs))
  failCons cd info = C_PM (failCons cd info)
  guardCons cd c (C_PM e) = C_PM (guardCons cd c e)
  match chc nrwd fr fl grd vl (C_PM v) = match (\cd i x y -> chc cd i (C_PM x)
    (C_PM y)) (\cd i xs -> nrwd cd i (map C_PM xs)) (\cd i xs -> fr cd i (map
    C_PM xs)) fl (\cd cs e -> grd cd cs (C_PM e)) (vl . C_PM) v

instance (Curry t0) => Generable (C_PM t0) where
  generate s c = C_PM (generate s c)

instance (Curry t0) => NormalForm (C_PM t0) where
  ($!!) cont (C_PM x) = ($!!) (\y -> cont (C_PM y)) x
  ($##) cont (C_PM x) = ($##) (\y -> cont (C_PM y)) x
  searchNF s cont (C_PM x) = searchNF s (cont . C_PM) x

instance (Curry t0) => Unifiable (C_PM t0) where
  (=.=) (C_PM x) (C_PM y) = (=.=) x y
  (=.<=) (C_PM x) (C_PM y) = (=.<=) x y
  bind cd i (C_PM x) = bind cd i x
  lazyBind cd i (C_PM x) = lazyBind cd i x

instance (Curry t0) => Curry (C_PM t0) where

d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Functor C_PM
d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Functor
    (d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    cd cs)
    (d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad._inst#Prelude.Functor#CPP.ICode.ParseMonad.PM#" [show
    x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseMonad._inst#Prelude.Functor#CPP.ICode.ParseMonad.PM#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Functor C_PM
nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Functor
    (nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    s0 cd cs)
    (nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    s1 cd cs)))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad._inst#Prelude.Functor#CPP.ICode.ParseMonad.PM#" [show
    x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseMonad._inst#Prelude.Functor#CPP.ICode.ParseMonad.PM#"
    (showCons x1))

d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t1 -> Cover -> ConstStore -> t0) -> Cover -> ConstStore -> C_PM t1
  -> Cover -> ConstStore -> C_PM t0
d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash cd cs =
  acceptCs id d_C_liftPM

nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (Func t1 t0) (Func (C_PM t1) (C_PM t0))
nd_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash s cd cs =
  wrapDX (wrapNX id) (acceptCs id nd_C_liftPM)

d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Cover -> ConstStore -> C_PM t0 -> Cover -> ConstStore -> C_PM t1
d_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_lt_dollar_hash_Prelude_dot_Functor
  d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  cd cs

nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Func (C_PM t0) (C_PM t1))
nd_OP_uscore_impl_hash_lt_dollar_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash s cd cs =
  let s0 = s
  in s0 `seq`
  Curry_Prelude.nd_OP_uscore_def_hash_lt_dollar_hash_Prelude_dot_Functor (wrapNX
  id
  nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)
  s0 cd cs

d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Applicative C_PM
d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Applicative
    d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    (d_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    cd cs)
    (d_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    cd cs)
    (d_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    cd cs)
    (d_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    cd cs)
    (d_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad._inst#Prelude.Applicative#CPP.ICode.ParseMonad.PM#"
    [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseMonad._inst#Prelude.Applicative#CPP.ICode.ParseMonad.PM#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Applicative C_PM
nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s5 = s
    in s5 `seq` (let s6 = leftSupply s5
                     s7 = rightSupply s5
                     s0 = leftSupply s6
                     s1 = rightSupply s6
                     s2 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s4 = rightSupply s8
    in s6 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s8 `seq` (s3 `seq`
    (s4 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Applicative (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Functor_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)
    (nd_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    s0 cd cs)
    (nd_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    s1 cd cs)
    (nd_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    s2 cd cs)
    (nd_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    s3 cd cs)
    (nd_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    s4 cd cs)))))))))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad._inst#Prelude.Applicative#CPP.ICode.ParseMonad.PM#"
    [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseMonad._inst#Prelude.Applicative#CPP.ICode.ParseMonad.PM#"
    (showCons x1))

d_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Cover
  -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> C_PM t0
d_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash cd cs =
  d_C_cleanPM

nd_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (C_PM t0)
nd_OP_uscore_impl_hash_pure_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash s cd cs =
  wrapDX id d_C_cleanPM

d_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_PM (t1 -> Cover -> ConstStore -> t0) -> Cover -> ConstStore -> C_PM
  t1 -> Cover -> ConstStore -> C_PM t0
d_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_lt_star_gt_hash_Prelude_dot_Applicative
  d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  cd cs

nd_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (C_PM (Func t1 t0)) (Func (C_PM t1) (C_PM
  t0))
nd_OP_uscore_impl_hash_lt_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash s cd cs =
  let s0 = s
  in s0 `seq`
  Curry_Prelude.nd_OP_uscore_def_hash_lt_star_gt_hash_Prelude_dot_Applicative
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)
  s0 cd cs

d_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_PM t1 -> Cover -> ConstStore -> C_PM t0 -> Cover -> ConstStore
  -> C_PM t0
d_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash cd cs =
  acceptCs id
  (Curry_Prelude.d_OP_uscore_def_hash_star_gt_hash_Prelude_dot_Applicative
  d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)

nd_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (C_PM t1) (Func (C_PM t0) (C_PM t0))
nd_OP_uscore_impl_hash_star_gt_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash s cd cs =
  wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_def_hash_star_gt_hash_Prelude_dot_Applicative
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)))

d_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_PM t1 -> Cover -> ConstStore -> C_PM t0 -> Cover -> ConstStore
  -> C_PM t1
d_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_lt_star_hash_Prelude_dot_Applicative
  d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
  cd cs

nd_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (C_PM t1) (Func (C_PM t0) (C_PM t1))
nd_OP_uscore_impl_hash_lt_star_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash s cd cs =
  let s0 = s
  in s0 `seq`
  Curry_Prelude.nd_OP_uscore_def_hash_lt_star_hash_Prelude_dot_Applicative
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)
  s0 cd cs

d_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Cover
  -> ConstStore -> forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> Cover -> ConstStore
  -> C_PM t2 -> Cover -> ConstStore -> C_PM t1 -> Cover -> ConstStore -> C_PM t0
d_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash cd cs =
  acceptCs id
  (Curry_Prelude.d_OP_uscore_def_hash_liftA2_hash_Prelude_dot_Applicative
  d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)

nd_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func (Func t2 (Func t1
  t0)) (Func (C_PM t2) (Func (C_PM t1) (C_PM t0)))
nd_OP_uscore_impl_hash_liftA2_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash s cd cs =
  wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_def_hash_liftA2_hash_Prelude_dot_Applicative
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)))

d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Monad C_PM
d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Monad
    d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    (d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    cd cs)
    (d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    cd cs)
    (d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad._inst#Prelude.Monad#CPP.ICode.ParseMonad.PM#" [show
    x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseMonad._inst#Prelude.Monad#CPP.ICode.ParseMonad.PM#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Monad
  C_PM
nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s3 = s
    in s3 `seq` (let s0 = leftSupply s3
                     s4 = rightSupply s3
                     s1 = leftSupply s4
                     s2 = rightSupply s4
    in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq`
    Curry_Prelude.HO_OP_uscore_Dict_hash_Monad (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)
    (nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    s0 cd cs)
    (nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    s1 cd cs)
    (nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    s2 cd cs)))))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad._inst#Prelude.Monad#CPP.ICode.ParseMonad.PM#" [show
    x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseMonad._inst#Prelude.Monad#CPP.ICode.ParseMonad.PM#"
    (showCons x1))

d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_PM t1 -> Cover -> ConstStore -> (t1 -> Cover -> ConstStore -> C_PM
  t0) -> Cover -> ConstStore -> C_PM t0
d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash cd cs =
  acceptCs id d_C_bindPM

nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (C_PM t1) (Func (Func t1 (C_PM t0)) (C_PM
  t0))
nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash s cd cs =
  wrapDX (wrapNX id) (acceptCs id nd_C_bindPM)

d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Cover
  -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_PM t1 -> Cover -> ConstStore -> C_PM t0 -> Cover -> ConstStore
  -> C_PM t0
d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_gt_gt_hash_Prelude_dot_Monad
  d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)

nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (C_PM t1) (Func (C_PM t0) (C_PM t0))
nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash s cd cs =
  wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_def_hash_gt_gt_hash_Prelude_dot_Monad (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash)))

d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: Cover
  -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> C_PM t0
d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash cd cs =
  d_C_cleanPM

nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (C_PM t0)
nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash s cd cs =
  wrapDX id d_C_cleanPM

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data (C_PM t0)
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash
    x1 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad._inst#Prelude.Data#CPP.ICode.ParseMonad.PM#0##" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseMonad._inst#Prelude.Data#CPP.ICode.ParseMonad.PM#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> C_PM t0 -> C_PM t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x2 of
  C_PM x4 -> let s0 = s in s0 `seq` nd_C__case_3 x4 x1 x3 s0 cd cs

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> IDSupply -> Cover -> ConstStore -> C_PM t0
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseMonad_dot_PM_hash_0_hash_hash x1 s cd cs =
  let s0 = s
  in s0 `seq` C_PM
  (CPP.ICode.Curry_ParseWarning.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
  (wrapNX id
  (CPP.ICode.Curry_ParseError.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseError_dot_PR_hash_0_hash_hash
  x1)) s0 cd cs)

d_C_warnPM :: forall t0 . (Curry_Prelude.Curry
  t0) => CPP.ICode.Curry_ParseError.C_PR t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> C_PM t0
d_C_warnPM x1 x2 cd cs = C_PM (CPP.ICode.Curry_ParseWarning.d_C_returnWM x1 x2
  cd cs)

d_C_bindPM :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_PM t1 -> (t1 -> Cover -> ConstStore -> C_PM t0) -> Cover
  -> ConstStore -> C_PM t0
d_C_bindPM x1 x2 cd cs = case x1 of
  C_PM x3 -> Curry_Prelude.d_OP_dollar (acceptCs id C_PM)
    (Curry_Prelude.d_OP_dollar (CPP.ICode.Curry_ParseWarning.d_C_bindWM x3)
    (d_OP_bindPM_dot_uscore_hash_lambda1 x2) cd cs) cd cs

nd_C_bindPM :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_PM t1 -> Func t1 (C_PM t0) -> IDSupply -> Cover -> ConstStore -> C_PM
  t0
nd_C_bindPM x1 x2 s cd cs = case x1 of
  C_PM x3 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id (acceptCs id
    C_PM)) (Curry_Prelude.nd_OP_dollar (wrapNX id
    (CPP.ICode.Curry_ParseWarning.nd_C_bindWM x3)) (wrapNX id
    (nd_OP_bindPM_dot_uscore_hash_lambda1 x2)) s0 cd cs) s1 cd cs))

d_OP_bindPM_dot_uscore_hash_lambda1 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (t1 -> Cover -> ConstStore -> C_PM t0)
  -> CPP.ICode.Curry_ParseError.C_PR t1 -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseWarning.C_WM (CPP.ICode.Curry_ParseError.C_PR t0)
d_OP_bindPM_dot_uscore_hash_lambda1 x1 x2 cd cs = case x2 of
  CPP.ICode.Curry_ParseError.C_Errors x3 -> CPP.ICode.Curry_ParseWarning.d_C_cleanWM
    (CPP.ICode.Curry_ParseError.C_Errors x3) cd cs
  CPP.ICode.Curry_ParseError.C_OK x4 -> d_C__case_2 x4 x1
    (Curry_Prelude.d_C_apply x1 x4 cd cs) cd cs
  CPP.ICode.Curry_ParseError.Choice_C_PR d i l r -> narrow d i
    (d_OP_bindPM_dot_uscore_hash_lambda1 x1 l cd cs)
    (d_OP_bindPM_dot_uscore_hash_lambda1 x1 r cd cs)
  CPP.ICode.Curry_ParseError.Choices_C_PR d i xs -> narrows cs d i (\z ->
    d_OP_bindPM_dot_uscore_hash_lambda1 x1 z cd cs) xs
  CPP.ICode.Curry_ParseError.Guard_C_PR d c e -> guardCons d c ((\x ->
    d_OP_bindPM_dot_uscore_hash_lambda1 x1 e cd x) $! addCs c cs)
  CPP.ICode.Curry_ParseError.Fail_C_PR d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad.bindPM._#lambda1" [show x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseMonad.bindPM._#lambda1" (showCons
    x2))

nd_OP_bindPM_dot_uscore_hash_lambda1 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (C_PM t0)
  -> CPP.ICode.Curry_ParseError.C_PR t1 -> IDSupply -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseWarning.C_WM (CPP.ICode.Curry_ParseError.C_PR t0)
nd_OP_bindPM_dot_uscore_hash_lambda1 x1 x2 s cd cs = case x2 of
  CPP.ICode.Curry_ParseError.C_Errors x3 -> CPP.ICode.Curry_ParseWarning.d_C_cleanWM
    (CPP.ICode.Curry_ParseError.C_Errors x3) cd cs
  CPP.ICode.Curry_ParseError.C_OK x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_2 x4 x1 (Curry_Prelude.nd_C_apply x1 x4 s0
    cd cs) s1 cd cs))
  CPP.ICode.Curry_ParseError.Choice_C_PR d i l r -> narrow d i
    (nd_OP_bindPM_dot_uscore_hash_lambda1 x1 l s cd cs)
    (nd_OP_bindPM_dot_uscore_hash_lambda1 x1 r s cd cs)
  CPP.ICode.Curry_ParseError.Choices_C_PR d i xs -> narrows cs d i (\z ->
    nd_OP_bindPM_dot_uscore_hash_lambda1 x1 z s cd cs) xs
  CPP.ICode.Curry_ParseError.Guard_C_PR d c e -> guardCons d c ((\x ->
    nd_OP_bindPM_dot_uscore_hash_lambda1 x1 e s cd x) $! addCs c cs)
  CPP.ICode.Curry_ParseError.Fail_C_PR d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad.bindPM._#lambda1" [show x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseMonad.bindPM._#lambda1" (showCons
    x2))

d_C_liftPM :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t1 -> Cover -> ConstStore -> t0) -> C_PM t1 -> Cover -> ConstStore
  -> C_PM t0
d_C_liftPM x1 x2 cd cs = d_C_bindPM x2 (Curry_Prelude.d_OP_dot d_C_cleanPM x1 cd
  cs) cd cs

nd_C_liftPM :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t1 t0 -> C_PM t1 -> IDSupply -> Cover -> ConstStore -> C_PM t0
nd_C_liftPM x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_bindPM x2 (Curry_Prelude.nd_OP_dot (wrapDX id
  d_C_cleanPM) x1 s0 cd cs) s1 cd cs))

d_C_cleanPM :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover -> ConstStore
  -> C_PM t0
d_C_cleanPM x1 cd cs = Curry_Prelude.d_C_apply (d_C_warnOKPM x1 cd cs)
  Curry_Prelude.OP_List cd cs

d_C_warnOKPM :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Cover -> ConstStore -> C_PM t0
d_C_warnOKPM x1 cd cs = d_C_warnPM (CPP.ICode.Curry_ParseError.d_C_okPR x1 cd
  cs)

d_C_throwPM :: forall t0 . (Curry_Prelude.Curry
  t0) => CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> C_PM t0
d_C_throwPM x1 x2 cd cs = Curry_Prelude.d_OP_dollar (acceptCs id C_PM)
  (CPP.ICode.Curry_ParseWarning.d_C_cleanWM
  (CPP.ICode.Curry_ParseError.d_C_throwPMsg x1 x2 cd cs) cd cs) cd cs

d_C_throwMultiPM :: forall t0 . (Curry_Prelude.Curry
  t0) => CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> C_PM t0
d_C_throwMultiPM x1 x2 cd cs = Curry_Prelude.d_OP_dollar (acceptCs id C_PM)
  (CPP.ICode.Curry_ParseWarning.d_C_cleanWM
  (CPP.ICode.Curry_ParseError.d_C_throwPR (Curry_Prelude.d_C_map
  (d_OP_throwMultiPM_dot_uscore_hash_lambda4 x1) x2 cd cs) cd cs) cd cs) cd cs

d_OP_throwMultiPM_dot_uscore_hash_lambda4 :: CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseError.C_PError
d_OP_throwMultiPM_dot_uscore_hash_lambda4 x1 x2 cd cs =
  CPP.ICode.Curry_ParseError.C_PError x1 x2

d_C_singlePM :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> C_PM t0
d_C_singlePM x1 x2 cd cs = Curry_Prelude.d_C_apply (d_C_warnOKPM x1 cd cs)
  (Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List) cd cs

d_C_discardWarningsPM :: forall t0 . (Curry_Prelude.Curry t0) => C_PM t0
  -> Cover -> ConstStore -> CPP.ICode.Curry_ParseError.C_PR t0
d_C_discardWarningsPM x1 cd cs = case x1 of
  C_PM x2 -> CPP.ICode.Curry_ParseWarning.d_C_discardWarnings x2 cd cs

d_C_getWarningsPM :: forall t0 . (Curry_Prelude.Curry t0) => C_PM t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_getWarningsPM x1 cd cs = case x1 of
  C_PM x2 -> CPP.ICode.Curry_ParseWarning.d_C_getWarnings x2 cd cs

d_C_mapWarnsPM :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> C_PM t0 -> Cover
  -> ConstStore -> C_PM t0
d_C_mapWarnsPM x1 x2 cd cs = case x2 of
  C_PM x3 -> Curry_Prelude.d_OP_dollar (acceptCs id C_PM)
    (CPP.ICode.Curry_ParseWarning.d_C_mapWarns x1 x3 cd cs) cd cs

nd_C_mapWarnsPM :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> C_PM t0 -> IDSupply -> Cover
  -> ConstStore -> C_PM t0
nd_C_mapWarnsPM x1 x2 s cd cs = case x2 of
  C_PM x3 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id (acceptCs id
    C_PM)) (CPP.ICode.Curry_ParseWarning.nd_C_mapWarns x1 x3 s0 cd cs) s1 cd
    cs))

d_C_crumplePM :: forall t0 . (Curry_Prelude.Curry t0) => C_PM (C_PM t0) -> Cover
  -> ConstStore -> C_PM t0
d_C_crumplePM x1 cd cs = d_C_bindPM x1 Curry_Prelude.d_C_id cd cs

d_C_swapIOPM :: forall t0 . (Curry_Prelude.Curry t0) => C_PM (Curry_Prelude.C_IO
  t0) -> Cover -> ConstStore -> Curry_Prelude.C_IO (C_PM t0)
d_C_swapIOPM x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (CPP.ICode.Curry_ParseError.d_C_swapIOPR (d_C_discardWarningsPM x1 cd
  cs) cd cs) cd cs) (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_flip (acceptCs id d_C_warnPM) (d_C_getWarningsPM x1
  cd cs)) cd cs) cd cs

nd_C_swapIOPM :: forall t0 . (Curry_Prelude.Curry t0) => C_PM
  (Curry_Prelude.C_IO t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (C_PM t0)
nd_C_swapIOPM x1 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s3 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s3 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (CPP.ICode.Curry_ParseError.nd_C_swapIOPR (d_C_discardWarningsPM x1
  cd cs) s1 cd cs) s2 cd cs)))) (let s6 = leftSupply s7
                                     s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_OP_dot
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s5 cd cs) (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id
  d_C_warnPM)) (d_C_getWarningsPM x1 cd cs))) s6 cd cs)) s8 cd cs))))

d_C_sequencePM :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_PM t0) -> Cover -> ConstStore -> C_PM (Curry_Prelude.OP_List t0)
d_C_sequencePM x1 cd cs = d_C_warnPM (CPP.ICode.Curry_ParseError.d_C_sequencePR
  (Curry_Prelude.d_C_map d_C_discardWarningsPM x1 cd cs) cd cs)
  (Curry_Prelude.d_C_foldr (acceptCs id Curry_Prelude.d_OP_plus_plus)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_map d_C_getWarningsPM x1 cd cs) cd
  cs) cd cs

d_C_fstPM :: Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => C_PM (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover
  -> ConstStore -> C_PM t1
d_C_fstPM cd cs = d_C_liftPM Curry_Prelude.d_C_fst

nd_C_fstPM :: IDSupply -> Cover -> ConstStore -> forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func (C_PM
  (Curry_Prelude.OP_Tuple2 t1 t0)) (C_PM t1)
nd_C_fstPM s cd cs = wrapNX id (nd_C_liftPM (wrapDX id Curry_Prelude.d_C_fst))

d_C_sndPM :: Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => C_PM (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover
  -> ConstStore -> C_PM t0
d_C_sndPM cd cs = d_C_liftPM Curry_Prelude.d_C_snd

nd_C_sndPM :: IDSupply -> Cover -> ConstStore -> forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func (C_PM
  (Curry_Prelude.OP_Tuple2 t1 t0)) (C_PM t0)
nd_C_sndPM s cd cs = wrapNX id (nd_C_liftPM (wrapDX id Curry_Prelude.d_C_snd))

d_C_combinePMs :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0) -> C_PM t2 -> C_PM t1 -> Cover -> ConstStore -> C_PM t0
d_C_combinePMs x1 x2 x3 cd cs = case x2 of
  C_PM x4 -> d_C__case_1 x4 x1 x3 cd cs

nd_C_combinePMs :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t2 (Func t1 t0)
  -> C_PM t2 -> C_PM t1 -> IDSupply -> Cover -> ConstStore -> C_PM t0
nd_C_combinePMs x1 x2 x3 s cd cs = case x2 of
  C_PM x4 -> let s0 = s in s0 `seq` nd_C__case_1 x4 x1 x3 s0 cd cs

d_OP_combinePMs_dot_concatWarns_dot_42 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => CPP.ICode.Curry_ParseWarning.C_WM t1
  -> CPP.ICode.Curry_ParseWarning.C_WM t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_combinePMs_dot_concatWarns_dot_42 x1 x2 cd cs = case x1 of
  CPP.ICode.Curry_ParseWarning.C_WM x3 x4 -> d_C__case_0 x4 x2 cd cs
  CPP.ICode.Curry_ParseWarning.Choice_C_WM d i l r -> narrow d i
    (d_OP_combinePMs_dot_concatWarns_dot_42 l x2 cd cs)
    (d_OP_combinePMs_dot_concatWarns_dot_42 r x2 cd cs)
  CPP.ICode.Curry_ParseWarning.Choices_C_WM d i xs -> narrows cs d i (\z ->
    d_OP_combinePMs_dot_concatWarns_dot_42 z x2 cd cs) xs
  CPP.ICode.Curry_ParseWarning.Guard_C_WM d c e -> guardCons d c ((\x ->
    d_OP_combinePMs_dot_concatWarns_dot_42 e x2 cd x) $! addCs c cs)
  CPP.ICode.Curry_ParseWarning.Fail_C_WM d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad.combinePMs.concatWarns.42" [show x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseMonad.combinePMs.concatWarns.42"
    (showCons x1))

nd_C__case_3 :: forall t0 . (Curry_Prelude.Curry
  t0) => CPP.ICode.Curry_ParseWarning.C_WM (CPP.ICode.Curry_ParseError.C_PR t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> C_PM t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_3 x4 x1 x3 s cd cs = case x3 of
  C_PM x5 -> let s0 = s
    in s0 `seq`
    CPP.ICode.Curry_ParseWarning.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    (wrapNX id
    (CPP.ICode.Curry_ParseError.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseError_dot_PR_hash_0_hash_hash
    x1)) x4 x5 s0 cd cs

d_C__case_2 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> (t1 -> Cover -> ConstStore -> C_PM t0) -> C_PM t0 -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseWarning.C_WM
  (CPP.ICode.Curry_ParseError.C_PR t0)
d_C__case_2 x4 x1 x6 cd cs = case x6 of
  C_PM x5 -> x5

nd_C__case_2 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Func t1 (C_PM t0) -> C_PM t0 -> IDSupply -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseWarning.C_WM (CPP.ICode.Curry_ParseError.C_PR t0)
nd_C__case_2 x4 x1 x6 s cd cs = case x6 of
  C_PM x5 -> x5

d_C__case_1 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => CPP.ICode.Curry_ParseWarning.C_WM
  (CPP.ICode.Curry_ParseError.C_PR t2) -> (t2 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> t0) -> C_PM t1 -> Cover -> ConstStore -> C_PM t0
d_C__case_1 x4 x1 x3 cd cs = case x3 of
  C_PM x5 -> d_C_warnPM (CPP.ICode.Curry_ParseError.d_C_combinePRs x1
    (CPP.ICode.Curry_ParseWarning.d_C_discardWarnings x4 cd cs)
    (CPP.ICode.Curry_ParseWarning.d_C_discardWarnings x5 cd cs) cd cs)
    (d_OP_combinePMs_dot_concatWarns_dot_42 x4 x5 cd cs) cd cs

nd_C__case_1 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => CPP.ICode.Curry_ParseWarning.C_WM
  (CPP.ICode.Curry_ParseError.C_PR t2) -> Func t2 (Func t1 t0) -> C_PM t1
  -> IDSupply -> Cover -> ConstStore -> C_PM t0
nd_C__case_1 x4 x1 x3 s cd cs = case x3 of
  C_PM x5 -> let s0 = s
    in s0 `seq` d_C_warnPM (CPP.ICode.Curry_ParseError.nd_C_combinePRs x1
    (CPP.ICode.Curry_ParseWarning.d_C_discardWarnings x4 cd cs)
    (CPP.ICode.Curry_ParseWarning.d_C_discardWarnings x5 cd cs) s0 cd cs)
    (d_OP_combinePMs_dot_concatWarns_dot_42 x4 x5 cd cs) cd cs

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> CPP.ICode.Curry_ParseWarning.C_WM t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_0 x4 x2 cd cs = case x2 of
  CPP.ICode.Curry_ParseWarning.C_WM x5 x6 -> Curry_Prelude.d_OP_plus_plus x4 x6
    cd cs
  CPP.ICode.Curry_ParseWarning.Choice_C_WM d i l r -> narrow d i (d_C__case_0 x4
    l cd cs) (d_C__case_0 x4 r cd cs)
  CPP.ICode.Curry_ParseWarning.Choices_C_WM d i xs -> narrows cs d i (\z ->
    d_C__case_0 x4 z cd cs) xs
  CPP.ICode.Curry_ParseWarning.Guard_C_WM d c e -> guardCons d c ((\x ->
    d_C__case_0 x4 e cd x) $! addCs c cs)
  CPP.ICode.Curry_ParseWarning.Fail_C_WM d info -> failCons d (traceFail
    "CPP.ICode.ParseMonad._case_0" [show x4, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseMonad._case_0" (showCons x2))

