{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CPP.ICode.Curry_ParseWarning
  ( C_WM (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
  , d_C_getWarnPos
  , d_C_setWarnPos
  , d_C_getWarnMsg
  , d_C_setWarnMsg
  , d_C_returnWM
  , d_C_bindWM
  , nd_C_bindWM
  , d_C_mapWarns
  , nd_C_mapWarns
  , d_C_cleanWM
  , d_C_singleWM
  , d_C_discardWarnings
  , d_C_getWarnings )
  where

import Basics
import qualified CPP.ICode.Curry_ParsePos
import qualified Curry_Prelude


data C_WM t0
  = C_WM t0 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
    CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)))
  | Choice_C_WM Cover ID (C_WM t0) (C_WM t0)
  | Choices_C_WM Cover ID [C_WM t0]
  | Fail_C_WM Cover FailInfo
  | Guard_C_WM Cover Constraints (C_WM t0)

instance (Curry t0) => Show (C_WM t0) where
  showsPrec d (Choice_C_WM cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_WM cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_WM cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_WM cd info) = showChar '!'
  showsPrec _ (C_WM x1 x2) = showString "(WM" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))

instance (Curry t0) => Read (C_WM t0) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_WM x1 x2, r2) | (_, r0) <-
    readQualified "CPP.ICode.ParseWarning" "WM" r, (x1, r1) <- readsPrec 11 r0,
    (x2, r2) <- readsPrec 11 r1]) s

instance NonDet (C_WM t0) where
  choiceCons = Choice_C_WM
  choicesCons = Choices_C_WM
  failCons = Fail_C_WM
  guardCons = Guard_C_WM
  try (Choice_C_WM cd i x y) = tryChoice cd i x y
  try (Choices_C_WM cd i xs) = tryChoices cd i xs
  try (Fail_C_WM cd info) = Fail cd info
  try (Guard_C_WM cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_WM cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_WM cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_WM cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_WM cd i _) = error
    ("CPP.ICode.ParseWarning.WM.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_WM cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_WM cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0) => Generable (C_WM t0) where
  generate s c = Choices_C_WM c (freeID [2] s) [C_WM (generate (leftSupply s) c)
    (generate (rightSupply s) c)]

instance (Curry t0) => NormalForm (C_WM t0) where
  ($!!) cont (C_WM x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_WM y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_WM cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_WM cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_WM cd c e) d cs = guardCons cd c (($!!) cont e d (addCs c
    cs))
  ($!!) _ (Fail_C_WM cd info) _ _ = failCons cd info
  ($##) cont (C_WM x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_WM y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_WM cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_WM cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_WM cd c e) d cs = guardCons cd c (($##) cont e d (addCs c
    cs))
  ($##) _ (Fail_C_WM cd info) _ _ = failCons cd info
  showCons (C_WM _ _) = "CPP.ICode.ParseWarning.WM _ _"
  showCons x = error ("CPP.ICode.ParseWarning.WM.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_WM x1 x2) = search (\y1 -> search (\y2 -> cont (C_WM
    y1 y2)) x2) x1
  searchNF _ _ x = error
    ("CPP.ICode.ParseWarning.WM.searchNF: no constructor: " ++ show x)

instance (Curry t0) => Unifiable (C_WM t0) where
  (=.=) (C_WM x1 x2) (C_WM y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2 d
    cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_WM x1 x2) (C_WM y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2 y2
    d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_WM x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind d i (Choice_C_WM cd j x y) = [ConstraintChoice cd j (bind d i x) (bind d
    i y)]
  bind d i (Choices_C_WM cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_WM cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_WM cd i _) = error
    ("CPP.ICode.ParseWarning.WM.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_WM cd info) = [Unsolvable info]
  bind d i (Guard_C_WM cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_WM x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_WM cd j x y) = [ConstraintChoice cd j (lazyBind d i x)
    (lazyBind d i y)]
  lazyBind d i (Choices_C_WM cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_WM cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_WM cd i _) = error
    ("CPP.ICode.ParseWarning.WM.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_WM cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_WM cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0) => Curry (C_WM t0) where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data (C_WM t0)
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    x1 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ParseWarning._inst#Prelude.Data#CPP.ICode.ParseWarning.WM#0##"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseWarning._inst#Prelude.Data#CPP.ICode.ParseWarning.WM#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> C_WM t0 -> C_WM t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x2 of
  C_WM x4 x5 -> let s0 = s in s0 `seq` nd_C__case_0 x5 x4 x1 x3 s0 cd cs
  Choice_C_WM d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    x1 l x3 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    x1 r x3 s cd cs)
  Choices_C_WM d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    x1 z x3 s cd cs) xs
  Guard_C_WM d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash
    x1 e x3 s cd x) $! addCs c cs)
  Fail_C_WM d info -> failCons d (traceFail
    "CPP.ICode.ParseWarning._impl#===#Prelude.Data#CPP.ICode.ParseWarning.WM#0##"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseWarning._impl#===#Prelude.Data#CPP.ICode.ParseWarning.WM#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> IDSupply -> Cover -> ConstStore -> C_WM t0
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseWarning_dot_WM_hash_0_hash_hash x1 s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_WM (Curry_Prelude.nd_C_aValue x1 s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  CPP.ICode.Curry_ParsePos.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  s1 cd cs)))

d_C_getWarnPos :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> CPP.ICode.Curry_ParsePos.C_Pos
d_C_getWarnPos cd cs = Curry_Prelude.d_C_fst

d_C_setWarnPos :: Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_setWarnPos x1 x2 cd cs = Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.d_C_apply
  (d_C_getWarnMsg cd cs) x1 cd cs)

d_C_getWarnMsg :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_getWarnMsg cd cs = Curry_Prelude.d_C_snd

d_C_setWarnMsg :: Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_setWarnMsg x1 x2 cd cs = Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply
  (d_C_getWarnPos cd cs) x1 cd cs) x2

d_C_returnWM :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Cover -> ConstStore -> C_WM t0
d_C_returnWM x1 x2 cd cs = C_WM x1 x2

d_C_bindWM :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_WM t1 -> (t1 -> Cover -> ConstStore -> C_WM t0) -> Cover
  -> ConstStore -> C_WM t0
d_C_bindWM x1 x2 cd cs = case x1 of
  C_WM x3 x4 -> let x5 = Curry_Prelude.d_C_apply x2 x3 cd cs
                    x6 = d_OP_bindWM_dot_uscore_hash_selFP2_hash_y x5 cd cs
                    x7 = d_OP_bindWM_dot_uscore_hash_selFP3_hash_w2 x5 cd cs
    in C_WM x6 (Curry_Prelude.d_OP_plus_plus x4 x7 cd cs)
  Choice_C_WM d i l r -> narrow d i (d_C_bindWM l x2 cd cs) (d_C_bindWM r x2 cd
    cs)
  Choices_C_WM d i xs -> narrows cs d i (\z -> d_C_bindWM z x2 cd cs) xs
  Guard_C_WM d c e -> guardCons d c ((\x -> d_C_bindWM e x2 cd x) $! addCs c cs)
  Fail_C_WM d info -> failCons d (traceFail "CPP.ICode.ParseWarning.bindWM"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseWarning.bindWM" (showCons x1))

nd_C_bindWM :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_WM t1 -> Func t1 (C_WM t0) -> IDSupply -> Cover -> ConstStore -> C_WM
  t0
nd_C_bindWM x1 x2 s cd cs = case x1 of
  C_WM x3 x4 -> let s0 = s
    in s0 `seq` (let x5 = Curry_Prelude.nd_C_apply x2 x3 s0 cd cs
                     x6 = d_OP_bindWM_dot_uscore_hash_selFP2_hash_y x5 cd cs
                     x7 = d_OP_bindWM_dot_uscore_hash_selFP3_hash_w2 x5 cd cs
    in C_WM x6 (Curry_Prelude.d_OP_plus_plus x4 x7 cd cs))
  Choice_C_WM d i l r -> narrow d i (nd_C_bindWM l x2 s cd cs) (nd_C_bindWM r x2
    s cd cs)
  Choices_C_WM d i xs -> narrows cs d i (\z -> nd_C_bindWM z x2 s cd cs) xs
  Guard_C_WM d c e -> guardCons d c ((\x -> nd_C_bindWM e x2 s cd x) $! addCs c
    cs)
  Fail_C_WM d info -> failCons d (traceFail "CPP.ICode.ParseWarning.bindWM"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseWarning.bindWM" (showCons x1))

d_OP_bindWM_dot_uscore_hash_selFP2_hash_y :: forall t0 . (Curry_Prelude.Curry
  t0) => C_WM t0 -> Cover -> ConstStore -> t0
d_OP_bindWM_dot_uscore_hash_selFP2_hash_y x1 cd cs = case x1 of
  C_WM x2 x3 -> x2
  Choice_C_WM d i l r -> narrow d i (d_OP_bindWM_dot_uscore_hash_selFP2_hash_y l
    cd cs) (d_OP_bindWM_dot_uscore_hash_selFP2_hash_y r cd cs)
  Choices_C_WM d i xs -> narrows cs d i (\z ->
    d_OP_bindWM_dot_uscore_hash_selFP2_hash_y z cd cs) xs
  Guard_C_WM d c e -> guardCons d c ((\x ->
    d_OP_bindWM_dot_uscore_hash_selFP2_hash_y e cd x) $! addCs c cs)
  Fail_C_WM d info -> failCons d (traceFail
    "CPP.ICode.ParseWarning.bindWM._#selFP2#y" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseWarning.bindWM._#selFP2#y"
    (showCons x1))

d_OP_bindWM_dot_uscore_hash_selFP3_hash_w2 :: forall t0 . (Curry_Prelude.Curry
  t0) => C_WM t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_bindWM_dot_uscore_hash_selFP3_hash_w2 x1 cd cs = case x1 of
  C_WM x2 x3 -> x3
  Choice_C_WM d i l r -> narrow d i (d_OP_bindWM_dot_uscore_hash_selFP3_hash_w2
    l cd cs) (d_OP_bindWM_dot_uscore_hash_selFP3_hash_w2 r cd cs)
  Choices_C_WM d i xs -> narrows cs d i (\z ->
    d_OP_bindWM_dot_uscore_hash_selFP3_hash_w2 z cd cs) xs
  Guard_C_WM d c e -> guardCons d c ((\x ->
    d_OP_bindWM_dot_uscore_hash_selFP3_hash_w2 e cd x) $! addCs c cs)
  Fail_C_WM d info -> failCons d (traceFail
    "CPP.ICode.ParseWarning.bindWM._#selFP3#w2" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseWarning.bindWM._#selFP3#w2"
    (showCons x1))

d_C_mapWarns :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> C_WM t0 -> Cover -> ConstStore -> C_WM t0
d_C_mapWarns x1 x2 cd cs = d_C_returnWM (d_C_discardWarnings x2 cd cs)
  (Curry_Prelude.d_C_map x1 (d_C_getWarnings x2 cd cs) cd cs) cd cs

nd_C_mapWarns :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> C_WM t0 -> IDSupply -> Cover
  -> ConstStore -> C_WM t0
nd_C_mapWarns x1 x2 s cd cs = let s0 = s
  in s0 `seq` d_C_returnWM (d_C_discardWarnings x2 cd cs)
  (Curry_Prelude.nd_C_map x1 (d_C_getWarnings x2 cd cs) s0 cd cs) cd cs

d_C_cleanWM :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover -> ConstStore
  -> C_WM t0
d_C_cleanWM x1 cd cs = d_C_returnWM x1 Curry_Prelude.OP_List cd cs

d_C_singleWM :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> C_WM t0
d_C_singleWM x1 x2 cd cs = d_C_returnWM x1 (Curry_Prelude.OP_Cons x2
  Curry_Prelude.OP_List) cd cs

d_C_discardWarnings :: forall t0 . (Curry_Prelude.Curry t0) => C_WM t0 -> Cover
  -> ConstStore -> t0
d_C_discardWarnings x1 cd cs = case x1 of
  C_WM x2 x3 -> x2
  Choice_C_WM d i l r -> narrow d i (d_C_discardWarnings l cd cs)
    (d_C_discardWarnings r cd cs)
  Choices_C_WM d i xs -> narrows cs d i (\z -> d_C_discardWarnings z cd cs) xs
  Guard_C_WM d c e -> guardCons d c ((\x -> d_C_discardWarnings e cd x) $! addCs
    c cs)
  Fail_C_WM d info -> failCons d (traceFail
    "CPP.ICode.ParseWarning.discardWarnings" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseWarning.discardWarnings" (showCons
    x1))

d_C_getWarnings :: forall t0 . (Curry_Prelude.Curry t0) => C_WM t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_getWarnings x1 cd cs = case x1 of
  C_WM x2 x3 -> x3
  Choice_C_WM d i l r -> narrow d i (d_C_getWarnings l cd cs) (d_C_getWarnings r
    cd cs)
  Choices_C_WM d i xs -> narrows cs d i (\z -> d_C_getWarnings z cd cs) xs
  Guard_C_WM d c e -> guardCons d c ((\x -> d_C_getWarnings e cd x) $! addCs c
    cs)
  Fail_C_WM d info -> failCons d (traceFail "CPP.ICode.ParseWarning.getWarnings"
    [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseWarning.getWarnings" (showCons x1))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_WM t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_0 x5 x4 x1 x3 s cd cs = case x3 of
  C_WM x6 x7 -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s3 = leftSupply s4
                                                          s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq_eq
    x1 s0 cd cs) x4 s1 cd cs)) x6 s3 cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    CPP.ICode.Curry_ParsePos.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash)
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
    x5 x7 s5 cd cs) cd cs))
  Choice_C_WM d i l r -> narrow d i (nd_C__case_0 x5 x4 x1 l s cd cs)
    (nd_C__case_0 x5 x4 x1 r s cd cs)
  Choices_C_WM d i xs -> narrows cs d i (\z -> nd_C__case_0 x5 x4 x1 z s cd cs)
    xs
  Guard_C_WM d c e -> guardCons d c ((\x -> nd_C__case_0 x5 x4 x1 e s cd x) $!
    addCs c cs)
  Fail_C_WM d info -> failCons d (traceFail "CPP.ICode.ParseWarning._case_0"
    [show x5, show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseWarning._case_0" (showCons x3))

