{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module FlatCurry.Curry_FlexRigid
  ( C_FlexRigidResult (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  , d_C_getFlexRigid )
  where

import Basics
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude


data C_FlexRigidResult
  = C_UnknownFR
  | C_ConflictFR
  | C_KnownFlex
  | C_KnownRigid
  | Choice_C_FlexRigidResult Cover ID C_FlexRigidResult C_FlexRigidResult
  | Choices_C_FlexRigidResult Cover ID [C_FlexRigidResult]
  | Fail_C_FlexRigidResult Cover FailInfo
  | Guard_C_FlexRigidResult Cover Constraints C_FlexRigidResult

instance Show C_FlexRigidResult where
  showsPrec d (Choice_C_FlexRigidResult cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_FlexRigidResult cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_FlexRigidResult cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_FlexRigidResult cd info) = showChar '!'
  showsPrec _ C_UnknownFR = showString "UnknownFR"
  showsPrec _ C_ConflictFR = showString "ConflictFR"
  showsPrec _ C_KnownFlex = showString "KnownFlex"
  showsPrec _ C_KnownRigid = showString "KnownRigid"

instance Read C_FlexRigidResult where
  readsPrec _ s = readParen False (\r -> [(C_UnknownFR, r0) | (_, r0) <-
    readQualified "FlatCurry.FlexRigid" "UnknownFR" r]) s ++ (readParen False
    (\r -> [(C_ConflictFR, r0) | (_, r0) <- readQualified "FlatCurry.FlexRigid"
    "ConflictFR" r]) s ++ (readParen False (\r -> [(C_KnownFlex, r0) | (_, r0)
    <- readQualified "FlatCurry.FlexRigid" "KnownFlex" r]) s ++ readParen False
    (\r -> [(C_KnownRigid, r0) | (_, r0) <- readQualified "FlatCurry.FlexRigid"
    "KnownRigid" r]) s))

instance NonDet C_FlexRigidResult where
  choiceCons = Choice_C_FlexRigidResult
  choicesCons = Choices_C_FlexRigidResult
  failCons = Fail_C_FlexRigidResult
  guardCons = Guard_C_FlexRigidResult
  try (Choice_C_FlexRigidResult cd i x y) = tryChoice cd i x y
  try (Choices_C_FlexRigidResult cd i xs) = tryChoices cd i xs
  try (Fail_C_FlexRigidResult cd info) = Fail cd info
  try (Guard_C_FlexRigidResult cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_FlexRigidResult cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_FlexRigidResult cd i@(NarrowedID _ _) xs) = f cd
    i xs
  match _ _ f _ _ _ (Choices_C_FlexRigidResult cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_FlexRigidResult cd i _) = error
    ("FlatCurry.FlexRigid.FlexRigidResult.match: Choices with ChoiceID " ++ show
    i)
  match _ _ _ f _ _ (Fail_C_FlexRigidResult cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_FlexRigidResult cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_FlexRigidResult where
  generate s c = Choices_C_FlexRigidResult c (freeID [0, 0, 0, 0] s)
    [C_UnknownFR, C_ConflictFR, C_KnownFlex, C_KnownRigid]

instance NormalForm C_FlexRigidResult where
  ($!!) cont C_UnknownFR d cs = cont C_UnknownFR d cs
  ($!!) cont C_ConflictFR d cs = cont C_ConflictFR d cs
  ($!!) cont C_KnownFlex d cs = cont C_KnownFlex d cs
  ($!!) cont C_KnownRigid d cs = cont C_KnownRigid d cs
  ($!!) cont (Choice_C_FlexRigidResult cd i x y) d cs = nfChoice cont cd i x y
    cd cs
  ($!!) cont (Choices_C_FlexRigidResult cd i xs) d cs = nfChoices cont cd i xs d
    cs
  ($!!) cont (Guard_C_FlexRigidResult cd c e) d cs = guardCons cd c (($!!) cont
    e d (addCs c cs))
  ($!!) _ (Fail_C_FlexRigidResult cd info) _ _ = failCons cd info
  ($##) cont C_UnknownFR d cs = cont C_UnknownFR d cs
  ($##) cont C_ConflictFR d cs = cont C_ConflictFR d cs
  ($##) cont C_KnownFlex d cs = cont C_KnownFlex d cs
  ($##) cont C_KnownRigid d cs = cont C_KnownRigid d cs
  ($##) cont (Choice_C_FlexRigidResult cd i x y) d cs = gnfChoice cont cd i x y
    cd cs
  ($##) cont (Choices_C_FlexRigidResult cd i xs) d cs = gnfChoices cont cd i xs
    d cs
  ($##) cont (Guard_C_FlexRigidResult cd c e) d cs = guardCons cd c (($##) cont
    e d (addCs c cs))
  ($##) _ (Fail_C_FlexRigidResult cd info) _ _ = failCons cd info
  showCons C_UnknownFR = "FlatCurry.FlexRigid.UnknownFR"
  showCons C_ConflictFR = "FlatCurry.FlexRigid.ConflictFR"
  showCons C_KnownFlex = "FlatCurry.FlexRigid.KnownFlex"
  showCons C_KnownRigid = "FlatCurry.FlexRigid.KnownRigid"
  showCons x = error
    ("FlatCurry.FlexRigid.FlexRigidResult.showCons: no constructor: " ++ show x)
  searchNF _ cont C_UnknownFR = cont C_UnknownFR
  searchNF _ cont C_ConflictFR = cont C_ConflictFR
  searchNF _ cont C_KnownFlex = cont C_KnownFlex
  searchNF _ cont C_KnownRigid = cont C_KnownRigid
  searchNF _ _ x = error
    ("FlatCurry.FlexRigid.FlexRigidResult.searchNF: no constructor: " ++ show x)

instance Unifiable C_FlexRigidResult where
  (=.=) C_UnknownFR C_UnknownFR d cs = C_True
  (=.=) C_ConflictFR C_ConflictFR d cs = C_True
  (=.=) C_KnownFlex C_KnownFlex d cs = C_True
  (=.=) C_KnownRigid C_KnownRigid d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_UnknownFR C_UnknownFR d cs = C_True
  (=.<=) C_ConflictFR C_ConflictFR d cs = C_True
  (=.<=) C_KnownFlex C_KnownFlex d cs = C_True
  (=.<=) C_KnownRigid C_KnownRigid d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_UnknownFR = (i :=: ChooseN 0 0) : concat []
  bind cd i C_ConflictFR = (i :=: ChooseN 1 0) : concat []
  bind cd i C_KnownFlex = (i :=: ChooseN 2 0) : concat []
  bind cd i C_KnownRigid = (i :=: ChooseN 3 0) : concat []
  bind d i (Choice_C_FlexRigidResult cd j x y) = [ConstraintChoice cd j (bind d
    i x) (bind d i y)]
  bind d i (Choices_C_FlexRigidResult cd j@(FreeID _ _) xs) = bindOrNarrow d i
    cd j xs
  bind d i (Choices_C_FlexRigidResult cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_FlexRigidResult cd i _) = error
    ("FlatCurry.FlexRigid.FlexRigidResult.bind: Choices with ChoiceID: " ++ show
    i)
  bind _ _ (Fail_C_FlexRigidResult cd info) = [Unsolvable info]
  bind d i (Guard_C_FlexRigidResult cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_UnknownFR = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_ConflictFR = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_KnownFlex = (i :=: ChooseN 2 0) : []
  lazyBind cd i C_KnownRigid = (i :=: ChooseN 3 0) : []
  lazyBind d i (Choice_C_FlexRigidResult cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_FlexRigidResult cd j@(FreeID _ _) xs) =
    lazyBindOrNarrow d i cd j xs
  lazyBind d i (Choices_C_FlexRigidResult cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_FlexRigidResult cd i _) = error
    ("FlatCurry.FlexRigid.FlexRigidResult.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_FlexRigidResult cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_FlexRigidResult cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_FlexRigidResult where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_FlexRigidResult
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._inst#Prelude.Data#FlatCurry.FlexRigid.FlexRigidResult#"
    [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._inst#Prelude.Data#FlatCurry.FlexRigid.FlexRigidResult#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: C_FlexRigidResult
  -> C_FlexRigidResult -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash x1 x2 cd cs =
  case x1 of
  C_UnknownFR -> d_C__case_12 x2 cd cs
  C_ConflictFR -> d_C__case_11 x2 cd cs
  C_KnownFlex -> d_C__case_10 x2 cd cs
  C_KnownRigid -> d_C__case_9 x2 cd cs
  Choice_C_FlexRigidResult d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    r x2 cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    z x2 cd cs) xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._impl#===#Prelude.Data#FlatCurry.FlexRigid.FlexRigidResult#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._impl#===#Prelude.Data#FlatCurry.FlexRigid.FlexRigidResult#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: IDSupply
  -> Cover -> ConstStore -> C_FlexRigidResult
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s1 = leftSupply s2
                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_UnknownFR C_ConflictFR s0 cd cs)
  C_KnownFlex s1 cd cs)) C_KnownRigid s3 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read
  C_FlexRigidResult
d_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Read (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash)
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._inst#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#"
    [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._inst#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read
  C_FlexRigidResult
nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Read (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash))
    (wrapDX id
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._inst#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#"
    [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._inst#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_FlexRigidResult
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_readParen Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda1
  cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_readParen Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda6
  cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_readParen Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda11
  cd cs) x2 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_readParen
  Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda16
  cd cs) x2 cd cs) cd cs) cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_FlexRigidResult (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda1 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_FlexRigidResult (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_FlexRigidResult (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_8 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "UnknownFR") cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._impl#readsPrec#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#._#lambda1._#lambda4"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._impl#readsPrec#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#._#lambda1._#lambda4"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda6 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_FlexRigidResult (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda6 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_FlexRigidResult (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_FlexRigidResult (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_7 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "ConflictFR") cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._impl#readsPrec#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#._#lambda6._#lambda9"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._impl#readsPrec#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#._#lambda6._#lambda9"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda11 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_FlexRigidResult (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda11 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_FlexRigidResult (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_FlexRigidResult (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_6 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "KnownFlex") cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda11_dot_uscore_hash_lambda14
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._impl#readsPrec#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#._#lambda11._#lambda14"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._impl#readsPrec#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#._#lambda11._#lambda14"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda16 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_FlexRigidResult (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda16 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda16_dot_uscore_hash_lambda19)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda16_dot_uscore_hash_lambda19 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_FlexRigidResult (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_FlexRigidResult (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda16_dot_uscore_hash_lambda19 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_5 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "KnownRigid") cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda16_dot_uscore_hash_lambda19
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda16_dot_uscore_hash_lambda19
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda16_dot_uscore_hash_lambda19
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash_dot_uscore_hash_lambda16_dot_uscore_hash_lambda19
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._impl#readsPrec#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#._#lambda16._#lambda19"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._impl#readsPrec#Prelude.Read#FlatCurry.FlexRigid.FlexRigidResult#._#lambda16._#lambda19"
    (showCons x1))

d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_FlexRigidResult) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_readList_hash_Prelude_dot_Read
  d_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  cd cs

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_FlexRigidResult
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._inst#Prelude.Show#FlatCurry.FlexRigid.FlexRigidResult#"
    [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._inst#Prelude.Show#FlatCurry.FlexRigid.FlexRigidResult#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_FlexRigidResult
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._inst#Prelude.Show#FlatCurry.FlexRigid.FlexRigidResult#"
    [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._inst#Prelude.Show#FlatCurry.FlexRigid.FlexRigidResult#"
    (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: Cover
  -> ConstStore -> C_FlexRigidResult -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: Curry_Prelude.C_Int
  -> C_FlexRigidResult -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash x1 x2 cd cs =
  case x2 of
  C_UnknownFR -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "UnknownFR")
  C_ConflictFR -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "ConflictFR")
  C_KnownFlex -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "KnownFlex")
  C_KnownRigid -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "KnownRigid")
  Choice_C_FlexRigidResult d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    x1 r cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    x1 z cd cs) xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._impl#showsPrec#Prelude.Show#FlatCurry.FlexRigid.FlexRigidResult#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.FlexRigid._impl#showsPrec#Prelude.Show#FlatCurry.FlexRigid.FlexRigidResult#"
    (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_FlexRigidResult -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_FlexRigid_dot_FlexRigidResult_hash
  cd cs

d_C_getFlexRigid :: FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> C_FlexRigidResult
d_C_getFlexRigid x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Var x2 -> C_UnknownFR
  FlatCurry.Curry_Types.C_Lit x3 -> C_UnknownFR
  FlatCurry.Curry_Types.C_Comb x4 x5 x6 -> Curry_Prelude.d_C_foldr (acceptCs id
    d_C_joinCaseTypes) C_UnknownFR (Curry_Prelude.d_C_map d_C_getFlexRigid x6 cd
    cs) cd cs
  FlatCurry.Curry_Types.C_Let x7 x8 -> d_C_getFlexRigid x8 cd cs
  FlatCurry.Curry_Types.C_Free x9 x10 -> d_C_getFlexRigid x10 cd cs
  FlatCurry.Curry_Types.C_Or x11 x12 -> d_C_joinCaseTypes (d_C_getFlexRigid x11
    cd cs) (d_C_getFlexRigid x12 cd cs) cd cs
  FlatCurry.Curry_Types.C_Case x13 x14 x15 -> Curry_Prelude.d_C_foldr (acceptCs
    id d_C_joinCaseTypes) (d_C__case_4 x13
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_CaseType_hash
    x13 FlatCurry.Curry_Types.C_Flex cd cs) cd cs) (Curry_Prelude.d_C_map
    d_C_getFlexRigid (Curry_Prelude.OP_Cons x14 (Curry_Prelude.d_C_map
    d_OP_getFlexRigid_dot_uscore_hash_lambda21 x15 cd cs)) cd cs) cd cs
  FlatCurry.Curry_Types.C_Typed x16 x17 -> d_C_getFlexRigid x16 cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C_getFlexRigid l
    cd cs) (d_C_getFlexRigid r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C_getFlexRigid z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x ->
    d_C_getFlexRigid e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.FlexRigid.getFlexRigid" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid.getFlexRigid" (showCons x1))

d_OP_getFlexRigid_dot_uscore_hash_lambda21 :: FlatCurry.Curry_Types.C_BranchExpr
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Expr
d_OP_getFlexRigid_dot_uscore_hash_lambda21 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Branch x2 x3 -> x3
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i
    (d_OP_getFlexRigid_dot_uscore_hash_lambda21 l cd cs)
    (d_OP_getFlexRigid_dot_uscore_hash_lambda21 r cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    d_OP_getFlexRigid_dot_uscore_hash_lambda21 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    d_OP_getFlexRigid_dot_uscore_hash_lambda21 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "FlatCurry.FlexRigid.getFlexRigid._#lambda21" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid.getFlexRigid._#lambda21"
    (showCons x1))

d_C_joinCaseTypes :: C_FlexRigidResult -> C_FlexRigidResult -> Cover
  -> ConstStore -> C_FlexRigidResult
d_C_joinCaseTypes x1 x2 cd cs = case x1 of
  C_ConflictFR -> d_C__case_3 x2 cd cs
  C_UnknownFR -> d_C__case_2 x2 cd cs
  C_KnownFlex -> d_C__case_1 x2 cd cs
  C_KnownRigid -> d_C__case_0 x2 cd cs
  Choice_C_FlexRigidResult d i l r -> narrow d i (d_C_joinCaseTypes l x2 cd cs)
    (d_C_joinCaseTypes r x2 cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z -> d_C_joinCaseTypes z
    x2 cd cs) xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x -> d_C_joinCaseTypes e x2
    cd x) $! addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid.joinCaseTypes" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid.joinCaseTypes" (showCons x1))

d_C__case_9 :: C_FlexRigidResult -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x2 cd cs = case x2 of
  C_UnknownFR -> Curry_Prelude.C_False
  C_ConflictFR -> Curry_Prelude.C_False
  C_KnownFlex -> Curry_Prelude.C_False
  C_KnownRigid -> Curry_Prelude.C_True
  Choice_C_FlexRigidResult d i l r -> narrow d i (d_C__case_9 l cd cs)
    (d_C__case_9 r cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z -> d_C__case_9 z cd cs)
    xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x -> d_C__case_9 e cd x) $!
    addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_9" [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_9" (showCons x2))

d_C__case_10 :: C_FlexRigidResult -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_10 x2 cd cs = case x2 of
  C_UnknownFR -> Curry_Prelude.C_False
  C_ConflictFR -> Curry_Prelude.C_False
  C_KnownFlex -> Curry_Prelude.C_True
  C_KnownRigid -> Curry_Prelude.C_False
  Choice_C_FlexRigidResult d i l r -> narrow d i (d_C__case_10 l cd cs)
    (d_C__case_10 r cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z -> d_C__case_10 z cd
    cs) xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x -> d_C__case_10 e cd x) $!
    addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_10" [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_10" (showCons x2))

d_C__case_11 :: C_FlexRigidResult -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_11 x2 cd cs = case x2 of
  C_UnknownFR -> Curry_Prelude.C_False
  C_ConflictFR -> Curry_Prelude.C_True
  C_KnownFlex -> Curry_Prelude.C_False
  C_KnownRigid -> Curry_Prelude.C_False
  Choice_C_FlexRigidResult d i l r -> narrow d i (d_C__case_11 l cd cs)
    (d_C__case_11 r cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z -> d_C__case_11 z cd
    cs) xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x -> d_C__case_11 e cd x) $!
    addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_11" [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_11" (showCons x2))

d_C__case_12 :: C_FlexRigidResult -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_12 x2 cd cs = case x2 of
  C_UnknownFR -> Curry_Prelude.C_True
  C_ConflictFR -> Curry_Prelude.C_False
  C_KnownFlex -> Curry_Prelude.C_False
  C_KnownRigid -> Curry_Prelude.C_False
  Choice_C_FlexRigidResult d i l r -> narrow d i (d_C__case_12 l cd cs)
    (d_C__case_12 r cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z -> d_C__case_12 z cd
    cs) xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x -> d_C__case_12 e cd x) $!
    addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_12" [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_12" (showCons x2))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_FlexRigidResult
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_FlexRigidResult
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_8 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    C_UnknownFR x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x3 x2 x4 l cd
    cs) (d_C__case_8 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x3 x2
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x3 x2 x4
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_8" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_8" (showCons x5))

d_C__case_7 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_FlexRigidResult
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_FlexRigidResult
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_7 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    C_ConflictFR x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x3 x2 x4 l cd
    cs) (d_C__case_7 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x3 x2
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x3 x2 x4
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_7" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_7" (showCons x5))

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_FlexRigidResult
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_FlexRigidResult
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_6 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    C_KnownFlex x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x3 x2 x4 l cd
    cs) (d_C__case_6 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x3 x2
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x3 x2 x4
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_6" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_6" (showCons x5))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_FlexRigidResult
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_FlexRigidResult
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_5 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    C_KnownRigid x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x3 x2 x4 l cd
    cs) (d_C__case_5 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x3 x2
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x3 x2 x4
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_5" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_5" (showCons x5))

d_C__case_4 :: FlatCurry.Curry_Types.C_CaseType -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_FlexRigidResult
d_C__case_4 x13 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> C_KnownFlex
  Curry_Prelude.C_False -> C_KnownRigid
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x13 l cd cs)
    (d_C__case_4 x13 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x13 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x13 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_4" [show x13, show x14] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_4" (showCons x14))

d_C__case_0 :: C_FlexRigidResult -> Cover -> ConstStore -> C_FlexRigidResult
d_C__case_0 x2 cd cs = case x2 of
  C_ConflictFR -> C_ConflictFR
  C_UnknownFR -> C_KnownRigid
  C_KnownFlex -> C_ConflictFR
  C_KnownRigid -> C_KnownRigid
  Choice_C_FlexRigidResult d i l r -> narrow d i (d_C__case_0 l cd cs)
    (d_C__case_0 r cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z -> d_C__case_0 z cd cs)
    xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x -> d_C__case_0 e cd x) $!
    addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_0" [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_0" (showCons x2))

d_C__case_1 :: C_FlexRigidResult -> Cover -> ConstStore -> C_FlexRigidResult
d_C__case_1 x2 cd cs = case x2 of
  C_ConflictFR -> C_ConflictFR
  C_UnknownFR -> C_KnownFlex
  C_KnownFlex -> C_KnownFlex
  C_KnownRigid -> C_ConflictFR
  Choice_C_FlexRigidResult d i l r -> narrow d i (d_C__case_1 l cd cs)
    (d_C__case_1 r cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z -> d_C__case_1 z cd cs)
    xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x -> d_C__case_1 e cd x) $!
    addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_1" [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_1" (showCons x2))

d_C__case_2 :: C_FlexRigidResult -> Cover -> ConstStore -> C_FlexRigidResult
d_C__case_2 x2 cd cs = case x2 of
  C_ConflictFR -> C_ConflictFR
  C_UnknownFR -> C_UnknownFR
  C_KnownFlex -> C_KnownFlex
  C_KnownRigid -> C_KnownRigid
  Choice_C_FlexRigidResult d i l r -> narrow d i (d_C__case_2 l cd cs)
    (d_C__case_2 r cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z -> d_C__case_2 z cd cs)
    xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x -> d_C__case_2 e cd x) $!
    addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_2" [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_2" (showCons x2))

d_C__case_3 :: C_FlexRigidResult -> Cover -> ConstStore -> C_FlexRigidResult
d_C__case_3 x2 cd cs = case x2 of
  C_ConflictFR -> C_ConflictFR
  C_UnknownFR -> C_ConflictFR
  C_KnownFlex -> C_ConflictFR
  C_KnownRigid -> C_ConflictFR
  Choice_C_FlexRigidResult d i l r -> narrow d i (d_C__case_3 l cd cs)
    (d_C__case_3 r cd cs)
  Choices_C_FlexRigidResult d i xs -> narrows cs d i (\z -> d_C__case_3 z cd cs)
    xs
  Guard_C_FlexRigidResult d c e -> guardCons d c ((\x -> d_C__case_3 e cd x) $!
    addCs c cs)
  Fail_C_FlexRigidResult d info -> failCons d (traceFail
    "FlatCurry.FlexRigid._case_3" [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.FlexRigid._case_3" (showCons x2))

