module ConfigPluralPackage where

--- Package version as a string.
packageVersion :: String
packageVersion = "3.1.0"

--- Returns the location (installation directory) of the package.
getPackagePath :: IO String
getPackagePath = return "/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0"

--- Package location (deprecated, use 'getPackagePath').
packagePath :: String
packagePath = "/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0"

--- Returns the load path for the package (if it is the main package).
getPackageLoadPath :: IO [String]
getPackageLoadPath = do
  pp <- getPackagePath
  return [pp ++ "/src", pp ++ "/.cpm/packages/read-legacy-3.0.0/src", pp ++ "/.cpm/packages/random-3.0.0/src", pp ++ "/.cpm/packages/queue-3.0.0/src", pp ++ "/.cpm/packages/wl-pprint-3.0.0/src", pp ++ "/.cpm/packages/frontend-exec-3.3.0/src", pp ++ "/.cpm/packages/propertyfile-3.0.0/src", pp ++ "/.cpm/packages/process-3.0.0/src", pp ++ "/.cpm/packages/io-extra-3.0.0/src", pp ++ "/.cpm/packages/execpath-3.0.0/src", pp ++ "/.cpm/packages/time-3.0.0/src", pp ++ "/.cpm/packages/filepath-3.0.0/src", pp ++ "/.cpm/packages/directory-3.0.0/src", pp ++ "/.cpm/packages/currypath-3.0.0/src", pp ++ "/.cpm/packages/abstract-curry-4.0.0/src"]

--- Load path for the package (deprecated, use 'getPackageLoadPath').
packageLoadPath :: String
packageLoadPath = "/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/read-legacy-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/random-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/queue-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/wl-pprint-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/frontend-exec-3.3.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/propertyfile-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/process-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/io-extra-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/execpath-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/time-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/filepath-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/directory-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/currypath-3.0.0/src:/var/www/webapps/curry-info/.curry_info_cache/checkouts/plural-arguments-3.1.0/.cpm/packages/abstract-curry-4.0.0/src"

--- Returns the location of the executable installed by this package.
getPackageExecutable :: IO String
getPackageExecutable = return "/var/www/webapps/curry-info/.cpm/bin/curry-plural"

--- Location of the executable (deprecated, use 'getPackageExecutable').
packageExecutable :: String
packageExecutable = "/var/www/webapps/curry-info/.cpm/bin/curry-plural"
