{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Curry_Roman
  ( C_Roman (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
  , d_C_regular
  , d_C_showRoman
  , d_C_showsRoman
  , d_C_toInt
  , d_C_fromInt )
  where

import Basics
import qualified Curry_Prelude
import qualified Test.Curry_Prop
import qualified Test.Prop.Curry_Types


data C_Roman
  = C_I
  | C_V
  | C_X
  | C_L
  | C_C
  | C_D
  | C_M
  | C_Minus C_Roman C_Roman
  | C_Plus C_Roman C_Roman
  | Choice_C_Roman Cover ID C_Roman C_Roman
  | Choices_C_Roman Cover ID [C_Roman]
  | Fail_C_Roman Cover FailInfo
  | Guard_C_Roman Cover Constraints C_Roman

instance Show C_Roman where
  showsPrec d (Choice_C_Roman cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Roman cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Roman cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Roman cd info) = showChar '!'
  showsPrec _ C_I = showString "I"
  showsPrec _ C_V = showString "V"
  showsPrec _ C_X = showString "X"
  showsPrec _ C_L = showString "L"
  showsPrec _ C_C = showString "C"
  showsPrec _ C_D = showString "D"
  showsPrec _ C_M = showString "M"
  showsPrec _ (C_Minus x1 x2) = showString "(Minus" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_Plus x1 x2) = showString "(Plus" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_Roman where
  readsPrec d s = readParen False (\r -> [(C_I, r0) | (_, r0) <- readQualified
    "Data.Roman" "I" r]) s ++ (readParen False (\r -> [(C_V, r0) | (_, r0) <-
    readQualified "Data.Roman" "V" r]) s ++ (readParen False (\r -> [(C_X
    , r0) | (_, r0) <- readQualified "Data.Roman" "X" r]) s ++ (readParen False
    (\r -> [(C_L, r0) | (_, r0) <- readQualified "Data.Roman" "L" r]) s ++
    (readParen False (\r -> [(C_C, r0) | (_, r0) <- readQualified "Data.Roman"
    "C" r]) s ++ (readParen False (\r -> [(C_D, r0) | (_, r0) <- readQualified
    "Data.Roman" "D" r]) s ++ (readParen False (\r -> [(C_M, r0) | (_, r0) <-
    readQualified "Data.Roman" "M" r]) s ++ (readParen ((>) d 10) (\r ->
    [(C_Minus x1 x2, r2) | (_, r0) <- readQualified "Data.Roman" "Minus" r, (x1
    , r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ readParen ((>)
    d 10) (\r -> [(C_Plus x1 x2, r2) | (_, r0) <- readQualified "Data.Roman"
    "Plus" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1])
    s)))))))

instance NonDet C_Roman where
  choiceCons = Choice_C_Roman
  choicesCons = Choices_C_Roman
  failCons = Fail_C_Roman
  guardCons = Guard_C_Roman
  try (Choice_C_Roman cd i x y) = tryChoice cd i x y
  try (Choices_C_Roman cd i xs) = tryChoices cd i xs
  try (Fail_C_Roman cd info) = Fail cd info
  try (Guard_C_Roman cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Roman cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Roman cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Roman cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Roman cd i _) = error
    ("Data.Roman.Roman.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Roman cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Roman cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Roman where
  generate s c = Choices_C_Roman c (freeID [0, 0, 0, 0, 0, 0, 0, 2, 2] s) [C_I
    , C_V, C_X, C_L, C_C, C_D, C_M, C_Minus (generate (leftSupply s) c)
    (generate (rightSupply s) c), C_Plus (generate (leftSupply s) c) (generate
    (rightSupply s) c)]

instance NormalForm C_Roman where
  ($!!) cont C_I d cs = cont C_I d cs
  ($!!) cont C_V d cs = cont C_V d cs
  ($!!) cont C_X d cs = cont C_X d cs
  ($!!) cont C_L d cs = cont C_L d cs
  ($!!) cont C_C d cs = cont C_C d cs
  ($!!) cont C_D d cs = cont C_D d cs
  ($!!) cont C_M d cs = cont C_M d cs
  ($!!) cont (C_Minus x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Minus y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Plus x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Plus y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Roman cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Roman cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Roman cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Roman cd info) _ _ = failCons cd info
  ($##) cont C_I d cs = cont C_I d cs
  ($##) cont C_V d cs = cont C_V d cs
  ($##) cont C_X d cs = cont C_X d cs
  ($##) cont C_L d cs = cont C_L d cs
  ($##) cont C_C d cs = cont C_C d cs
  ($##) cont C_D d cs = cont C_D d cs
  ($##) cont C_M d cs = cont C_M d cs
  ($##) cont (C_Minus x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Minus y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_Plus x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Plus y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Roman cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Roman cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Roman cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Roman cd info) _ _ = failCons cd info
  showCons C_I = "Data.Roman.I"
  showCons C_V = "Data.Roman.V"
  showCons C_X = "Data.Roman.X"
  showCons C_L = "Data.Roman.L"
  showCons C_C = "Data.Roman.C"
  showCons C_D = "Data.Roman.D"
  showCons C_M = "Data.Roman.M"
  showCons (C_Minus _ _) = "Data.Roman.Minus _ _"
  showCons (C_Plus _ _) = "Data.Roman.Plus _ _"
  showCons x = error ("Data.Roman.Roman.showCons: no constructor: " ++ show x)
  searchNF _ cont C_I = cont C_I
  searchNF _ cont C_V = cont C_V
  searchNF _ cont C_X = cont C_X
  searchNF _ cont C_L = cont C_L
  searchNF _ cont C_C = cont C_C
  searchNF _ cont C_D = cont C_D
  searchNF _ cont C_M = cont C_M
  searchNF search cont (C_Minus x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Minus y1 y2)) x2) x1
  searchNF search cont (C_Plus x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Plus y1 y2)) x2) x1
  searchNF _ _ x = error ("Data.Roman.Roman.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_Roman where
  (=.=) C_I C_I d cs = C_True
  (=.=) C_V C_V d cs = C_True
  (=.=) C_X C_X d cs = C_True
  (=.=) C_L C_L d cs = C_True
  (=.=) C_C C_C d cs = C_True
  (=.=) C_D C_D d cs = C_True
  (=.=) C_M C_M d cs = C_True
  (=.=) (C_Minus x1 x2) (C_Minus y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2
    y2 d cs) d cs
  (=.=) (C_Plus x1 x2) (C_Plus y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_I C_I d cs = C_True
  (=.<=) C_V C_V d cs = C_True
  (=.<=) C_X C_X d cs = C_True
  (=.<=) C_L C_L d cs = C_True
  (=.<=) C_C C_C d cs = C_True
  (=.<=) C_D C_D d cs = C_True
  (=.<=) C_M C_M d cs = C_True
  (=.<=) (C_Minus x1 x2) (C_Minus y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=)
    x2 y2 d cs) d cs
  (=.<=) (C_Plus x1 x2) (C_Plus y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_I = (i :=: ChooseN 0 0) : concat []
  bind cd i C_V = (i :=: ChooseN 1 0) : concat []
  bind cd i C_X = (i :=: ChooseN 2 0) : concat []
  bind cd i C_L = (i :=: ChooseN 3 0) : concat []
  bind cd i C_C = (i :=: ChooseN 4 0) : concat []
  bind cd i C_D = (i :=: ChooseN 5 0) : concat []
  bind cd i C_M = (i :=: ChooseN 6 0) : concat []
  bind cd i (C_Minus x3 x4) = (i :=: ChooseN 7 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_Plus x3 x4) = (i :=: ChooseN 8 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind d i (Choice_C_Roman cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Roman cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Roman cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Roman cd i _) = error
    ("Data.Roman.Roman.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Roman cd info) = [Unsolvable info]
  bind d i (Guard_C_Roman cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_I = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_V = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_X = (i :=: ChooseN 2 0) : []
  lazyBind cd i C_L = (i :=: ChooseN 3 0) : []
  lazyBind cd i C_C = (i :=: ChooseN 4 0) : []
  lazyBind cd i C_D = (i :=: ChooseN 5 0) : []
  lazyBind cd i C_M = (i :=: ChooseN 6 0) : []
  lazyBind cd i (C_Minus x3 x4) = (i :=: ChooseN 7 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_Plus x3 x4) = (i :=: ChooseN 8 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_Roman cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Roman cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_Roman cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Roman cd i _) = error
    ("Data.Roman.Roman.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Roman cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Roman cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Roman where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Roman
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Roman._inst#Prelude.Data#Data.Roman.Roman#" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman._inst#Prelude.Data#Data.Roman.Roman#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash :: C_Roman
  -> C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash x1 x2 cd cs =
  case x1 of
  C_I -> d_C__case_34 x2 cd cs
  C_V -> d_C__case_33 x2 cd cs
  C_X -> d_C__case_32 x2 cd cs
  C_L -> d_C__case_31 x2 cd cs
  C_C -> d_C__case_30 x2 cd cs
  C_D -> d_C__case_29 x2 cd cs
  C_M -> d_C__case_28 x2 cd cs
  C_Minus x31 x32 -> d_C__case_27 x32 x31 x2 cd cs
  C_Plus x37 x38 -> d_C__case_26 x38 x37 x2 cd cs
  Choice_C_Roman d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    r x2 cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    z x2 cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail
    "Data.Roman._impl#===#Prelude.Data#Data.Roman.Roman#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Data.Roman._impl#===#Prelude.Data#Data.Roman.Roman#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash :: IDSupply
  -> Cover -> ConstStore -> C_Roman
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash s cd cs =
  let s21 = s
  in s21 `seq` (let s20 = leftSupply s21
                    s22 = rightSupply s21
                    s15 = leftSupply s22
                    s19 = rightSupply s22
  in s20 `seq` (s22 `seq` (s15 `seq` (s19 `seq` choice (let s14 = leftSupply s15
                                                            s16 = rightSupply
                                                              s15
                                                            s10 = leftSupply s16
                                                            s13 = rightSupply
                                                              s16
  in s14 `seq` (s16 `seq` (s10 `seq` (s13 `seq` choice (let s9 = leftSupply s10
                                                            s8 = rightSupply s10
  in s9 `seq` (s8 `seq` choice (let s7 = leftSupply s8
                                    s6 = rightSupply s8
  in s7 `seq` (s6 `seq` choice (let s5 = leftSupply s6
                                    s4 = rightSupply s6
  in s5 `seq` (s4 `seq` choice (let s3 = leftSupply s4
                                    s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s1 = leftSupply s2
                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_I C_V s0 cd cs) C_X s1 cd cs)) C_L s3
  cd cs)) C_C s5 cd cs)) C_D s7 cd cs)) C_M s9 cd cs)) (let s11 = leftSupply s13
                                                            s12 = rightSupply
                                                              s13
  in s11 `seq` (s12 `seq` C_Minus
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
  s11 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
  s12 cd cs))) s14 cd cs)))) (let s17 = leftSupply s19
                                  s18 = rightSupply s19
  in s17 `seq` (s18 `seq` C_Plus
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
  s17 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
  s18 cd cs))) s20 cd cs))))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_Roman
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Roman._inst#Prelude.Eq#Data.Roman.Roman#" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman._inst#Prelude.Eq#Data.Roman.Roman#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_Roman
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Roman._inst#Prelude.Eq#Data.Roman.Roman#" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman._inst#Prelude.Eq#Data.Roman.Roman#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash :: C_Roman
  -> C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash x1 x2 cd cs =
  case x1 of
  C_I -> d_C__case_25 x2 cd cs
  C_V -> d_C__case_24 x2 cd cs
  C_X -> d_C__case_23 x2 cd cs
  C_L -> d_C__case_22 x2 cd cs
  C_C -> d_C__case_21 x2 cd cs
  C_D -> d_C__case_20 x2 cd cs
  C_M -> d_C__case_19 x2 cd cs
  C_Minus x31 x32 -> d_C__case_18 x32 x31 x2 cd cs
  C_Plus x37 x38 -> d_C__case_17 x38 x37 x2 cd cs
  Choice_C_Roman d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    r x2 cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    z x2 cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail
    "Data.Roman._impl#==#Prelude.Eq#Data.Roman.Roman#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Roman._impl#==#Prelude.Eq#Data.Roman.Roman#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash :: Cover
  -> ConstStore -> C_Roman -> Cover -> ConstStore -> C_Roman -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash)

d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord C_Roman
d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Ord
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    (d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)
    (d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)
    (d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash)
    (d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)
    (d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)
    (d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash z
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Roman._inst#Prelude.Ord#Data.Roman.Roman#" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman._inst#Prelude.Ord#Data.Roman.Roman#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord
  C_Roman
nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Ord (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash)
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)) (wrapDX (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Roman._inst#Prelude.Ord#Data.Roman.Roman#" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman._inst#Prelude.Ord#Data.Roman.Roman#"
    (showCons x1))

d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash :: Cover
  -> ConstStore -> C_Roman -> Cover -> ConstStore -> C_Roman -> Cover
  -> ConstStore -> Curry_Prelude.C_Ordering
d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_compare_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash)

d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash :: Cover
  -> ConstStore -> C_Roman -> Cover -> ConstStore -> C_Roman -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_lt_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash)

d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash :: Cover
  -> ConstStore -> C_Roman -> Cover -> ConstStore -> C_Roman -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_gt_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash)

d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash :: C_Roman
  -> C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash x1 x2 cd cs =
  case x1 of
  C_I -> d_C__case_16 x2 cd cs
  C_V -> d_C__case_15 x2 cd cs
  C_X -> d_C__case_14 x2 cd cs
  C_L -> d_C__case_13 x2 cd cs
  C_C -> d_C__case_12 x2 cd cs
  C_D -> d_C__case_11 x2 cd cs
  C_M -> d_C__case_10 x2 cd cs
  C_Minus x31 x32 -> d_C__case_9 x32 x31 x2 cd cs
  C_Plus x37 x38 -> d_C__case_8 x38 x37 x2 cd cs
  Choice_C_Roman d i l r -> narrow d i
    (d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    r x2 cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    z x2 cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail
    "Data.Roman._impl#<=#Prelude.Ord#Data.Roman.Roman#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Roman._impl#<=#Prelude.Ord#Data.Roman.Roman#"
    (showCons x1))

d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash :: Cover
  -> ConstStore -> C_Roman -> Cover -> ConstStore -> C_Roman -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_gt_eq_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash)

d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash :: Cover
  -> ConstStore -> C_Roman -> Cover -> ConstStore -> C_Roman -> Cover
  -> ConstStore -> C_Roman
d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_min_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash)

d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash :: Cover
  -> ConstStore -> C_Roman -> Cover -> ConstStore -> C_Roman -> Cover
  -> ConstStore -> C_Roman
d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_max_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash)

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_Roman
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash z
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Roman._inst#Prelude.Show#Data.Roman.Roman#" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman._inst#Prelude.Show#Data.Roman.Roman#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_Roman
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Roman._inst#Prelude.Show#Data.Roman.Roman#" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman._inst#Prelude.Show#Data.Roman.Roman#"
    (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash :: Cover
  -> ConstStore -> C_Roman -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash :: Curry_Prelude.C_Int
  -> C_Roman -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash x1 x2 cd cs =
  case x2 of
  C_I -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "I")
  C_V -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "V")
  C_X -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "X")
  C_L -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "L")
  C_C -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "C")
  C_D -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "D")
  C_M -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "M")
  C_Minus x3 x4 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Minus "))
    (Curry_Prelude.d_OP_dot
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    (Curry_Prelude.C_Int (11)) x3 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " "))
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    (Curry_Prelude.C_Int (11)) x4 cd cs) cd cs) cd cs) cd cs) cd cs
  C_Plus x5 x6 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Plus "))
    (Curry_Prelude.d_OP_dot
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    (Curry_Prelude.C_Int (11)) x5 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " "))
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    (Curry_Prelude.C_Int (11)) x6 cd cs) cd cs) cd cs) cd cs) cd cs
  Choice_C_Roman d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    x1 r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    x1 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail
    "Data.Roman._impl#showsPrec#Prelude.Show#Data.Roman.Roman#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "Data.Roman._impl#showsPrec#Prelude.Show#Data.Roman.Roman#" (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Roman -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash cd
  cs

d_C_regular :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_regular x1 cd cs =
  d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
  (d_C_fromInt (d_C_toInt x1 cd cs) cd cs) x1 cd cs

d_C_showRoman :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showRoman x1 cd cs = Curry_Prelude.d_C_apply (d_C_showsRoman x1 cd cs)
  Curry_Prelude.OP_List cd cs

d_C_showsRoman :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showsRoman x1 cd cs = let x2 = Curry_Prelude.d_C_apply
                                (Curry_Prelude.d_C_shows
                                d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Roman_dot_Roman_hash
                                cd cs) x1 cd cs
  in d_C__case_7 x2 x1 cd cs

d_C_toInt :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_toInt x1 cd cs = case x1 of
  C_I -> Curry_Prelude.C_Int (1)
  C_V -> Curry_Prelude.C_Int (5)
  C_X -> Curry_Prelude.C_Int (10)
  C_L -> Curry_Prelude.C_Int (50)
  C_C -> Curry_Prelude.C_Int (100)
  C_D -> Curry_Prelude.C_Int (500)
  C_M -> Curry_Prelude.C_Int (1000)
  C_Minus x2 x3 -> Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (d_C_toInt x3 cd cs) (d_C_toInt x2 cd cs) cd cs
  C_Plus x4 x5 -> Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (d_C_toInt x4 cd cs) (d_C_toInt x5 cd cs) cd cs
  Choice_C_Roman d i l r -> narrow d i (d_C_toInt l cd cs) (d_C_toInt r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C_toInt z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C_toInt e cd x) $! addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman.toInt" [show x1]
    info)
  _ -> failCons cd (consFail "Data.Roman.toInt" (showCons x1))

d_C_fromInt :: Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Roman
d_C_fromInt x1 cd cs = d_C__case_6 x1 (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (1)) x1 cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Int (4000)) cd cs) cd cs) cd cs

d_C_base :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List C_Roman -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Roman
d_C_base x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let x5 = Curry_Prelude.d_OP_uscore_impl_hash_divMod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
                                       x1 (d_C_toInt x3 cd cs) cd cs
                                     x6 = d_OP_base_dot_uscore_hash_selFP2_hash_dR
                                       x5 cd cs
                                     x7 = d_OP_base_dot_uscore_hash_selFP3_hash_mR
                                       x5 cd cs
                                     x8 = d_C_base x7 x4 cd cs
    in d_C__case_5 x6 x8 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (9)) x6 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_base x1 l cd cs)
    (d_C_base x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_base x1 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_base x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Data.Roman.base"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Roman.base" (showCons x2))

d_OP_base_dot_uscore_hash_selFP2_hash_dR :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_OP_base_dot_uscore_hash_selFP2_hash_dR x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_base_dot_uscore_hash_selFP2_hash_dR l cd cs)
    (d_OP_base_dot_uscore_hash_selFP2_hash_dR r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_base_dot_uscore_hash_selFP2_hash_dR z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_base_dot_uscore_hash_selFP2_hash_dR e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Roman.base._#selFP2#dR" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman.base._#selFP2#dR" (showCons x1))

d_OP_base_dot_uscore_hash_selFP3_hash_mR :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_OP_base_dot_uscore_hash_selFP3_hash_mR x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_base_dot_uscore_hash_selFP3_hash_mR l cd cs)
    (d_OP_base_dot_uscore_hash_selFP3_hash_mR r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_base_dot_uscore_hash_selFP3_hash_mR z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_base_dot_uscore_hash_selFP3_hash_mR e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Roman.base._#selFP3#mR" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman.base._#selFP3#mR" (showCons x1))

d_OP_base_dot_times_dot_38 :: C_Roman -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> C_Roman
d_OP_base_dot_times_dot_38 x1 x2 cd cs = Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_C_foldr1 (acceptCs (acceptCs id) C_Plus))
  (Curry_Prelude.d_C_replicate x2 x1 cd cs) cd cs

d_C_five :: C_Roman -> Cover -> ConstStore -> C_Roman
d_C_five x1 cd cs = case x1 of
  C_C -> C_D
  C_X -> C_L
  C_I -> C_V
  C_V -> Curry_Prelude.d_C_failed cd cs
  C_L -> Curry_Prelude.d_C_failed cd cs
  C_D -> Curry_Prelude.d_C_failed cd cs
  C_M -> Curry_Prelude.d_C_failed cd cs
  C_Minus x2 x3 -> Curry_Prelude.d_C_failed cd cs
  C_Plus x4 x5 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Roman d i l r -> narrow d i (d_C_five l cd cs) (d_C_five r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C_five z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C_five e cd x) $! addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman.five" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman.five" (showCons x1))

d_C_ten :: C_Roman -> Cover -> ConstStore -> C_Roman
d_C_ten x1 cd cs = case x1 of
  C_C -> C_M
  C_X -> C_C
  C_I -> C_X
  C_V -> Curry_Prelude.d_C_failed cd cs
  C_L -> Curry_Prelude.d_C_failed cd cs
  C_D -> Curry_Prelude.d_C_failed cd cs
  C_M -> Curry_Prelude.d_C_failed cd cs
  C_Minus x2 x3 -> Curry_Prelude.d_C_failed cd cs
  C_Plus x4 x5 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Roman d i l r -> narrow d i (d_C_ten l cd cs) (d_C_ten r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C_ten z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C_ten e cd x) $! addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman.ten" [show x1] info)
  _ -> failCons cd (consFail "Data.Roman.ten" (showCons x1))

d_C_allRegular :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_allRegular x1 cd cs = Test.Curry_Prop.d_OP_eq_eq_gt
  (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Int (1)) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  x1 (Curry_Prelude.C_Int (4000)) cd cs) cd cs)
  (Test.Curry_Prop.d_OP_minus_eq_minus
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  (d_C_toInt (d_C_fromInt x1 cd cs) cd cs) x1 cd cs) cd cs

d_C_roman42 :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_roman42 cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
  (d_C_showRoman (d_C_fromInt (Curry_Prelude.C_Int (42)) cd cs) cd cs)
  (Curry_Prelude.toCurryString "XLII") cd cs

d_C_roman1963 :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_roman1963 cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
  (d_C_showRoman (d_C_fromInt (Curry_Prelude.C_Int (1963)) cd cs) cd cs)
  (Curry_Prelude.toCurryString "MCMLXIII") cd cs

d_C__case_26 :: C_Roman -> C_Roman -> C_Roman -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_26 x38 x37 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x39 x40 -> Curry_Prelude.C_False
  C_Plus x41 x42 -> Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    x37 x41 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    x38 x42 cd cs) cd cs
  Choice_C_Roman d i l r -> narrow d i (d_C__case_26 x38 x37 l cd cs)
    (d_C__case_26 x38 x37 r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_26 x38 x37 z cd cs)
    xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_26 x38 x37 e cd x) $!
    addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_26" [show x38
    , show x37, show x2] info)
  _ -> failCons cd (consFail "Data.Roman._case_26" (showCons x2))

d_C__case_27 :: C_Roman -> C_Roman -> C_Roman -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_27 x32 x31 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x33 x34 -> Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    x31 x33 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Roman_dot_Roman_hash
    x32 x34 cd cs) cd cs
  C_Plus x35 x36 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_27 x32 x31 l cd cs)
    (d_C__case_27 x32 x31 r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_27 x32 x31 z cd cs)
    xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_27 x32 x31 e cd x) $!
    addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_27" [show x32
    , show x31, show x2] info)
  _ -> failCons cd (consFail "Data.Roman._case_27" (showCons x2))

d_C__case_28 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_28 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_True
  C_Minus x27 x28 -> Curry_Prelude.C_False
  C_Plus x29 x30 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_28 l cd cs) (d_C__case_28 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_28 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_28 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_28" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_28" (showCons x2))

d_C__case_29 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_29 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_True
  C_M -> Curry_Prelude.C_False
  C_Minus x23 x24 -> Curry_Prelude.C_False
  C_Plus x25 x26 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_29 l cd cs) (d_C__case_29 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_29 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_29 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_29" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_29" (showCons x2))

d_C__case_30 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_30 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_True
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x19 x20 -> Curry_Prelude.C_False
  C_Plus x21 x22 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_30 l cd cs) (d_C__case_30 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_30 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_30 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_30" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_30" (showCons x2))

d_C__case_31 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_31 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_True
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x15 x16 -> Curry_Prelude.C_False
  C_Plus x17 x18 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_31 l cd cs) (d_C__case_31 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_31 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_31 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_31" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_31" (showCons x2))

d_C__case_32 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_32 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_True
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x11 x12 -> Curry_Prelude.C_False
  C_Plus x13 x14 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_32 l cd cs) (d_C__case_32 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_32 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_32 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_32" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_32" (showCons x2))

d_C__case_33 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_33 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_True
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x7 x8 -> Curry_Prelude.C_False
  C_Plus x9 x10 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_33 l cd cs) (d_C__case_33 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_33 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_33 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_33" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_33" (showCons x2))

d_C__case_34 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_34 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_True
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x3 x4 -> Curry_Prelude.C_False
  C_Plus x5 x6 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_34 l cd cs) (d_C__case_34 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_34 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_34 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_34" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_34" (showCons x2))

d_C__case_17 :: C_Roman -> C_Roman -> C_Roman -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_17 x38 x37 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x39 x40 -> Curry_Prelude.C_False
  C_Plus x41 x42 -> Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    x37 x41 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    x38 x42 cd cs) cd cs
  Choice_C_Roman d i l r -> narrow d i (d_C__case_17 x38 x37 l cd cs)
    (d_C__case_17 x38 x37 r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_17 x38 x37 z cd cs)
    xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_17 x38 x37 e cd x) $!
    addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_17" [show x38
    , show x37, show x2] info)
  _ -> failCons cd (consFail "Data.Roman._case_17" (showCons x2))

d_C__case_18 :: C_Roman -> C_Roman -> C_Roman -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_18 x32 x31 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x33 x34 -> Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    x31 x33 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    x32 x34 cd cs) cd cs
  C_Plus x35 x36 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_18 x32 x31 l cd cs)
    (d_C__case_18 x32 x31 r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_18 x32 x31 z cd cs)
    xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_18 x32 x31 e cd x) $!
    addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_18" [show x32
    , show x31, show x2] info)
  _ -> failCons cd (consFail "Data.Roman._case_18" (showCons x2))

d_C__case_19 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_19 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_True
  C_Minus x27 x28 -> Curry_Prelude.C_False
  C_Plus x29 x30 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_19 l cd cs) (d_C__case_19 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_19 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_19 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_19" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_19" (showCons x2))

d_C__case_20 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_20 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_True
  C_M -> Curry_Prelude.C_False
  C_Minus x23 x24 -> Curry_Prelude.C_False
  C_Plus x25 x26 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_20 l cd cs) (d_C__case_20 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_20 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_20 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_20" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_20" (showCons x2))

d_C__case_21 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_21 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_True
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x19 x20 -> Curry_Prelude.C_False
  C_Plus x21 x22 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_21 l cd cs) (d_C__case_21 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_21 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_21 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_21" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_21" (showCons x2))

d_C__case_22 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_22 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_True
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x15 x16 -> Curry_Prelude.C_False
  C_Plus x17 x18 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_22 l cd cs) (d_C__case_22 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_22 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_22 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_22" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_22" (showCons x2))

d_C__case_23 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_23 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_True
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x11 x12 -> Curry_Prelude.C_False
  C_Plus x13 x14 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_23 l cd cs) (d_C__case_23 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_23 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_23 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_23" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_23" (showCons x2))

d_C__case_24 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_24 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_True
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x7 x8 -> Curry_Prelude.C_False
  C_Plus x9 x10 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_24 l cd cs) (d_C__case_24 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_24 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_24 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_24" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_24" (showCons x2))

d_C__case_25 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_25 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_True
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x3 x4 -> Curry_Prelude.C_False
  C_Plus x5 x6 -> Curry_Prelude.C_False
  Choice_C_Roman d i l r -> narrow d i (d_C__case_25 l cd cs) (d_C__case_25 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_25 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_25 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_25" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_25" (showCons x2))

d_C__case_8 :: C_Roman -> C_Roman -> C_Roman -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_8 x38 x37 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x39 x40 -> Curry_Prelude.C_False
  C_Plus x41 x42 -> Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs) x37 cd cs) x41 cd cs) (Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    x37 x41 cd cs)
    (d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    x38 x42 cd cs) cd cs) cd cs
  Choice_C_Roman d i l r -> narrow d i (d_C__case_8 x38 x37 l cd cs)
    (d_C__case_8 x38 x37 r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_8 x38 x37 z cd cs)
    xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_8 x38 x37 e cd x) $!
    addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_8" [show x38
    , show x37, show x2] info)
  _ -> failCons cd (consFail "Data.Roman._case_8" (showCons x2))

d_C__case_9 :: C_Roman -> C_Roman -> C_Roman -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_9 x32 x31 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_False
  C_Minus x33 x34 -> Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    cd cs) x31 cd cs) x33 cd cs) (Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Roman_dot_Roman_hash
    x31 x33 cd cs)
    (d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Roman_dot_Roman_hash
    x32 x34 cd cs) cd cs) cd cs
  C_Plus x35 x36 -> Curry_Prelude.C_True
  Choice_C_Roman d i l r -> narrow d i (d_C__case_9 x32 x31 l cd cs)
    (d_C__case_9 x32 x31 r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_9 x32 x31 z cd cs)
    xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_9 x32 x31 e cd x) $!
    addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_9" [show x32
    , show x31, show x2] info)
  _ -> failCons cd (consFail "Data.Roman._case_9" (showCons x2))

d_C__case_10 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_10 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_False
  C_M -> Curry_Prelude.C_True
  C_Minus x27 x28 -> Curry_Prelude.C_True
  C_Plus x29 x30 -> Curry_Prelude.C_True
  Choice_C_Roman d i l r -> narrow d i (d_C__case_10 l cd cs) (d_C__case_10 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_10 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_10 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_10" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_10" (showCons x2))

d_C__case_11 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_11 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_False
  C_D -> Curry_Prelude.C_True
  C_M -> Curry_Prelude.C_True
  C_Minus x23 x24 -> Curry_Prelude.C_True
  C_Plus x25 x26 -> Curry_Prelude.C_True
  Choice_C_Roman d i l r -> narrow d i (d_C__case_11 l cd cs) (d_C__case_11 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_11 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_11 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_11" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_11" (showCons x2))

d_C__case_12 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_12 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_False
  C_C -> Curry_Prelude.C_True
  C_D -> Curry_Prelude.C_True
  C_M -> Curry_Prelude.C_True
  C_Minus x19 x20 -> Curry_Prelude.C_True
  C_Plus x21 x22 -> Curry_Prelude.C_True
  Choice_C_Roman d i l r -> narrow d i (d_C__case_12 l cd cs) (d_C__case_12 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_12 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_12 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_12" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_12" (showCons x2))

d_C__case_13 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_13 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_False
  C_L -> Curry_Prelude.C_True
  C_C -> Curry_Prelude.C_True
  C_D -> Curry_Prelude.C_True
  C_M -> Curry_Prelude.C_True
  C_Minus x15 x16 -> Curry_Prelude.C_True
  C_Plus x17 x18 -> Curry_Prelude.C_True
  Choice_C_Roman d i l r -> narrow d i (d_C__case_13 l cd cs) (d_C__case_13 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_13 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_13 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_13" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_13" (showCons x2))

d_C__case_14 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_14 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_False
  C_X -> Curry_Prelude.C_True
  C_L -> Curry_Prelude.C_True
  C_C -> Curry_Prelude.C_True
  C_D -> Curry_Prelude.C_True
  C_M -> Curry_Prelude.C_True
  C_Minus x11 x12 -> Curry_Prelude.C_True
  C_Plus x13 x14 -> Curry_Prelude.C_True
  Choice_C_Roman d i l r -> narrow d i (d_C__case_14 l cd cs) (d_C__case_14 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_14 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_14 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_14" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_14" (showCons x2))

d_C__case_15 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_15 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_False
  C_V -> Curry_Prelude.C_True
  C_X -> Curry_Prelude.C_True
  C_L -> Curry_Prelude.C_True
  C_C -> Curry_Prelude.C_True
  C_D -> Curry_Prelude.C_True
  C_M -> Curry_Prelude.C_True
  C_Minus x7 x8 -> Curry_Prelude.C_True
  C_Plus x9 x10 -> Curry_Prelude.C_True
  Choice_C_Roman d i l r -> narrow d i (d_C__case_15 l cd cs) (d_C__case_15 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_15 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_15 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_15" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_15" (showCons x2))

d_C__case_16 :: C_Roman -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_16 x2 cd cs = case x2 of
  C_I -> Curry_Prelude.C_True
  C_V -> Curry_Prelude.C_True
  C_X -> Curry_Prelude.C_True
  C_L -> Curry_Prelude.C_True
  C_C -> Curry_Prelude.C_True
  C_D -> Curry_Prelude.C_True
  C_M -> Curry_Prelude.C_True
  C_Minus x3 x4 -> Curry_Prelude.C_True
  C_Plus x5 x6 -> Curry_Prelude.C_True
  Choice_C_Roman d i l r -> narrow d i (d_C__case_16 l cd cs) (d_C__case_16 r cd
    cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_16 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_16 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_16" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Roman._case_16" (showCons x2))

d_C__case_7 :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Roman
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_7 x2 x1 cd cs = case x1 of
  C_Minus x3 x4 -> Curry_Prelude.d_OP_dot (d_C_showsRoman x3 cd cs)
    (d_C_showsRoman x4 cd cs) cd cs
  C_Plus x5 x6 -> Curry_Prelude.d_OP_dot (d_C_showsRoman x5 cd cs)
    (d_C_showsRoman x6 cd cs) cd cs
  C_I -> x2
  C_V -> x2
  C_X -> x2
  C_L -> x2
  C_C -> x2
  C_D -> x2
  C_M -> x2
  Choice_C_Roman d i l r -> narrow d i (d_C__case_7 x2 l cd cs) (d_C__case_7 x2
    r cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> d_C__case_7 x2 z cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> d_C__case_7 x2 e cd x) $! addCs c
    cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_7" [show x2
    , show x1] info)
  _ -> failCons cd (consFail "Data.Roman._case_7" (showCons x1))

nd_C__case_7 :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Roman -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C__case_7 x2 x1 s cd cs = case x1 of
  C_Minus x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id (d_C_showsRoman x3 cd cs))
    (wrapDX id (d_C_showsRoman x4 cd cs)) s0 cd cs
  C_Plus x5 x6 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id (d_C_showsRoman x5 cd cs))
    (wrapDX id (d_C_showsRoman x6 cd cs)) s0 cd cs
  C_I -> x2
  C_V -> x2
  C_X -> x2
  C_L -> x2
  C_C -> x2
  C_D -> x2
  C_M -> x2
  Choice_C_Roman d i l r -> narrow d i (nd_C__case_7 x2 l s cd cs) (nd_C__case_7
    x2 r s cd cs)
  Choices_C_Roman d i xs -> narrows cs d i (\z -> nd_C__case_7 x2 z s cd cs) xs
  Guard_C_Roman d c e -> guardCons d c ((\x -> nd_C__case_7 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Roman d info -> failCons d (traceFail "Data.Roman._case_7" [show x2
    , show x1] info)
  _ -> failCons cd (consFail "Data.Roman._case_7" (showCons x1))

d_C__case_6 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Roman
d_C__case_6 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_foldr1 (acceptCs (acceptCs id)
    C_Plus) (d_C_base x1 (Curry_Prelude.OP_Cons C_M (Curry_Prelude.OP_Cons C_C
    (Curry_Prelude.OP_Cons C_X (Curry_Prelude.OP_Cons C_I
    Curry_Prelude.OP_List)))) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x1 l cd cs)
    (d_C__case_6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Roman._case_6"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Roman._case_6" (showCons x2))

d_C__case_5 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List C_Roman -> C_Roman
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Roman
d_C__case_5 x6 x8 x3 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_Minus
    (d_OP_base_dot_times_dot_38 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x6 (Curry_Prelude.C_Int (8)) cd cs) cd cs) (d_C_ten x3 cd cs)) x8
  Curry_Prelude.C_False -> d_C__case_4 x6 x8 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (6)) x6 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x6 x8 x3 l cd
    cs) (d_C__case_5 x6 x8 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x6 x8
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x6 x8 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Roman._case_5"
    [show x6, show x8, show x3, show x9] info)
  _ -> failCons cd (consFail "Data.Roman._case_5" (showCons x9))

d_C__case_4 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List C_Roman -> C_Roman
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Roman
d_C__case_4 x6 x8 x3 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_Plus (d_C_five x3 cd cs)
    (d_OP_base_dot_times_dot_38 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x6 (Curry_Prelude.C_Int (5)) cd cs) cd cs)) x8
  Curry_Prelude.C_False -> d_C__case_3 x6 x8 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (5)) x6 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x6 x8 x3 l cd
    cs) (d_C__case_4 x6 x8 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x6 x8
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x6 x8 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Roman._case_4"
    [show x6, show x8, show x3, show x9] info)
  _ -> failCons cd (consFail "Data.Roman._case_4" (showCons x9))

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List C_Roman -> C_Roman
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Roman
d_C__case_3 x6 x8 x3 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (d_C_five x3 cd cs) x8
  Curry_Prelude.C_False -> d_C__case_2 x6 x8 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (4)) x6 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x6 x8 x3 l cd
    cs) (d_C__case_3 x6 x8 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x6 x8
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x6 x8 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Roman._case_3"
    [show x6, show x8, show x3, show x9] info)
  _ -> failCons cd (consFail "Data.Roman._case_3" (showCons x9))

d_C__case_2 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List C_Roman -> C_Roman
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Roman
d_C__case_2 x6 x8 x3 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_Minus x3 (d_C_five x3 cd cs))
    x8
  Curry_Prelude.C_False -> d_C__case_1 x6 x8 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (1)) x6 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x6 x8 x3 l cd
    cs) (d_C__case_2 x6 x8 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x6 x8
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x6 x8 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Roman._case_2"
    [show x6, show x8, show x3, show x9] info)
  _ -> failCons cd (consFail "Data.Roman._case_2" (showCons x9))

d_C__case_1 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List C_Roman -> C_Roman
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Roman
d_C__case_1 x6 x8 x3 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (d_OP_base_dot_times_dot_38 x3
    x6 cd cs) x8
  Curry_Prelude.C_False -> d_C__case_0 x8 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x6 x8 x3 l cd
    cs) (d_C__case_1 x6 x8 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x6 x8
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x6 x8 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Roman._case_1"
    [show x6, show x8, show x3, show x9] info)
  _ -> failCons cd (consFail "Data.Roman._case_1" (showCons x9))

d_C__case_0 :: Curry_Prelude.OP_List C_Roman -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Roman
d_C__case_0 x8 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> x8
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x8 l cd cs)
    (d_C__case_0 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x8 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x8 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Roman._case_0"
    [show x8, show x9] info)
  _ -> failCons cd (consFail "Data.Roman._case_0" (showCons x9))

