{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry.Curry_Position
  ( C_Position (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
  , d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
  , d_C_line
  , d_C_column
  , d_C_rowDist
  , d_C_incr )
  where

import Basics
import qualified Curry_Prelude


data C_Position
  = C_Position Curry_Prelude.C_Int Curry_Prelude.C_Int
  | C_NoPos
  | Choice_C_Position Cover ID C_Position C_Position
  | Choices_C_Position Cover ID [C_Position]
  | Fail_C_Position Cover FailInfo
  | Guard_C_Position Cover Constraints C_Position

instance Show C_Position where
  showsPrec d (Choice_C_Position cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Position cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Position cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Position cd info) = showChar '!'
  showsPrec _ (C_Position x1 x2) = showString "(Position" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ C_NoPos = showString "NoPos"

instance Read C_Position where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Position x1 x2, r2) | (_, r0)
    <- readQualified "Curry.Position" "Position" r, (x1, r1) <- readsPrec 11 r0,
    (x2, r2) <- readsPrec 11 r1]) s ++ readParen False (\r -> [(C_NoPos
    , r0) | (_, r0) <- readQualified "Curry.Position" "NoPos" r]) s

instance NonDet C_Position where
  choiceCons = Choice_C_Position
  choicesCons = Choices_C_Position
  failCons = Fail_C_Position
  guardCons = Guard_C_Position
  try (Choice_C_Position cd i x y) = tryChoice cd i x y
  try (Choices_C_Position cd i xs) = tryChoices cd i xs
  try (Fail_C_Position cd info) = Fail cd info
  try (Guard_C_Position cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Position cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Position cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Position cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Position cd i _) = error
    ("Curry.Position.Position.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Position cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Position cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Position where
  generate s c = Choices_C_Position c (freeID [2, 0] s) [C_Position (generate
    (leftSupply s) c) (generate (rightSupply s) c), C_NoPos]

instance NormalForm C_Position where
  ($!!) cont (C_Position x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_Position y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont C_NoPos d cs = cont C_NoPos d cs
  ($!!) cont (Choice_C_Position cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Position cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Position cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Position cd info) _ _ = failCons cd info
  ($##) cont (C_Position x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_Position y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont C_NoPos d cs = cont C_NoPos d cs
  ($##) cont (Choice_C_Position cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Position cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Position cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Position cd info) _ _ = failCons cd info
  showCons (C_Position _ _) = "Curry.Position.Position _ _"
  showCons C_NoPos = "Curry.Position.NoPos"
  showCons x = error ("Curry.Position.Position.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_Position x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Position y1 y2)) x2) x1
  searchNF _ cont C_NoPos = cont C_NoPos
  searchNF _ _ x = error
    ("Curry.Position.Position.searchNF: no constructor: " ++ show x)

instance Unifiable C_Position where
  (=.=) (C_Position x1 x2) (C_Position y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) C_NoPos C_NoPos d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Position x1 x2) (C_Position y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) C_NoPos C_NoPos d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Position x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind cd i C_NoPos = (i :=: ChooseN 1 0) : concat []
  bind d i (Choice_C_Position cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Position cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Position cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_Position cd i _) = error
    ("Curry.Position.Position.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Position cd info) = [Unsolvable info]
  bind d i (Guard_C_Position cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Position x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i C_NoPos = (i :=: ChooseN 1 0) : []
  lazyBind d i (Choice_C_Position cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Position cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_Position cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Position cd i _) = error
    ("Curry.Position.Position.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Position cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Position cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Position where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Position
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Position._inst#Prelude.Data#Curry.Position.Position#" [show x1] info)
  _ -> failCons cd (consFail
    "Curry.Position._inst#Prelude.Data#Curry.Position.Position#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash :: C_Position
  -> C_Position -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash x1 x2 cd cs =
  case x1 of
  C_Position x3 x4 -> d_C__case_9 x4 x3 x2 cd cs
  C_NoPos -> d_C__case_8 x2 cd cs
  Choice_C_Position d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    r x2 cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    z x2 cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Position d info -> failCons d (traceFail
    "Curry.Position._impl#===#Prelude.Data#Curry.Position.Position#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Curry.Position._impl#===#Prelude.Data#Curry.Position.Position#" (showCons
    x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash :: IDSupply
  -> Cover -> ConstStore -> C_Position
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s0 = leftSupply s2
                                    s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Position
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s1 cd cs))) C_NoPos s3 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_Position
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Position._inst#Prelude.Eq#Curry.Position.Position#" [show x1] info)
  _ -> failCons cd (consFail
    "Curry.Position._inst#Prelude.Eq#Curry.Position.Position#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_Position
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Position._inst#Prelude.Eq#Curry.Position.Position#" [show x1] info)
  _ -> failCons cd (consFail
    "Curry.Position._inst#Prelude.Eq#Curry.Position.Position#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash :: C_Position
  -> C_Position -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash x1 x2 cd cs =
  case x1 of
  C_Position x3 x4 -> d_C__case_7 x4 x3 x2 cd cs
  C_NoPos -> d_C__case_6 x2 cd cs
  Choice_C_Position d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    r x2 cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    z x2 cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Position d info -> failCons d (traceFail
    "Curry.Position._impl#==#Prelude.Eq#Curry.Position.Position#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "Curry.Position._impl#==#Prelude.Eq#Curry.Position.Position#" (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash :: Cover
  -> ConstStore -> C_Position -> Cover -> ConstStore -> C_Position -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash)

d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord C_Position
d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Ord
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    (d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs)
    (d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs)
    (d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash)
    (d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs)
    (d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs)
    (d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Position._inst#Prelude.Ord#Curry.Position.Position#" [show x1] info)
  _ -> failCons cd (consFail
    "Curry.Position._inst#Prelude.Ord#Curry.Position.Position#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord
  C_Position
nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Ord (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash)
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs)) (wrapDX (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Position._inst#Prelude.Ord#Curry.Position.Position#" [show x1] info)
  _ -> failCons cd (consFail
    "Curry.Position._inst#Prelude.Ord#Curry.Position.Position#" (showCons x1))

d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash :: Cover
  -> ConstStore -> C_Position -> Cover -> ConstStore -> C_Position -> Cover
  -> ConstStore -> Curry_Prelude.C_Ordering
d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_compare_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash)

d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash :: Cover
  -> ConstStore -> C_Position -> Cover -> ConstStore -> C_Position -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_lt_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash)

d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash :: Cover
  -> ConstStore -> C_Position -> Cover -> ConstStore -> C_Position -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_gt_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash)

d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash :: C_Position
  -> C_Position -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash x1 x2 cd cs =
  case x1 of
  C_Position x3 x4 -> d_C__case_5 x4 x3 x2 cd cs
  C_NoPos -> d_C__case_4 x2 cd cs
  Choice_C_Position d i l r -> narrow d i
    (d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    r x2 cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    z x2 cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Position d info -> failCons d (traceFail
    "Curry.Position._impl#<=#Prelude.Ord#Curry.Position.Position#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Curry.Position._impl#<=#Prelude.Ord#Curry.Position.Position#" (showCons
    x1))

d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash :: Cover
  -> ConstStore -> C_Position -> Cover -> ConstStore -> C_Position -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_gt_eq_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash)

d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash :: Cover
  -> ConstStore -> C_Position -> Cover -> ConstStore -> C_Position -> Cover
  -> ConstStore -> C_Position
d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_min_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash)

d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash :: Cover
  -> ConstStore -> C_Position -> Cover -> ConstStore -> C_Position -> Cover
  -> ConstStore -> C_Position
d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_max_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash)

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_Position
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Position._inst#Prelude.Show#Curry.Position.Position#" [show x1] info)
  _ -> failCons cd (consFail
    "Curry.Position._inst#Prelude.Show#Curry.Position.Position#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_Position
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Position._inst#Prelude.Show#Curry.Position.Position#" [show x1] info)
  _ -> failCons cd (consFail
    "Curry.Position._inst#Prelude.Show#Curry.Position.Position#" (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash :: Cover
  -> ConstStore -> C_Position -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.C_Int
  -> C_Position -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash x1 x2 cd cs =
  case x2 of
  C_Position x3 x4 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Position "))
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (11)) cd cs) x3 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " "))
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (11)) cd cs) x4 cd cs) cd cs) cd cs) cd cs) cd
    cs
  C_NoPos -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "NoPos")
  Choice_C_Position d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    x1 r cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    x1 z cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_Position d info -> failCons d (traceFail
    "Curry.Position._impl#showsPrec#Prelude.Show#Curry.Position.Position#" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "Curry.Position._impl#showsPrec#Prelude.Show#Curry.Position.Position#"
    (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Position -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
  cd cs

d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read C_Position
d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Read (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash)
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Position._inst#Prelude.Read#Curry.Position.Position#" [show x1] info)
  _ -> failCons cd (consFail
    "Curry.Position._inst#Prelude.Read#Curry.Position.Position#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read
  C_Position
nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Read (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash))
    (wrapDX id
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Position._inst#Prelude.Read#Curry.Position.Position#" [show x1] info)
  _ -> failCons cd (consFail
    "Curry.Position._inst#Prelude.Read#Curry.Position.Position#" (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_readParen (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs)
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1
  cd cs) x2 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_readParen
  Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda14
  cd cs) x2 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_Position (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_Position (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_3 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "Position") cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Curry.Position._impl#readsPrec#Prelude.Read#Curry.Position.Position#._#lambda1._#lambda4"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Curry.Position._impl#readsPrec#Prelude.Read#Curry.Position.Position#._#lambda1._#lambda4"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_foldr (acceptCs id
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x3)) Curry_Prelude.OP_List (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (11)) cd cs) x4 cd cs) cd cs) x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Curry.Position._impl#readsPrec#Prelude.Read#Curry.Position.Position#._#lambda1._#lambda4._#lambda8"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Curry.Position._impl#readsPrec#Prelude.Read#Curry.Position.Position#._#lambda1._#lambda4._#lambda8"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12 :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_Position (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12 x1 x2 x3 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 (C_Position x1 x4) x5) x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x1 l x3 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x1 e x3 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Curry.Position._impl#readsPrec#Prelude.Read#Curry.Position.Position#._#lambda1._#lambda4._#lambda8._#lambda12"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Curry.Position._impl#readsPrec#Prelude.Read#Curry.Position.Position#._#lambda1._#lambda4._#lambda8._#lambda12"
    (showCons x2))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda14 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_Position (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda14 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_Position (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_2 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "NoPos") cd cs)
    cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Curry.Position._impl#readsPrec#Prelude.Read#Curry.Position.Position#._#lambda14._#lambda17"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Curry.Position._impl#readsPrec#Prelude.Read#Curry.Position.Position#._#lambda14._#lambda17"
    (showCons x1))

d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_Position) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_readList_hash_Prelude_dot_Read
  d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
  cd cs

d_C_line :: C_Position -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_line x1 cd cs = case x1 of
  C_Position x2 x3 -> x2
  C_NoPos -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Position d i l r -> narrow d i (d_C_line l cd cs) (d_C_line r cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C_line z cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C_line e cd x) $! addCs c
    cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position.line" [show
    x1] info)
  _ -> failCons cd (consFail "Curry.Position.line" (showCons x1))

d_C_column :: C_Position -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_column x1 cd cs = case x1 of
  C_Position x2 x3 -> x3
  C_NoPos -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Position d i l r -> narrow d i (d_C_column l cd cs) (d_C_column r cd
    cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C_column z cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C_column e cd x) $! addCs c
    cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position.column" [show
    x1] info)
  _ -> failCons cd (consFail "Curry.Position.column" (showCons x1))

d_C_rowDist :: C_Position -> C_Position -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C_rowDist x1 x2 cd cs = case x1 of
  C_NoPos -> d_C__case_1 x2 cd cs
  C_Position x5 x6 -> d_C__case_0 x5 x2 cd cs
  Choice_C_Position d i l r -> narrow d i (d_C_rowDist l x2 cd cs) (d_C_rowDist
    r x2 cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C_rowDist z x2 cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C_rowDist e x2 cd x) $!
    addCs c cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position.rowDist" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "Curry.Position.rowDist" (showCons x1))

d_C_incr :: C_Position -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> C_Position
d_C_incr x1 x2 cd cs = case x1 of
  C_NoPos -> C_NoPos
  C_Position x3 x4 -> C_Position x3
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x4 x2 cd cs)
  Choice_C_Position d i l r -> narrow d i (d_C_incr l x2 cd cs) (d_C_incr r x2
    cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C_incr z x2 cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C_incr e x2 cd x) $! addCs c
    cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position.incr" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "Curry.Position.incr" (showCons x1))

d_C__case_8 :: C_Position -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_8 x2 cd cs = case x2 of
  C_Position x7 x8 -> Curry_Prelude.C_False
  C_NoPos -> Curry_Prelude.C_True
  Choice_C_Position d i l r -> narrow d i (d_C__case_8 l cd cs) (d_C__case_8 r
    cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C__case_8 z cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C__case_8 e cd x) $! addCs c
    cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position._case_8" [show
    x2] info)
  _ -> failCons cd (consFail "Curry.Position._case_8" (showCons x2))

d_C__case_9 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Position -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x4 x3 x2 cd cs = case x2 of
  C_Position x5 x6 -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) x5 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x4 cd cs) x6 cd cs) cd cs
  C_NoPos -> Curry_Prelude.C_False
  Choice_C_Position d i l r -> narrow d i (d_C__case_9 x4 x3 l cd cs)
    (d_C__case_9 x4 x3 r cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C__case_9 x4 x3 z cd cs)
    xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C__case_9 x4 x3 e cd x) $!
    addCs c cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position._case_9" [show
    x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Curry.Position._case_9" (showCons x2))

d_C__case_6 :: C_Position -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_6 x2 cd cs = case x2 of
  C_Position x7 x8 -> Curry_Prelude.C_False
  C_NoPos -> Curry_Prelude.C_True
  Choice_C_Position d i l r -> narrow d i (d_C__case_6 l cd cs) (d_C__case_6 r
    cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C__case_6 z cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C__case_6 e cd x) $! addCs c
    cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position._case_6" [show
    x2] info)
  _ -> failCons cd (consFail "Curry.Position._case_6" (showCons x2))

d_C__case_7 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Position -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_7 x4 x3 x2 cd cs = case x2 of
  C_Position x5 x6 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x3 x5 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x4 x6 cd cs) cd cs
  C_NoPos -> Curry_Prelude.C_False
  Choice_C_Position d i l r -> narrow d i (d_C__case_7 x4 x3 l cd cs)
    (d_C__case_7 x4 x3 r cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C__case_7 x4 x3 z cd cs)
    xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C__case_7 x4 x3 e cd x) $!
    addCs c cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position._case_7" [show
    x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Curry.Position._case_7" (showCons x2))

d_C__case_4 :: C_Position -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x2 cd cs = case x2 of
  C_Position x7 x8 -> Curry_Prelude.C_False
  C_NoPos -> Curry_Prelude.C_True
  Choice_C_Position d i l r -> narrow d i (d_C__case_4 l cd cs) (d_C__case_4 r
    cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C__case_4 z cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C__case_4 e cd x) $! addCs c
    cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position._case_4" [show
    x2] info)
  _ -> failCons cd (consFail "Curry.Position._case_4" (showCons x2))

d_C__case_5 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Position -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x4 x3 x2 cd cs = case x2 of
  C_Position x5 x6 -> Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) x5 cd cs) (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x3 x5 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    x4 x6 cd cs) cd cs) cd cs
  C_NoPos -> Curry_Prelude.C_True
  Choice_C_Position d i l r -> narrow d i (d_C__case_5 x4 x3 l cd cs)
    (d_C__case_5 x4 x3 r cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C__case_5 x4 x3 z cd cs)
    xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C__case_5 x4 x3 e cd x) $!
    addCs c cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position._case_5" [show
    x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Curry.Position._case_5" (showCons x2))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_3 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_foldr
    (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8)
    Curry_Prelude.OP_List (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (11)) cd cs) x4 cd cs) cd cs) x2 cd cs
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x3 x2 x4 l cd
    cs) (d_C__case_3 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x3 x2
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x3 x2 x4
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Curry.Position._case_3" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "Curry.Position._case_3" (showCons x5))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_2 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 C_NoPos
    x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x3 x2 x4 l cd
    cs) (d_C__case_2 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x3 x2
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x3 x2 x4
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Curry.Position._case_2" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "Curry.Position._case_2" (showCons x5))

d_C__case_0 :: Curry_Prelude.C_Int -> C_Position -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C__case_0 x5 x2 cd cs = case x2 of
  C_NoPos -> Curry_Prelude.C_Int (0)
  C_Position x7 x8 -> Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x7 x5 cd cs
  Choice_C_Position d i l r -> narrow d i (d_C__case_0 x5 l cd cs) (d_C__case_0
    x5 r cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C__case_0 x5 z cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C__case_0 x5 e cd x) $!
    addCs c cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position._case_0" [show
    x5, show x2] info)
  _ -> failCons cd (consFail "Curry.Position._case_0" (showCons x2))

d_C__case_1 :: C_Position -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_1 x2 cd cs = case x2 of
  C_NoPos -> Curry_Prelude.C_Int (0)
  C_Position x3 x4 -> Curry_Prelude.C_Int (0)
  Choice_C_Position d i l r -> narrow d i (d_C__case_1 l cd cs) (d_C__case_1 r
    cd cs)
  Choices_C_Position d i xs -> narrows cs d i (\z -> d_C__case_1 z cd cs) xs
  Guard_C_Position d c e -> guardCons d c ((\x -> d_C__case_1 e cd x) $! addCs c
    cs)
  Fail_C_Position d info -> failCons d (traceFail "Curry.Position._case_1" [show
    x2] info)
  _ -> failCons cd (consFail "Curry.Position._case_1" (showCons x2))

